'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfASD" "3pf"
.SH NAME
.upperok
.B pfASD
\- 
Create pfASD, specify pfASD properties.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfASDCalcVirtualClipTexParamsFuncType\ \ \ 'u
#include <Performer/pf/pfASD.h>
.nf
.fi
.TP
\ 
\f3\%pfASD::pfASD\fP();
.nf
.fi
.TP
static pfType *
\f3\%pfASD::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::setAttr\fP(int\ _which,
'in +2
'll -2
int\ _bind,
int\ _size,
void\ *_attr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::getAttr\fP(int\ _which,
'in +2
'll -2
int\ *_bind,
int\ *_size,
void\ **_attr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::setMorphAttrs\fP(int\ _mc);
.nf
.fi
.TP
int
\f3\%pfASD::getMorphAttrs\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::getActiveGeode\fP(pfChannel\ *_chan,
'in +2
'll -2
pfList\ *_geom);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::setNumBaseFaces\fP(int\ num);
.nf
.fi
.TP
int
\f3\%pfASD::getNumBaseFaces\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::setGStates\fP(pfGeoState\ **gs,
'in +2
'll -2
int\ num);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::getGStates\fP(pfGeoState\ ***gs,
'in +2
'll -2
int\ *num);
.in
.ll
.nf
.fi
.TP
pfGeoState*
\f3\%pfASD::getGState\fP(int\ num);
.nf
.fi
.TP
int
\f3\%pfASD::getNumGStates\fP();
.nf
.fi
.TP
void
\f3\%pfASD::setLODState\fP(pfLODState\ *ls);
.nf
.fi
.TP
void
\f3\%pfASD::getLODState\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::setLODStateIndex\fP(int\ index);
.nf
.fi
.TP
void
\f3\%pfASD::getLODStateIndex\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::setSyncGroup\fP(uint\ _syncGroup);
.nf
.fi
.TP
uint
\f3\%pfASD::getSyncGroup\fP();
.nf
.fi
.TP
void
\f3\%pfASD::enableClipRings\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::setNumClipRings\fP(int\ _numrings);
.nf
.fi
.TP
int
\f3\%pfASD::getNumClipRings\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::setClipRings\fP(float\ *_rings);
.nf
.fi
.TP
float*
\f3\%pfASD::getClipRings\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::setCalcVirtualClipTexParamsFunc\fP(pfASDCalcVirtualClipTexParamsFuncType\ _func);
.nf
.fi
.TP
pfASDCalcVirtualClipTexParamsFuncType
\f3\%pfASD::getCalcVirtualClipTexParamsFunc\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::setFaceBBoxes\fP(pfBox\ *_box);
.nf
.fi
.TP
pfBox*
\f3\%pfASD::getFaceBBoxes\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::setFaceBBox\fP(pfBox\ *_facebbox,
'in +2
'll -2
int\ _faceid);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::getFaceBBox\fP(pfBox\ *_facebbox,
'in +2
'll -2
int\ _faceid);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::setBBox\fP(pfBox\ *_box);
.nf
.fi
.TP
void
\f3\%pfASD::getBBox\fP(pfBox\ *_box);
.nf
.fi
.TP
void
\f3\%pfASD::config\fP();
.nf
.fi
.TP
void
\f3\%pfASD::setMaxMorphDepth\fP(int\ _m,
'in +2
'll -2
float\ _morphweightconstraint);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::getMaxMorphDepth\fP(int\ *_m,
'in +2
'll -2
float\ *_morphweightconstraint);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::setEvalMethod\fP(int\ method);
.nf
.fi
.TP
int
\f3\%pfASD::getEvalMethod\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::setEvalFunc\fP(pfTerrainEvalFuncType\ _eval);
.nf
.fi
.TP
pfTerrainEvalFuncType
\f3\%pfASD::getEvalFunc\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::setMask\fP(uint\ _which,
'in +2
'll -2
uint\ _mask,
int\ _id);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::setCullEnlarge\fP(float\ fov,
'in +2
'll -2
float\ near,
float\ far);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::setMorphWeight\fP(int\ _vertid,
'in +2
'll -2
float\ _morphweight);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::unsetMorphWeight\fP(int\ _vertid);
.nf
.fi
.TP
void
\f3\%pfASD::initMask\fP(uint\ _which);
.nf
.fi
.TP
void
\f3\%pfASD::clearAllMasks\fP(uint\ _which);
.nf
.fi
.TP
int
\f3\%pfASD::isPaging\fP(void);
.nf
.fi
.TP
int
\f3\%pfASD::isPageMaster\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::initPaging\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::setTileSize\fP(float\ **_tsize);
.nf
.fi
.TP
float**
\f3\%pfASD::getTileSize\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::setPageSize\fP(int\ **_page);
.nf
.fi
.TP
int**
\f3\%pfASD::getPageSize\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::setTotalTiles\fP(short\ **_tilenum);
.nf
.fi
.TP
short**
\f3\%pfASD::getTotalTiles\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::setMaxTileMemSize\fP(int\ _tilefaces,
'in +2
'll -2
int\ _tileverts);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::getMaxTileMemSize\fP(int\ *_tilefaces,
'in +2
'll -2
int\ *_tileverts);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::setOrigin\fP(pfVec3\ *_min);
.nf
.fi
.TP
pfVec3*
\f3\%pfASD::getOrigin\fP(void);
.nf
.fi
.TP
void
\f3\%pfASD::setPageFname\fP(char\ *_fname);
.nf
.fi
.TP
char*
\f3\%pfASD::getPageFname\fP(void);
.nf
.fi
.TP
virtual int
\f3\%pfASD::addQueryArray\fP(float\ *_vertices,
'in +2
'll -2
float\ *_down,
int\ nofVertices,
uint\ _mask,
pfFlux\ *_results);
.in
.ll
.nf
.fi
.TP
virtual void
\f3\%pfASD::deleteQueryArray\fP(int\ _index);
.nf
.fi
.TP
virtual void
\f3\%pfASD::setQueryArrayElement\fP(int\ _arrayIndex,
'in +2
'll -2
int\ _elementIndex,
float\ *_vertex,
float\ *_down);
.in
.ll
.nf
.fi
.TP
virtual void
\f3\%pfASD::getQueryArrayPositionSpan\fP(int\ _index,
'in +2
'll -2
pfBox\ *_box);
.in
.ll
.nf
.fi
.TP
unsigned long
\f3\%pfASD::ContainsQueryArray\fP(pfASD\ *_asd,
'in +2
'll -2
float\ *_vertices,
float\ *_down,
int\ _nofVertices);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfASD::addQueryTriangles\fP(float\ *_v,
'in +2
'll -2
float\ *_t,
float\ *_c,
int\ _nofTriangles,
float\ *_base,
float\ *_down,
float\ *_projection,
float\ *_azimuth,
unsigned\ long\ _opcode,
uint\ _mask,
pfFlux\ *_results);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::deleteQueryGeoSet\fP(int\ _index);
.nf
.fi
.TP
int
\f3\%pfASD::addQueryGeoSet\fP(pfGeoSet\ *gset,
'in +2
'll -2
float\ *_down,
uint\ _mask,
pfFlux\ *_results);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::replaceQueryGeoSet\fP(int\ index,
'in +2
'll -2
pfGeoSet\ *gset,
float\ *_down);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::projectPointFinestPositionNormal\fP(float\ *_base,
'in +2
'll -2
float\ *_down,
unsigned\ long\ _flags,
float\ *_base_pos,
float\ *_base_normal);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::projectPointFinestPosition\fP(float\ *_base,
'in +2
'll -2
float\ *_down,
unsigned\ long\ _flags,
float\ *_base_pos);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfASD::getQueryArrayPositionSpan\fP(int\ _index,
'in +2
'll -2
pfBox\ *_box);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfASD\fP is
derived from the parent class \f3\%pfNode\fP,
so each of these member functions of
class \f3\%pfNode\fP
are also directly usable with objects
of class \f3\%pfASD\fP.
This is also true for
ancestor classes
of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfNode::getParent\fP(int\ i);
.PD 0
.TP
int
\f3\%pfNode::getNumParents\fP(void);
.PD 0
.TP
void
\f3\%pfNode::setBound\fP(pfSphere\ *bsph,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getBound\fP(pfSphere\ *bsph);
.PD 0
.TP
pfNode*
\f3\%pfNode::clone\fP(int\ mode);
.PD 0
.TP
pfNode*
\f3\%pfNode::bufferClone\fP(int\ mode,
'in +2
'll -2
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::flatten\fP(int\ mode);
.PD 0
.TP
int
\f3\%pfNode::setName\fP(const\ char\ *name);
.PD 0
.TP
const char *
\f3\%pfNode::getName\fP(void);
.PD 0
.TP
pfNode*
\f3\%pfNode::find\fP(const\ char\ *pathName,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfNode::lookup\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::isect\fP(pfSegSet\ *segSet,
'in +2
'll -2
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravMask\fP(int\ which,
'in +2
'll -2
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfNode::getTravMask\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::getTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravData\fP(int\ which,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfNode::getTravData\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravMode\fP(int\ which,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getTravMode\fP(int\ which,
'in +2
'll -2
int\ mode)\ const;
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfASD\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfASD\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A pfASD is a pfNode which can handle the dynamic generation and morphing
geometry based on multiple LODs.
pfASD contains a small scene graph that is generated dynamically
to reflect the changing geometry being rendered.

Active Surface Definition approach,
models terrain as a single connected surface
rather than using the traditional multiple-patch configuration. The
surface is modeled with several hierarchical level of detail meshes
in the special ASD data structures. In the real-time simulation,
an ASD evaluation process selects polygons from the appropriate
LODs and constructs a valid meshing to best approximate the visible terrain
on the screen based on criteria such as view point, viewing frustum,
desired polygon count, desired
terrain fidelity, and similar factors. The resulting mesh is the "active
mesh" for the current evaluation. The positions of vertices in the active
mesh are smoothly morphed between positions stored in the different LODs.
The goal for ASD is to present a visually realistic terrain with
minimum geometry while simultaneously allowing freedom of motion through
the terrain with the maintenance of visual fidelity. This eliminates
artifacts such as instant LOD transition popping, rigid patch boundaries,
and limited size of textures. In summary, the ASD system takes as
input a hierarchical description of LODs and a collection of predefined
evaluation functions and produces active meshes.

These routines implement the Active Surface Definition (ASD) feature.
ASD defines a hierarchical structure that organizes all the LODs of
a terrain. At run-time, ASD traverses the structure, selecting triangles
from different LODs to render the portion of the terrain that is
within a volume of interest. Triangles are rendered either at their
pre-stored locations, when they are in a particular LOD range, or
at computed morphed locations, when they are between the morphing ranges.
There will be other ways to evaluate the terrain other than
purely range based approach. These are also supported by ASD.

pfASD evaluation can be carried out in a separate asynchronize thread when
user claimed multiprocessing mode,
e.g. PFMP_FORK_COMPUTE. Asychronizely, the evaluation is done in the
thread and the created geometry (geosets) are merged into the scenegraph
at synchronization time.
pfASD enlarges the viewing frustum to accommodate the delay of
evaluation.

The cull of pfASD is handled together with the
evaluation. In another word, the gsets that are generated by evaluation
is the set of triangles that should be or soon to be visible.
Therefore, the cull process of pfASD is a trivial ALL_IN.

Since the evaluation is done asynchronizely, it is hard to
predict how many frames the evaluation takes. User can
monitor the length of the process by not forking the COMPUTE process.

\f3\%new pfASD\fP creates and returns a handle to a pfASD.
Like other pfNodes, pfASDs are always allocated from shared memory
and cannot be created statically, on the stack or in arrays.
pfASDs should be deleted using \f3\%pfDelete\fP rather than the
delete operator.

\f3\%pfASD::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfASD\fP.  The \f3\%pfType\fP* returned
by \f3\%pfASD::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfASD\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfASD::setAttr\fP sets up the database for terrain. \f2which\fP takes one of
the 6 values:
PFASD_LODS, PFASD_COORDS, PFASD_FACES,
PFASD_PER_VERTEX_ATTR, or PFASD_OVERALL_ATTR.
\f2type\fP is a bit combination of PFASD_NORMALS,
PFASD_COLORS, and PFASD_TCOORDS that defined which
attribute is described in the \f2attr\fP list.
\f2size\fP is the number of attributes and \f2attr\fP is the pointer
to the attribte list.

1. ASD face pfASDFace description:

The terrain database consists of several layers of
triangle meshes that are organized as a tree.
For detailed explaination of the structure of the
database, please refer to Performer Programmer's Guide.
The vertices in each triangle must be arranged ccw. Let the three
vetices be vertex[0], vertex[1], and vertex[2]. The reference point i
locates between vertex[(i-1)%3] and vertex[i].
If the triangle is part of a triangle strip, then the vertices
should also be arranged such that vertex[2] is the vertex
used in the tstrip.

2. pfASDFace structure

.Ex
.nf

struct pfASDFace
{
    int level;
    int tsid;
    int vert[3];
    int attr[3];
    int refvert[3];
    int sattr[3];
    int child[4];
    ushort gstateid;
    ushort mask;
} ;
.Ee
.fi
.na


Each face has an unique entry in this array, and the index is
the faceID.
The LOD level in which this face is present is defined by level.
The entry tsid is the triangle strip ID of this face.
The vertices and reference points, vert[3] and refvert[3], are indices into
the coordinate array.
The attr is the attribute index of the vertex, and sattr is the
attribute index of the reference point.
The field child[4] is the 4 indices of the child nodes in the tree.
If any of the entries is missing, enter PFASD_NIL_ID in the field.
ASD takes on an array of geostates. Each face can point to 1
geostate. This is useful when the terrain has multiple
appearances, for example, multiple textures.
The gstateid is the index of the geostate.
A face can be rendered as a "hole", i.e. not drawn. This can
be described by setting mask to PFASD_FACE_NODRAW.
Although a face is rendered as a "hole", its virtual position can
still be queried. If the position of the face should not
be used is alignment query, OR the mask with bit value PFASD_FACE_NOQUERY.
If mask is 0, then the face is drawn regularly and queried regularly.


1. When \f2which\fP is PFASD_COORDS, \f2attr\fP is the pointer
to the pfASDVert array.

.Ex
.nf

struct pfASDVert
{
    pfVec3 v0, vd;
    int neighborid[2];
    int vertid;
};
.Ee
.fi
.na


Each vertex i in the database has 2 values associated with it:
v0 is the final position of the vertex, and vd is the vector
which is the difference between the reference and final position.
The index i is the vertex id.
Each vertex is a reference point on a unique edge.
The edge has two neighboring faces.
The field neighborid[2] holds the indices of the two neighboring faces.

2. When \f2which\fP is PFASD_PER_VERTEX_ATTR,
\f2attr\fP is the pointer to an array of attributes.
Normal, color, and texture coordinates are
defined in this attribute array of interleaved floats.
Each attribute has two values, the final attribute and attribute change.
The format of each unit in this array is :
n0(pfVec3, 3 floats), nd(pfVec3, 3 floats), c0(pfVec4, 4 floats),
cd(pfVec4, 4 floats), t0(pfVec2, 2 floats), td(pfVec2, 2 floats).
Any of the attributes can be missing from this array.
The \f2type\fP field defines which attributes are in the array.
For example, if the array is
a list of normal and texture coordinates, but no color,
then unit in the array looks like
.Ex
.nf

n0 (3 floats)
nd (3 floats)
t0 (2 floats)
td (2 floats)
.Ee
.fi
.na

and \f2type\fP is PFASD_NORMALS | PFASD_TCOORDS

If there is only Normals in the attr list, then the unit will look like:
.Ex
.nf

n0 (3 floats)
nd (3 floats)
.Ee
.fi
.na

and \f2type\fP is PFASD_NORMALS.

PFASD_PER_VERTEX_ATTR defines attributes for individual
vertices. Each vertex in ASD can have one attribute per
face. For example, to describe a very sharp edge, a vertex
can have more than 1 normals.
The attribute is defined in each pfASDFace structure.
The attr and sattr field are indices into the
units in the attribute array. They are morphed based on
the morph weight of the vertex.

3. When \f2which\fP is PFASD_OVERALL_ATTR, \f2attr\fP
points to a set of attributes describing the overall appearance of
the terrain. This attribute can be morphed as well.

Notice, there is only one PFASD_PER_VERTEX_ATTR attribute array
for each ASD, There is also only one OVERALL attribute array.
The terrain can not have both of them at the same time.
Whichever is defined last will be the effective appearance of
the terrain.
The attributes defined in \f2attr\fP do not have to be morphing
at the same time. User can require ASD to morph only the
color of each vertex but let vertex take on the final normal value.
See pfASDMorphAttrs for details.

4. \f2size\fP is the size of the input arrays.

5. ASD face pfASDFace description:

The terrain database consists of several layers of
triangle meshes that are organized as a tree.
For detailed explaination of the structure of the
database, please refer to Performer Programmer's Guide.
The vertices in each triangle must be arranged ccw. Let the three
vetices be vertex[0], vertex[1], and vertex[2]. The reference point i
locates between vertex[(i-1)%3] and vertex[i].
If the triangle is part of a triangle strip, then the vertices
should also be arranged such that vertex[2] is the vertex
used in the tstrip.

6. pfASDFace structure

.Ex
.nf

struct pfASDFace
{
    int level;
    int tsid;
    int vert[3];
    int attr[3];
    int refvert[3];
    int sattr[3];
    int child[4];
    ushort gstateid;
    ushort mask;
} ;
.Ee
.fi
.na


Each face has an unique entry in this array, and the index is
the faceID.
The LOD level in which this face is present is defined by level.
The coarsest LOD is level 0.
The entry tsid is the triangle strip ID of this face.
The vertices and reference points, vert[3] and refvert[3], are indices into
the coordinate array.
The attr is the attribute index of the vertex, and sattr is the
attribute index of the reference point.
The field child[4] is the 4 indices of the child nodes in the tree.
If any of the entries is missing, enter PFASD_NIL_ID in the field.
ASD takes on an array of geostates. Each face can point to 1
geostate. This is useful when the terrain has multiple
appearances, for example, multiple textures.
The gstateid is the index of the geostate.
A face can be rendered as a "hole", i.e. not drawn. This can
be described by setting mask to PFASD_FACE_NODRAW.
Although a face is rendered as a "hole", its virtual position can
still be queried. If the position of the face should not
be used is alignment query, OR the mask with bit value PFASD_FACE_NOQUERY.
If mask is 0, then the face is drawn regularly and queried regularly.

Notice that although the reference position and the final position
can be different for a vertex, they are all referenced by the same
index in the vertex array. Therefore the reference field in the
pfASDFace structure should be the same as the vert field in another
pfASDFace structure if they all refer to the same vertex.
It is very important that each vertex and face must have an
unique vertex ID and face ID.

OpenGL Performer provides a default evaluation function to
calculate the morph weight of each edge in the database.
When user chooses to use this function, a set of LOD switch ranges
needs to be entered.
When \f2which\fP is PFASD_LODS, \f2attr\fP is a pointer to the pfASDLODRange
lod array. \f2size\fP is the number of lod levels in the database.
The pfASDLODRange structure is

.Ex
.nf

struct pfASDLODRange
{
    float switchin;
    float morph;
} ;
.Ee
.fi
.na


Inside a pfASDLODRange structure, \f2switchin\fP is the "far" range.
If the distance from the eyepoint to the final position of a vertex of
a face at level i is less than switchin[i],
than the LODi edge associated with this vertex
will be replaced by edges from the next LOD. (See pfTerrainEvalMethod for more details).

The morphing distance \f2morph\fP decides how
close a vertex will morph to its final position. When the distance is less than
switchin[i] - morph[i], the vertex is completely morphed to
its final position.

The LOD range can be adjusted at run time. It could be adjusted based on
channel information, scene information, or stress, to name a few.

Among all the attributes, only LODRange can be changed at run time.
The rest of Attrs are "read-only" data, i.e., there is no
internal copies of the data. LODRange is copied internally,
and user can make changes on the copy of LODRange returned by
pfASDGetAttr.

TRIANGLE STRIPS

Mesh triangles in each individual LOD separately. Assign an unique tstrip ID
to each triangle. Make sure triangles in the same tstrip have contiguous
IDs. Tstrip ID ranges between tstrips are not continuous.
For example: tstrip (f1, f2, f3, f4) and tstrip (f6, f7, f8) might have IDs
like f1 = 10, f2 = 11, f3 = 12, f4 = 13; and f6 = 20, f7 = 21, f8 = 22.
but they can't have f1 = 10, f2 = 11, f3 = 12, f4 = 13; and f6 = 14, f7 = 15,
f8 = 16;

It is very important to start a tstrip on an even tstrip ID.
For example, triangles in the first tstrip can have IDs 0,1,2...;
but they can't have 1,2,3,...

Triangles will be sorted at run time by their tstrip ID to determine the meshing.
The field \f2tsid\fP in face structure is the tstrip ID.

\f3\%pfASD::setNumBaseFaces\fP
sets the total number of faces on the base (the coarsest) level of detail.
The faces on the first LOD (LOD0) must be listed at the beginning
of face array. Other faces can be listed in any order.
We recommand listing faces that are in the same LOD together.

\f3\%pfASD::setMorphAttrs\fP
sets the attributes to be morphed. \f2_mc\fP is a bit combination of
\f3\%PFASD_NORMALS\fP, \f3\%PFASD_COLORS\fP, or \f3\%PFASD_TCOORDS\fP.
The attributes set by the pattern will be morphed on a
per vertex per face level based on morphing weights.
If there is no attributes to be morphed, set \f2_mc\fP to
\f3\%PFASD_NO_ATTR\fP. If \f3\%pfASDMorphAttrs\fP is not called,
ASD morphes the PFASD_PER_VERTEX_ATTR attributes.

\f3\%pfASD::getMorphAttrs\fP
returns the bit mask that describes the morphing attributes.

\f3\%pfASD::setEvalMethod\fP

\f3\%pfASD::getEvalMethod\fP
method identifies the morphing weight calculation at each point.
\f3\%PFASD_DIST\fP makes morphing weight linear to the real distance.
.Ex
.nf

morphing weight = 1 - (switchin - dist)/morph;
.Ee
.fi
.na

\f3\%PFASD_DIST2\fP uses square of distance instead of real distance.
.Ex
.nf

morphing weight = 1 - (switchin - dist_square)/ (morph*morph);
.Ee
.fi
.na

\f3\%PFASD_DIST\fP is chosen by default. When \f3\%PFASD_DIST2\fP
is picked, the switchin and morph on each LOD is sqaured internally.
The input array of LODRange is left untouched.

\f3\%pfASD::getActiveGeom\fP
fills a pointer \f2_geom\fP to a List of pfGroup pointers which
contain the active geometry (active mesh) that is the result
of current ASD evaluation. Since ASD evaluation
is done on a per channel bases, the geometry
corresponds to that being displayed in that channel \f2chan\fP.
\f2geom\fP is a user allocated pfList * whose element is
a pfGroup pointer.

\f3\%pfASD::setGStates\fP
defines the pfGeoState list that is associated with pfASD.
Each triangle face in pfASD can take on a separate pfGeoState.
\f2gstateid\fP in the pfASDFace is an index into the
pfGeoState list \f2gs\fP. \f2num\fP is the size of the geostate list.
The active geometry generated by ASD evaluation are
sorted into GeoSets based on the GeoStates.
The GeoState list is not copied into pfASD internally.

\f3\%pfASD::getGStates\fP
returns the pointer to pfGeoState list and the size of the list.

\f3\%pfASD::getGState\fP
returns a particular pfGeoState in the pfGeoState list indexed by \f2num\fP.

\f3\%pfASD::getNumGStates\fP
returns the size of the pfGeoState list.

\f3\%pfASD::setLODState\fP associates the given pfASD and pfLODState.  This enables
the control of how a particular pfASD LODRange responds to stress and range.
\f3\%pfASD::getLODState\fP returns the pfLODState associated with pfASD if there
is one or NULL if one does not exist.
The LODState parameters rangeRangeA modifies the channel LODscale and rangeRangeB offsets the result. If you do not want channel LODscale to affect LODRange, simple set the parameter[rangeRangeA] to 0 and parameter[rangeRangeB] to 1.0. Similarly, parameters rangeFOVA and rangFOVB modefied the channel aspect ratio affects LODRanges. To disable the FOV influence on LODRange,
set parameter[rangeFOVA] to 0 and parameter[rangeFOVB] to 1.0. Currently, channel stress does not affect LODRanges.

\f3\%pfASD::setLODStateIndex\fP allows pfLODStates to be indexed on a
per channel
basis.  \f2index\fP is an index into an pfList of pfLODStates specified via
\f3\%pfChannel::setLODStateList\fP.
\f3\%pfASD::getLODStateIndex\fP returns the index currently specified for the pfASD
or -1 if no index has been specified.

\f3\%pfASD::setSyncGroup\fP
defines a group of fluxed objects that are associated with
pfASD geometry. These objects might be vehicles on the terrain,
or trees or houses on the terrain. By registering them
to the terrain, their properties will be update in sync with
the terrain position. The new properties will only be available
when new terrain geometry is generated.
The \f2_syncGroup\fP identifies the final objects,
e.g. z coordinates of trees, not any intermediate pfFluxes.

\f3\%pfASD::getSyncGroup\fP
returns the object group whose property is synchronized with
ASD evaluations.

\f3\%pfASD::enableClipRings\fP
turns on the clipring mode in pfASD for virtual cliptxture.
pfASD will sort the active mesh into several groups of
geometry each of which is inside one of the set of concentric
bounded rings around eye point.
Currently the concentric rings are bounded by switchin fields
in pfLODRange arrays. As eyepoint moves in application, the
coordinates of the rings change too in real-time. If the smallest
ring is not fine enough for the high resolution cliptexture, more rings
can be specified by enlarge the pfLODRange size.
Refer to pfdASDClipring.c for example. User needs to allocate
some additional LODRanges in order for pfASD to sort things
into cliprings.
Currently, this API is all that is needed to make
pfASD and virtual cliptexture work together.

\f3\%pfASD::setNumClipRings\fP
specifies the number of cliprings. This API is not active.

\f3\%pfASD::getNumClipRings\fP
return the number of cliprings. This API is not active.

\f3\%pfASD::setClipRings\fP
This API is not active.

\f3\%pfASD::getClipRings\fP
This API is not active.

\f3\%pfASD::setCalcVirtualClipTexParamsFunc\fP
User callback function to define the virtual cliptexture
parameters. The format is the same as the function in pfutil.

\f3\%pfASD::getCalcVirtualClipTexParamsFunc\fP
returns the user callback function that defines the virtual cliptexture
parameters.

\f3\%pfASD::setFaceBBoxes\fP
ASD keeps a bounding box tree that coresponds to
the pfASDFace tree. The bounding box of a face bounds all of
its possible positions and all the bounding boxes of its children.
User can enter a full bounding box array \f2_box\fP. The box with
index i is the bounding box of pfASDFace i. If \f2_box\fP is NULL,
ASD computes the bounding boxes.
Since faces are "read-only", ASD will not allocate internal
space if \f2_box\fP is not NULL.

\f3\%pfASD::getFaceBBoxes\fP
returns the pointer to the bounding box array.

Each bounding box of a particular face can be
set or queried by calling
\f3\%pfASD::setFaceBBox\fP or
\f3\%pfASD::getFaceBBox\fP.

\f3\%pfASD::config\fP
should be called after user has set all the
attributes of a pfASD node, i.e. face, vertices, attributes,
and basefaces. The routine computes the bounding box
array for the pfASD node and does other time consuming
data structure changes before the real-time evaluation starts.
The rountine should be called before alignment objects
are registered to this node.

\f3\%pfASD::setMaxMorphDepth\fP
restricts the ASD evaluation to be carried out
to certain LOD level with morphweight no less than
\f2_morphweightconstraint\fP. \f2_m\fP is the level, with base
level at LOD0. Notice that in ASD, morphweight 0 means
a vertex is in its fully morphed final position, and 1
means the vertex is in NO_MORPH, reference position.
Therefore a morph weight less than certain number implies
that the vertex is not morphed further than that constraint.
For example: \f2_m\fP is 4, \f2_morphweightconstraint\fP is 0.3
means the finest triangle possible in current active mesh is
from LOD 4, with its vertices at 0.3 away from
their final positions. Refer to asdfly/terrain.c for examples.
This API is useful for stress load control.

The maximum evaluation LOD depth and morphweightconstraint
can be queried using
\f3\%pfASD::getMaxMorphDepth\fP.


\f3\%pfASD::setEvalFunc\fP
\f3\%pfASD::getEvalFunc\fP
.Ex
.nf

typedef float (*pfTerrainEvalFuncType)(pfTerrain *mesh, int faceid, int refvertid).Ee
.fi
.na

The vertex in the database is evaluated by \f2eval\fP. \f2eval\fP is a user
defined callback function that returns a float between 0 and 1. 1 means
the edge in the current LOD associated with this vertex is not replaced.
Any number less than 1 means the
edge is replaced by 2 edges from the next LOD.
0 means the vertex is
at its final position.  A number in (0, 1) is used as the morph weight to
determine the position of the vertex by linearly interpolate
using its final position and its delta vector.

OpenGL Performer provides a default evaluation function which is purely based on
distance from the eyepoint to the final position of the new vertex
associated with the edge. The distance is compared with the range in
pfASDLODRange that is entered in \f3\%pfASDAttr\fP. The edge of a face on
lod level i is evaluated using range[i+1] in pfsLODRange.
To use the default evaluation function, do not call \f3\%pfASDEvalFunc\fP.

\f2pfASDEvalFuncType\fP takes as arguments \f2faceid\fP which identifies
the face of which the edge is evaluated. \f2refvertid\fP is the index of
the vertex whose reference position is on this edge.

\f3\%pfASD::initMask\fP

\f3\%pfASD::setMask\fP

\f3\%pfASD::clearAllMasks\fP
A set of routines to override the morphing of certain vertices or the
draw mode of certain faces. \f3\%pfASDInitMask\fP indicates whether
the user wants to override vertex mode or face mode. This call should be
made once before any override masks are set. \f2which\fP can be
PFASD_TRAV_VERTEX or PFASD_TRAV_FACE.
When \f2which\fP is PFASD_TRAV_VERTEX,
a vertex can be marked completely morphed or not allowed to morph by
setting \f2mask\fP to either PFASD_C_MORPH or PFASD_NO_MORPH respectively.\f2id\fP is the index of the vertex. If a vertex is marked PFASD_C_MORPH,
then all of vertices in its parent triangles are marked PFASD_C_MORPH
recursively. The result is the vertex will definitely be rendered at its
final position if it is within the culling polytope.
When \f2which\fP is PFASD_TRAV_FACE, a face can be rendered as a hole
by setting \f2mask\fP to PFASD_FACE_NODRAW. \f2id\fP is the index of the face
in the faces array.
\f3\%pfASDClearAllMasks\fP reset all the masks to 0.

\f3\%pfASD::setMorphWeight\fP

\f3\%pfASD::unsetMorphWeight\fP
can set the morph weight for any vertex. Notice that pfASD does not take care
of marking the associated vertices. Users are responsible for setting the
correct morphing weights for all the vertices involved to make sure the vertex
will be rendered. \f2vertid\fP is the index of the vertex, and \f2morphweight\fP is
the morphing weight that is between 0 and 1.

\f3\%pfASD::setCullEnlarge\fP
sets the culling frustum of ASD evaluation.
The FOV of this frutum is \f2fov\fP * FOV of viewing frustum.
The near clipping plane is moved closer the view point by \f2near\fP ratio.
Similarly, the far clipping plane is \f2far\fP * far clipping plane of viewing frustum.
This routine can be called at run time to adjust the culling
in response to load stress.

pfASD supports multi-resolution paging.
The format of a paging file is
.Ex
.nf

int numfaces
int numverts
/* numfaces of the following */
int faceid1
pfASDFace face <--- structure of the face faceid1
int faceid2
pfASDFace face <--- structure of the face faceid2
...
/* numfaces of the following */
pfBox box <-- face bounding box of faceid1
pfBox box <-- face bounding box of faceid2
...
/* numverts of the following */
int vertid1
pfASDVert vert <-- structure of vertex vertid1
int vertid2
pfASDVert vert <-- structure of vertex vertid2
...
.Ee
.fi
.na





\f3\%pfASD::isPaging\fP
returns TRUE is the pfASD node is paging database;
returns FALSE is all of the data is in memory.

\f3\%pfASD::isPageMaster\fP
Multiple ASD nodes can share paged database through cloning.
The node that initializes paging by calling pfASDInitPaging
is the pageMaster and is responsible for bringing in
data from disk. All other nodes will use the data
that is being paged.
This function returns TRUE if the node issues paging requests.

\f3\%pfASD::initPaging\fP
is called at data loading time to indicate this
node is going to be paging data.

\f3\%pfASD::setTileSize\fP
Every LOD of the database is subdivided into grided tiles.
Each tile is a rectangle in terrain. Tile in different LOD
has different size. This size is
measured in object space. \f2_tsize\fP is an array of
2 floats. The \f2_tsize[i]\fP is the dimension of
tiles in LODi. \f2_tsize[i][0]\fP is the length is
x dimension and \f2_tsize[i][1]\fP is that in y.
The size of the array should be number of LODs in pfASD.

\f3\%pfASD::getTileSize\fP
returns the pointer to the tilesize array.

\f3\%pfASD::setPageSize\fP
A page is a paging unit that contains
pfASDFaces and pfASDVerts that are located inside
a tile.
The paging is scheduled according to the paging
center, which currently is eyepoint projected onto
x-y plane, and offset defined by \f2_page\fP.
In any LODi, let paging center falls inside tile[x][y],
then the tiles to be resident in memory are
.Ex
.nf

tile[x-_page[i][0]][y-_page[i][1]], tile[x-_page[i][0]+1],[y-_page[i][1]],
...,
tile[x+_page[i][0]][y+_page[i][1]]
.Ee
.fi
.na

This paging is done for every LOD.

In the other words, we page in all tiles centered around
the paging center, with index offset within \f2_page\fP.

\f3\%pfASD::getPageSize\fP
returns the paging offset array.

\f3\%pfASD::setTotalTiles\fP
This function sets the total number of tiles in
the database. \f2_tilenum\fP is an array of 2 shorts.
The length of the array is number of LODs in pfASD.
The 2 shorts describe the number of tiles in
x and y dimension in that particular LOD.

\f3\%pfASD::getTotalTiles\fP
returns a pointer to the total tile size.

\f3\%pfASD::setMaxTileMemSize\fP
This function sets the maximum memory for a tile
among all the tiles in all the LODs.
\f2_tilefaces\fP is the maximum faces a tile can
possibly contain in the database. \f2_tileverts\fP
is the maximum vertices.

\f3\%pfASD::getMaxTileMemSize\fP
requires the maximum faces and vertices a tile
could contain in the database.

\f3\%pfASD::setOrigin\fP
This function sets the lower left corner
of each LOD in the database. \f2_min\fP is an
array of pfVec3 that describes the the corner
of tile[0][0] in each LOD.
This set of numbers is given in object space.

\f3\%pfASD::getOrigin\fP
queries the corners of each LOD.

\f3\%pfASD::setPageFname\fP
enters the basename of all paging files on disk.
Each file is a paging unit that refers
to a tile of a particular LOD in the database.
The filenames are constructed as
"basename%02d%03d%03d.asd".
the first 2 digits describes the LOD level.
the next 3 digits describes the tile index in
x dimension, and the last 3 digits describes
tile index in y dimension.
Notice the pageName is a simple pointer copy
instead of copy-by-value.

\f3\%pfASD::getPageFname\fP
returns the basename of paging files on disk.

\f3\%pfASD\fP supports queries for point location on the morphing surface. Given a
query point and a vector pointing downwards from that point, pfASD can calculate
the projection of this point in the specified down direction onto the surface.
Note that the projection of the query point may vary between frames according
to the morphing behavior of the pfASD surface. For each query point, \f3\%pfASD\fP
can calculate the position and plane normal at the projection point. Point
queries are relevant only in visible parts of the surface. pfASD does not
perform surface morphing evaluation outside of the culling frustum. pfASD faces
with a mask bit \f3\%PFTERRAIN_FACE_NOQUERY\fP set do not participate in the query
calculation. This way, the application can switch faces into or out of the
query mechanism. Note that \f3\%pfASD\fP does not exclude faces with the
\f3\%PFTERRAIN_FACE_NODRAW\fP bit set from the query calculation, therefore one can
turn a face off for drawing, replace it with some coplanar geometry, and
continue to query the original \f3\%pfASD\fP face.

\f3\%pfASD::addQueryArray\fP adds an array of query
points to pfASD. It expects two arrays of 3D vectors: \f2vertices\fP and
\f2down\fP containing \f2nofVertices\fP (x,y,z) triplets each.
pfASD calculates the results for each query point after it pfASD finished
its surface evaluation. Query results are reported by packing them into the
supplied pfFlux \f2_results\fP. \f2mask\fP specifies the type of query
results desired. It is a bitwise OR of the following constants:

.RS
.TP 5
\f3\%PR_QUERY_FRAME\fP
make the first 8 bytes in the returned array contain the time of the
view parameters for this query array result.
.TP
\f3\%PR_QUERY_RECORD_FRAME\fP
For each query point, store a \f3\%double word aligned\fP double precision float
containing the time of the view parameters when the query results for this
point were calculated. Note that the same query result array may contain query
results of different ages because when pfASD can not reply to a query, we
return the most recent query results for this point. pfASD can not reply to
queries about points outside the viewing frustum.
.TP
\f3\%PR_QUERY_POSITION\fP
- For each query point, store three floats containing x,y,z coordinates of the
projected point.
.TP
\f3\%PR_QUERY_NORMAL\fP
- For each query point, store three floats containing the surface normal at the
projection point.
.RE

Query point results are packed into the result array by storing all the results
for each point in the above order, following by all the result for the next
point. For example, for a \f2mask\fP of (\f3\%PR_QUERY_RECORD_FRAME\fP |
\f3\%PR_QUERY_FRAME\fP | \f3\%PR_QUERY_NORMAL\fP), For a query array containing three
query points, the returned query result pfFlux shall be packed as follows:
.PP
.TS
center tab($) ;
c | c .
Word$Contents
_
0$Frame Time (0)$
1$Frame Time (1)$
2$Record#0 Time(0)$
3$Record#0 Time(1)$
4$Normal#0 X$
5$Normal#0 Y$
6$Normal#0 Z$
7$Nothing (doubleword alignment)$
8$Record#1 Time(0)$
9$Record#1 Time(1)$
10$Normal#1 X$
11$Normal#1 Y$
12$Normal#1 Z$
13$Nothing (doubleword alignment)$
14$Record#2 Time(0)$
15$Record#2 Time(1)$
16$Normal#2 X$
17$Normal#2 Y$
18$Normal#2 Z$
.TE
.PP
\f3\%pfASD::addQueryArray\fP returns a unique number
identifying the query array. This number identifies this array for other
pfASD routines such as \f3\%pfASD::deleteQueryArray\fP.

\f3\%pfASD::deleteQueryArray\fP deletes a previously
added query point array. \f2index\fP is the number returned by
\f3\%pfASD::addQueryArray\fP.

\f3\%pfASD::getQueryArrayPositionSpan\fP
returns the maximum bounding box of all the query points in a query array
with the given index. This bounding box contains all the possible positions
of the query points for all possible surface morphing states.

\f3\%pfASD::containsQueryArray\fP takes an
array of 3D points, and a corresponding array of down vectors. It checks each
point individually and composes a result. Each point can be one of the
following:

.RS
.TP 5
1.
Projects on some level-zero face. For each face it projects onto, if this
face has higher level children, it projects on at least one of them (denote:
always contained).
.TP
2.
Projects on some level-zero face. There exists a face with children in the
pfASD structure, such that the point projects on the face but not on any of its
children or on the children of its direct neighbors (denote: maybe contained).
.TP
3.
Does not project on any level-zero face (denote: never contained).
.RE

The following table shows the returned values of
\f3\%pfASD::containsQueryArray\fP. The three
leftmost columns describe the results of the single point queries. If at least
one point returned a given value, its corresponding column is set to 1.

.TS
center tab($) ;
c | c | c | c .
Always$Maybe$Never$Returned
_
0$0$0$PFIS_FALSE
0$0$1$PFIS_FALSE
0$1$0$PFIS_MAYBE
0$1$1$PFIS_MAYBE
1$0$0$PFIS_MAYBE | PFIS_TRUE | PFIS_ALL_IN
1$0$1$PFIS_MAYBE | PFIS_TRUE
1$1$0$PFIS_MAYBE | PFIS_TRUE
1$1$1$PFIS_MAYBE | PFIS_TRUE
.TE

pfASD supports the projection and tessellation of triangles onto the currently
visible pfASD surface. The results of such queries are useful for casting
the shadow of objects on the pfASD surface, and for adding surface decals.
Similar to query vertices, the calculation of triangle query results ignores
\f3\%pfASD\fP faces with a mask bit \f3\%PFTERRAIN_FACE_NOQUERY\fP set.

\f3\%pfASD::addQueryGeoSet\fP adds the triangles in
a pfGeoSet to pfASD. \f2_gset\fP is a pfGeoSet containing triangle primitives.
The query result for each triangle is the projection (in direction \f2_down\fP)
of the triangle onto the current pfASD geometry, tessellated to match the
ASD surface tessellation. pfASD generates query results after evaluating its
own geometry. it stores the results in the pfFlux \f2_results\fP.

If \f2_results\fP is a fluxed pfGeoset,
\f3\%pfASD::addQueryGeoSet\fP stores results as pfGeoSet
attributes according to \f2_mask\fP (see below). It takes care of allocating
memory for NULL attributes, and reallocating it if it has too many result
triangles. It also sets the number of primitives in the pfGeoSet to the number
of triangle fragments in the query result.
The query mechanism generates pfGeoSet attributes ready for hooking
onto a pfGeode for drawing.  However, the query mechanism does not set any
other pfGeoSet attributes (e.g. Primitive type, Bounding box, pfGeoState,
any overall attributes).

The contents of the query results is determined by the type of information
requested. \f2_mask\fP specifies the type of query results desired. It is a
bitwise OR of the following constants:

.RS
.TP 5
\f3\%PR_QUERY_FRAME\fP
- Store the query frame as a double-word at the head of the result pfFlux
buffer.
.TP
\f3\%PR_QUERY_TRI_COORD\fP
- For each query triangle, store three floats containing x,y,z coordinates
of the projected point.
.TP
\f3\%PR_QUERY_TRI_TEXTURE\fP
- For each vertex in the tessellated projected triangle, store two floats
containing the interpolated texture coordinates at the projection point.
.TP
\f3\%PR_QUERY_TRI_COLOR\fP
- For each vertex in the tessellated projected triangle, store four floats
containing the interpolated RGBA color at the projection point.
.TP
\f3\%PR_QUERY_TRI_NORMAL\fP
- For each vertex in the tessellated projected triangle, store three floats
containing the interpolated normal at the projection point.
.RE

If \f2_results\fP is a fluxed pfGeoset, the bit \f3\%PR_QUERY_FRAME\fP is ignored.

The input pfGeoSet must contain the requested attributes.
An input number of triangles can generates many tessellated triangles,
In a regular result pfFlux, the query mechanism will generate triangles to fill
the input pfFlux without overflow. Any remaining triangles will be ignored.
It is the responsibility of the calling application to allocate a large enough
pfFlux buffer. Following is an example of the result flux format for regular
pfFlux result buffer (not a fluxed pfGeoSet):  If \f2_mask\fP is
\f3\%(PR_QUERY_FRAME | PR_QUERY_TRI_COORD | PR_QUERY_TRI_TEXTURE)\fP, the format
of the output pfFlux is (assume the query result contains two
triangles):

.PP
.TS
center tab($) ;
c | c .
Word$Contents
_
0$Frame Time (0)$
1$Frame Time (1)$
2$Number of result triangles (= 2)$
3$Vertex (Tri 0, v0, X)$
4$Vertex (Tri 0, v0, Y)$
5$Vertex (Tri 0, v0, Z)$
60$Texture (Tri 0, v0, s)$
7$Texture (Tri 0, v0, t)$
8$Vertex (Tri 0, v1, X)$
9$Vertex (Tri 0, v1, Y)$
10$Vertex (Tri 0, v1, Z)$
11$Texture (Tri 0, v1, s)$
12$Texture (Tri 0, v1, t)$
13$Vertex (Tri 0, v2, X)$
14$Vertex (Tri 0, v2, Y)$
15$Vertex (Tri 0, v2, Z)$
16$Texture (Tri 0, v2, s)$
17$Texture (Tri 0, v2, t)$
18$Vertex (Tri 1, v0, X)$
19$Vertex (Tri 1, v0, Y)$
20$Vertex (Tri 1, v0, Z)$
21$Texture (Tri 1, v0, s)$
22$Texture (Tri 1, v0, t)$
23$Vertex (Tri 1, v1, X)$
24$Vertex (Tri 1, v1, Y)$
25$Vertex (Tri 1, v1, Z)$
26$Texture (Tri 1, v1, s)$
27$Texture (Tri 1, v1, t)$
28$Vertex (Tri 1, v2, X)$
29$Vertex (Tri 1, v2, Y)$
30$Vertex (Tri 1, v2, Z)$
31$Texture (Tri 1, v2, s)$
32$Texture (Tri 1, v2, t)$
.TE
.PP

The current implementation supports queries of tessellated triangle vertex and
texture only. queries of tessellated color and normal will be added in the
future.

\f3\%pfASD::deleteQueryGeoSet\fP removes the query
pfGeoSet with index \f2_index\fP.

\f3\%pfASD::replaceQueryGeoSet\fP replaces the
query pfGeoSet with index \f2_index\fP by the input pfGeoset \f2gset\fP. It
also sets the down direction to \f2down\fP.

Notice, pfASD works in multipipe and multichannel environment. Please
refer to pfChannel for details.

.SH SEE ALSO
pfNode,
pfGeode,
pfFlux,
pfGeoState,
pfChannel,
pfdAlignVerticesToASD,
pfdProjectVerticesOnASD.
