'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfPipeVideoChannel" "3pf"
.SH NAME
.upperok
.B pfPipeVideoChannel
\- 
Multiprocessed video channel hookup for pfPipes, pfWindows, and pfChannels
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfWSVideoCha\ \ \ 'u
#include <Performer/pf/pfPipeVideoChannel.h>
.nf
.fi
.TP
\ 
\f3\%pfPipeVideoChannel::pfPipeVideoChannel\fP(pfPipe\ *pipe);
.nf
.fi
.TP
pfType *
\f3\%pfPipeVideoChannel::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::setAreaScale\fP(float\ s);
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::setCallig\fP(pfCalligraphic*\ callig);
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::setDVRMode\fP(int\ index);
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::setFullRect\fP(void);
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::setId\fP(int\ index);
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::setMode\fP(int\ mode,
'in +2
'll -2
int\ val);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::setOutputOrigin\fP(int\ xo,
'in +2
'll -2
int\ yo);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::setOutputSize\fP(int\ xs,
'in +2
'll -2
int\ ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::setScale\fP(float\ xs,
'in +2
'll -2
float\ ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::setStress\fP(float\ s);
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::setStressFilter\fP(float\ *frameFrac,
'in +2
'll -2
float\ *lowLoad,
float\ *highLoad,
float\ *pipeLoadScale,
float\ *stressScale,
float\ *maxStress);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::setWSWindow\fP(pfWSWindow\ wsWin);
.nf
.fi
.TP
float
\f3\%pfPipeVideoChannel::getAreaScale\fP(void);
.nf
.fi
.TP
pfCalligraphic*
\f3\%pfPipeVideoChannel::getCallig\fP(void);
.nf
.fi
.TP
int
\f3\%pfPipeVideoChannel::getDVRMode\fP(void);
.nf
.fi
.TP
int
\f3\%pfPipeVideoChannel::getId\fP(void);
.nf
.fi
.TP
float
\f3\%pfPipeVideoChannel::getLoad\fP(void);
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::getMinDecScale\fP(float\ *xs,
'in +2
'll -2
float\ *ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::getMinDeltas\fP(int\ *_dx,
'in +2
'll -2
int\ *_dy);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::getMinIncScale\fP(float\ *xs,
'in +2
'll -2
float\ *ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::getMinScale\fP(float\ *xs,
'in +2
'll -2
float\ *ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::getMaxDecScale\fP(float\ *xs,
'in +2
'll -2
float\ *ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::getMaxIncScale\fP(float\ *xs,
'in +2
'll -2
float\ *ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::getMaxScale\fP(float\ *xs,
'in +2
'll -2
float\ *ys);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfPipeVideoChannel::getMode\fP(int\ _mode);
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::getOutputOrigin\fP(int\ *xo,
'in +2
'll -2
int\ *yo);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::getOutputSize\fP(int\ *xs,
'in +2
'll -2
int\ *ys);
.in
.ll
.nf
.fi
.TP
pfPipe *
\f3\%pfPipeVideoChannel::getPipe\fP(void);
.nf
.fi
.TP
pfPipeWindow *
\f3\%pfPipeVideoChannel::getPWin\fP(void);
.nf
.fi
.TP
int
\f3\%pfPipeVideoChannel::getPWinIndex\fP(void);
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::getScale\fP(float\ *xs,
'in +2
'll -2
float\ *ys);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfPipeVideoChannel::getStress\fP(void);
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::getStressFilter\fP(float\ *frameFrac,
'in +2
'll -2
float\ *lowLoad,
float\ *highLoad,
float\ *pipeLoadScale,
float\ *stressScale,
float\ *maxStress);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::getSize\fP(int\ *xs,
'in +2
'll -2
int\ *ys);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfPipeVideoChannel::getScreen\fP(void);
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::getScreenOutputOrigin\fP(int\ *xo,
'in +2
'll -2
int\ *yo);
.in
.ll
.nf
.fi
.TP
pfWSVideoChannelInfo
\f3\%pfPipeVideoChannel::getPVChanInfo\fP(void);
.nf
.fi
.TP
pfWSWindow
\f3\%pfPipeVideoChannel::getWSWindow\fP(void);
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::apply\fP(void);
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::bind\fP(void);
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::unbind\fP(void);
.nf
.fi
.TP
void
\f3\%pfPipeVideoChannel::select\fP(void);
.nf
.fi
.TP
int
\f3\%pfPipeVideoChannel::isBound\fP(void);
.nf
.fi
.TP
int
\f3\%pfPipeVideoChannel::isActive\fP(void);
.fi

.Ex
.nf

/* typedef of X-based Performer Types */
typedef XSGIvcChannelInfo         *pfWSVideoChannelInfo;
.Ee
.fi
.na

.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfPipeVideoChannel\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfPipeVideoChannel\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfPipeVideoChannel\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

The \f3\%pfPipeVideoChannel\fP capability is used to direct the output of
pfChannels to different video outputs. A pfPipeVideoChannel is created
from a pfPipe and can only be used to manage video channels on the graphics
pipeline managed by the parent pfPipe. pfPipeVideoChannels are attached
to pfPipeWindows that cover their output area.  A pfPipeVideoChannel belongs
to one pfPipeWindow at a time and a pfPipeWindow may manage multiple
pfPipeVideoChannels.

pfPipeVideoChannels are similar to pfVideoChannels but are tracked/maintained by
libpf and are used by libpf to direct final rendering output of pfChannels
within a pfPipeWindow.
Because of their similarity, many of the pfPipeVideoChannel routines are
identical to pfVideoChannel routines accept for the fact that the
pfPVChan<*> routines
operate on a pfPipeVideoChannel and the pfVChan<*> routines operate on a
pfVideoChannels.  These corresponding routines are listed in the table below
and their functionality is documented in the pfVideoChannels man page.

.ne 34
.TS
center tab($);
C | C
L | L .
pfPipeVideoChannel routine$pfVideoChannels routine
_
pfPVChanAreaScale$pfVChanAreaScale
pfPVChanFullRect$pfVChanFullRect
pfPVChanId$pfVChanId
pfPVChanMinScale$pfVChanMinScale
pfPVChanMaxScale$pfVChanMaxScale
pfPVChanOutputOrigin$pfVChanOutputOrigin
pfPVChanOutputSize$pfVChanOutputSize
pfPVChanScale$pfVChanScale
pfPVChanWSWindow$pfVChanWSWindow
pfGetPVChanAreaScale$pfGetVChanAreaScale
pfGetPVChanId$pfGetVChanId
pfGetPVChanMaxScale$pfGetVChanMaxScale
pfGetPVChanMinDeltas$pfGetVChanMinDeltas
pfGetPVChanMinScale$pfGetVChanMinScale
pfGetPVChanMode$pfGetVChanMode
pfGetPVChanOrigin$pfGetVChanOrigin
pfGetPVChanOutputOrigin$pfGetVChanOutputOrigin
pfGetPVChanOutputSize$pfGetVChanOutputSize
pfGetPVChanScale$pfGetVChanScale
pfGetPVChanSize$pfGetVChanSize
pfGetPVChanScreen$pfGetVChanScreen
pfGetPVChanScreenOutputOrigin$pfGetVChanScreenOutputOrigin
pfGetPVChanInfo$pfGetPVChanInfo
pfGetPVChanWSWindow$pfGetVChanWSWindow
pfApplyPVChan$pfApplyVChan
pfBindPVChan$pfBindVChan
pfUnbindPVChan$pfUnbindVChan
pfIsPVChanBound$pfIsVChanBound
pfIsPVChanActive$pfIsVChanActive
pfPVChanMode$pfVChanMode
pfSelectPVChan$pfSelectVChan
.TE


\f3\%new pfPipeVideoChannel\fP creates and returns a handle to a
pfPipeVideoChannel.
pfPipeVideoChannels are always allocated from shared memory
and cannot be created statically, on the stack or in arrays.

\f3\%pfPipeVideoChannel::getClassType\fP returns
the \f3\%pfType\fP* for the class \f3\%pfPipeVideoChannel\fP.
The \f3\%pfType\fP* returned
by \f3\%pfPipeVideoChannel::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfPipeVideoChannel\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfPipeVideoChannel::setId\fP selects the hardware output
video channel for the pfPipeVideoChannel to use.
The output video channel of a pfPipeVideoChannel can be queried
with \f3\%pfPipeVideoChannel::getId\fP.
Care should be taken with hard-coding this number because these numbers
are not guaranteed to start at 0 or be sequential and have different meanings
on different hardware platforms.  pfPipeWindows by default will assign
their pfPipeVideoChannels to available hardware video channels.
Note that a video channel Id is relative to a screen and information about
a video channel cannot be known until the screen is known, either by having
it set explicitly on the parent pfPipe with \f3\%pfPipe::setScreen\fP
or pfPipeWindow  with  \f3\%pfPipeWindow::setScreen\fP
or having the pfPipeWindow opened and thus the screen being set implicitly.

\f3\%pfPipeVideoChannel::setMode\fP sets a given mode to
\f2val\fP where \f2mode\fP may be one of the following:
.RS
.TP
\f3\%PFVCHAN_SYNC\fP
sets the video boundary upon which changes to the video channel origin and
size should take effect: \f3\%PFVCHAN_SYNC_SWAP\fP for swapbuffers (the default)
and \f3\%PFVCHAN_SYNC_FIELD\fP for a field, or vertical retrace, boundary.
For resizing for load management, the default swapbuffers boundary is
usually appropriate. Allowing changes to the origin and size take
effect on the following field boundary allows the panning of video output
from the visible color buffer asynchronous to drawing and so should be used
in conjunction with the \f3\%PFVCHAN_AUTO_APPLY\fP mode and doing a
\f3\%select\fP on the pfPipeVideoChannel.
.TP
\f3\%PFVCHAN_AUTO_APPLY\fP
accepts a boolean value indicating if changes to \f2pvchan\fP should be
applied automatically, as opposed to waiting for
an explicit call to \f3\%apply\fP.  The changes
are not applied by the set routines because those routines may
be called from an asynchronous process.
On InfiniteReality changes to the video channel
must be applied by the draw process so these
are applied automatically by the DRAW process. The
\f3\%pfPipeVideoChannel::select\fP for
\f2pvchan\fP is done automatically by its pfPipe.  Only one
pfPipeVideoChannel can be actively \f3\%PFVCHAN_AUTO_APPLY\fP at
a time for a single pfPipe.
.RE
\f3\%pfPipeVideoChannel::getMode\fP will return the
value of the specified \f2mode\fP for \f2pvchan\fP.

\f3\%pfPipeVideoChannel::setDVRMode\fP sets the dynamic
video resizing mode to that specified by \f2mode\fP which may be one of:
.RS
.TP
\f3\%PFPVC_DVR_OFF\fP
to disable dynamic video resizing, the default.
.TP
\f3\%PFPVC_DVR_MANUAL\fP
to allow the manual specification of video channel resizing through
routines like
\f3\%pfPipeVideoChannel::setOutputSize\fP,
\f3\%pfPipeVideoChannel::setAreaScale\fP, and
\f3\%pfPipeVideoChannel::setScale\fP.
.TP
\f3\%PFPVC_DVR_AUTO\fP
allows the automatic dynamic resizing of video channels based
on the current load and stress filter of the pfPipeVideoChannel.
Dynamic resizing of pfPipeVideoChannel will only be done when
a stress filter has been specified with
\f3\%pfPipeVideoChannel::setStressFilter\fP
that includes a non-zero stress scale value.
.RE

\f3\%pfPipeVideoChannel::setMaxDecScale\fP
sets the maximum X and Y decrement scaling that can happen in a single
step of automatic dynamic video resizing. A scale value of (-1) removes
the upper bound on decremental scales and is the default.

\f3\%pfPipeVideoChannel::setMaxIncScale\fP
sets the maximum X and Y increment scaling that can happen in a single
step of automatic dynamic video resizing. A scale value of (-1) removes
the upper bound on incremental scales and is the default.

\f3\%pfPipeVideoChannel::setMinDecScale\fP
sets the minimum X and Y decrement scaling that can happen in a single
step of automatic dynamic video resizing.  The default value is 0.0.

\f3\%pfPipeVideoChannel::setMinIncScale\fP
sets the minimum X and Y increment scaling that can happen in a single
step of automatic dynamic video resizing.  The default value is 0.0.

\f3\%pfPipeVideoChannel::setStress\fP
sets the stress of the pfPipeVideoChannel for the current frame.
This call should be made in the application process after
pfSync and before pfFrame to affect the next immediate draw process frame.

\f3\%pfPipeVideoChannel::setStressFilter\fP
sets the parameters for computing stress, when not explicitly set for
the current frame by \f3\%pfPipeVideoChannel::setStress\fP,
for the pfPipeVideoChannel.
\f2frac\fP is the fraction of a frame period
the pfPipeVideoChannel is expected to take
to render.  \f2frac\fP should be 1.0 if only a single pfPipeVideoChannel is drawn
on a pfPipe and should be > 0.0 and < 1.0 when using multiple active
pfPipeVideoChannels.  \f2frac\fP allows the application to apportion rendering
time amongst multiple video channels so that a channel rendering complex
scenes may be allocated more time than a channel rendering simple ones.
\f3\%pfPipeVideoChannel::getStressFilter\fP
returns the stress filter parameters for
the pfPipeVideoChannel.
If \f2stressScale\fP is non-zero, stress is computed for the pfPipeVideoChannel
every frame.
\f2low\fP and \f2high\fP define a hysteresis band for system load.  When
load is >= \f2low\fP and <= \f2high\fP, stress is held constant.  When load
is < \f2low\fP or > \f2high\fP, OpenGL Performer will reduce or increase stress
respectively by dynamically resizing the output area of the pfPipeVideoChannel
until load stabilizes within the hysteresis band.  \f2low\fP
should be <= \f2high\fP and they both should be positive.  If \f2pipeLoadScale\fP
is non-zero, the load of the pfPipe of the pfPipeVideoChannel will be
considered in computing stress.
pfPipeVideoChannel stress is computed using the following algorithm:
.Ex
.nf

    pfPipeVideoChannel *pvchan;
    ......
    float vcLoad = pfGetPVChanLoad(pvchan);
    float pipeLoad = pfGetPipeLoad(pvchan);
    float stressLevel = pfGetPVChanStress(pvchan);
    float areaScale;

    /* consider pipe load for stress */
    if (pipeLoad > vcLoad)
	vcLoad += pipeLoadScale*(pipeLoad - vcLoad);
    else if (pipeLoad < vcLoad)
	vcLoad -= pipeLoadScale*(vcLoad - pipeLoad);


    /* scale by frac of proper draw time relative to 1 sec. */
    if (vcLoad > 0.0f)
    {
	if ((vcLoad <= lowLoad) || (vcLoad >= highLoad))
	{
	    scale = (1.0f / vcLoad);
	    if ((stressLevel > 0.0f) && (stressLevel != 1.0f))
		scale *= (1.0f / (stressLevel * stressLevel));
	    areaScale = scale * pfGetPVChanAreaScale(pvchan);
	}
	else
	{
	    stressLevel = 1.0f;
	    return;
	}
    }
    else
	areaScale = 1.0f;

    pfPVChanAreaScale(pvchan, areaScale);
.Ee
.fi
.na

The resulting computed scale value is then compared against the
limits on minimum and maximum overall scale values for the pfPipeVideoChannel,
as well as the limits on minimum and maximum incremental and
decremental scaling steps permitted in a single step.

\f3\%pfPipeVideoChannel::getLoad\fP
will return the last computed load for
the pfPipeVideoChannel.  The
load value is defined as time * frameRate / \f2frac\fP, where time is
the sum of the rendering times of the pfChannels drawing to the
pfPipeVideoChannel.

\f3\%pfPipeVideoChannel::getMaxDecScale\fP
returns the X and Y upper bounds on scaling decrements for
the pfPipeVideoChannel in \f2x\fP and \f2y\fP.

\f3\%pfPipeVideoChannel::getMaxIncScale\fP
returns the X and Y upper bounds on scaling increments for
the pfPipeVideoChannel in \f2x\fP and \f2y\fP.

\f3\%pfPipeVideoChannel::getMinDecScale\fP
returns the X and Y lower bounds on scaling decrements for
the pfPipeVideoChannel in \f2x\fP and \f2y\fP.

\f3\%pfPipeVideoChannel::getMinIncScale\fP
returns the X and Y lower bounds on scaling increments for
the pfPipeVideoChannel in \f2x\fP and \f2y\fP.

\f3\%pfPipeVideoChannel::getPipe\fP returns the parent pfPipe of
the pfPipeVideoChannel.
\f3\%pfPipeVideoChannel::getPWin\fP returns the
pfPipeWindow of the pfPipeVideoChannel.
\f3\%pfChannel::getPWinIndex\fP can be used to get the position
of a channel in its pfPipeWindow list.  A return value of (-1) indicates that the
pfPipeVideoChannel is not assigned to a pfPipeWindow.
pfPipeVideoChannels can be added or moved
to other pfPipeWindows via list style API on pfPipeWindows. See the
pfPipeWindow man page
for more information.

Example 1: How to set up a pfChannel, pfPipeVideoChannel, and pfPipeWindow
.Ex
.nf

    pfPipe *pipe = pfGetPipe(0);
    pfChannel *chan = pfNewChan(pipe);
    pfPipeWindow *pwin = pfNewPWin(pipe);
    pfPipeVideoChannel pvchan = pfNewPVChan(pipe);
    int index;

    /* select the screen of interest  - can be done here or implicitly through
     * the pfPipeWindow but no pfPipeVideoChannel queries can be done until the
     * screen is known
     */
    pfPipeScreen(pipe, 0);
    /* select output video channel; default is to find first active */
    pfPVChanId(pvchan, 0);
    /* assign the pfPipeVideoChannel to the pfPipeWindow */
    index = pfPWinAddPVChan(pwin, pvchan);
    /* assign the pfChannel to the video channel via its pfPipeWindow */
    pfChanPWinPVChanIndex(chan, index);
.Ee
.fi
.na


\f3\%pfPipeVideoChannel::select\fP makes \f2pvchan\fP
the current pfPipeVideoChannel in the process to have \f3\%PFVCHAN_AUTO_APPLY\fP
changes applied in the current process. This is done automatically in the DRAW
process for pfPipeVideoChannels that have \f3\%PFVCHAN_AUTO_APPLY\fP enabled.
The pfVideoChannel contained withint the pfPipeVideoChannel will be
selected. \f3\%pfGetCurVChan\fP will return a pointer to the current
pfVideoChannel.

\f3\%pfPipeVideoChannel::apply\fP will cause outstanding
changes to \f2pvchan\fP to be immediately applied to the selected
hardware video channel.  On InfiniteReality, changes to the video output origin
and size should be done in the DRAW process and so OpenGL Performer automatically
does an apply, if necessary, automatically at
the start of the frame.  The changes will then effect the video scan-out
of that immediate frame.  Changes made in the APP process between \f3\%pfSync\fP and
\f3\%pfFrame\fP will affect the next immediate DRAW process.

\f3\%pfPipeVideoChannel::setCallig\fP let you set the \f2callig\fP
to use for calligraphic lights points. \f3\%pfPipeVideoChannel::getCallig\fP
returns the pfCalligraphic in use. Please see the CALLIGRAPHIC section of pfChannel
for more information.

.SH NOTES


pfPipeVideoChannel functionality is not currently supported under Linux.

An XSGIvc video channel may only be bound to a single window at a time on the system.
Only  a single pfPipeVideoChannel may bind a hardware video channel.

On InfiniteReality, changes to video channel origin and size require an active graphics
context and so should be made in the DRAW to avoid a graphics context change which
can be expensive.

See the sample program /usr/share/Performer/src/pguide/libpr/C/queryvchan.c
for an example of how to query general video channel attributes.
See the sample program /usr/share/Performer/src/pguide/libpf/C/pvchan.c for
an example of basic pfPipeVideoChannel setup.
See the sample program /usr/share/Performer/src/pguide/libpr/C/vchan.c for
a basic resizing example using pfVideoChannels.

.SH SEE ALSO
pfDelete,
pfGetNumScreenVChans,
pfChannel,
pfPipe,
pfPipeWindow,
pfVideoChannel,
XSGIvc,
glXSGIvcQueryChannelInfo,
glXBindChannelToWindowSGIX.
