'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfdCombineLayers" "3pf"
.SH NAME
.upperok
.B pfdCombineLayers
\- 
Merge layer nodes together.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'void\ \ \ 'u
#include <Performer/pfdu.h>
.nf
.fi
.TP
void
\f3\%pfdCombineLayers\fP(pfNode\ *node);
.fi
.SH DESCRIPTION

\f3\%pfdCombineLayers\fP gathers sibling layers (\f3\%pfLayer\fP) together
into a single super-layer.  All bases are grouped together followed by
all the layers.

All layer nodes, both existing and newly created, are set to use the
\f3\%PFDECAL_LAYER_DISPLACE\fP style for rendering coplanar geometry.
.SH NOTES

The libpfdu source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
.SH SEE ALSO
pfLayer
