'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuTextureMemory" "3pf"
.SH NAME
.upperok
.B pfuShowTextureMemory,
.B pfuClearTextureMemory
\- 
Utilities for texture memory on Infinte Reality.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'void\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
void
\f3\%pfuShowTextureMemory\fP(PipeWindow\ *pw,
'in +2
'll -2
pfList\ *texList,
int\ format);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuClearTextureMemory\fP(void);
.fi
.SH DESCRIPTION

Get a snap shot of Infinte Reality texture memory with \f3\%pfuShowTextureMemory\fP
and clear texture memory with \f3\%pfuClearTextureMemory\fP.

\f3\%pw\fP is the pfPipeWindow where the texture banks will be displayed.

\f3\%texList\fP is a list of all textures thought to be loaded in texture memory,
such as returned by \f3\%pfuMakeTexList\fP.



\f3\%format\fP may be any of
\f3\%PFTEX_RGB_5\fP
\f3\%PFTEX_RGB_4\fP
\f3\%PFTEX_RGB5_A1\fP
\f3\%PFTEX_RGBA_4\fP
\f3\%PFTEX_IA_8\fP
\f3\%PFTEX_I_12A_4\fP
\f3\%PFTEX_I_8\fP
\f3\%PFTEX_I_16\fP
\f3\%PFTEX_IA_12\fP
\f3\%PFTEX_RGBA_8\fP
\f3\%PFTEX_RGB_12\fP
\f3\%PFTEX_RGBA_12\fP

.SH SEE ALSO
pfuMakeTexList,
pfPipeWindow,
pfTexture
