'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfCalligraphic" "3pf"
.SH NAME
.upperok
.B pfNewCallig,
.B pfGetCalligClassType,
.B pfCalligInitBoard,
.B pfCalligIsBoardInited,
.B pfGetCalligBoardMemSize,
.B pfGetCalligInfo,
.B pfGetCalligDeviceId,
.B pfCalligCloseBoard,
.B pfCalligQueryBoard,
.B pfCalligPartition,
.B pfCalligWaitForVME,
.B pfCalligWaitForVISI,
.B pfCalligSwapVME,
.B pfCalligChannel,
.B pfGetCalligChannel,
.B pfCalligMultisample,
.B pfGetCalligMultisample,
.B pfCalligProjMatrix,
.B pfGetCalligProjMatrix,
.B pfCalligIsInited,
.B pfCalligZFootPrintSize,
.B pfGetCalligZFootPrintSize,
.B pfCalligDrawTime,
.B pfGetCalligDrawTime,
.B pfCalligExposureRatio,
.B pfGetCalligExposureRatio,
.B pfCalligFilterSize,
.B pfGetCalligFilterSize,
.B pfCalligDefocus,
.B pfGetCalligDefocus,
.B pfCalligRasterDefocus,
.B pfGetCalligRasterDefocus,
.B pfCalligStress,
.B pfGetCalligStress,
.B pfCalligDownLoadSlewTable,
.B pfCalligUpLoadSlewTable,
.B pfCalligDownLoadGammaTable,
.B pfCalligUpLoadGammaTable,
.B pfCalligWin,
.B pfGetCalligWin,
.B pfCalligXYSwap,
.B pfGetCalligXYSwap,
.B pfSelectCallig,
.B pfGetCurCallig
\- 
Calligraphic Lights Points optional extension to OpenGL Performer
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfCalligraphic\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfCalligraphic *
\f3\%pfNewCallig\fP(void\ *arena);
.nf
.fi
.TP
pfType *
\f3\%pfGetCalligClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfCalligInitBoard\fP(int\ board);
.nf
.fi
.TP
int
\f3\%pfCalligIsBoardInited\fP(int\ board);
.nf
.fi
.TP
int
\f3\%pfGetCalligBoardMemSize\fP(int\ board);
.nf
.fi
.TP
LPB_info *
\f3\%pfGetCalligInfo\fP(int\ board);
.nf
.fi
.TP
int
\f3\%pfGetCalligDeviceId\fP(int\ board);
.nf
.fi
.TP
int
\f3\%pfCalligCloseBoard\fP(int\ board);
.nf
.fi
.TP
unsigned int
\f3\%pfCalligQueryBoard\fP(int\ board);
.nf
.fi
.TP
int
\f3\%pfCalligPartition\fP(int\ board,
'in +2
'll -2
size_t\ *allocate,
int\ n);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfCalligWaitForVME\fP(int\ board);
.nf
.fi
.TP
int
\f3\%pfCalligWaitForVISI\fP(int\ board);
.nf
.fi
.TP
void
\f3\%pfCalligSwapVME\fP(int\ board);
.nf
.fi
.TP
int
\f3\%pfCalligChannel\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
int\ board,
int\ channel);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetCalligChannel\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
int\ *board,
int\ *channel);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfCalligMultisample\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
int\ n);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetCalligMultisample\fP(pfCalligraphic*\ calligraphic);
.nf
.fi
.TP
void
\f3\%pfCalligProjMatrix\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
pfMatrix\ *projMat);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetCalligProjMatrix\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
pfMatrix\ *projMat);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfCalligIsInited\fP(pfCalligraphic*\ calligraphic);
.nf
.fi
.TP
void
\f3\%pfCalligZFootPrintSize\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
float\ size);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetCalligZFootPrintSize\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
float\ size);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfCalligDrawTime\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
float\ time);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetCalligDrawTime\fP(pfCalligraphic*\ calligraphic);
.nf
.fi
.TP
void
\f3\%pfCalligExposureRatio\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
float\ ratio);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetCalligExposureRatio\fP(pfCalligraphic*\ calligraphic);
.nf
.fi
.TP
void
\f3\%pfCalligFilterSize\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
unsigned\ int\ sizeX,
unsigned\ int\ sizeY);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetCalligFilterSize\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
unsigned\ int\ *sizeX,
unsigned\ int\ *sizeY);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfCalligDefocus\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
float\ defocus);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetCalligDefocus\fP(pfCalligraphic*\ calligraphic);
.nf
.fi
.TP
void
\f3\%pfCalligRasterDefocus\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
float\ defocus);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetCalligRasterDefocus\fP(pfCalligraphic*\ calligraphic);
.nf
.fi
.TP
void
\f3\%pfCalligStress\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
float\ stress);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetCalligStress\fP(pfCalligraphic*\ calligraphic);
.nf
.fi
.TP
int
\f3\%pfCalligDownLoadSlewTable\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
pfCalligSlewTableEnum\ offset,
pfCalligSlewTable\ Slew);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfCalligUpLoadSlewTable\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
pfCalligSlewTableEnum\ offset,
pfCalligSlewTable\ Slew);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfCalligDownLoadGammaTable\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
pfCalligGammaTableEnum\ offset,
pfCalligGammaTable\ Gamma);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfCalligUpLoadGammaTable\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
pfCalligGammaTableEnum\ offset,
pfCalligGammaTable\ Gamma);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfCalligWin\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
float\ xmin,
float\ ymin,
float\ width,
float\ height);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetCalligWin\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
float\ *xmin,
float\ *ymin,
float\ *width,
float\ *height);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfCalligXYSwap\fP(pfCalligraphic*\ calligraphic,
'in +2
'll -2
int\ flag)\ ;
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetCalligXYSwap\fP(pfCalligraphic*\ calligraphic);
.nf
.fi
.TP
void
\f3\%pfSelectCallig\fP(pfCalligraphic\ *calligraphic);
.nf
.fi
.TP
pfCalligraphic *
\f3\%pfGetCurCallig\fP(void);
.fi

.Ex
.nf

typedef enum {
    pfXSlewQuality0 = 0,
    pfXSlewQuality1 = 1,
    pfXSlewQuality2 = 2,
    pfYSlewQuality0 = 3,
    pfYSlewQuality1 = 4,
    pfYSlewQuality2 = 5,
    pfDefocusQuality0 = 6,
    pfDefocusQuality1 = 7
} pfCalligSlewTableEnum;

typedef float pfCalligSlewTable[256][256];

typedef enum {
    pfRedGammaTable = 0,
    pfGreenGammaTable = 1,
    pfBlueGammaTable = 2
} pfCalligGammaTableEnum;

typedef float pfCalligGammaTable[1024];
.Ee
.fi
.na

.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfCalligraphic\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfCalligraphic\fP.
Casting an object of class \f3\%pfCalligraphic\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfCalligraphic\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'calligraphic\ \ 'u
\f2calligraphic\fP
identifies a pfCalligraphic.
.TP
\f2Slew\fP
identifies a pfCalligraphicSlewTable
.TP
\f2Gamma\fP
identifies a pfCalligraphicGammaTable
.SH DESCRIPTION

The pfCalligraphic object is a \f3\%libpr\fP data structure that is used,
in conjunction with a pfLPointState, to control the calligraphic light
point features in OpenGL Performer. Calligraphic light points require a
calligraphic light point board (LPB) with it's low-level device driver,
a calligraphic display system, and special cables between the
InifiniteReality raster manager boards and the LPB. If you do not have
this specific optional hardware, you are limited to raster light
points, as supported by the pfLPointState extension to the pfGeoState.

The main difference between the usual raster display and a calligraphic
display is that the number of lights that can be displayed is
proportional to the time preallocated for the calligraphic display in
the video format.  No more points can be displayed once the Vsync point
is reached so the LPB must stop its drawing, returning control back to
the raster display no matter how many points were still waiting for
calligraphic display.

An other main difference is that an error in a program or an invalid
parameter specified in a pfCalligraphic object may have a \f3\%destructive
effect\fP on the (often very expensive) calligraphic projector or the
light point board.

pfCalligraphic support provides advanced functions to manage
calligraphic light points such as using raster lights instead of
calligraphic lights based on user-specified significance, allowing
delayed computation in a hybrid video format and returning detailed
information of the previous frame for a good feedback loop.

The light point computation, and especially the calligraphic light
point computation, is a sensitive (sometimes proprietary) part of a
simulator.  The design of pfCalligraphic and pfLPointState processing
allows the user to implement their own algorithms using a pre or post
processing callback.

.SS LPB Hardware Configuration

LPB are fully supported only on InfiniteReality systems. The LPB is a
9U VME board that is connected to a IR pipe through the following links:

.RS

.TP
o The VME bus is used to transfer all the lights points to the LPB,
including the color, focus, exposure time, quality and position of
each light point.
.TP
o The VISI bus is used to transfer the Z\-buffer comparison result
from the graphic pipe to the LPB. Each Light Point have a unique Id
sent to the pipe which is transferred back to the LPB with the number
of visible samples. The VISI bus is a connector on each RM board, the
LPB must be connected to all RMs board (1,2 or 4).
.TP
o The video, including vertical and horizontal synchronization signals.
The LPB uses these signals to trigger the display of calligraphics.
.TP
o The Swap Ready signal. This signal is used to tell the LPB that the
raster display has swapped, so it should also swap it's internal
buffers. If the LPB does not get a Swap Ready acknowledgement, the LPB
will redisplay the same calligraphic light points at each Vsync (since
the raster frame is being repeated, so must the calligraphic lights be
unchanged).
.RE

\f2Only one light point board is supported per pipe\fP. The LPB is
connected to all the Video Channels produced by a single pipe.

The board may be used in a system without a VISI bus (systems prior to
IR), in which case no Z-buffer information will be given to the board,
so all points will be 100% visible.

Calligraphic computation is a very CPU consuming process, and does a
lot of Kernel calls through the LPB VME driver. It is recommanded that
at least one CPU is dedicated on a system per LPB. The process creation
and synchronization is automatically handled in libpf when giving
\f3\%PFMP_FORK_LPOINT\fP to pfMultiprocess before calling pfConfig. It is
based on the display list preprocessing capacity introduced in OpenGL
Performer 2.2.

A special environment variable PF_LPOINT_BOARD may be used when one wants
to try pfCalligraphics without a light point board. In this mode all the
computations will be performed, and raster light points will be displayed
with the following limitations:
.RS
.TP
o focus as no effect on simulated display
.TP
o every light point have the same size, defined by the Z-footprint
.RE

.SS LPB Initialization

Each LPB must be initialized before any fork() or sproc() call. This
means they must be initialized before calling pfConfig() when using
libpf. Each board is initialized by
\f3\%pfCalligInitBoard\fP
with \f2board\fP the number of the board. As there is one board per pipe,
the board number is also the pipe number.

This call will open the LPB device "/dev/lpb%" (% is the board #) and
get the current configuration. The configuration of the board is not
available through libpr, and all Calligraphic channels have to be
enabled before using the LPB utilities.

This function returns TRUE in case of success, FALSE otherwise.
\f3\%pfCalligIsBoardInited\fP can be
used to check if the board has been initialized.

\f3\%pfGetCalligInfo\fP returns a pointer to
the info structure maintained by the LPB driver. \f3\%LPB_info\fP is defined as an
unknown structure in 'pr.h'. In order to use the correct definition of this
structure, one must include the driver 'lpb.h' file \f3\%before\fP any OpenGL Performer
includes files. This file is not distributed with OpenGL Performer, it is part of
the LPB driver distribution.

\f3\%pfGetCalligDeviceId\fP returns the
device Id returned by the open() call done by libpr.

\f3\%pfCalligCloseBoard\fP close the
driver and the initBoard function has to be called again in order to use
calligraphic light points again. This function can be used in a test
routine that just look if a board is there by using initBoard and
then closeBoard.

\f3\%pfCalligQueryBoard\fP returns a
bit mask indicating which channels are enabled on a board. A return
of 0 is returned if there is no board, or if no channel is enabled,
in either case no calligraphic light points can be used on this pipe.
If the board is not opened, the this function will open and then
close the board, so it can be used anytime, like other pfQuery functions.

Once a board is initialized, it has to be partitioned. Each enabled
channel on the LPB are given an equal amount of Light Point Memory at
initialization.
\f3\%LcpfCalligPartition\fP can be
used to set up an other partition. This function accepts an array of
type int specifying how many bytes of memory should be allocated for
each channel. The size of the LPB memory is given by
\f3\%pfCalligraphic::getBoardMemSize\fP
and is reported in bytes.

.SS LPB Synchronization

As described above, the LPB is connected to the VME bus and the VISI
bus. Both buses contain information for the light points that are
buffered in the LPB. The SwapReady connection to the graphic pipe tells
the board when the transfer on the VISI bus is finished, and that we
should display the next Frame at the next VSync.
\f3\%pfCalligSwapVME\fP does the same
for the VME bus.

In a calligraphic-only video mode, the VME bus swap command should be
issued before the graphic pipe swapbuffer command because the LPB
starts displaying the lights as soon as the next Vsync. But in hybrid
mode, this allow the LPB to use some of the raster display time to
catch up with delayed VME transfers.

If the VME bus swap is too late, the LPB will not wait for the command
and raise a TOO_LATE error exception. pfCalligraphic handle that
problem and ensure that the LPB buffers always contain valid data even
if such an event occurs.

The LPB needs some time before being able to accept new information on
the VME and the VISI bus after receiving the corresponding swap
command.
\f3\%pfCalligWaitForVME\fP
and
\f3\%LcpfCalligWaitForVISI\fP
are used to wait for the board to be ready before sending new
information to the board.

All of this synchronization mechanism is handled automatically in libpf.
Note that if you use calligraphics, and you do also use directly
\f2pfSwapPWinBuffers\fP, then you will have to do a VME swap to keep the
board in sync, or issue 2 VME swap after a series of WIN swap to resynchronize
the LPB.

.SS Initializing a Calligraphic Channel

If the LPB can be initialized in libpr, and some channels have been
enabled
when its video format has been programmed, a pfCalligraphic object can be
created \f3\%pfNewCallig\fP, and mapped
to on channel on one LPB using \f3\%pfCalligChannel\fP.
This function returns TRUE in case of success, FALSE otherwise.
\f3\%pfGetCalligChannel\fP or
\f3\%pfCalligIsInited\fP can be
used to check if the pfCalligraphic is well initialized. More than one
pfCalligraphic can be mapped to the same LPB video channel, but they cannot
be processed in parallel.
Once mapped, any changed made to a pfCalligraphic is immediately transmitted
to the driver.

\f3\%pfCalligMultisample\fP is
used
to tell the pfCalligraphic how many multisample are used in the corresponding
video channel. \f3\%pfGetCalligMultisample\fP
returns the current setting. This call is automatically done by libpf to
tell the current pfCalligraphic how many multisample are used in the
current window, only direct libpr users have to use that function.

\f3\%pfCalligProjMat\fP is used by libpf
to give a projection matrix to use when sending the calligraphic footprint
to the pipe when this matrix should not be identity. It is the case when
DVR is in use. \f3\%pfCalligGetProjMat\fP
copy the current projMatrix at the address specicied as an argument.

\f3\%pfCalligDownLoadSlewTable\fP
and
\f3\%pfCalligDownLoadGammaTable\fP
respectively loads a slew table and a gamma table in the LPB.
There are \f3\%pfSlewTableEnum\fP (8) slew tables and \f3\%pfGammaTableEnum\fP (3) Gamma table per channel.

Some projectors do not need Slew Tables and/or Gamma Tables. A default gamma
and Slew table are loaded in the LPB by the driver at the initialisation of the
system. The tables stay loaded until a new call to \f3\%pfCalligDownLoadXX\fP
is done, but they will not survive a power off of the system.

\f3\%pfCalligUpLoadSlewTable\fP
gives back the slew table for the \f2offset\fP.  A slew value is given in
nanoseconds, and converted to the LPB internal representation.  A gamma
value is a normalize floating point number [0,1].  Be aware that not
all values may have a meaning for the LPB/Projector component. Refers
to the LPB and projector documentation.

A default generic (slow) Slew Table is loaded in the LPB when
initializing the board.  A linear ramp is preprogrammed as a GammaTable
(gamma = 1).

\f3\%pfCalligZFootPrintSize\fP
gives the diameter in pixels of the footprint sent to the graphic pipe
for the Z buffer test. It is required that the foot print covers at
least 4 multisamples. The default value is 4 pixels, giving for a 8
multisample configuration a total of (PI*4*4/4*8) 100 multisamples for a
100% visible point.

A light point that covers less than 4 multisamples is considered not
visible at all. A light point cannot cover more than 255 multisamples, as
the light point board register is 8 bits. Anyway, the coverage should
be limited to 100 multisamples as after this size, OpenGL uses an approximation of a point using a triangle fan, that does not provide a perfect circle and may result in slight blinking effects.

\f3\%pfGetCalligZFootPrintSize\fP
gives back the current setting.

\f3\%pfCalligWin\fP set the
pfCalligraphic range for the 2D coordinate system accepted by the
projector and the LPB. Default values are for an EIS projector,
please refers to the projector documentation if you are using a
different projector. You can also use the Win to draw in a smaller
area than the full screen in case you whant to have multiple
calligraphic channel on the same projector.
Negative numbers can be used if the axis are reversed on the
projector, and the projector do not have a INVERT option.

\f3\%pfGetCalligWin\fP gives
back the current setting.

\f3\%pfCalligXYSwap\fP let you
exchange the X and Y axis if it is needed for your projector.
\f3\%pfGetCalligXYSwap\fP returns
the current setting.

The formulas used to compute the projector coordinates from
the 2D coordinates are:
Xp = ax * X + bx;
Yp = ay * Y + by;

with:
ax = (-width)/2.;
bx = (xmin+width/2.);
ay = (height/2.);
by = (ymin+height/2.);

.SS Calligraphic parameters

\f3\%pfCalligDrawTime\fP set the
draw time of the calligraphic lights points. Changing this value result
in a global change in the intensity, but also in the number of
Calligraphic Light Points drawable in a video field, as each point
takes more time to draw.
\f3\%pfGetCalligDrawTime\fP
returns the current setting.

Draw times are given in nano seconds, and are scaled to the projector
values dividing by the exposureRatio. The by default value is for
a EIS projector, please refers to the projector documentation if
you want to change the \f2ratio\fP using
\f3\%pfCalligExposureRatio\fP.
\f3\%pfGetCalligExposureRatio\fP
returns the current settings.


\f3\%pfCalligFilterSize\fP set
the Calligraphic debunching filter.
\f3\%pfGetCalligFilterSize\fP
returns the current values.

\f2sizeX\fP and \f2sizeY\fP gives the size of the filter in the 2D
coordinate system defined by the pfCalligraphic viewport. If two consecutive Light
Points are separate by less than the filter size, the one that have the
lowest intensity is removed. Filter is not active is both sizes are
less or equal to 1. Filter is always done after the callbacks (see the
pfLPointState extension below)

\f3\%pfCalligDefocus\fP set the
requested defocus value for the light points. (see the pfLPointState
extension below)
\f3\%pfGetCalligDefocus\fP returns
the current setting.

\f3\%pfCalligRasterDefocus\fP
set the defocus for the Raster part of the Hybrid projector.
\f3\%pfGetCalligRasterDefocus\fP
returns the current value.

The defocus result is very dependent of the LPB/projector system used.
No rule can be givent here for the setting of this value, refers to the
LPB and projector documentation.

\f3\%pfCalligStress\fP sets the
current Calligraphic Stress. If a Calligraphic light point does not
pass the stress test, it will be drawned as a Raster light point. (see
the plLPointState extension below)
\f3\%pfGetCalligStress\fP returns
the current setting.

When using libpf, the calls to change the Calligraphic parameters can
be done in the LPoint process callback function with
\f3\%pfChanTravFunc\fP(chan, PFTRAV_LPOINT,
LpointFunc)

.SS Preprocessing a DL in a Process

Calligraphic light points require a fair amount of CPU. To add
calligraphic light points to an application, OpenGL Performer uses the
Display List preprocessing capacity is a separate process that runs in
parallel with the Draw Process.

Use \f3\%pfSelectCallig\fP to select on which channel of which LPB
the calligraphic light points have to be sent. See \f3\%pfDispList\fP man
pages for a complete description of Display List preprocessing.

\f3\%pfGetCurCallig\fP returns the current selected calligraphic.

.SS Extension to pfLPointState

Calligraphic lights points is an extension to the pfLPointState. Every
field in a pfLPointState should be correctly filled before adding the
Calligraphic capability. So a pfLPointState that have a Calligraphic
capability can be rendered either in Raster or Calligraphic mode.

Extensions to the pfLPointState Mode:
.TP
\f3\%PFLPS_DRAW_MODE\fP  /* Enable calligraphic drawing */
.br
\f3\%PFLPS_DRAW_MODE_RASTER\fP - Default value: raster only
.br
\f3\%PFLPS_DRAW_MODE_CALLIGRAPHIC\fP - Draw in Calligraphic mode


.TP
\f3\%PFLPS_QUALITY_MODE\fP   /* Set the quality of draw */
.br
\f3\%PFLPS_QUALITY_MODE_HIGH\fP - Use High Quality Slew Tables
.br
\f3\%PFLPS_QUALITY_MODE_MEDIUM\fP - Use Medium Quality Slew Tables
.br
\f3\%PFLPS_QUALITY_MODE_LOW\fP - Use Low Quality Slew Tables

.TP
\f3\%PFLPS_DEBUNCHING_MODE\fP   /* Enable calligraphic debunching */
.br
\f3\%PFLPS_DEBUNCHING_MODE_ON\fP - Turn on the debunching (see FilterSize)
.br
\f3\%PFLPS_DEBUNCHING_MODE_OFF\fP - Turn off debunching

.TP
Extensions to the pfLPointState Vals:
.TP
\f3\%PFLPS_SIGNIFICANCE\fP give the significance of the light points.  This
value is compared to the pfCalligraphic stress value, and if the
significance value is higher than the stress value, then the light goes
calligraphic. If not, it will be drawned as regular raster lights.

.TP
\f3\%PFLPS_MIN_DEFOCUS\fP set the min defocus value for the light points.
.TP
\f3\%PFLPS_MAX_DEFOCUS\fP set the max defocus value for the light points.

The pfCalligraphic defocus value is clamped against those min and max
defocus values.

When using libpf and in order to optimize the drawing time of the
calligraphic light points, it is recommended to set the draw order of
each GeoSet attached to a pfLPointState. The lpoint process creates the
\f3\%PFSORT_LPSTATE_BIN\fP that have the \f3\%PFSORT_DRAW_ORDER\fP sort that
use directly the draw order set in the pfGeoSet. See pfGeoSet and
pfChannel man pages.

.SS Callbacks

The Calligraphic callback function is set through the
\f3\%pfLPointState\fP.

As for the pfLPointState callbacks, pfCalligraphic callbacks can be
done before or after the standard computation by choosing the
\f3\%PFLPS_CALLBACK_MODE_PRE\fP or \f3\%PFLPS_CALLBACK_MODE_POST\fP mode.

The callback function receive many arguments (as defined in pr.h):
.Ex
.nf


typedef struct {
        pfLPointState   *lpstate;  /* Read Only LPState */
        pfGeoSet        *geoset;   /* Read Only GeoSet */
        void            *userData; /* Provided when setting the callback */
        unsigned short  *index;    /* Read Write - index of visible lpoints */
        int             *n;        /* Read Write - number of visible lpoints */
        pfVec3          *coords2D; /* Read Write - screen space X,Y,Z */
        float           *intensity;/* Write Only - resulting intensity */
        float           **focus;   /* Write Only - optional per lpoint (de)focus */
        float           **drawTime;/* Write Only - optional per lpoint drawTime */
} pfCalligData;

.Ee
.fi
.na


\f2lpstate\fP, \f2geoset\fP, \f2userData\fP are defined just like in the raster callback
(see man pfLPointState).

But in the case of pfCalligraphic, a 2D projection and clipping to the
calligraphic viewport is always done. So the callback has also access
to:
.TP
o \f2coords2D\fP the screen space (X,Y,Z) coordinate of the vertices after the
OpenGL transformations, including the projection matrix.
.TP
o \f2index\fP the indirection vector, that give the list of non clipped points. The
order of points in the indirection vector may be changed, so the user
callback can do a screen sort.
.TP
o \f2n\fP the number of elements to that indirection vector, that write-able,
so the callback can eliminate some lpoints. One can use it to do it's own
debunching and disable the one done by Performer.

Some post processing is also always done. The filter is called, it can
be disabled by setting the filter sized to 1.

Then the computed lpoints have to be sent to the LPB and to the graphic
pipe if a VISI bus is available. Two more options are given to the
Callback:

.TP
o returning a non null pointer to an array of \f2focus\fP values allow each
individual lights in the pfGeoSet to have a different defocus value
instead of using the standard min and max clamping. For drawing
performance materm it is not recommanded to set a different value to
each point, but this can be used for special effects such as local
windscreen wipers.
.TP
o returning a non null pointer to an array of \f2drawTime\fP values allow
each individual lights in the pfGeoSet to have a different drawTime
value instead of the fixed value given in the pfCalligraphic. This may
be necessary for some very fine tuning, such as required but the FAA
regulation.

The \f2focus\fP and \f2drawTime\fP arrays are not allocated by OpenGL Performer. It is safe
not to allocate them from the Shared Memory, but not from the stack of the Callback
function. To return defocus values, simply change the \f2focus\fP pointer to where the
defocus values are.

.SH NOTES


pfCalligraphic functionality is not supported under Linux.

EIS is short for Electronic Image Systems, Inc. 600 Bellbrook Avenue, Xenia, OH 45385 USA.
Returning a negative alpha cause Performer to use the BackColor in the
\f2pfLPointState\fP and -alpha as the alpha value.

The filtering algorithm is active within a pfGeoSet, not filtering occurs between points
that are not in the same geoset.

The GeoSet used for calligraphics has to have a color setting, otherwise this
will result in a core dump of the lpoint process.

.SH SEE ALSO
pfChannel,
pfConfig,
pfDispList,
pfGeoSet,
pfGeoState,
pfLPointState,
pfMultiprocess,
pfState
