'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfChannel" "3pf"
.SH NAME
.upperok
.B pfNewChan,
.B pfGetChanClassType,
.B pfGetChanPipe,
.B pfChanViewport,
.B pfGetChanViewport,
.B pfGetChanOrigin,
.B pfGetChanSize,
.B pfChanLODState,
.B pfGetChanLODState,
.B pfChanLODStateList,
.B pfGetChanLODStateList,
.B pfGetChanPWinIndex,
.B pfGetChanPWin,
.B pfChanTravFunc,
.B pfGetChanTravFunc,
.B pfAllocChanData,
.B pfChanData,
.B pfGetChanData,
.B pfGetChanDataSize,
.B pfPassChanData,
.B pfClearChan,
.B pfAttachChan,
.B pfDetachChan,
.B pfASDattachChan,
.B pfASDdetachChan,
.B pfChanShare,
.B pfGetChanShare,
.B pfChanFOV,
.B pfGetChanFOV,
.B pfChanNearFar,
.B pfGetChanNearFar,
.B pfChanAutoAspect,
.B pfGetChanAutoAspect,
.B pfGetChanBaseFrust,
.B pfGetChanPtope,
.B pfMakePerspChan,
.B pfMakeOrthoChan,
.B pfMakeSimpleChan,
.B pfGetChanFrustType,
.B pfChanAspect,
.B pfGetChanAspect,
.B pfOrthoXformChan,
.B pfGetChanNear,
.B pfGetChanFar,
.B pfGetChanEye,
.B pfApplyChan,
.B pfChanContainsPt,
.B pfChanContainsSphere,
.B pfChanContainsCyl,
.B pfChanContainsBox,
.B pfChanCullPtope,
.B pfGetChanCullPtope,
.B pfChanPick,
.B pfChanNodeIsectSegs,
.B pfChanScene,
.B pfGetChanScene,
.B pfChanESky,
.B pfGetChanESky,
.B pfChanGState,
.B pfGetChanGState,
.B pfChanGStateTable,
.B pfGetChanGStateTable,
.B pfChanStressFilter,
.B pfGetChanStressFilter,
.B pfChanStress,
.B pfGetChanStress,
.B pfGetChanLoad,
.B pfChanTravMode,
.B pfGetChanTravMode,
.B pfChanTravMask,
.B pfGetChanTravMask,
.B pfChanBinSort,
.B pfGetChanBinSort,
.B pfChanBinOrder,
.B pfGetChanBinOrder,
.B pfGetChanFreeBin,
.B pfChanView,
.B pfGetChanView,
.B pfChanViewMat,
.B pfGetChanViewMat,
.B pfChanViewOffsets,
.B pfGetChanViewOffsets,
.B pfGetChanOffsetViewMat,
.B pfGetChanFStats,
.B pfChanStatsMode,
.B pfDrawChanStats,
.B pfChanLODAttr,
.B pfGetChanLODAttr,
.B pfChanProjMode,
.B pfGetChanProjMode,
.B pfGetChanPVChan,
.B pfChanPWinPVChanIndex,
.B pfGetChanPWinPVChanIndex,
.B pfChanOutputViewport,
.B pfGetChanOutputViewport,
.B pfGetChanOutputOrigin,
.B pfGetChanOutputSize,
.B pfChanPixScale,
.B pfGetChanPixScale,
.B pfChanMinPixScale,
.B pfGetChanMinPixScale,
.B pfChanMaxPixScale,
.B pfGetChanMaxPixScale,
.B pfChanCallig,
.B pfGetChanCallig,
.B pfGetChanCurCallig,
.B pfChanCalligEnable,
.B pfGetChanCalligEnable,
.B pfApp,
.B pfCull,
.B pfDraw,
.B pfLPoint,
.B pfDrawBin,
.B pfDrawScene,
.B pfNodePickSetup
\- 
Set and get pfChannel definition parameters.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfPipeVideoChan\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfChannel *
\f3\%pfNewChan\fP(pfPipe\ *pipe);
.nf
.fi
.TP
pfType *
\f3\%pfGetChanClassType\fP(void);
.nf
.fi
.TP
pfPipe *
\f3\%pfGetChanPipe\fP(const\ pfChannel\ *chan);
.nf
.fi
.TP
void
\f3\%pfChanViewport\fP(pfChannel*\ chan,
'in +2
'll -2
float\ l,
float\ r,
float\ b,
float\ t);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanViewport\fP(const\ pfChannel*\ chan,
'in +2
'll -2
float*\ l,
float*\ r,
float*\ b,
float*\ t);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanOrigin\fP(const\ pfChannel*\ chan,
'in +2
'll -2
int\ *xo,
int\ *yo);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanSize\fP(const\ pfChannel*\ chan,
'in +2
'll -2
int\ *xs,
int\ *ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfChanLODState\fP(pfChannel*\ chan,
'in +2
'll -2
const\ pfLODState\ *ls);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanLODState\fP(const\ pfChannel*\ chan,
'in +2
'll -2
pfLODState\ *ls);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfChanLODStateList\fP(const\ pfChannel*\ chan,
'in +2
'll -2
pfList\ *lsList);
.in
.ll
.nf
.fi
.TP
pfList*
\f3\%pfGetChanLODStateList\fP(const\ pfChannel*\ chan);
.nf
.fi
.TP
int
\f3\%pfGetChanPWinIndex\fP(pfChannel\ *chan);
.nf
.fi
.TP
pfPipeWindow *
\f3\%pfGetChanPWin\fP(pfChannel\ *chan);
.nf
.fi
.TP
void
\f3\%pfChanTravFunc\fP(pfChannel*\ chan,
'in +2
'll -2
int\ trav,
pfChanFuncType\ func);
.in
.ll
.nf
.fi
.TP
pfChanFuncType
\f3\%pfGetChanTravFunc\fP(pfChannel*\ chan,
'in +2
'll -2
int\ trav);
.in
.ll
.nf
.fi
.TP
void *
\f3\%pfAllocChanData\fP(pfChannel*\ chan,
'in +2
'll -2
int\ size);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfChanData\fP(pfChannel\ *chan,
'in +2
'll -2
void\ *data,
size_t\ size);
.in
.ll
.nf
.fi
.TP
void *
\f3\%pfGetChanData\fP(pfChannel*\ chan);
.nf
.fi
.TP
size_t
\f3\%pfGetChanDataSize\fP(const\ pfChannel\ *chan);
.nf
.fi
.TP
void
\f3\%pfPassChanData\fP(pfChannel*\ chan);
.nf
.fi
.TP
void
\f3\%pfClearChan\fP(pfChannel*\ chan);
.nf
.fi
.TP
int
\f3\%pfAttachChan\fP(pfChannel*\ chan0,
'in +2
'll -2
pfChannel*\ chan1);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfDetachChan\fP(pfChannel*\ chan0,
'in +2
'll -2
pfChannel*\ chan1);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfASDattachChan\fP(pfChannel*\ chan0,
'in +2
'll -2
pfChannel*\ chan1);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfASDdetachChan\fP(pfChannel*\ chan0,
'in +2
'll -2
pfChannel*\ chan1);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfChanShare\fP(pfChannel*\ chan,
'in +2
'll -2
uint\ mask);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfGetChanShare\fP(pfChannel*\ chan);
.nf
.fi
.TP
void
\f3\%pfChanFOV\fP(pfChannel*\ chan,
'in +2
'll -2
float\ horiz,
float\ vert);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanFOV\fP(const\ pfChannel*\ chan,
'in +2
'll -2
float*\ horiz,
float*\ vert);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfChanNearFar\fP(pfChannel*\ chan,
'in +2
'll -2
float\ near,
float\ far);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanNearFar\fP(const\ pfChannel*\ chan,
'in +2
'll -2
float*\ near,
float*\ far);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfChanAutoAspect\fP(pfChannel*\ chan,
'in +2
'll -2
int\ which);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetChanAutoAspect\fP(const\ pfChannel*\ chan);
.nf
.fi
.TP
void
\f3\%pfGetChanBaseFrust\fP(const\ pfChannel*\ chan,
'in +2
'll -2
pfFrustum\ *frust);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanPtope\fP(const\ pfChannel\ *chan,
'in +2
'll -2
pfPolytope\ *ptope);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMakePerspChan\fP(pfChannel*\ chan,
'in +2
'll -2
float\ left,
float\ right,
float\ bottom,
float\ top);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMakeOrthoChan\fP(pfChannel*\ chan,
'in +2
'll -2
float\ left,
float\ right,
float\ bottom,
float\ top);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMakeSimpleChan\fP(pfChannel*\ chan,
'in +2
'll -2
float\ fov);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetChanFrustType\fP(const\ pfChannel*\ chan);
.nf
.fi
.TP
void
\f3\%pfChanAspect\fP(pfChannel*\ chan,
'in +2
'll -2
int\ which,
float\ widthHeightRatio);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetChanAspect\fP(const\ pfChannel*\ chan);
.nf
.fi
.TP
void
\f3\%pfOrthoXformChan\fP(pfChannel*\ dst,
'in +2
'll -2
pfChannel*\ src,
const\ pfMatrix\ mat);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanNear\fP(const\ pfChannel*\ chan,
'in +2
'll -2
pfVec3\ ll,
pfVec3\ lr,
pfVec3\ ul,
pfVec3\ ur);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanFar\fP(const\ pfChannel*\ chan,
'in +2
'll -2
pfVec3\ ll,
pfVec3\ lr,
pfVec3\ ul,
pfVec3\ ur);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetChanEye\fP(const\ pfChannel*\ chan,
'in +2
'll -2
pfVec3\ eye);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfApplyChan\fP(pfChannel\ *chan);
.nf
.fi
.TP
int
\f3\%pfChanContainsPt\fP(const\ pfVec3\ pt,
'in +2
'll -2
pfChannel*\ chan);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfChanContainsSphere\fP(const\ pfChannel*\ chan,
'in +2
'll -2
const\ pfSphere*\ sph);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfChanContainsCyl\fP(const\ pfChannel*\ chan,
'in +2
'll -2
const\ pfCylinder*\ cyl);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfChanContainsBox\fP(const\ pfChannel*\ chan,
'in +2
'll -2
const\ pfBox*\ box);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfChanCullPtope\fP(pfChannel\ *chan,
'in +2
'll -2
const\ pfPolytope\ *ptope);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanCullPtope\fP(const\ pfChannel\ *chan,
'in +2
'll -2
pfPolytope\ *ptope,
int\ space);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfChanPick\fP(pfChannel\ *chan,
'in +2
'll -2
int\ mode,
float\ px,
float\ py,
float\ radius,
pfHit\ **picklist[]);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfChanNodeIsectSegs\fP(pfChannel\ *chan,
'in +2
'll -2
pfNode\ *node,
pfSegSet\ *segSet,
pfHit\ **hits[],
pfMatrix\ *mat);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfChanScene\fP(pfChannel*\ chan,
'in +2
'll -2
pfScene\ *scene);
.in
.ll
.nf
.fi
.TP
pfScene *
\f3\%pfGetChanScene\fP(const\ pfChannel*\ chan);
.nf
.fi
.TP
void
\f3\%pfChanESky\fP(pfChannel*\ chan,
'in +2
'll -2
pfEarthSky\ *sky);
.in
.ll
.nf
.fi
.TP
pfEarthSky *
\f3\%pfGetChanESky\fP(const\ pfChannel*\ chan);
.nf
.fi
.TP
void
\f3\%pfChanGState\fP(pfChannel\ *chan,
'in +2
'll -2
pfGeoState\ *gstate);
.in
.ll
.nf
.fi
.TP
pfGeoState *
\f3\%pfGetChanGState\fP(const\ pfChannel\ *chan);
.nf
.fi
.TP
void
\f3\%pfChanGStateTable\fP(pfChannel\ *chan,
'in +2
'll -2
pfList\ *gstable);
.in
.ll
.nf
.fi
.TP
pfList *
\f3\%pfGetChanGStateTable\fP(const\ pfChannel\ *chan);
.nf
.fi
.TP
void
\f3\%pfChanStressFilter\fP(pfChannel\ *chan,
'in +2
'll -2
float\ frac,
float\ low,
float\ high,
float\ scale,
float\ max);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanStressFilter\fP(const\ pfChannel\ *chan,
'in +2
'll -2
float\ *frac,
float\ *low,
float\ *high,
float\ *scale,
float\ *max);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfChanStress\fP(pfChannel\ *chan,
'in +2
'll -2
float\ stress);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetChanStress\fP(const\ pfChannel\ *chan);
.nf
.fi
.TP
float
\f3\%pfGetChanLoad\fP(const\ pfChannel\ *chan);
.nf
.fi
.TP
void
\f3\%pfChanTravMode\fP(pfChannel\ *chan,
'in +2
'll -2
int\ trav,
int\ mode);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetChanTravMode\fP(const\ pfChannel\ *chan,
'in +2
'll -2
int\ trav);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfChanTravMask\fP(pfChannel*\ chan,
'in +2
'll -2
int\ trav,
uint\ mask);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfGetChanTravMask\fP(const\ pfChannel*\ chan,
'in +2
'll -2
int\ trav);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfChanBinSort\fP(pfChannel\ *chan,
'in +2
'll -2
int\ bin,
int\ sortType,
uint64_t\ *sortOrders);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetChanBinSort\fP(const\ pfChannel\ *chan,
'in +2
'll -2
int\ bin,
uint64_t\ *sortOrders);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfChanBinOrder\fP(pfChannel\ *chan,
'in +2
'll -2
int\ bin,
int\ order);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetChanBinOrder\fP(const\ pfChannel\ *chan,
'in +2
'll -2
int\ bin);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetChanFreeBin\fP(pfChannel*\ chan);
.nf
.fi
.TP
void
\f3\%pfChanView\fP(pfChannel*\ chan,
'in +2
'll -2
pfVec3\ xyz,
pfVec3\ hpr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanView\fP(pfChannel*\ chan,
'in +2
'll -2
pfVec3\ xyz,
pfVec3\ hpr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfChanViewMat\fP(pfChannel*\ chan,
'in +2
'll -2
pfMatrix\ mat);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanViewMat\fP(const\ pfChannel*\ chan,
'in +2
'll -2
pfMatrix\ mat);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfChanViewOffsets\fP(pfChannel*\ chan,
'in +2
'll -2
pfVec3\ xyz,
pfVec3\ hpr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanViewOffsets\fP(const\ pfChannel*\ chan,
'in +2
'll -2
pfVec3\ xyz,
pfVec3\ hpr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanOffsetViewMat\fP(const\ pfChannel\ *chan,
'in +2
'll -2
pfMatrix\ mat);
.in
.ll
.nf
.fi
.TP
pfFrameStats *
\f3\%pfGetChanFStats\fP(pfChannel*\ chan);
.nf
.fi
.TP
int
\f3\%pfChanStatsMode\fP(pfChannel*\ chan,
'in +2
'll -2
uint\ mode,
uint\ val);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfDrawChanStats\fP(pfChannel*\ chan);
.nf
.fi
.TP
void
\f3\%pfChanLODAttr\fP(pfChannel*\ chan,
'in +2
'll -2
int\ attr,
float\ val);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetChanLODAttr\fP(pfChannel*\ chan,
'in +2
'll -2
int\ attr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfChanProjMode\fP(pfChannel*\ chan,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetChanProjMode\fP(const\ pfChannel*\ chan);
.nf
.fi
.TP
pfPipeVideoChannel *
\f3\%pfGetChanPVChan\fP(const\ pfChannel*\ chan);
.nf
.fi
.TP
void
\f3\%pfChanPWinPVChanIndex\fP(pfChannel*\ chan,
'in +2
'll -2
int\ num);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetChanPWinPVChanIndex\fP(const\ pfChannel*\ chan);
.nf
.fi
.TP
void
\f3\%pfChanOutputViewport\fP(const\ pfChannel*\ chan,
'in +2
'll -2
float\ l,
float\ r,
float\ b,
float\ t);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanOutputViewport\fP(const\ pfChannel*\ chan,
'in +2
'll -2
float\ *l,
float\ *r,
float\ *b,
float\ *t);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanOutputOrigin\fP(const\ pfChannel*\ chan,
'in +2
'll -2
int\ \ *xo,
int\ *yo);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetChanOutputSize\fP(const\ pfChannel*\ chan,
'in +2
'll -2
int\ \ *xs,
int\ *ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfChanPixScale\fP(pfChannel*\ chan,
'in +2
'll -2
float\ s);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetChanPixScale\fP(const\ pfChannel*\ chan);
.nf
.fi
.TP
void
\f3\%pfChanMinPixScale\fP(pfChannel*\ chan,
'in +2
'll -2
float\ min);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetChanMinPixScale\fP(const\ pfChannel*\ chan);
.nf
.fi
.TP
void
\f3\%pfChanMaxPixScale\fP(pfChannel*\ chan,
'in +2
'll -2
float\ max);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetChanMaxPixScale\fP(const\ pfChannel*\ chan);
.nf
.fi
.TP
void
\f3\%pfChanCallig\fP(pfChannel*\ chan,
'in +2
'll -2
pfCalligraphic*\ callig);
.in
.ll
.nf
.fi
.TP
pfCalligraphic*
\f3\%pfGetChanCallig\fP(const\ pfChannel*\ chan);
.nf
.fi
.TP
pfCalligraphic*
\f3\%pfGetChanCurCallig\fP(pfChannel*\ chan);
.nf
.fi
.TP
void
\f3\%pfChanCalligEnable\fP(pfChannel*\ chan,
'in +2
'll -2
int\ enable)
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetChanCalligEnable\fP(const\ pfChannel*\ chan);
.nf
.fi
.TP
void
\f3\%pfApp\fP(void);
.nf
.fi
.TP
void
\f3\%pfCull\fP(void);
.nf
.fi
.TP
void
\f3\%pfDraw\fP(void);
.nf
.fi
.TP
void
\f3\%pfLPoint\fP(void);
.nf
.fi
.TP
void
\f3\%pfDrawBin\fP(int\ bin);
.nf
.fi
.TP
void
\f3\%pfDrawScene\fP(void);
.nf
.fi
.TP
void
\f3\%pfNodePickSetup\fP(pfNode\ *node);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfChannel\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfChannel\fP.
Casting an object of class \f3\%pfChannel\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfChannel\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'chan\ \ 'u
\f2chan\fP
identifies a pfChannel.
.TP
\f2node\fP
identifies a pfNode.
.TP
\f2trav\fP
is a symbolic token identifying a traversal:
.IP
\f3\%PFTRAV_CULL\fP

\f3\%PFTRAV_DRAW\fP
.PP
.SH DESCRIPTION

A pfChannel is essentially a view onto a scene.
\f3\%pfNewChan\fP creates a
new pfChannel on the pfPipe identified by \f2pipe\fP.  The new
pfChannel will be rendered by the \f2pipe\fP into a pfPipeWindow
window associated with
\f2pipe\fP (See \f3\%pfConfigPWin\fP).
\f3\%pfNewChan\fP creates and returns a handle to a pfChannel.
pfChannels are always allocated from shared memory.

\f3\%pfGetChanClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfChannel\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetChanClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfChannel\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

.SS PIPE WINDOWS, PIPES, AND CHANNELS

\f3\%pfGetChanPipe\fP returns the parent pfPipe
of \f2chan\fP.
\f3\%pfGetChanPWin\fP returns the pfPipeWindow
of \f2chan\fP.

Multiple pfChannels may be rendered by a single pfPipe into a single
pfPipeWindow.  It is recommended that multiple pfChannels rather than
multiple pfPipes be used to render multiple views on a single hardware
pipeline.  If necessary, multiple pfPipeWindows can be rendered by a
single pfPipe on a single hardware pipeline.  The handle returned by
\f3\%pfNewChan\fP should be used to identify the
pfChannel in OpenGL Performer routines.

Upon creation, pfChannels are automatically assigned to the first
pfPipeWindow of its parent pfPipe.
\f3\%pfGetChanPWin\fP will return the
pfPipeWindow of \f2chan\fP.

Channels of a pfPipeWindow are drawn in the order in which they are
assigned to the pfPipeWindow.
\f3\%pfGetChanPWinIndex\fP can be used to
get the position of a channel in its pfPipeWindow list.  A return value
of (-1) indicates that the channel is not assigned to a pfPipeWindow.
Channels can be re-ordered in their pfPipeWindow, or moved to other
pfPipeWindows via list style API on pfPipeWindows.  See the
\f3\%pfAddChan\fP, \f3\%pfInsertChan\fP, \f3\%pfMoveChan\fP, and
\f3\%pfRemoveChan\fP man pages for more
information.

All active pfChannels are culled and drawn by \f3\%pfFrame\fP.  A pfChannel
is by default active but can be selectively turned on and off by
\f3\%PFDRAW_ON\fP and \f3\%PFDRAW_OFF\fP arguments to
\f3\%pfChanTravMode\fP.  Multiple pfChannels
on a pfPipe will be drawn only if they are assigned to a pfPipeWindow
and will be drawn in the order they were assigned to that
pfPipeWindow.

\f3\%pfChanViewport\fP specifies the
fractional viewport used by \f2chan\fP.  \f2l\fP,
\f2r\fP, \f2b\fP, \f2t\fP specify the left, right, bottom, and top extents of
a viewport in the range 0.0 to 1.0.  The fractional viewport is
relative to the parent pfPipe's graphics window.  Channel viewports on
a single pfPipe may overlap.  Viewport extents are clamped to the range
0.0 to 1.0.

\f3\%pfGetChanViewport\fP copies the
fractional viewport of \f2chan\fP into \f2l\fP,
\f2r\fP, \f2b\fP, \f2t\fP.

\f3\%pfChanOutputViewport\fP sets
the area of the pfChannel viewport that is to be output to display.
Typically this does not need to be set and is by default equal
to that set by
\f3\%pfChanViewportpfChanProjMode\fP is used to set the
projection mode, which is important when using the Dynamic Video
Resizing (DVR) feature of InfiniteReality graphics systems. In operation,
the two modes are nearly indistinguishable and are mostly important in
the case where a pfChannel has a draw callback function that expects
the viewport to be set to the default (PFCHAN_PROJ_OUTPUT_VIEWPORT) value.
The \f2mode\fP argument is one of these values:

.RS
.TP
PFCHAN_PROJ_OUTPUT_VIEWPORT
This is the default mode of operation.
it sets the graphics library viewport and scissor mask (see glScissor(3g))
to the output viewport of the
pfChannel, which typically is also the full viewport.
.TP
PFCHAN_PROJ_VIEWPORT
The viewport will be set to the full pfChannel viewport but the
screen scissor mask will be set to the pfChannel output viewport.
.TP
PFCHAN_PROJ_WINDOW
This mode sets the graphics library viewport for the pfChannel to be
the full extent of the pfPipeWindow, then uses the projection matrix and
GL scissor mask to scale down the displayed area to the output viewport.
This can be important when using the DVR facility since it reduces any
jitter that might otherwise occur between adjacent channels caused by
clamping viewport boundaries to integer pixel values.
.RE

Use \f3\%pfGetChanProjMode\fP to get the
current setting of a channel's projection mode.


\f3\%pfGetChanOrigin\fP copies the window
coordinates of the origin of \f2chan\fP's viewport into \f2xo\fP and
\f2yo\fP.

\f3\%pfGetChanSize\fP copies the X and Y pixel
sizes of \f2chan\fP's viewport into \f2xs\fP and
\f2ys\fP.

.SS APPLICATION-DEFINED CALLBACKS AND DATA

Although OpenGL Performer normally handles all culling and drawing,
invocation of user written and registered extension functions
(\f2callback functions\fP) is supported to allow custom culling and
drawing by the application.  Furthermore, OpenGL Performer manages
callback data such that when configured for multiprocessing, data
contention and synchronization issues are handled transparently.

\f3\%pfChanTravFunc\fP sets the application,
cull, draw or light points process callback functions for
\f2chan\fP.  The \f2trav\fP argument specifies which
traversal is to be set and is one of: \f3\%PFTRAV_APP\fP, \f3\%PFTRAV_CULL\fP,
\f3\%PFTRAV_DRAW\fP or \f3\%PFTRAV_LPOINT\fP.  User-data that is passed to
these functions is allocated on a per-channel basis by
\f3\%pfAllocChanData\fP.
\f3\%pfAllocChanData\fP returns a pointer
to a word-aligned buffer of shared memory of \f2size\fP bytes.
Alternately, applications can provide passthrough data with
\f3\%pfChanData\fP. \f2data\fP is a memory
block of \f2size\fP bytes which should be allocated from a shared malloc
arena visible to all OpenGL Performer processes when multiprocessing (see
\f3\%pfMultiprocess\fP).

\f3\%pfGetChanDataSize\fP returns the
size of \f2chan\fP's passthrough data block.
\f3\%pfGetChanData\fP returns a pointer to a
buffer that was set by \f3\%pfChanData\fP or
allocated by \f3\%pfAllocChanData\fP or
\f3\%NULL\fP if no buffer has been allocated or set.
\f3\%pfChanTravFunc\fP returns the app, cull
or draw callback functions for \f2chan\fP or \f3\%NULL\fP if the callback has
not been set.

In order to propagate user data downstream to the cull and draw
callbacks, \f3\%pfPassChanData\fP should be
called whenever the user data is changed to indicate that the data
should be "passed through" the OpenGL Performer rendering pipeline.  The
next call to \f3\%pfFrame\fP will copy the channel buffer into internal
OpenGL Performer memory so that the application will then be free to
modify data in the buffer without fear of corruption.

In the cull phase of the rendering pipeline, OpenGL Performer invokes the
cull callback with a pointer to the pfChannel being culled and a
pointer to the pfChannel's data buffer.  The cull callback may modify
data in the buffer.  The potentially modified buffer is then copied and
passed to the user's draw callback.  Modifications to the data buffer
are not visible upstream. For example, changes made by the cull or draw
process are not seen by the application process.

When OpenGL Performer is configured for multiprocessing (see
\f3\%pfMultiprocess\fP), it is important to realize that the cull and draw
callbacks may be invoked from different processes and thus may run in
parallel with each other as well as with the main application process.
OpenGL Performer provides both shared arenas (see \f3\%pfGetSemaArena\fP and
\f3\%pfGetSharedArena\fP) and channel data
(\f3\%pfAllocChanData\fP) for interprocess
communication.

With user callbacks, it is possible to extend or even completely
replace OpenGL Performer actions with custom traversal, culling and
drawing.  \f3\%pfApp\fP, \f3\%pfCull\fP, \f3\%pfDraw\fP and \f3\%pfLPoint\fP trigger
the default OpenGL Performer processing.  This default processing is
invoked automatically in the absence of any user callbacks specified by
\f3\%pfChanTravFunc\fP , otherwise the
user callback usually invokes them directly.

\f3\%pfApp\fP carries out the application traversal for the channel and
should only be invoked in the application callback specified by
\f3\%pfChanTravFunc\fP.  The application
callback is invoked once for each channel group that is sharing
\f3\%PFCHAN_APPFUNC\fP.

\f3\%pfLPoint\fP runs in parallel with draw. It opens a ring display list
and preprocess the light points in the bin that has been provided by
the culling. The display list stays opened after the call to pfLPoint()
so every command issued after that call will be sent over to the
draw process. Note that every command issued before pfLPoint() will
be immediately executed, such as pfCalligraphic parametrisation for
the current frame. Note also that the light point process does not
have any graphic context and therefore it is forbidden to do some
direct graphic calls here.

\f3\%pfCull\fP should only be called in the cull callback and causes OpenGL
Performer to cull the current channel and generate an OpenGL Performer
display list (see \f3\%pfDispList\fP) suitable for rendering if the
\f3\%PFMP_CULL_DL_DRAW\fP multiprocessing mode is enabled (see
\f3\%pfMultiprocess\fP).  Then, in the draw callback only, \f3\%pfDraw\fP will
traverse the pfDispList and send rendering commands to the graphics
hardware, thus drawing the scene.

If the \f3\%PFMP_CULL_DL_DRAW\fP multiprocessing mode is not set then all
display-listable operations will be applied directly to the graphics
pipeline rather than accumulated in a pfDispList for subsequent
drawing.  In essence, the draw process does the work of both \f3\%pfCull\fP
and \f3\%pfDraw\fP without the intermediate step of building a pfDispList.
This mode avoids the overhead of building and traversing a pfDispList
but consequently is not suitable for multipass renderings which require
multiple invocations of \f3\%pfDraw\fP.

When the draw callback is invoked, the graphics context will already
have been properly configured for drawing the pfChannel.  Specifically,
the viewport, perspective and viewing matrices are set to the correct
values.  In addition, graphics library light sources corresponding to
the active pfLightSources in the scene will be enabled so that geometry
rendered in the draw callback will be properly lit.  User modifications
of this initial state are not reset by \f3\%pfDraw\fP.

If a draw callback is specified, OpenGL Performer will not automatically
clear the viewport, leaving control of this to the application.
\f3\%pfClearChan\fP called from the draw callback
will clear the channel viewport.  If \f2chan\fP has
a pfEarthSky (see \f3\%pfChanESky\fP), then the
pfEarthSky will be drawn.  Otherwise, the viewport will be cleared to
black and the z-buffer cleared to its maximum value.

By default, \f3\%pfFrame\fP causes \f3\%pfCull\fP and \f3\%pfDraw\fP to be invoked
for each active pfChannel.  It is legal for the draw callback to call
\f3\%pfDraw\fP more than once for multipass renderings.
Note that \f3\%pfDraw\fP will render the internal multipass \f3\%pfLightSource\fP
projected texture lights and shadows every time it is called. \f3\%pfDrawScene\fP
may be more convenient as it will draw the scene without the internal multipass.


Example 1: Set up channel callbacks and passthrough data
.Ex
.nf

typedef struct
{
    int        val;
} PassData;

void cullFunc(pfChannel *chan, void *data);
void drawFunc(pfChannel *chan, void *data);

int
main()
{
    PassData    *pd;

    /* Initialize OpenGL Performer */
    pfInit();
    pfConfig();

    /* Create and initialize pfChannel 'chan' */
    chan = pfNewChan(pfGetPipe(0));
     :

    /* Setup channel passthrough data */
    pd = (PassData*)pfAllocChanData(chan, sizeof(PassData));

    /* Bind cull and draw callback functions to channel */
    pfChanTravFunc(chan, PFTRAV_CULL, cullFunc);
    pfChanTravFunc(chan, PFTRAV_DRAW, drawFunc);

    pd->val = 0;
    pfPassChanData(chan);
    pfFrame();
     :
}

void
cullFunc(pfChannel *chan, void *data)
{
    PassData    *pd = (PassData*)data;
    pd->val++;
    pfCull();
}

void
drawFunc(pfChannel *chan, void *data)
{
    PassData    *pd = (PassData*)data;
    fprintf(stderr, "%ld\\n", pd->val);
    pfClearChan(chan);
    pfDraw();
}
.Ee
.fi
.na


.SS SHARING ATTRIBUTES THROUGH CHANNEL GROUPS

OpenGL Performer supports the notion of a 'channel group' which is a
collection of pfChannels that share certain attributes.  A channel
group is created by attaching a pfChannel to another with
\f3\%pfAttachChan\fP.  If \f2chan0\fP or \f2chan1\fP are themselves members of a channel group,
then all channels that are grouped with either \f2chan0\fP or \f2chan1\fP are combined into a single channel group.
All attached channels acquire the share mask and shared attributes of
the channel group.  A channel is removed from a channel group by
\f3\%pfDetachChan\fP.

The attributes shared by the members of a channel group are specified
by the \f2mask\fP argument to \f3\%pfChanShare\fP.
By definition,
all channels in a group have the same share mask.  A pfChannel that is
attached to a channel group inherits the share mask of the group.
\f2mask\fP is a bitwise OR of the following tokens which enumerate the
attributes that can be shared:
.RS
.TP 5
\f3\%PFCHAN_FOV\fP
Horizontal and vertical fields of view are shared.
.TP
\f3\%PFCHAN_VIEW\fP
The view position and orientation are shared.
.TP
\f3\%PFCHAN_VIEW_OFFSETS\fP
The XYZ and HPR offsets from the view direction are shared.
.TP
\f3\%PFCHAN_NEARFAR\fP
The near and far clip planes are shared.
.TP
\f3\%PFCHAN_SCENE\fP
All channels display the same scene.
.TP
\f3\%PFCHAN_EARTHSKY\fP
All channels display the same earth-sky model.
.TP
\f3\%PFCHAN_STRESS\fP
All channels use the same stress filter parameters.
.TP
\f3\%PFCHAN_LOD\fP
All channels use the same LOD modifiers.
.TP
\f3\%PFCHAN_SWAPBUFFERS\fP
All channels swap buffers at the same time, even when the channels are
on multiple pfPipes.
.TP
\f3\%PFCHAN_SWAPBUFFERS_HW\fP
All channels swap buffers at the same time. Under IrisGL the \f3\%GANGDRAW\fP
feature of the \f2mswapbuffers\fP function, under OpenGL the \f2glxSwapBarrier\fP
extension, is used to synchronize buffer swapping through hardware
interlocking.
When channels are distributed across more than one pipe, the \f3\%SwapReady\fP
signal is to be connected between the pipes.
This signal can also be used to synchronize graphics pipelines across
multiple machines.
.TP
\f3\%PFCHAN_STATS_DRAWMODE\fP
All channels draw the same statistics graph.
.TP
\f3\%PFCHAN_APPFUNC\fP
The application callback is invoked once for all
channels sharing \f3\%PFCHAN_APPFUNC\fP.
.TP
\f3\%PFCHAN_CULLFUNC\fP
All channels invoke the same channel cull callback.
.TP
\f3\%PFCHAN_DRAWFUNC\fP
All channels invoke the same channel draw callback.
.TP
\f3\%PFCHAN_LPOINTFUNC\fP
All channels invoke the same channel light points callback.
.TP
\f3\%PFCHAN_VIEWPORT\fP
All channels use the same viewport specification.
.RE

\f3\%pfGetChanShare\fP returns the share mask of
\f2chan\fP.  The default
attributes cause channels within a share group to share all attributes
except \f3\%PFCHAN_VIEW_OFFSETS\fP, \f3\%PFCHAN_VIEWPORT\fP and
\f3\%PFCHAN_SWAPBUFFERS_HW\fP.

Channel groups are useful for multichannel simulations where many of
the viewing parameters are the same across pfChannels.  For example, a
3-channel simulation consisting of left, middle, and right views
typically shares the near and far clipping planes.  With a channel
group, the clipping planes need only be set on a single pfChannel, say
the middle one, and all other pfChannels in the group will acquire the
same settings.

Example 1: Set up a single pipe, 3-channel simulation
.Ex
.nf

left   = pfNewChan(pfGetPipe(0));
middle = pfNewChan(pfGetPipe(0));
right  = pfNewChan(pfGetPipe(0));

/* Form channel group with middle as the "master" */
pfAttachChan(middle, left);
pfAttachChan(middle, right);

/* Set FOV of all channels */
pfMakeSimpleFrust(middle, 45.0f);
pfChanAutoAspect(middle, PFFRUST_CALC_VERT);

/* Set clipping planes of all channels */
pfChanNearFar(middle, 1.0f, 2000.0f);

pfSetVec3(hprOffsets, 0.0f, 0.0f, 0.0f);
pfSetVec3(xyzOffsets, 0.0f, 0.0f, 0.0f);

/*
 * Set up viewport and viewing offsets.
 * Note that these are not shared by default.
 */
pfChanViewport(left, 0.0f, 1.0f/3.0f, 0.0f, 1.0f);
hprOffsets[PF_H] = 45.0f;
pfChanViewOffsets(left, xyzOffsets, hprOffsets);

pfChanViewport(middle, 1.0f/3.0f, 2.0f/3.0f, 0.0f, 1.0f);
hprOffsets[PF_H] = 0.0f;
pfChanViewOffsets(middle, xyzOffsets, hprOffsets);

pfChanViewport(right, 2.0f/3.0f, 1.0f, 0.0f, 1.0f);
hprOffsets[PF_H] = -45.0f;
pfChanViewOffsets(right, xyzOffsets, hprOffsets);
.Ee
.fi
.na


.SS VIEWING FRUSTUM

Many pfChannel frustum routines are borrowed from pfFrustum. These
routines have the identical function as the pfFrustum routines but
operate on the pfChannel's internal viewing frustum. The routine
correspondence is listed in the following table.

.TS
center tab($);
C | C
L | L .
pfChannel routine$pfFrustum routine
_
pfMakeSimpleChan$pfMakeSimpleFrust
pfMakePerspChan$pfMakePerspFrust
pfMakeOrthoChan$pfMakeOrthoFrust
pfChanNearFar$pfFrustNearFar
pfGetChanNearFar$pfGetFrustNearFar
pfGetChanFOV$pfGetFrustFOV
pfChanAspect$pfFrustAspect
pfGetChanAspect$pfGetFrustAspect
pfGetChanFrustType$pfGetFrustType
pfOrthoXformChan$pfOrthoXformFrust
pfGetChanNear$pfGetFrustNear
pfGetChanFar$pfGetFrustFar
pfGetChanEye$pfGetFrustEye
pfApplyChan$pfApplyFrust
pfChanContainsPt$pfFrustContainsPt
pfChanContainsSphere$pfFrustContainsSphere
pfChanContainsBox$pfFrustContainsBox
pfChanContainsCyl$pfFrustContainsCyl
.TE
The reader is referred to the pfFrustum man page
for details on the function descriptions.

In addition to the pfFrustum routines, OpenGL Performer provides the
\f3\%pfChanFOV\fP and
\f3\%pfChanAutoAspect\fP convenience
routines.

The \f2horiz\fP and \f2vert\fP arguments to
\f3\%pfChanFOV\fP specify total horizontal and
vertical fields of view (FOV) in degrees.  If either angle is <= 0.0 or
>= 180.0, OpenGL Performer will automatically compute that field of view
based on the other specified field of view and the aspect ratio of the
pfChannel viewport.  If both angles are defaulted in this way, OpenGL
Performer will use its default of \f2horiz\fP=45.0 with \f2vert\fP matched
to the aspect ratio of the pfChannel.  Note that the aspect ratio of a
pfChannel is defined by its fractional viewport as well as the pixel
size of its physical display window.

\f3\%pfChanFOV\fP constructs a on-axis frustum,
one where the line from the eyepoint passing through the center of the
image is perpendicular to the projection plane.
\f3\%pfMakeSimpleChan\fP also creates an
on-axis frustum but both horizontal and vertical fields of view are
specified with \f2fov\fP.

\f3\%pfGetChanFOV\fP copies the total horizontal
and vertical fields of view into \f2horiz\fP and \f2vert\fP respectively.
If an angle is matched to the aspect ratio of the pfChannel, then the
computed angle is returned.

The \f2which\fP argument to
\f3\%pfChanAutoAspect\fP specifies which
FOV extent to automatically match to the aspect ratio of
\f2chan\fP's viewport.  \f2which\fP is a symbolic
token and is one of:
.RS
.TP 5
\f3\%PFFRUST_CALC_NONE\fP
Do not automatically modify field of view.
.TP
\f3\%PFFRUST_CALC_HORIZ\fP
Automatically modify horizontal FOV to match channel aspect.
.TP
\f3\%PFFRUST_CALC_VERT\fP
Automatically modify vertical FOV to match channel aspect.
.RE

Automatic aspect ratio matching is useful for situations where the
initial size of the display window is not known or where the display
window may change size during runtime.  Aspect ratio matching
guarantees that the image will not be distorted in either horizontal or
vertical dimensions. \f3\%pfMakePerspChan\fP
and \f3\%pfMakeOrthoChan\fP disable automatic
aspect ratio matching since it is assumed that the viewing frustum
aspect ratio is completely specified by these commands.

\f3\%pfChanNearFar\fP specifies the near and
far clip distances of the viewing frustum.  \f2near\fP and \f2far\fP are
the positive, world-coordinate distances along the viewing ray from the
eye point to the near and far clipping planes which are parallel to the
viewing plane.  \f3\%pfGetChanNearFar\fP
copies the near and far clipping distances into \f2near\fP and \f2far\fP.
The default values are 1.0 for the near plane and 1000.0 for the far
plane.

\f3\%pfGetChanBaseFrust\fP copies the base
viewing frustum of \f2chan\fP into \f2frust\fP.  The
base viewing frustum has its eyepoint at the origin and
its viewing direction as the +Y axis.  The base frustum of a pfChannel
is transformed into world coordinates by the viewing transformation
(see \f3\%pfChanView\fP).
\f3\%pfOrthoXformChan\fP transforms the base
frustum of \f2src\fP by \f2mat\fP and copies the result into the base frustum
of the \f2dst\fP pfChannel. \f3\%pfGetChanPtope\fP
copies the transformed base frustum into \f2dst\fP.

Example 1: Two equivalent ways of defining a typical viewing channel.

This method is the easiest and most common.
.Ex
.nf

/* Set up a simple viewing frustum */
chan = pfNewChan(pipe0);

/*
 * Set horizontal FOV to 45 degrees and automatically match
 * vertical FOV to channel viewport.
 */
pfChanFOV(chan, 45.0f, -1.0f);
.Ee
.fi
.na


Here's how to do the same thing using the basic primitives.
.Ex
.nf

/* Set up a simple viewing frustum */
chan = pfNewChan(pipe0);

/*
 * Set horizontal FOV to 45 degrees and automatically match
 * vertical FOV to channel viewport.
 */
pfMakeSimpleChan(chan, 45.0f);
pfChanAutoAspect(chan, PFFRUST_CALC_VERT);
.Ee
.fi
.na


Example 2: Set up a 4 channel, 4 pipe video wall with total horizontal
and vertical FOVs of 90 degrees.
.Ex
.nf

/*
 * ul == upper left  ur == upper right
 * ll == lower left  lr == lower right
 */
llChan = pfNewChan(pfGetPipe(0));
lrChan = pfNewChan(pfGetPipe(1));
urChan = pfNewChan(pfGetPipe(2));
ulChan = pfNewChan(pfGetPipe(3));

/* Form channel group with urChan as the "master" */
pfAttachChan(urChan, llChan);
pfAttachChan(urChan, lrChan);
pfAttachChan(urChan, ulChan);

/*
 * Share viewport but not field of view
 * in addition to the default shared attributes.
 */
share = pfGetChanShare(urChan);
pfChanShare(urChan, (share & ~PFCHAN_FOV) | PFCHAN_VIEWPORT );

/*
 * Set up off-axis viewing frusta which "tile" video wall.
 * pfChannel viewport aspect ratio must be 1:1 or image will
 * be distorted.
 */
pfMakePerspChan(llChan, -1.0f, 0.0f, -1.0f, 0.0f);
pfMakePerspChan(lrChan,  0.0f, 1.0f, -1.0f, 0.0f);
pfMakePerspChan(urChan,  0.0f, 1.0f,  0.0f, 1.0f);
pfMakePerspChan(ulChan, -1.0f, 0.0f,  0.0f, 1.0f);

pfChanNearFar(urChan, 1.0f, 2000.0f);
.Ee
.fi
.na


Example 3: Set up a single pipe, 3-channel simulation.
.Ex
.nf

left   = pfNewChan(pfGetPipe(0));
middle = pfNewChan(pfGetPipe(0));
right  = pfNewChan(pfGetPipe(0));

/* Form channel group with middle as the "master" */
pfAttachChan(middle, left);
pfAttachChan(middle, right);

/* Set FOV of all channels */
pfMakeSimpleChan(middle, 45.0f);
pfChanAutoAspect(middle, PFFRUST_CALC_VERT);

/* Set clipping planes of all channels */
pfChanNearFar(middle, 1.0f, 2000.0f);

hprOffsets[PF_P] = 0.0f;
hprOffsets[PF_R] = 0.0f;
pfSetVec3(xyzOffsets, 0.0f, 0.0f, 0.0f);

/*
 * Set up viewport and viewing offsets.
 * Note that these are not shared by default.
 */
pfChanViewport(left, 0.0f, 1.0f/3.0f, 0.0f, 1.0f);
hprOffsets[PF_H] = 45.0f;
pfChanViewOffsets(left, hprOffsets, xyzOffsets);

pfChanViewport(middle, 1.0f/3.0f, 2.0f/3.0f, 0.0f, 1.0f);
hprOffsets[PF_H] = 0.0f;
pfChanViewOffsets(middle, hprOffsets, xyzOffsets);

pfChanViewport(right, 2.0f/3.0f, 1.0f, 0.0f, 1.0f);
hprOffsets[PF_H] = -45.0f;
pfChanViewOffsets(right, hprOffsets, xyzOffsets);
.Ee
.fi
.na


Example 4: Custom culling to pfChannel viewing frustum.
.Ex
.nf

/*
 * User-supplied cull callback (see \f3\%pfChanTravFunc\fP)
 */
extern void
myCullFunc(pfChannel *chan, void *data)
{
    pfBox *boundingBox = (pfBox*)data;

    if (pfChanContainsBox(chan, boundingBox))
        drawGSetsWithinBoundingBox();
}
.Ee
.fi
.na


\f3\%pfASDattachChan\fP lets one channel shares
the active geometry evaluated by pfASD nodes from another channel.
Normally, pfASD evaluates separate active meshes based on each channel
that traverses the node. It automatically ensures that the meshes are
consistantly connected between channels. This is very useful for multiple channels that
panel a wall like shown above. If channels have very different
view points, such as in a multi-player game, then  the application should
define one pfASD node for each channel, since the active mesh is going
to be very different from one channel to the other. This is especially
important if one channel is going to have a different evaluation function or
a different LODRange from another, e.g. infra-rad channel and regular channel.
pfASD nodes can share the same raw attribute data, such as pfASDFaces, and pfASDVerts.

In some applications, one channel would like to display the same geometry
as another channel, e.g. a bird's eye view of the terrain, then
this API should be used to define it.
\f2chan0\fP is the current channel, and \f2chan1\fP is the channel
that supplies the orginal active mesh. The API can be called
multiple times to define that \f2channel0\fP shares active meshes from
multiple channels.
Example: Define an inset window that looks at the active geometry generated
by master channel traversal.
.Ex
.nf

    /* top down view of the active geometry in master Channel */
    pfASDattachChan(ViewState->insetChannel, masterChan);
.Ee
.fi
.na


\f3\%pfASDdettachChan\fP detaches the channel from
sharing the active mesh from another channel.

\f3\%pfGetChanAutoAspect\fP returns the
aspect ratio matching mode of \f2chan\fP.

A pfChannel normally uses its viewing frustum for culling its pfScene
(\f3\%pfChanScene\fP).  However, a custom
culling volume may be specified by
\f3\%pfChanCullPtope\fP.  If non-NULL,
\f2ptope\fP identifies a pfPolytope which is used for scene culling. A
copy of \f2ptope\fP, internal to \f2chan\fP, is
transformed by \f2chan\fP's viewing matrix before culling. If \f2ptope\fP
is NULL, \f2chan\fP will use its view frustum for
culling. A pfPolytope is a set of half spaces whose intersection
defines a convex volume. Culling performance will be proportional to
the number of facets in \f2ptope\fP.
\f3\%pfGetChanCullPtope\fP copies the
culling polytope of \f2chan\fP into \f2ptope\fP.
The \f2space\fP argument must be one of the constants
PF_WORLDSPACE or PF_EYESPACE; the culling polytope will be expressed
in the respective coordinate space.

.SS VIDEO CHANNELS

The pfPipeVideoChannel associated with a channel is returned by
\f3\%pfGetChanPVChan\fP. In the indexed case,
the pfPipeVideoChannel index is set to \f2num\fP using
\f3\%pfChanPWinPVChanIndex\fP and
returned by
\f3\%pfGetChanPWinPVChanIndex\fP.

With Dynamic Video Resolution, the actual rendering area (known as the
output viewport) may be smaller than the nominal channel viewport. The
size of the actual viewport area is available from
\f3\%pfGetChanOutputViewport\fP where
the \f2l\fP, \f2r\fP, \f2b\fP, and \f2t\fP arguments are pointers to float
values that will be updated by the call.

The origin and size of a channel are dynamic under the effect of video
resizing in the same sense.  As an example, a viewport whose lower-left
corner is at the center of the pfPipe (with coordinates 0.5, 0.5) would
be changed to an origin of (0.25, 0.25) with respect to the full pfPipe
window if the DVR settings were for scale factors of 0.5 in both X and
Y.  The actual rendering origin of a pfChannel is available from
\f3\%pfGetChanOutputOrigin\fP with the
returned values in the integers pointed to by \f2xo\fP and \f2yo\fP.  The
size of a viewport also changes when DVR scaling is in use, and the
actual values are returned by
\f3\%pfGetChanOutputSize\fP in the
integers pointed to by \f2xs\fP and \f2ys\fP.

When Dynamic Video Resolution is used to alter the rendered size of a
pfChannel, a corresponding change should be made to the width of points
and lines, the two geometry types that support a specific pixel width.
For example, when a channel is scaled in size by on half, lines and
points must be drawn half as wide as well so that when the final image
is enlarged by the inverse scale factor, in this case two, the lines
and points will have the same screen size.
\f3\%pfChanPixScale\fP sets the indicated
channel's pixel scale factor to \f2s\fP.
\f3\%pfGetChanPixScale\fP returns this value
for the channel.

Channels also have minimum and maximum pixel scale values, that can be
used to define an acceptable range of pixel scale values. This can be
used to keep lines and points from getting too thin under the effects
of extreme DVR scaling.
\f3\%pfChanMinPixScale\fP sets the
minimum allowable pixel scale value for the channel, and
\f3\%pfGetChanMinPixScale\fP gets the
value.  \f3\%pfChanMaxPixScale\fP sets
the maximum allowable pixel scale value for the channel, and
\f3\%pfGetChanMaxPixScale\fP gets the
value.


.SS CALLIGRAPHIC LIGHT POINTS

If a LightPointBoard has been found and initialized before pfConfig,
each pfPipeVideoChannel is automatically setup with a
pfCalligraphic initialized with the pfPipeVideoChannel screen
as the Light Point Board number, and the Video Channel Id as
the output to use for calligraphic light points. You may change
this automatic behavior by setting you own pfCalligraphic
on the pfPipeVideoChannel (see
pfPVChanCallig).

It is also possible to specify a pfCalligraphic per channel using
\f3\%pfChanCallig\fP and
\f3\%pfGetChanCallig\fP get the value
that has been set.
\f3\%pfGetChanCurCallig\fP get the
pfCalligraphic that is used for this pfChannel. If a pfCalligraphic
has been set then this value is returned, otherwise the
pfCalligraphic set in the pfPipeVideoChannel is returned.

The lightpoint board is connected to the SwapReady signal
to be synchronized with the swapBuffer of the graphic pipe.
Usually, the SwapReady signal is enabled only when more
than one pipe is used by an application, in order to synchronize
the swapBuffer of channels distributed across more than one pipe.
However, the signal SwapReady has to be enabled even in single
pipe configuration. Enabling calligraphic light points on a pfChannel
will take care of that by attaching the pfWindow to a swapBarrier.
To enable calligraphic call \f3\%pfChanCalligEnable\fP
with 1 as \f2enable\fP. \f3\%pfGetChanCalligEnable\fP
returns this value. By default calligraphic light points are not enabled,
the returned value is therefore 0.

.SS PICKING

\f3\%pfChanPick\fP is used for screen to
world-space ray intersections on a pfChannel's scene.  This operation
is often referred to as picking.  Intersections will only occur with
parts of the database that are within the viewing frustum, and that are
enabled for picking intersections.  The return value of
\f3\%pfChanPick\fP is the number of successful
intersections with the channel scene according to \f2mode\fP.

\f2picklist\fP is a user-supplied pointer.  Upon return, the address of
an array of pointers to pfHit objects is stored there.  The pfHit
objects come from an internally maintained pool and are reused on
subsequent calls.  Hence, the contents are only valid until the next
invocation of \f3\%pfChanPick\fP in the current
process.  They should not be deleted by the application.

The contents of the pfHit object are queried using
\f3\%pfQueryHit\fP and
\f3\%pfMQueryHit\fP.  See the man pages for \f3\%pfHit\fP
and \f3\%pfNodeIsectSegs\fP for a description of the
queries.

\f2mode\fP specifies the behavior of the traversal and type of
information that will be returned from the picking process.

\f2mode\fP is a bitwise OR of tokens.  In addition to those tokens that
can be specified to \f3\%pfNodeIsectSegs\fP in the
\f2mode\fP field of the pfSegSet, the following values are also allowed:

.RS
.TP 5
\f3\%PFPK_M_NEAREST\fP
Return the picking intersection closest to the viewpoint.
.TP
\f3\%PFPK_M_ALL\fP
Return all picking intersections.
.TP
\f3\%PFTRAV_LOD_CUR\fP
When traversing pfLODs, select the child to traverse based
on range in the specified channel.
.RE

When \f3\%PFPK_M_ALL\fP is set, \f2picklist\fP will contain all of the
successful picking intersections in order of increasing distance from
the viewer eyepoint.  See the \f3\%pfNodeIsectSegs\fP manual
page for information on the \f3\%PFIS_\fP intersection tokens.

\f2px\fP, \f2py\fP identify a 2-dimensional point in normalized channel
screen coordinates in the range 0.0 to 1.0 (with the lower left corner
being (0.0, 0.0)), that corresponds to the channel location to be used
for picking.  This 2-dimensional point is used to create a ray from the
viewer eyepoint through the near clipping plane to intersect with the
channel scene.

\f2radius\fP is the radius of the picking region in normalized channel
coordinates used for the picking of lines.  This argument is provided
for coarse picking, and possibly for eventual picking of lines and
points which is currently not implemented.  If \f2radius\fP is non-zero,
then the \f2mode\fP argument must not specify the \f3\%PFTRAV_IS_PRIM\fP
mode.

\f3\%pfNodePickSetup\fP enables the entire database tree under \f2node\fP for
picking intersections and should be called with a pointer to the
pfChannel's scene graph.  This effectively calls
\f3\%pfNodeTravMask\fP with \f3\%PFIS_SET_PICK\fP.
Selective picking can be done by calling
\f3\%pfNodeTravMask\fP, setting the traversal
to \f3\%PFTRAV_ISECT\fP and including \f3\%PFIS_SET_PICK\fP in the intersection
mask for nodes that are to be enabled for picking intersections.  The
picking traversal will not continue past any node that has not been
enabled for picking intersections.  See the
\f3\%pfNodeTravMask\fP manual page for more
information on intersection setup.

\f3\%pfChanNodeIsectSegs\fP is identical to
\f3\%pfNodeIsectSegs\fP except a pfChannel is
provided for evaluating pfLODs during the intersection traversal. In
addition, \f2mat\fP specifies an initial transform, allowing intersection
traversals to begin at non-root nodes.  All line segments in \f2segSet\fP
will be transformed by \f2mat\fP.  \f2mat\fP may be NULL if no initial
transform is needed.

.SS EARTH AND SKY

\f3\%pfChanScene\fP and
\f3\%pfChanESky\fP set the pfScene and
pfEarthSky that \f2chan\fP will cull and draw.
\f3\%pfChanScene\fP increments the reference
count of \f2scene\fP so that \f2scene\fP must first be removed from
\f2chan\fP by
\f3\%pfChanScene\fP(chan, NULL) before
\f2scene\fP can be deleted with \f3\%pfDelete\fP.

\f3\%pfGetChanScene\fP and
\f3\%pfGetChanESky\fP return the current pfScene
and pfEarthSky for \f2chan\fP.  

Example 1: Setting a pfChannel's pfScene.
.Ex
.nf

void
cullFunc(pfChannel *chan, void *data)
{
    pfCull();
}

void
drawFunc(pfChannel *chan, void *data)
{
    pfClearChan(chan);
    pfDraw();
}

/* somewhere in application setup phase */
 :
/* set channel's scene */
pfChanScene(chan, scene);

/* bind cull and draw process callbacks */
pfChanTravFunc(chan, PFTRAV_CULL, cullFunc);
pfChanTravFunc(chan, PFTRAV_DRAW, drawFunc);

.Ee
.fi
.na


.SS GEOSTATES

\f3\%pfChanGState\fP sets \f2chan\fP's pfGeoState to \f2gstate\fP. If non-NULL, \f2gstate\fP is
loaded before \f2chan\fP's \f3\%DRAW\fP callback is
invoked.  Specifically, \f2gstate\fP is loaded with
\f3\%pfLoadGState\fP so that the state
encapsulated by \f2gstate\fP becomes the global state that may be
inherited by other pfGeoStates within the scene graph. The pfGeoState
state inheritance mechanism is described in detail in the pfGeoState
man page.  Note that the channel pfGeoState is loaded before any scene
pfGeoState so that state elements in the scene pfGeoState override
those in the channel's pfGeoState.
\f3\%pfGetChanGState\fP returns the pfGeoState
of \f2chan\fP.

\f3\%pfChanGStateTable\fP sets
\f2chan\fP's pfGeoState table to \f2gstable\fP.  If
non-NULL, \f2gstable\fP is made the global pfGeoState table with
\f3\%pfApplyGStateTable\fP before
\f2chan\fP's \f3\%DRAW\fP callback is invoked.  Any
indexed pfGeoStates, either referenced by a pfScene
(\f3\%pfSceneGStateIndex\fP) or by scene
pfGeoSets (\f3\%pfGSetGStateIndex\fP) will
be accessed through \f2gstable\fP. Indexed pfGeoStates are useful for
efficiently managing a single database with multiple appearances, e.g.,
a normal vs.  an infrared view of a scene would utilize 2 pfGeoState
tables, each referencing a different set of pfGeoStates.

.SS STRESS PROCESSING AND LEVEL-OF-DETAIL

OpenGL Performer attempts to maintain the fixed frame rate set with
\f3\%pfFrameRate\fP by manipulating levels-of-detail (LODs) to reduce
graphics load when rendering time approaches a frame period.  At the
end of each frame, OpenGL Performer computes a load metric for each
pfChannel based on the length of time it took to render the pfChannel.
Load is simply the actual rendering time divided by the desired frame
interval.

\f3\%pfChanLODState\fP specifies a global
pfLODState to be used for this channel.

\f3\%pfChanLODStateList\fP specifies a
pfList of pfLODStates to be indexed into by pfLODs that have specified
indexes via \f3\%pfLODLODStateIndex\fP.
(See \f3\%pfLOD\fP and \f3\%pfLODState\fP).

If stress processing is enabled, OpenGL Performer uses the load metric
and a user-defined stress filter to compute a stress value which
multiplies effective LOD ranges (see \f3\%pfLOD\fP) for the next frame.
Stress > 1.0 'pushes out' LOD ranges so that coarser models are drawn
and graphics load is reduced.  Stress == 1.0 means the system is not in
stress and LODs are not modified.

\f3\%pfChanStressFilter\fP sets the
stress filter used by \f2chan\fP.  \f2frac\fP is the
fraction of a frame period \f2chan\fP is expected
to take to render.  \f2frac\fP should be 1.0 if only a single pfChannel
is drawn on a pfPipe and should be > 0.0 and < 1.0 for multichannel
simulations.  \f2frac\fP allows the application to apportion rendering
time amongst multiple channels so that a channel drawing a complex
scene may be allocated more time than a channel drawing a simple one.
\f3\%pfGetChanStressFilter\fP returns
the stress filter parameters for \f2chan\fP.

\f2low\fP and \f2high\fP define a hysteresis band for system load.  When
load is >= \f2low\fP and <= \f2high\fP, stress is held constant.  When load
is < \f2low\fP or > \f2high\fP, OpenGL Performer will reduce or increase
stress respectively until load stabilizes within the hysteresis band.
\f2low\fP should be <= \f2high\fP and they both should be positive.  Stress
is computed using the following algorithm:
.Ex
.nf

/* increase stress when above \f2high\fP load level */
if (load > \f2high\fP)
    S[i] = \f2minimum\fP(S[i-1] + \f2scale\fP*load, \f2max\fP);
else
/* decrease stress when below \f2low\fP load level */
if (load < \f2low\fP)
    S[i] = \f2maximum\fP(S[i-1] - \f2scale\fP*load, 0.0f);
else
/* stress unchanged when between \f2low\fP and \f2high\fP load levels */
    S[i] = S[i-1];
.Ee
.fi
.na


where S[i] == stress for frame i and load = time[i] * frameRate /
\f2frac\fP.  By default, \f2scale\fP = 0.0 and \f2max\fP = 1.0 so that stress
is disabled.  Stress is clamped to the range [1.0, \f2max\fP].

pfChannels in a channel group may share a stress filter
(\f3\%PFCHAN_STRESS\fP), and LOD behavior (\f3\%PFCHAN_LOD\fP) (see
\f3\%pfAttachChan\fP).  It is useful for
pfChannels which draw into adjacent displays to share LOD behavior.  In
this case, the LOD multiplier used by all pfChannels in the channel
group is the maximum of each individual pfChannel.  This ensures that
LOD's which straddle displays will always be drawn at the same LOD on
each display.

\f3\%pfGetChanLoad\fP will return the last
computed load for \f2chan\fP.  The load value is
defined as time * frameRate / \f2frac\fP.

The application may choose to not use the default OpenGL Performer stress
filter by calling \f3\%pfChanStress\fP to
explicitly set the stress value.  Stress values set by
\f3\%pfChanStress\fP will override the default
stress values computed by the stress filter shown above.

\f3\%pfGetChanStress\fP returns the last
computed stress value for \f2chan\fP.  The
individual stress value is returned regardless of pfChannel attribute
sharing (\f3\%pfChanShare\fP).

.SS CUSTOMIZING SCENE GRAPH TRAVERSAL

A pfChannel directs two important traversals: cull and draw.  In the
cull traversal, the pfChannel defines the viewing frustum that the
database is culled to and also defines other parameters that modify
level-of-detail behavior.  When drawing, the pfChannel defines the
parameters of the "camera" which views the scene.  In both cases, a
pfChannel traverses a pfScene which is attached to the pfChannel via
\f3\%pfChanScene\fP.  A pfScene is a hierarchy
of pfNodes that defines the visual database.

\f3\%pfChanTravMode\fP sets the traversal
mode of \f2chan\fP.  \f2trav\fP specifies a traversal
type and is either \f3\%PFTRAV_CULL\fP, \f3\%PFTRAV_DRAW\fP or \f3\%PFTRAV_LPOINT\fP,
for the culling, drawing and light points traversal respectively.
\f2mode\fP specifies the corresponding traversal mode.  The culling mode
is a bitwise OR of:
.RS
.TP 5
\f3\%PFCULL_VIEW\fP
When set, \f3\%PFCULL_VIEW\fP enables culling to the viewing frustum.  If
not set, the entire database will be rendered every frame.  For best
drawing performance it is recommended that \f3\%PFCULL_VIEW\fP be set.
Unless \f3\%PFCULL_GSET\fP is also set, OpenGL Performer culls the database
only down to the pfGeode level.
.TP
\f3\%PFCULL_SORT\fP
When \f3\%PFCULL_SORT\fP is set, OpenGL Performer sorts the database
into "bins" which are rendered in a user-specified order.
In addition, geometry within a bin may be sorted by graphics state
like texture or by range for front-to-back or back-to-front rendering.
Unless the cull stage of the OpenGL Performer pipeline becomes the
bottleneck or \f3\%PFMP_CULLoDRAW\fP mode is used, \f3\%PFCULL_SORT\fP should
be set for optimal drawing performance. Further sorting details are
described below.
.TP
\f3\%PFCULL_GSET\fP
When \f3\%PFCULL_GSET\fP is set, OpenGL Performer culls individual pfGeoSets
within pfGeodes.  At the expense of some extra culling time, this can
provide a significantly tighter cull both because of the finer
granularity and because pfGeoSet culling uses bounding boxes rather
than bounding spheres.  However, when traversing portions of the scene
graph under a transformation (pfSCS or pfDCS), OpenGL Performer reverts
back to a cull which stops at the pfGeode level.
.TP
\f3\%PFCULL_IGNORE_LSOURCES\fP
When \f3\%PFCULL_IGNORE_LSOURCES\fP is not set, OpenGL Performer will
traverse all paths in the scene hierarchy which end at a pfLightSource
node before proceeding with the normal cull traversal (see
\f3\%pfLightSource\fP).  This is required for pfLightSources to illuminate
the scene and will ensure that graphics hardware lighting is properly
configured before the user's draw callback is invoked
(see \f3\%pfChanTravFunc\fP).  If it is set,
any pfLightSources in the pfScene will be ignored.

The pfLightSource cull traversal obeys all traversal rules such as node
callbacks, traversal masks, transformations (pfSCS and pfDCS nodes),
and selectors (pfSwitch and pfLOD).
.RE

For drawing, \f2mode\fP is either \f3\%PFDRAW_OFF\fP or \f3\%PFDRAW_ON\fP.
\f3\%PFDRAW_OFF\fP essentially turns off \f2chan\fP.  No culling or drawing
traversal will take place.  Drawing is enabled by default.

When the optional light points process is used, light points
preprocessing and drawing can be disable for a particular channel
giving \f3\%PFDRAW_OFF\fP for \f2mode\fP. Creating a light points process
enable the the preprocessing for every channel by default.

\f3\%pfGetChanTravMode\fP returns the mode
corresponding to \f2trav\fP or -1 if \f2trav\fP is an illegal or unknown
traversal type.

The \f3\%PFTRAV_MULTIPASS\fP traversal mode is only active when the
pfChannel's scene has one or more pfLightSources which use projected
texture-type lighting. See the pfLightSource man page for more
details.

By default, culling to the viewing frustum, culling to pfGeoSet
bounding boxes, pfLightSource culling, and sorting is enabled:
(\f3\%PFCULL_VIEW\fP | \f3\%PFCULL_GSET\fP | \f3\%PFCULL_SORT\fP) For convenience,
this default bitmask is provided by the \f3\%PFCULL_ALL\fP token.

\f3\%pfChanTravMask\fP sets
\f2chan\fP's drawing mask and is used in
conjunction with \f3\%pfNodeTravMask\fP for
selective culling and drawing of scene graphs on a per-pfChannel
basis.  During the traversal, the bitwise AND of the traversal mask and
the node mask is computed.  If the result is non-zero, the node is
culled or drawn as usual.  If off (zero), the behavior is as follows
depending on \f2trav\fP:
.RS
.TP 5
\f3\%PFTRAV_CULL\fP
Node is not culled and is considered to be entirely within the viewing
frustum.  The cull traversal traverses the node and its children without
any view culling.
.TP
\f3\%PFTRAV_DRAW\fP
Node is completely ignored.  Both cull and draw traversals skip the node
and its children. It is therefore ignored by the light points process.
.RE

Node traversal masks are set by
\f3\%pfNodeTravMask\fP.  The default pfNode and
pfChannel masks are 0xffffffff so that a pfChannel culls and draws all
pfNodes.

\f3\%pfGetChanTravMask\fP returns the
drawing traversal mask for the specified pfChannel.  \f2trav\fP is either
\f3\%PFTRAV_CULL\fP or \f3\%PFTRAV_DRAW\fP.

.SS USING BINS

As mentioned above, pfChannels can sort the database for improved image
quality and improved rendering performance. Database sorting consists of
two steps:
.RS
.TP 5
1.
Partition database into "bins" which are rendered in a particular order.
.TP
2.
Sort database within each bin by:
.TP
2a.
Graphics state, in which case there is no particular rendering order or,
.TP
2b.
Range from the eyepoint in which case the database is rendered either
front-to-back or back-to-front.
.RE

During the cull traversal, pfGeoSets are placed into the appropriate
bin according to their bin identifier that was set by
\f3\%pfGSetDrawBin\fP.  If the bin identifier
is >= 0, the cull traversal will place that pfGeoSet into the bin with
that identifier. If the bin identifier is < 0, then the cull traversal
will decide in which default bin the pfGeoSet belongs.

Note that a pfGeoSet will not go in a bin if:
- \f3\%PFCULL_SORT\fP is not set
- the bin has no drawing order set (see \f3\%pfChanBinOrder\fP)
- the pfGeoSet has no directly attached pfGeoState.

OpenGL Performer provides 2 default bins: \f3\%PFSORT_OPAQUE_BIN\fP and
\f3\%PFSORT_TRANSP_BIN\fP for opaque and transparent geometry respectively.
Transparent geometry is that which uses \f3\%PFTR_BLEND_ALPHA\fP type of
\f3\%pfTransparency\fP. \f3\%PFTR_MS_ALPHA\fP-type
transparency is considered to be opaque for purposes of binning.

In addition, if the light points process is enabled, a special bin
\f3\%PFSORT_LPSTATE_BIN\fP is created to sort out all pfGeoSets that have a
\f3\%pfLPointState\fP attached to their pfGeoState.  This bin will not be
given directly to the draw process but instead will be preprocessed by
pfLPoint(). The result of the preprocessing is sent to the draw process
through an internal ring display list.

Each draw bin has a rendering order set by
\f3\%pfChanBinOrder\fP. If \f2order\fP is < 0,
then \f2bin\fP is not ordered at all - pfGeoSets which belong to \f2bin\fP
are not stored in the bin but are rendered immediately.  If \f2order\fP
is >=0, it defines the order in which the bin is rendered, 0 == first,
1 == second etc.

By default, the opaque bin rendering order is
\f3\%PFSORT_OPAQUE_BIN_ORDER\fP (0) and the transparent bin is
\f3\%PFSORT_TRANSP_BIN_ORDER\fP (1) so that transparent surfaces are
rendered after opaque surfaces. It is legal to change the rendering
order of the default bins and for different bins to have the same
rendering order although the relative order of these bins is
undefined.

The light point bin has a huge \f3\%PFSORT_LPSTATE_BIN_ORDER\fP which is an
indicative value telling that the result of the preprocessing will be
drawned after every other geometry.  Modifying the order of this bin as
no effect on that behavior.

\f3\%pfGetChanFreeBin\fP returns the next
available bin identifier and should be used to avoid collisions with
previously selected bins and bins that are used internally by OpenGL
Performer. Note that a bin is considered unsused if no call to
\f3\%pfChanBinOrder\fP has been made.

Normally, \f3\%pfDraw\fP renders all bins in the appropriate order.
Individual bins may be rendered with \f3\%pfDrawBin\fP when called in the
pfChannel's draw callback (see
\f3\%pfChanTravFunc\fP).
\f3\%-1\fP is a special argument to \f3\%pfDrawBin\fP that let you render the
default sceneDisplayList that contains all the objects that did not fall in
any defined bin. Note that this default sceneDisplayList exists only in
\f3\%PFMP_CULL_DL_DRAW\fP multiprocessing mode.

\f3\%pfChanBinSort\fP defines how pfGeoSets
are sorted within a bin. \f2sortType\fP is a symbolic token which
identifies the sorting method for \f2bin\fP:

.RS
.TP 5
\f3\%PFSORT_NO_SORT\fP
Do not sort the bin. \f2sortOrders\fP is ignored.
.TP
\f3\%PFSORT_FRONT_TO_BACK\fP
Sort the pfGeoSets in the bin in increasing range from the eyepoint. Range
is computed as the distance from the pfChannel eyepoint to the center of
the pfGeoSet's bounding box. \f2sortOrders\fP is ignored.
.TP
\f3\%PFSORT_BACK_TO_FRONT\fP
Sort the pfGeoSets in the bin in decreasing range from the eyepoint. Range
is computed as the distance from the pfChannel eyepoint to the center of
the pfGeoSet's bounding box. \f2sortOrders\fP is ignored.
.TP
\f3\%PFSORT_BY_STATE\fP
Sort the pfGeoSets in the bin by graphics state. The pfGeoSets in \f2bin\fP
are first sorted by pfGeoState. Then if \f2sortOrders\fP is not NULL,
the pfGeoSets will be further sorted by the ordered list of
\f3\%PFSTATE_*\fP elements in \f2sortOrders\fP. In this case, \f2sortOrders\fP
should consist of a \f3\%PFSORT_STATE_BGN\fP token followed by 0 or more
\f3\%PFSTATE_*\fP tokens followed by a \f3\%PFSORT_STATE_END\fP token followed by
a \f3\%PFSORT_END\fP token to end the list. The \f3\%PFSTATE_*\fP tokens define
a sorting hierarchy.  The elements in \f2sortOrders\fP are copied into the
pfChannel data structure, so in this case it is acceptable to pass
static or automatic data not allocated through \f3\%pfMalloc\fP.
.TP
\f3\%PFSORT_DRAW_ORDER\fP
Sort the pfGeoSets in the bin directly by their draw order, in
ascending number.

By default, a new bin as a \f3\%PFSORT_NO_SORT\fP sort order.
.RE

Example 1: Sorting configuration example
.Ex
.nf

int	sortOrders[PFSORT_MAX_KEYS], i = 0;

sortOrders[i++] = PFSORT_STATE_BGN;
sortOrders[i++] = PFSTATE_FOG;
sortOrders[i++] = PFSTATE_MATERIAL;
sortOrders[i++] = PFSTATE_TEXTURE;
sortOrders[i++] = PFSORT_STATE_END;
sortOrders[i++] = PFSORT_END;

pfChanBinSort(chan, PFSORT_OPAQUE_BIN, PFSORT_BY_STATE, sortOrders);
pfChanBinSort(chan, PFSORT_TRANSP_BIN, PFSORT_BACK_TO_FRONT, NULL);
.Ee
.fi
.na


The default sorting order for the \f3\%PFSORT_OPAQUE_BIN\fP bin is by
pfGeoState only and the default sorting order for the
\f3\%PFSORT_TRANSP_BIN\fP bin is \f3\%PFSORT_BACK_TO_FRONT\fP.

The light points bins sorting is \f3\%PFSORT_DRAW_ORDER\fP.

Sorting by state is limited to the scope of a transformation (pfDCS or
pfSCS) or a node with draw callbacks, i.e. - pfGeoSets affected by
different transformations or draw callbacks are not sorted together.
However, range sorting spans both transformation and draw callback
boundaries.  Thus a range-sorted scene graph with many transformations
and expensive draw callbacks may suffer reduced performance due to an
increased number of transformation and draw callback changes.

.SS VIEWPOINT AND CAMERA SPECIFICATION

\f3\%pfChanView\fP specifies both the origin and
direction of view for a pfChannel.  \f2xyz\fP specifies the x,y,z
position of the viewpoint in world coordinates and \f2hpr\fP specifies
the Euler angles (heading, pitch, and roll) in degrees of the viewing
direction relative to the nominal view (as defined below).  The order
of application of these angles is ROTy(roll) * ROTx(pitch) *
ROTz(heading) where ROTa(angle) is a rotation matrix about world axis
\f2a\fP of \f2angle\fP degrees.  In all cases a positive rotation is
counterclockwise by the right hand rule.  The nominal viewing
coordinate system is +Y = forward, +Z = up, +X = right.  For example, a
roll of 90 degrees and a heading of -90 degrees would align the view
direction with the +X world axis and the up direction with the -Y world
axis.

\f3\%pfChanViewMat\fP provides another means
of specifying view point and direction.  \f2mat\fP is a 4x4 homogeneous
matrix which defines the view coordinate system such that the upper 3x3
submatrix defines the coordinate system axes and the bottom vector
defines the coordinate system origin.  OpenGL Performer defines the view
direction to be along the positive Y axis and the up direction to be
the positive Z direction, e.g., the second row of \f2mat\fP defines the
viewing direction and the third row defines the up direction in world
coordinates.  \f2mat\fP must be orthonormal or results are undefined.

The actual viewing direction used for culling and drawing is modified
by the offsets specified by
\f3\%pfChanViewOffsets\fP.  The argument
\f2xyz\fP defines a translation from the nominal eyepoint.  The Euler
angles given in \f2hpr\fP define an additional rotation of the viewing
direction from that specified by
\f3\%pfChanView\fP and
\f3\%pfChanViewMat\fP.  Although this has
similar functionality to \f3\%pfChanView\fP, it
is specifically useful for applications which render the same scene
into adjacent displays using multiple pfChannels.  Two examples where
one would use \f3\%pfChanViewOffsets\fP
as well as \f3\%pfChanView\fP are offset-eye
stereo image viewing applications, and for video wall applications.

Example 1: Set up a single pipe, 3-channel simulation using
pfChanViewOffsets.
.Ex
.nf

left   = pfNewChan(pfGetPipe(0));
middle = pfNewChan(pfGetPipe(0));
right  = pfNewChan(pfGetPipe(0));

/* Form channel group with middle as the "master" */
pfAttachChan(middle, left);
pfAttachChan(middle, right);

/* Set FOV of all channels */
pfMakeSimpleChan(middle, 45.0f, 45.0f);
pfChanAutoAspect(middle, PFFRUST_CALC_VERT);

/* Set clipping planes of all channels */
pfChanNearFar(middle, 1.0f, 2000.0f);

hprOffsets[PF_P] = 0.0f;
hprOffsets[PF_R] = 0.0f;
pfSetVec3(xyzOffsets, 0.0f, 0.0f, 0.0f);

/*
 * Set up viewport and viewing offsets.
 * Note that these are not shared by default.
 */
pfChanViewport(left, 0.0f, 1.0f/3.0f, 0.0f, 1.0f);
hprOffsets[PF_H] = 45.0f;
pfChanViewOffsets(left, hprOffsets, xyzOffsets);

pfChanViewport(middle, 1.0f/3.0f, 2.0f/3.0f, 0.0f, 1.0f);
hprOffsets[PF_H] = 0.0f;
pfChanViewOffsets(middle, hprOffsets, xyzOffsets);

pfChanViewport(right, 2.0f/3.0f, 1.0f, 0.0f, 1.0f);
hprOffsets[PF_H] = -45.0f;
pfChanViewOffsets(right, hprOffsets, xyzOffsets);
.Ee
.fi
.na


Both translation and rotational offsets are encoded in the
graphics library's ModelView matrix.  This ensures
that fogging is consistent across
multiple, adjacent pfChannels.  However, proper lighting
requires a lighting model which specifies a local viewer.
Otherwise, geometry which spans multiple pfChannels will be lit
differently on each pfChannel.

Example 2: Local viewer lighting model

.Ex
.nf

pfLightModel	*lm;

lm = pfNewLModel(arena);
pfLModelLocal(lm, 1);
pfApplyLModel(lm);
.Ee
.fi
.na


\f3\%pfGetChanView\fP copies the view
point/direction into \f2xyz\fP and \f2hpr\fP.

\f3\%pfGetChanViewMat\fP copies the viewing
matrix (without viewing offsets) into \f2mat\fP.

\f3\%pfGetChanViewOffsets\fP copies the
view positional and rotational offsets into the indicated arrays
(\f2xyz\fP and \f2hpr\fP).

\f3\%pfGetChanOffsetViewMat\fP copies
the combined nominal and offset viewing matrices into \f2mat\fP. This
combined viewing matrix is that used for culling and for configuring
the graphics library with the appropriate transformation. It is defined
as \f3\%offset\fP * \f3\%nominal\fP where \f3\%offset\fP is specified by
\f3\%pfChanViewOffsets\fP and \f3\%nominal\fP
is specified by either \f3\%pfChanViewMat\fP
or \f3\%pfChanView\fP.
.SS DRAWING FRAME STATISTICS

OpenGL Performer keeps track of times spent, and operations done, in the
application, cull, and draw stages of the rendering pipeline and
accumulates the data in a pfFrameStats structure.
\f3\%pfGetChanFStats\fP is used to get this
pfFrameStats structure from the indicated channel.
\f3\%pfChanStatsMode\fP of the
\f3\%PFCSTATS_DRAW\fP mode selects which of
the enabled statistics classes should be displayed in that channel by
\f3\%pfDrawChanStats\fP or
\f3\%pfDrawFStats\fP.  The statistics
are enabled by \f3\%pfFStatsClass\fP
and the \f3\%PFCSTATS_DRAW\fP mode is only controlling the display
of statistics that are already enabled.


\f3\%pfDrawChanStats\fP or
\f3\%pfDrawFStats\fP must be called during each
frame that a statistics display is desired and may be called from any
of OpenGL Performer's application, cull, or draw processes.  This manual
page give some pointers on how to interpret the statistics to help in
tuning your database.  Refer to the OpenGL Performer Programming Guide
for more detailed information.

\f3\%pfChanStatsMode\fP selects which of the currently
already enabled statistics through
\f3\%pfFStatsClass\fP, should be drawn.
It takes a pointer to a pfChannel, \f2chan\fP, and \f2mode\fP, which is currently
just \f3\%PFCSTATS_DRAW\fP, and the corresponding value for \f2val\fP, which is a
statistics class enabling bitmask.  The statistics classes displayed by
\f3\%pfDrawChanStats\fP or
\f3\%pfDrawFStats\fP are those statistics
classes that have been enabled by
\f3\%pfChanStatsMode\fP for display, and
are also enabled for collection. By default, all enabled statistics
are displayed.

At the top of the display is the actual frame rate being achieved and
the frame rate set by \f3\%pfFrameRate\fP and the phase set by
\f3\%pfPhase\fP.  If statistics collection of process frame times has been
disabled, then the actual frame rate will not be known and "???" will
be shown.  When the graphics statistics class is enabled for
collection, the average number of pfGeoSets and triangles being
displayed is also shown on the top of the statistics display.  See the
\f3\%pfStatsClass\fP manual page for more
information on enabling statistics classes.

For the Process Frame Times Statistics class,
\f3\%pfDrawChanStats\fP displays the amount of
time, on average, spent by each process on a single frame, as well as
the number of frames that missed the goal, or extended beyond the time
for the specified goal frame rate.  When the \f3\%PFFSTATS_PFTIMES_HIST\fP
mode is enabled (on by default), a timing diagram of previous frames is
displayed.

Red vertical lines indicate video retrace intervals and green ones
indicate frame boundaries.  Horizontal bars indicate the time taken by
pipeline stages.  The three different stages: APP, CULL, AND draw are
separated vertically and stages belonging to the same frame are the
same color.  Each stage of each frame is labeled with the name of the
stage and its offset from the current frame.  For example, the current
application stage is labeled \f3\%app0\fP and \f3\%draw-3\fP is the draw stage
of three frames back.  Stages that are in the same process are
connected by thin vertical lines while stages that are a single process
by themselves are not.

The bar for the application stage is split into a total of six pieces.
The frame starts where the colors change right after a frame boundary
line. Pick up where a new color starts.  This will be inside pfFrame
and is where control is given back to the application.

.RS
.TP
o Post-pfFrame()
The time spent in the application's main loop between the pfFrame() call and the
pfSync() call (highest segment in application line, drawn as a thick, bright line).
.TP
o pfSync() clean and pfApp()
The time spent cleaning the scene graph from application changes during pfSync();
drawn as mid-hight thick, bright line. This will also include the time for
pfAppFrame() which is called from pfSync() if not already called for the current
frame by the user. pfSequences are also evaluated as part of pfAppFrame().
.TP
o pfSync() sleep
The time spent sleeping in pfSync() while waiting for the next field or frame
boundary (depending on pfPhase and process model); the lowest point in the
application line, drawn as a thin pale dotted line. Typically this wait is for
when pfPhase is  \f3\%PFPHASE_LOCK\fP or \f3\%PFPHASE_FLOAT\fP.  However, note that in
single process with
pfPhase of \f3\%PFPHASE_FREE_RUN\fP, there will be a sleep period to wait for the swapbuffer
of the draw to complete before continuing with the application since any other graphics
call would effective force such a sleep anyway and in a place where its timing effect
could not be measured.
.TP
o Critical Section
The time spent in the application code between calling pfSync() and calling
pfFrame(); drawn as bright raised line. This is the critical path section and this line
should be as small as possible or non-existent.
.TP
o pfFrame() clean
The time spent in pfFrame() cleaning the scene graph after any changes that might
have been made in the previous subsegment, and then checking intersections;
drawn as mid-hight thick bright line. This line should typically be very small or
non-existent as it is part of the critical path and implies database changes between
pfSync() and pfFrame() which would be an expensive place to do such changes.
.TP
o pfFrame() update
The time spent waiting while the cull and other downstream process copy updated
information from the application and then starting the downstream stages on the
the now-finished frame (drawn as a low thin line). The end of this line is where
pfFrame() returns and the user main application section (or post frame section)
starts again.
.RE

The cull bar is divided into two pieces: first the time spent getting
updates from the application process (slightly raised), and the time
spent culling the scene graph.

The draw timing bar is divided into potentially six pieces:
.RS
.TP
o Pre-pfDraw()
The time spent in the channel draw callback before the call to pfDraw() (a very
short thick dark raised segment. This will include the time for your call to
pfClearChan(). However, under normal circumstances, this segment should barely
be visible at all). Operations taking place during this time should only be
latency-critical since they are holding off the draw for the current frame..
.TP
o pfDraw()
The time spent by OpenGL Performer traversing the scene graph in pfDraw() (drawn as
lowered bright thick segment). This should typically be the largest segment as in
the draw line.
.TP
o Post-pfDraw()
The time spent in the channel draw callback after pfDraw() (another short thick
dark raised segment;). On InfiniteReality, if graphics pipeline timing statistics have
been enabled by specifying \f3\%PFFSTATS_ENGFXPFTIMES\fP to
\f3\%pfFStatsClass\fP,
this line will include the time to finish the fill for this channel.
Otherwise, it only includes the time for the CPU to execute and send graphics
commands and graphics pipeline processing from this channel could impact the
timing of other channels.
.TP
o Raster LPoint Draw
The time to rendering raster light points computed by a forked lpoint process. This
is drawn as a very raised bright line and if it exists will be the highest point in the
draw line.
The last channel drawn on the pipe will include the time for the graphics pipeline to
finish its drawing. Even if you have no operations after pfDraw() in you draw
callback, this line for the last channel might look quite long, particularly if you are
very fill-limited and do not have InfiniteReailty graphics pipeline statistics enabled.
It is possible for rendering calls issued in the previous section to fill up the graphics
FIFO and have calls issued on this section have to wait while the graphics pipeline
processes the commands and FIFO drains, making the time look longer than
expected. If there is no forked lpoint process, this line will be combined with the
post-draw line of the last pfChannel.
.TP
o Draw Stats and Call Swapbuffers
The time spent waiting for the graphics pipeline to finish drawing the current
frame, draw the channel statistics (for all channels), and make the call to swap color
buffers. This is drawn as apale dotted line. The hardware will complete the
swapbuffers upon the following vertical field or frame line.
.RE

The draw timing bar is somewhat inaccurate because the time stamps are
taken from the host and do not reflect when the graphics pipeline
actually finished rendering.  Therefore, time for graphics work done in
one part of the draw might be counted in a following part when the
graphics pipeline FIFO filled up and caused the host to wait.  This
means that some \f3\%pfDraw()\fP time could be counted in the following
user callback time, or in the time to draw the statistics.  If graphics pipeline
timing statistics are enabled by specifying \f3\%PFFSTATS_ENGFXPFTIMES\fP to
\f3\%pfFStatsClass\fP
(available on InfiniteReality graphics platforms),
the draw timing line will not have the above inaccuracy as the end time will
be generated by the graphics pipeline when the channel is done drawing.


If the light process is used its timing bar is added. Like the draw
timing line, the lowest part represent the time actually spent in
\f3\%pfLPoint()\fP preprocessing the light points; time spend in the user's
call back routine is in the darkened parts bedore and after. The
rendering time to draw the preprocessed light points is included in the
draw timing bar.

When fill statistics are enabled, the main channel will be painted in
colors ranging from blue to pink that indicate per-pixel
depth-complexity.  The brightest (pinkest) areas are those pixels that
have been written many times.  The statistics displayed, in green,
include average total depth complexity (total number of pixel writes),
as well as the average, minimum, and maximum number of times a given
pixel is written.

When the Graphics Statistics class is enabled for collection and
display, detailed statistics on numbers of primitives, attributes,
state changes, and matrix transformations are all displayed.  These
statistics show what is being drawn by the graphics pipeline.  When the
\f3\%PFSTATS_GFX_TSTRIP_LENGTHS\fP mode is enabled, a histogram of triangle
strip lengths showing the percentage of triangles in the scene in
strips of given lengths is also displayed.  For the strip length
statistics, quads are counted as strips of length two and independent
triangles are counted as strips of length one.  For graphics
performance, it is good to have much of the database as possible in
triangle strips, and making those triangle strips as long as possible.
On a system with RealityEngine graphics, pay special attention to the
numbers for texture loads and number of bytes loaded.  If these numbers
are non-zero, then it means that hardware texture memory is being
overflowed and swapped regularly and this will degrade graphics
performance. Both InfiniteReality and Impact graphics systems are
designed to page textures during simulation and have FIFOS in strategic
locations within the hardware pipeline to support this operation.

The CPU statistics display will show some of the statistics seen in
\f3\%osview(1)\fP.  Graphics context switches occur when there are
multiple active graphics windows on the same screen.  An application
needing high fixed frame rates should not be encurring graphics
context switches.  Another useful indicator of graphics overload is
the \f3\%fifonowait\fP and \f3\%fifowait\fP numbers.  An excessive number of
times seen waiting on the graphics FIFO could indicate a graphics
bottleneck and fill statistics should be examined.  If there are an
excessive number of process context switches, then it might help
performance to restrict the draw process to a single processor and
then isolate that processor.  OpenGL Performer will not do this
automatically; however, there are utilities in the OpenGL Performer
utility library, \f3\%libpfutil\fP (see \f3\%pfuLockCPU\fP), that enable you
to do this.  These utilities are demonstrated in the OpenGL Performer
Perfly sample application.  These utilities use the IRIX REACT
extensions via \f3\%sysmp(2)\fP.

When the Database Statistics class is enabled for collection and
display, the number of displayed and evaluated nodes for each node type
is shown.  When the cull statistics are displayed, a table showing the
total number of nodes and pfGeoSets traversed by the cull process, the
number of node bounding sphere and pfGeoSet bounding boxes tested, and
the total number of nodes, and pfGeoSets, (of those traversed) that
were trivially rejected as being outside the viewing frustum, the
number that were fully inside the viewing frustum, and the number that
intersected the viewing frustum.  The database and culling statistics
together can show the efficiency of the database hierarchy.  If many of
the nodes in the database are being traversed by the cull process when
only a small percentage are actually visible, then this indicates that
the database hierarchy is not spatially coherent.  If there are many
pfGeoSets in each pfGeode, and many pfGeoSets are being rejected by the
cull, then adding more database hierarchy above current nodes may
actually speed up the culling traversal because cull tests on nodes
would be able to accept or reject large pieces of the database without
traversing lower nodes.  If the number of pfLOD nodes evaluated is much
more then the number that are actually drawn, then adding LOD hierarchy
might help to reduce the total number of LOD range calculations, which
are fairly expensive.

If there are few nodes in the database relative to the number of
pfGeoSets and the cull is taking a small amount of time but the draw is
taking longer than desired, then adding more nodes and using a database
hierarchy that is spatially coherent should improve the accuracy of the
cull and speed up the draw traversal.  If there are only a few
pfGeoSets per pfGeode and the cull is taking longer than the draw in
multiprocess mode, or is taking a significant amount of time in a
process shared with the draw, then it might benefit to not cull down to
the pfGeoSet level.  Refer to the
\f3\%pfChanTravMode\fP reference page for
information on setting cull traversal modes.

Graphics load is displayed in the lower portion of the statistics
window.  The load hysteresis band (see
\f3\%pfChanStress\fP) is drawn in white and
the previous 3 seconds of graphics load is drawn in red.  Load is not
scaled and ranges from 0.0 to 1.0 within the lower portion of the
statistics window.

If stress is active, the display shows a graph of the previous 3
seconds of stress which is drawn in white.  Stress is drawn into the
upper portion and is scaled to fit.

The \f3\%pfDrawChanStats\fP display is very
useful for debugging and profiling a particular application and also
for visualizing the behavior of differing multiprocessing modes and
pfPipe phases.

OpenGL Performer level-of-detail behavior is primarily dependent on
pfChannel viewing parameters such as view position, field-of-view, and
viewport pixel size.  OpenGL Performer assumes that LODs are modeled for
a canonical FOV of 45 degrees and a viewport size of 1024 pixels.  OpenGL
Performer computes an internal scale value for pfChannels whose FOV or
viewport size differ from these defaults.  This scale value is used to
modify LOD ranges so that correct LOD behavior is maintained.  If your
LODs were not modeled with the above defaults you may use
\f3\%PFLOD_SCALE\fP (see below) to adjust the LOD ranges.

Other LOD modification parameters are set with
\f3\%pfChanLODAttr\fP.
\f2attr\fP is a symbolic token that specifies which LOD parameter to set
and is one of the following:
.RS
.TP 5
\f3\%PFLOD_SCALE\fP
\f2val\fP multiplies the range computed between \f2chan\fP's eyepoint and
all pfLOD's drawn by \f2chan\fP.  This is used to
globally increase or
decrease level of detail on a per-pfChannel basis.  The default LOD
scale is 1.0. See the \f3\%pfLODState\fP and \f3\%pfLOD\fP man page for more details.
.TP
\f3\%PFLOD_FADE\fP
\f2val\fP specifies the global fade scale used to fade between levels of
detail.  Fade is enabled when \f2val\fP > 0, and is disabled when \f2val\fP
<= 0.  Fade is disabled by default.  Note that when computing the actual
"fade" or transition distances, this scale is multiplied by individual
fade distance values that are specified via
\f3\%pfLODTransition\fP.  Default pfLOD
transition ranges are 1.0.
See the \f3\%pfLODState\fP and \f3\%pfLOD\fP man page for more details.
.TP
\f3\%PFLOD_STRESS_PIX_LIMIT\fP
System stress (\f3\%pfChanStress\fP) will
not affect LOD's whose projected pixel size exceeds \f2val\fP pixels.
This feature is disabled by default.
.TP
\f3\%PFLOD_FRUST_SCALE\fP
The range multiplier based on \f2chan\fP's viewport
and FOV is multipled
by \f2val\fP.  Typically, this feature is enabled with a value of 1.0 and
disabled with a value of 0.0.
.RE

LOD fade is useful for avoiding distracting LOD switches.  When within
the fade range, LODs are drawn semi-transparent so that adjacent LODs
smoothly blend together.  Fade determines the transparency of an two
independent levels of detail.  Here is an example for a pfLOD with 3
levels-of-detail and fade range of 30 database units:
.Ex
.nf

			Switch Range
0   		 100			 250		 350
|  		  |		 	  |		  |
|------------|====|====|-------------|====|====|-----|====|====|
|	^	  |   ^                   |	          | ^
	|	      |					    |
	|	20/80 LOD0/LOD1		  ^		    |
   100% LOD0	   			  |		40% LOD2
				50/50 LOD1/LOD2

=== indicates where fading is active.
.Ee
.fi
.na


Fade transparency is complementary so that fading the same LOD child
with (fade) and (1.0 - fade) will generate a fully opaque image.  As an
example, a fade of 0.7 will cover 70% of the screen area while a fade
of (1.0 - fade) = (1.0 - 0.7) = 0.3 will cover the remaining 30% of
the screen area.

OpenGL Performer ensures that LODs whose switch range is <= 0.0 do not
fade in and also clamps the user-specified fade range to half the
distance between LOD switches.  For example, if a pfLOD is specified
with switch ranges 0.0, 100.0, 400.0 and the fade range is 80.0, the
result will be:

Example 2: Fade clamping
.Ex
.nf

  Range                           LOD(s) drawn
----------		-----------------------------------
  0 ->  50              100% LOD0
 50 -> 100              100% -> 50% LOD0 +   0% ->  50% LOD1
100 -> 180               50% ->  0% LOD0 +  50% -> 100% LOD1
180 -> 320                                         100% LOD1
320 -> 400                                 100% ->  50% LOD1
400 -> 480                                  50% ->   0% LOD1
.Ee
.fi
.na


Use fade with discretion since it increases rendering time because two
LODs instead of one are drawn when range is within the fade interval.

\f3\%pfGetChanLODAttr\fP returns the value of
the LOD modification parameter specified by \f2attr\fP.

OpenGL Performer computes a stress value based on graphics load
(\f3\%pfChanStress\fP) to modify LODs.
Specifically, when the system approaches overload, simpler LODs are
drawn in order to reduce graphics load.  However, in some situations
image fidelity considerations make it undesirable to draw low
levels-of-detail of objects which are close to the viewer and thus
occupy considerable screen space.  \f3\%PFLOD_STRESS_PIX_LIMIT\fP limits
the effects of stress to LODs whose projected pixel size is less than
\f2val\fP.  Projected pixel size is based on the bounding volume of the
LOD and is approximate.  When \f2val\fP < 0.0, the stress pixel limit is
disabled.

\f3\%PFLOD_SCALE\fP is a global scale that is useful for debugging and for
adapting LODs modeled at one FOV and viewport size to the canonical
FOV and viewport size used by OpenGL Performer.  A \f2val\fP of 0.0 will
cause only the highest LODs are displayed, since the effective distance
will be uniformly scaled to 0.0.
.SH NOTES

All pfChannels on a pfPipe are rendered into a single graphics window
so that they can share hardware resources such as textures.  Additionally,
each channel is rendered in succession rather than in parallel to avoid
costly graphics context switching.

For best performance, channel buffers allocated by
\f3\%pfAllocChanData\fP should be as small
as possible and \f3\%pfPassChanData\fP
should be called only when necessary to reduce copying overhead.

When configured as a process separate from the draw, the cull callback
should not invoke OpenGL graphics calls since only the draw
process is attached to a graphics context.  However, the display
listable libpr commands invoked in the cull callback will be correctly
added to the current OpenGL Performer libpr display list being built for
later processing by the draw process. Light points process should never
invoke graphics calls as it is separate from the draw process.

Callbacks should not modify the OpenGL Performer database but may use
\f3\%pfGet\fP routines to inquire information as
desired.

Draw callbacks should not attempt to perform framebuffer swapping
operations directly since OpenGL Performer must control this to handle
frame and channel synchronization.  If user control of buffer swapping
is required, register a \f3\%pfPipeSwapFunc\fP
callback to cause the named user written function to be used by OpenGL
Performer for swapping buffers.

Sorting back-to-front is required for accurate rendering of
\f3\%PFTR_BLEND_ALPHA\fP surfaces. The ordering mechanism described above
provides range sorting on a per-pfGeoSet, not a per-triangle basis so
some anomalies may be apparent when rendering transparent surfaces.
These anomalies may be reduced by rejecting back-facing polygons (see
\f3\%pfCullFace\fP and \f3\%PFSTATE_CULLFACE\fP).

The OpenGL Performer world coordinate system is +X = East, +Y = North, +Z
= Up and viewing coordinate system is +X = Right, +Y = Forward, +Z =
Up.  Note that this is not the same as the OpenGL default
coordinate system which uses +X = Right, +Y = Up, +Z = Out of the
screen.  OpenGL Performer internally manages the transformation required
to go from a 'Z-up' world to a 'Y-up' world.

\f3\%pfDrawChanStats\fP
and \f3\%pfDrawFStats\fP do not actually draw
the diagram but set a flag so that the diagram is drawn just before
OpenGL Performer swaps image buffers.

Drawing the timing diagram does take a small amount of time in the
draw process, so it will perturb the frame rate and timing data to
some degree.

Fade-based level of detail transition is supported only on RealityEngine
systems and then only when multisampling is enabled.

.SH BUGS

Intersections, and thus picking, with lines and points is not yet
implemented.
.SH SEE ALSO
pfConfigPWin,
pfAddChan,
pfInsertChan,
pfMoveChan,
pfRemoveChan,
pfPipeSwapFunc,
pfNodeIsectSegs,
pfLoadGState,
pfNodeBSphere,
pfNodeTravMask,
pfStatsClass,
pfStatsClassMode,
pfConfig,
pfCullFace,
pfDispList,
pfEarthSky,
pfESkyFog,
pfObject,
pfFrame,
pfFrameRate,
pfFrustum,
pfGetSemaArena,
pfLightSource,
pfLOD,
pfMultipipe,
pfMultiprocess,
pfPolytope,
pfPhase,
pfScene,
pfGetSemaArena,
pfTransparency,
pfuLockCPU
