'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfHighlight" "3pf"
.SH NAME
.upperok
.B pfNewHlight,
.B pfGetHlightClassType,
.B pfApplyHlight,
.B pfHlightMode,
.B pfGetHlightMode,
.B pfHlightColor,
.B pfGetHlightColor,
.B pfHlightAlpha,
.B pfGetHlightAlpha,
.B pfHlightNormalLength,
.B pfGetHlightNormalLength,
.B pfHlightLineWidth,
.B pfGetHlightLineWidth,
.B pfHlightPntSize,
.B pfGetHlightPntSize,
.B pfHlightLinePat,
.B pfGetHlightLinePat,
.B pfHlightFillPat,
.B pfGetHlightFillPat,
.B pfHlightGState,
.B pfGetHlightGState,
.B pfHlightGStateIndex,
.B pfGetHlightGStateIndex,
.B pfHlightTex,
.B pfGetHlightTex,
.B pfHlightTEnv,
.B pfGetHlightTEnv,
.B pfHlightTGen,
.B pfGetHlightTGen,
.B pfGetCurHlight
\- 
Control, create, modify and query highlight state
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfHighlight\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfHighlight*
\f3\%pfNewHlight\fP(void\ *arena);
.nf
.fi
.TP
pfType *
\f3\%pfGetHlightClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfApplyHlight\fP(pfHighlight\ *\ hl);
.nf
.fi
.TP
void
\f3\%pfHlightMode\fP(pfHighlight\ *hl,
'in +2
'll -2
uint\ mode);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfGetHlightMode\fP(const\ pfHighlight\ *hl);
.nf
.fi
.TP
void
\f3\%pfHlightColor\fP(pfHighlight\ *hl,
'in +2
'll -2
uint\ which,
float\ r,
float\ g,
float\ b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetHlightColor\fP(const\ pfHighlight\ *hl,
'in +2
'll -2
uint\ which,
float\ *r,
float\ *g,
float\ *b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfHlightAlpha\fP(pfHighlight\ *hl,
'in +2
'll -2
float\ a);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetHlightAlpha\fP(const\ pfHighlight\ *hl);
.nf
.fi
.TP
void
\f3\%pfHlightNormalLength\fP(pfHighlight*\ hl,
'in +2
'll -2
float\ length,
float\ bboxScale);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetHlightNormalLength\fP(const\ pfHighlight*\ hl,
'in +2
'll -2
float\ *length,
float\ *bboxScale);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfHlightLineWidth\fP(pfHighlight*\ hl,
'in +2
'll -2
float\ width\ );
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetHlightLineWidth\fP(const\ pfHighlight*\ hl);
.nf
.fi
.TP
void
\f3\%pfHlightPntSize\fP(pfHighlight*\ hl,
'in +2
'll -2
float\ size\ );
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetHlightPntSize\fP(const\ pfHighlight*\ hl);
.nf
.fi
.TP
void
\f3\%pfHlightLinePat\fP(pfHighlight*\ hl,
'in +2
'll -2
int\ which,
ushort\ pat);
.in
.ll
.nf
.fi
.TP
ushort
\f3\%pfGetHlightLinePat\fP(const\ pfHighlight*\ hl,
'in +2
'll -2
int\ which);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfHlightFillPat\fP(pfHighlight*\ hl,
'in +2
'll -2
int\ which,
uint\ *fillPat\ );
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetHlightFillPat\fP(const\ pfHighlight*\ hl,
'in +2
'll -2
int\ which,
uint\ *pat);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfHlightGState\fP(pfHighlight*\ hl,
'in +2
'll -2
pfGeoState\ *gstate);
.in
.ll
.nf
.fi
.TP
pfGeoState *
\f3\%pfGetHlightGState\fP(const\ pfHighlight*\ hl);
.nf
.fi
.TP
void
\f3\%pfHlightGStateIndex\fP(pfHighlight*\ hl,
'in +2
'll -2
int\ id);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetHlightGStateIndex\fP(const\ pfHighlight*\ hl);
.nf
.fi
.TP
void
\f3\%pfHlightTex\fP(pfHighlight*\ hl,
'in +2
'll -2
pfTexture\ *tex);
.in
.ll
.nf
.fi
.TP
pfTexture*
\f3\%pfGetHlightTex\fP(const\ pfHighlight*\ hl);
.nf
.fi
.TP
void
\f3\%pfHlightTEnv\fP(pfHighlight*\ hl,
'in +2
'll -2
pfTexEnv\ *tev);
.in
.ll
.nf
.fi
.TP
pfTexEnv*
\f3\%pfGetHlightTEnv\fP(const\ pfHighlight*\ hl);
.nf
.fi
.TP
void
\f3\%pfHlightTGen\fP(pfHighlight*\ hl,
'in +2
'll -2
pfTexGen\ *tgen);
.in
.ll
.nf
.fi
.TP
pfTexGen*
\f3\%pfGetHlightTGen\fP(const\ pfHighlight*\ hl);
.nf
.fi
.TP
pfHighlight *
\f3\%pfGetCurHlight\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfHighlight\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfHighlight\fP.
Casting an object of class \f3\%pfHighlight\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfHighlight\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'hl\ \ 'u
\f2hl\fP
identifies a pfHighlight.
.SH DESCRIPTION

OpenGL Performer supports a mechanism for highlighting individual objects
in a scene with a variety of special drawing styles that are activated
by applying a pfHighlight state structure.  Highlighting makes use of
outlining of lines and polygons and of filling polygons with patterned
or textured overlays.  Highlighted drawing uses a highlighting color, or
foreground color, and in some modes, a contrasting, or background,
color.  Additionally, there are highlighting modes for displaying the
bound normals and cached bounding boxes of pfGeoState geometry.

A pfHighlight structure can be applied in immediate mode to the current
active pfGeoState with \f3\%pfApplyHlight\fP, and added
to a specific pfGeoState with \f3\%pfGStateMode\fP.  Highlighting can be
enabled and disabled in immediate mode with
\f3\%pfEnable\fP(\f3\%PFEN_HIGHLIGHTING\fP)
and
\f3\%pfDisable\fP(\f3\%PFEN_HIGHLIGHTING\fP),
and the override for highlighting can be set with
\f3\%pfOverride\fP(\f3\%PFSTATE_HIGHLIGHT\fP).  Unlike other types of state, a
structure may be applied to a specific pfGeoSet with \f3\%pfGSetHlight\fP.
This will cause the pfGeoSet to be drawn as highlighted with the
specified highlighting structure, unless highlighting has been
overridden as off with \f3\%pfOverride\fP.

This special exception was made because it is assumed that highlighting
is to be used dynamically to highlight specific objects for a short
period of time and should not impact the rest of the state structure.

Highlighting does have some performance penalty, in part because some
of the highlighting modes make use of expensive graphics features, and
in part because, to offer this flexibility, highlighted objects go
through a slightly slower path in OpenGL Performer rendering code.

\f3\%pfNewHlight\fP creates and returns a handle to a pfHighlight.
\f2arena\fP specifies a malloc arena out of which the pfHighlight is
allocated or \f3\%NULL\fP for allocation off the process heap.
pfHighlights can be deleted with \f3\%pfDelete\fP.

\f3\%pfGetHlightClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfHighlight\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetHlightClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfHighlight\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfApplyHlight\fP makes \f2hl\fP
the current active pfHighlight structure.

\f3\%pfGetCurHlight\fP returns a pointer to the current active pfHighlight
structure.

\f3\%pfHlightGState\fP
sets a highlighting pfGeoState of \f2hl\fP to \f2gstate\fP.
This pfGeoState is made the current pfGeoState for the highlighting phase
of the drawing of the highlighted pfGeoSet.
Additional highlighting mode changes are applied on top of this pfGeoState.
This allows a user to make additional custom state changes to highlighted objects.
\f3\%pfGetHlightGState\fP
returns the previously set highlighting pfGeoState of \f2hl\fP.
\f3\%pfHlightGStateIndex\fP specifies the index
into a pfGeoState table to use for the highlighting pfGeoState.
\f3\%pfGetHlightGStateIndex\fP
returns the previously set highlighting pfGeoState index of \f2hl\fP.

\f3\%pfHlightMode\fP sets the highlighting mode \f2mode\fP
for \f2hl\fP.
The mode specifies the drawing style:
how the filled region and polygon outlines of an object should be
drawn.  This mode is a bitmask composed by bitwise OR-ing together
the following tokens.  The default is \f3\%PFHL_FILL\fP, and a zero mask
is ignored.
.RS
.TP 20
\f3\%PFHL_POINTS\fP
Selects the display of object vertices as points using the point size specified by
\f3\%pfHlightPntSize\fP.
.TP
\f3\%PFHL_NORMALS\fP
Selects the display of object normals as lines of width determined by
\f3\%pfHlightLineWidth\fP, length determined by
\f3\%pfHlightNormalLength\fP, and color determined by
\f3\%pfHlightColor\fP.
.TP
\f3\%PFHL_BBOX_LINES\fP
Selects the display of the object's cached bounding box in lines
of width determined by \f3\%pfHlightLineWidth\fP
and color determined by \f3\%pfHlightColor\fP.
.TP
\f3\%PFHL_BBOX_FILL\fP
Selects the display of the object's cached bounding box as a
solid filled box of the foreground color of \f2hl\fP.
.TP
\f3\%PFHL_LINES\fP
Selects outlining of primitives. The lines are drawn
of width determined by \f3\%pfHlightLineWidth\fP
and color determined by \f3\%pfHlightColor\fP.
.TP
\f3\%PFHL_LINES_R\fP
Selects outlining of primitives and reverses foreground and background
colors for the lines.
.TP
\f3\%PFHL_LINESPAT\fP
Selects outlining of primitives with patterned lines.
.TP
\f3\%PFHL_LINESPAT2\fP
Selects outlining of primitives with 2-pass patterned lines, using both
foreground and background highlighting colors.
.TP
\f3\%PFHL_FILL\fP
Selects filling of polygons with the foreground highlighting color.  In
this mode, the highlighted polygons are filled once.  The foreground
highlighting color is used as the base color of polygons, and as the
material color for lit polygons.
.TP
\f3\%PFHL_FILL_R\fP
Selects outlining of primitives and reverses foreground and background
colors for fill highlight modes.
.TP
\f3\%PFHL_FILLTEX\fP
Selects the application of a highlight texture on the object geometry.
The default texture may be used, or a texture and associated attributes may be
set with
\f3\%pfHlightTex\fP,
\f3\%pfHlightTEnv\fP, and
\f3\%pfHlightTGen\fP.
.TP
\f3\%PFHL_FILLPAT\fP
Selects patterned filling of polygons with the foreground highlighting color.
This patterning will be done in addition to the normal filling of the
polygons and will be an overlay with the normal base polygons showing through.
.TP
\f3\%PFHL_FILLPAT2\fP
Selects 2-pass patterned filling of polygons using both the foreground and
background highlighting colors.  This patterning will be done in addition to
the normal filling of the polygons and will be an overlay with the normal
base polygons showing through.
.TP
\f3\%PFHL_SKIP_BASE\fP
Causes the normal drawing phase of the highlighted pfGeoSet to be skipped.
This includes the application of the pfGeoState for that pfGeoSet.
.RE

\f3\%pfGetHlightMode\fP
returns the highlighting mode of \f2hl\fP.

\f3\%pfHlightColor\fP
sets the specified highlighting color \f2color\fP,
\f3\%PFHL_FGCOLOR\fP or \f3\%PFHL_BGCOLOR\fP, of \f2hl\fP, to \f2r\fP, \f2g\fP, and
\f2b\fP.
\f3\%pfGetHlightColor\fP
copies the specified \f2color\fP, \f3\%PFHL_FGCOLOR\fP
or \f3\%PFHL_BGCOLOR\fP, of \f2hl\fP, into \f2r\fP, \f2g\fP, and \f2b\fP.

\f3\%pfHlightAlpha\fP
sets the alpha of \f2hl\fP to \f2a\fP.
\f3\%pfGetHlightAlpha\fP
returns the alpha of \f2hl\fP.

\f3\%pfHlightLineWidth\fP
sets the line width to be used for the \f3\%PFHL_LINES\fP, \f3\%PFHL_NORMALS\fP, and
\f3\%PFHL_BBOX\fP  highlighting modes
of \f2hl\fP to \f2width\fP.
If \f2width\fP is not greater than zero, the line width will not
be set by the highlight structure and will be inherited from the
current environment.
\f3\%pfGetHlightLineWidth\fP
returns the line width of \f2hl\fP.

\f3\%pfHlightNormalLength\fP
sets a length and a scale factor for the normals drawn
in the \f3\%PFHL_NORMALS\fP highlighting mode. The normals will
be drawn of length
.CE
normalLength + bboxScale*bboxLength.
\f3\%pfGetHlightNormalLength\fP
will return the normal length and scale values of
\f2hl\fP in \f2length\fP and \f2bboxScale\fP,
respectively.

\f3\%pfHlightPntSize\fP
sets the point size to be used for the \f3\%PFHL_POINTS\fP highlighting mode
of \f2hl\fP to \f2size\fP.
If \f2size\fP is not greater than zero, the point size will not
be set by the highlight structure and will be inherited from the
current environment.
\f3\%pfGetHlightPntSize\fP
returns the point size of \f2hl\fP.

\f3\%pfHlightLinePat\fP
sets the pattern to be used for lines in the  \f3\%PFHL_LINES\fP highlighting modes
of \f2hl\fP to \f2pat\fP.
\f3\%pfGetHlightLinePat\fP
returns the highlighting line pattern of \f2hl\fP.
For both functions, the \f2which\fP argument determines if the line pattern
pertaining to the foreground (\f3\%PFHL_FGPAT\fP) or background (\f3\%PFHL_BGPAT\fP)
style is to be set or inquired.

\f3\%pfHlightFillPat\fP
sets the fill pattern to be used in the  \f3\%PFHL_FILLPAT\fP highlighting modes
of \f2hl\fP to \f2pat\fP.
\f3\%pfGetHlightFillPat\fP
returns the highlighting fill pattern of \f2hl\fP.

\f3\%pfHlightTex\fP
sets the pfTexture for the \f3\%PFHL_TEX\fP highlighting modes
of \f2hl\fP to \f2tex\fP.
\f3\%pfGetHlightTex\fP
returns the previously set highlighting texture of \f2hl\fP.
If a texture is not specified but the \f3\%PFHL_TEX\fP is selected for \f2hl\fP,
a default two-component texture using the highlighting foreground and background colors will be used.

\f3\%pfHlightTEnv\fP
sets the texture environment (pfTexEnv) for the \f3\%PFHL_TEX\fP highlighting modes
of \f2hl\fP to \f2tev\fP.
\f3\%pfGetHlightTEnv\fP
returns the previously set highlighting texture environment of \f2hl\fP.
If a texture environment is not specified but the \f3\%PFHL_TEX\fP is selected
for \f2hl\fP, a default texture blend environment will be used.

\f3\%pfHlightTGen\fP
sets the texture coordinate generation attribute (pfTexGen)
for the \f3\%PFHL_TEX\fP highlighting modes
of \f2hl\fP to \f2tgen\fP.
\f3\%pfGetHlightTGen\fP
returns the previously set highlighting pfTexGen of \f2hl\fP.
If a texture coordinate generation function is not specified and the object to be
highlighted has no texture coordinates of its own and the \f3\%PFHL_TEX\fP is selected
for \f2hl\fP, a default texture coordinate generation
function will be used.

.SH EXAMPLES
Example 1: Set up a highlighting structure and apply it in immediate mode
to the current pfGeoState.
.Ex
.nf

pfHighlight *hl;

/* allocate a new highlight color */
hl = pfNewHlight(NULL);

/* specify highlight modes */
pfHlightMode(hl, PFHL_FILL);
pfHlightColor(hl, PFHL_FGCOLOR, 1.0f,  0.0f,  1.0f);

/* apply highlight */
pfApplyHlight(hl);
.Ee
.fi
.na

.SH SEE ALSO
pfDelete,
pfDisable,
pfDrawHlightedGSet,
pfEnable,
pfGSetHlight,
pfGeoState,
pfGetGSetHlight,
pfObject,
pfOverride,
pfState
