'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfVideoChannel" "3pf"
.SH NAME
.upperok
.B pfNewVChan,
.B pfGetVChanClassType,
.B pfVChanAreaScale,
.B pfVChanCallig,
.B pfVChanFullRect,
.B pfVChanId,
.B pfVChanOutputOrigin,
.B pfVChanOutputSize,
.B pfVChanScale,
.B pfVChanMinScale,
.B pfVChanMaxScale,
.B pfVChanMode,
.B pfVChanScreen,
.B pfVChanWSWindow,
.B pfGetVChanAreaScale,
.B pfGetVChanCallig,
.B pfGetVChanId,
.B pfGetVChanInfo,
.B pfGetVChanOutputOrigin,
.B pfGetVChanOutputSize,
.B pfGetVChanScale,
.B pfGetVChanMinScale,
.B pfGetVChanMaxScale,
.B pfGetVChanMinDeltas,
.B pfGetVChanMode,
.B pfGetVChanOrigin,
.B pfGetVChanSize,
.B pfGetVChanScreen,
.B pfGetVChanWSWindow,
.B pfApplyVChan,
.B pfBindVChan,
.B pfSelectVChan,
.B pfUnbindVChan,
.B pfIsVChanBound,
.B pfIsVChanActive,
.B pfGetCurVChan
\- 
Create, modify and query video channel state
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfWSVideoChanne\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfVideoChannel *
\f3\%pfNewVChan\fP(void\ *arena);
.nf
.fi
.TP
pfType *
\f3\%pfGetVChanClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfVChanAreaScale\fP(pfVideoChannel*\ vchan,
'in +2
'll -2
float\ s);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVChanCallig\fP(pfVideoChannel*\ vchan\ pfCalligraphic*\ callig);
.nf
.fi
.TP
void
\f3\%pfVChanFullRect\fP(pfVideoChannel*\ vchan);
.nf
.fi
.TP
void
\f3\%pfVChanId\fP(pfVideoChannel*\ vchan,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVChanOutputOrigin\fP(pfVideoChannel*\ vchan,
'in +2
'll -2
int\ xo,
int\ yo);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVChanOutputSize\fP(pfVideoChannel*\ vchan,
'in +2
'll -2
int\ xs,
int\ ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVChanScale\fP(pfVideoChannel*\ vchan,
'in +2
'll -2
float\ xs,
float\ ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVChanMinScale\fP(pfVideoChannel*\ vchan,
'in +2
'll -2
float\ xs,
float\ ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVChanMaxScale\fP(pfVideoChannel*\ vchan,
'in +2
'll -2
float\ xs,
float\ ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVChanMode\fP(pfVideoChannel*\ vchan,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVChanScreen\fP(pfVideoChannel*\ vchan,
'in +2
'll -2
int\ screen);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVChanWSWindow\fP(pfVideoChannel*\ vchan,
'in +2
'll -2
pfWSWindow\ wsWin);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetVChanAreaScale\fP(pfVideoChannel*\ vchan);
.nf
.fi
.TP
pfCalligraphic*
\f3\%pfGetVChanCallig\fP(const\ pfVideoChannel*\ vchan);
.nf
.fi
.TP
int
\f3\%pfGetVChanId\fP(pfVideoChannel*\ vchan);
.nf
.fi
.TP
pfWSVideoChannelInfo
\f3\%pfGetVChanInfo\fP(pfVideoChannel*\ vchan);
.nf
.fi
.TP
void
\f3\%pfGetVChanOutputOrigin\fP(const\ pfVideoChannel*\ vchan,
'in +2
'll -2
int\ *xo,
int\ *yo);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetVChanOutputSize\fP(const\ pfVideoChannel*\ vchan,
'in +2
'll -2
int\ *xs,
int\ *ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetVChanScale\fP(const\ pfVideoChannel*\ vchan,
'in +2
'll -2
float\ *xs,
float\ *ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetVChanMinScale\fP(const\ pfVideoChannel*\ vchan,
'in +2
'll -2
float\ *xs,
float\ *ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetVChanMaxScale\fP(const\ pfVideoChannel*\ vchan,
'in +2
'll -2
float\ *xs,
float\ *ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetVChanMinDeltas\fP(const\ pfVideoChannel*\ vchan,
'in +2
'll -2
int\ *dx,
int\ *dy);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetVChanMode\fP(pfVideoChannel*\ vchan,
'in +2
'll -2
int\ _mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetVChanOrigin\fP(pfVideoChannel*\ vchan,
'in +2
'll -2
int\ *xo,
int\ *yo);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetVChanSize\fP(pfVideoChannel*\ vchan,
'in +2
'll -2
int\ *xs,
int\ *ys);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetVChanScreen\fP(const\ pfVideoChannel*\ vchan);
.nf
.fi
.TP
pfWSWindow
\f3\%pfGetVChanWSWindow\fP(const\ pfVideoChannel*\ vchan);
.nf
.fi
.TP
void
\f3\%pfApplyVChan\fP(pfVideoChannel*\ vchan);
.nf
.fi
.TP
void
\f3\%pfBindVChan\fP(pfVideoChannel*\ vchan);
.nf
.fi
.TP
void
\f3\%pfSelectVChan\fP(pfVideoChannel*\ vchan);
.nf
.fi
.TP
void
\f3\%pfUnbindVChan\fP(pfVideoChannel*\ vchan);
.nf
.fi
.TP
int
\f3\%pfIsVChanBound\fP(const\ pfVideoChannel*\ vchan);
.nf
.fi
.TP
int
\f3\%pfIsVChanActive\fP(const\ pfVideoChannel*\ vchan);
.nf
.fi
.TP
pfVideoChannel *
\f3\%pfGetCurVChan\fP(void);
.fi

.Ex
.nf

/* typedef of X-based Performer Types */
typedef XSGIvcChannelInfo         *pfWSVideoChannelInfo;
.Ee
.fi
.na

.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfVideoChannel\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfVideoChannel\fP.
Casting an object of class \f3\%pfVideoChannel\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfVideoChannel\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'vchan\ \ 'u
\f2vchan\fP
identifies a pfVideoChannel
.SH DESCRIPTION

The \f3\%pfVideoChannel\fP capability is used to query and control the state and
output area of a hardware video channel.  This support is done through the XSGIvc video
control X extension for SGI platforms.
See the \f3\%XSGIvc\fP man page for more information on this library.
The \f3\%pfVideoChannel\fP only accesses video hardware in the action routines of
\f3\%pfApplyVChan\fP,
\f3\%pfBindVChan\fP, and
\f3\%pfUnbindVChan\fP.
All parameters set on the pfVideoChannel take effect turning these actions.
These actions require that a pfWSWindow be set on the \f3\%pfVideoChannel\fP
via \f3\%pfVChanWSWindow\fP.

\f3\%pfNewVChan\fP creates and returns a handle to a pfVideoChannel.  \f2arena\fP
specifies a malloc arena out of which the pfVideoChannel is allocated or
\f3\%NULL\fP for allocation off the process heap.  pfVideoChannel can be deleted
with \f3\%pfDelete\fP.

\f3\%pfVChanMode\fP sets a given mode to
\f2val\fP where \f2mode\fP may be one of the following:
.RS
.TP
\f3\%PFVCHAN_SYNC\fP
sets the video boundary upon which changes to the video channel origin and
size should take effect: \f3\%PFVCHAN_SYNC_SWAP\fP for swapbuffers (the default)
and \f3\%PFVCHAN_SYNC_FIELD\fP for a field, or vertical retrace, boundary.
For resizing for load management, the default swapbuffers boundary is
usually appropriate. Allowing changes to the origin and size take
effect on the following field boundary allows the panning of video output
from the visible color buffer asynchronous to drawing and so should be used
in conjunction with the \f3\%PFVCHAN_AUTO_APPLY\fP mode and doing a
\f3\%pfSelectVChan\fP on the pfVideoChannel.
.TP
\f3\%PFVCHAN_AUTO_APPLY\fP
accepts a boolean value indicating if changes to \f2vchan\fP should be
applied automatically, as opposed to waiting for
an explicit call to \f3\%pfApplyVChan\fP. This is done if
\f2vchan\fP has been selected via
\f3\%pfSelectVChan\fP
to be the current active pfVideoChannel. The changes
are not applied by the set routines because those routines may
be called from an asynchronous process.
On InfiniteReality changes to the video channel
must be applied by the draw process so these
are applied internally by the rendering portion of OpenGL Performer.
.RE
\f3\%pfGetVChanMode\fP will return the
value of the specified \f2mode\fP for \f2vchan\fP.

\f3\%pfVChanFullRect\fP will cause the output area
of the video channel to be reset to its full size.

\f3\%pfVChanId\fP will cause the pfVideoChannel to refer
to the hardware video channel indicated by \f2index\fP.  This is the same index used by the
XSGIvc routines.

\f3\%pfVChanOutputOrigin\fP will set
the origin of the output area of the video channel to be
the lower-left channel relative coordinates of \f2xo\fP, \f2yo\fP.
The actual screen origin of the video channel can be gotten with
\f3\%pfGetVChanOrigin\fP.

\f3\%pfVChanOutputSize\fP will set
the size of the output area of the video channel to be that
specified by \f2xs\fP, \f2ys\fP.  The size of the video channel can not be
set larger than its full size which can be queried with
\f3\%pfGetVChanSize\fP.

\f3\%pfVChanAreaScale\fP will scale
the X and Y dimensions of the output area of the video channel to
achieve a scaling of the drawing area by \f2s\fP. The implementation is
to scale both X and Y by the square root of \f2s\fP, so that compound
effect on area is \f2s\fP.  For example a 1000-pixel square display area
scaled by 0.5 would result in a 707-pixel square render area, since
707*707 is 0.5*1000*1000 (the actual X and Y resolutions are subject
to hardware constrains as well).  The maximum scale allowed is 1.0
which will reset the channel output area to its full size.

\f3\%pfVChanScale\fP will scale
the size of the X and Y dimensions output area of the video channel by
specified by \f2xs\fP, \f2ys\fP. The minimum and and maximum scaling allowed is
that set by \f3\%pfVChanMinScale\fP
and \f3\%pfVChanMaxScale\fP.
The minimum and maximum scale bounds default to 0.25 and 1.0, respectively.

\f3\%pfVChanMinScale\fP will set the
lower bound on the allowable pixel scale values for the X and Y dimensions
of the pfVideoChannel.

\f3\%pfVChanMaxScale\fP will set the
upper bound on the allowable pixel scale values for the X and Y dimensions
of the pfVideoChannel.

\f3\%pfVChanWSWindow\fP sets the WSWindow for
\f2vchan\fP to be \f2wsWin\fP.
This window should be the WSDrawable that is connected to the main GL
context being displayed into that video channel.  This can be gotten from a
pfWindow or pfPipeWindow with
pfGetWinWSDrawable\f3\% or
pfGetPWinWSDrawable\fP, respectively.
Video channel resize operations will be triggered by the
swapping of the display buffers for that GL context.
If \f2wsWin\fP is NULL, it will cause an unbind of the video channel from
its current WSWindow upon the next call to
\f3\%pfApplyVChan\fP.
If \f2wsWin\fP is not null,
the screen of the pfVideoChannel will be set to that of \f2wsWin\fP.

\f3\%pfGetVChanId\fP will return the video channel
index of the pfVideoChannel.

\f3\%pfGetVChanInfo\fP will return the XSGIvcChannelInfo
handle, useful for doing XSGIvc queries directly.

\f3\%pfGetVChanMinDeltas\fP will return the
minimum resolution of resize for X and Y that the video channel size can
be changed in \f2dx\fP and \f2dy\fP, respectively.

\f3\%pfGetVChanOutputOrigin\fP will return
the origin of the output area of the video channel in \f2xo\fP, \f2yo\fP.

\f3\%pfGetVChanOutputSize\fP will return
the size of the output area of the video channel in \f2xs\fP and \f2ys\fP.

\f3\%pfGetVChanScale\fP will return
the area scale the video channel. This value represents the ratio of
drawn to displayed area in pixels. For example a 1000-pixel square
display scaled to 707-pixels would return an area scale value of
to 0.5, since 707*707 is 0.5*1000*1000.

\f3\%pfGetVChanScale\fP will return
the scale of the X and Y dimensions output area of the video channel
in \f2xs\fP and \f2ys\fP.

\f3\%pfGetVChanMinScale\fP will return
the lower bound on pixel scale of the X and Y dimensions
in \f2xs\fP and \f2ys\fP. The default pixel scale lower bound is 0.25.

\f3\%pfGetVChanMaxScale\fP will return
the upper bound on pixel scale of the X and Y dimensions
in \f2xs\fP and \f2ys\fP. The default pixel scale upper bound is 1.0.

\f3\%pfVChanScreen\fP sets the screen
number of \f2vchan\fP to \f2screen\fP and
\f3\%pfGetVChanScreen\fP returns
the screen number of \f2vchan\fP.

\f3\%pfGetVChanSize\fP will return the full
size of the video channel in \f2xs\fP and \f2ys\fP.

\f3\%pfBindVChan\fP forces a bind of the video
channel to the WSWindow set with
\f3\%pfVChanWSWindow\fP.

\f3\%pfUnbindVChan\fP forces an unbind of the video
from its current WSWindow.  This will also cause the video channel to
reset its output area to the configuration it had before the channel
was bound.

\f3\%pfIsVChanBound\fP returns a boolean
value indicating whether or not the \f2vchan\fP
is currently bound to a window and able to be resized.

\f3\%pfIsVChanActive\fP returns a boolean
value indicating whether or not the \f2vchan\fP
is currently active and able to produce video output.

\f3\%pfSelectPVChan\fP makes \f2vchan\fP
the current pfVideoChannel in the process. This should be done in
a rendering process if the purpose is for using the \f3\%PFVCHAN_AUTO_APPLY\fP
mode.

\f3\%pfGetCurVChan\fP will return a pointer to the current pfVideoChannel.

\f3\%pfApplyVChan\fP will apply the current
origin and size parameters to the currently selected video channel.
A bind of the video channel to the specified WSWindow will be automatically
done if necessary.

\f3\%pfVChanCallig\fP set the \f2callig\fP
to use with this pfVideoChannel. If a light-point board (see pfCalligraphic)
has been initialized before pfConfig, then each pfVideoChannel automatically
create a pfCalligraphic with its screen as the Light Point Board id, and
its display id as the channel to use on the Light Point Board.

\f3\%pfGetVChanCallig\fP returns the
pfCalligraphic in use with this pfVideoChannel, or NULL if none are
used (so only Raster Light Points are available).

.SH NOTES


pfVideoChannel functionality is not currently supported under Linux.

An XSGIvc video channel may only be bound to a single window at a time on the system.
Only  a single pfVideoChannel may bind a hardware video channel.

On InfiniteReality, changes to video channel origin and size require an active graphics
context and so should be made in a rendering process to avoid a graphics context change
which can be expensive.

See the sample program /usr/share/Performer/src/pguide/libpr/C/queryvchan.c
for an example of how to query general video channel attributes.
See the sample program /usr/share/Performer/src/pguide/libpr/C/vchan.c for
a basic resizing example using pfVideoChannels.

.SH SEE ALSO
pfDelete,
pfDispList,
pfGetNumScreenVChans,
pfState,
pfWindow,
XSGIvc,
glXSGIvcQueryChannelInfo,
glXBindChannelToWindowSGIX.
