'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfiInputXformDrive" "3pf"
.SH NAME
.upperok
.B pfiGetIXformDriveClassType,
.B pfiNewIXformDrive,
.B pfiIXformDriveMode,
.B pfiGetIXformDriveMode,
.B pfiIXformDriveHeight,
.B pfiGetIXformDriveHeight,
.B pfiCreate2DIXformDrive,
.B pfiUpdate2DIXformDrive
\- 
pfiInputXformDrive functions.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfiInputXformDrive\ *\ \ \ 'u
#include <Performer/pfui.h>
.nf
.fi
.TP
pfType *
\f3\%pfiGetIXformDriveClassType\fP(void);
.nf
.fi
.TP
pfiInputXformDrive *
\f3\%pfiNewIXformDrive\fP(void\ *arena);
.nf
.fi
.TP
void
\f3\%pfiIXformDriveMode\fP(pfiInputXformDrive\ *drive,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfiGetIXformDriveMode\fP(pfiInputXformDrive\ *drive,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiIXformDriveHeight\fP(pfiInputXformDrive*\ drive,
'in +2
'll -2
float\ height);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfiGetIXformDriveHeight\fP(pfiInputXformDrive*\ drive);
.nf
.fi
.TP
pfiInputXformDrive *
\f3\%pfiCreate2DIXformDrive\fP(void\ *arena);
.nf
.fi
.TP
int
\f3\%pfiUpdate2DIXformDrive\fP(pfiInputXform\ *drive,
'in +2
'll -2
pfiInputCoord\ *icoord,
void\ *data);
.in
.ll
.fi
.SH DESCRIPTION

\f3\%pfiInputXformDrive\fP functions.

A pfiInputXformDrive is a child of the pfiInputXform class and
so pfiInputXform routines may be called with a pfiInputXformDrive.
See the pfiInputXform reference page for information on pfiInputXform
functionality.
The pfiInputXformDrive has a complete C++ API
following the conventions of general OpenGL Performer C++ API; C++ methods
are declared in /usr/include/Performer/pfui/pfiInputXformDrive.h.

\f3\%pfiInit\fP should be called once before any pfiInputXformDrive routines and before
the forked creation of any additional processes that will be calling
pfiInputXformDrive routines.
.SH NOTES

The libpfui source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
