'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfiPick" "3pf"
.SH NAME
.upperok
.B pfiGetPickClassType,
.B pfiNewPick,
.B pfiPickMode,
.B pfiGetPickMode,
.B pfiPickHitFunc,
.B pfiGetPicktHitFunc,
.B pfiAddPickChan,
.B pfiInsertPickChan,
.B pfiRemovePickChan,
.B pfiGetPickNumHits,
.B pfiGetPickNode,
.B pfiGetPickGSet,
.B pfiSetupPickChans,
.B pfiDoPick,
.B pfiResetPick
\- 
pfiPick functions.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfGeoSet\ *\ \ \ 'u
#include <Performer/pfui.h>
.nf
.fi
.TP
pfType *
\f3\%pfiGetPickClassType\fP(void);
.nf
.fi
.TP
pfiPick *
\f3\%pfiNewPick\fP(void\ *arena);
.nf
.fi
.TP
void
\f3\%pfiPickMode\fP(pfiPick\ *pick,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfiGetPickMode\fP(pfiPick\ *pick,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiPickHitFunc\fP(pfiPick\ *pick,
'in +2
'll -2
pfiPickFuncType\ func,
void\ *data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetPicktHitFunc\fP(pfiPick\ *pick,
'in +2
'll -2
pfiPickFuncType\ *func,
void\ **data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiAddPickChan\fP(pfiPick\ *pick,
'in +2
'll -2
pfChannel\ *chan);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiInsertPickChan\fP(pfiPick\ *pick,
'in +2
'll -2
int\ index,
pfChannel\ *chan);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiRemovePickChan\fP(pfiPick\ *pick,
'in +2
'll -2
pfChannel\ *chan);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfiGetPickNumHits\fP(pfiPick\ *pick);
.nf
.fi
.TP
pfNode *
\f3\%pfiGetPickNode\fP(pfiPick\ *pick);
.nf
.fi
.TP
pfGeoSet *
\f3\%pfiGetPickGSet\fP(pfiPick\ *pick);
.nf
.fi
.TP
void
\f3\%pfiSetupPickChans\fP(pfiPick\ *pick);
.nf
.fi
.TP
int
\f3\%pfiDoPick\fP(pfiPick\ *pick,
'in +2
'll -2
int\ x,
int\ y);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiResetPick\fP(pfiPick\ *pick);
.fi

.Ex
.nf

typedef int (*pfiPickFuncType)(pfiPick *, void *);
.Ee
.fi
.na

.SH DESCRIPTION

\f3\%pfiPick\fP functions.

The pfiPick has a complete C++ API
following the conventions of general OpenGL Performer C++ API; C++ methods
are declared in /usr/include/Performer/pfui/pfiPick.h.

\f3\%pfiInit\fP should be called once before any pfiPick routines and before
the forked creation of any additional processes that will be calling
pfiPick routines.
.SH NOTES

The libpfui source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
