'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfCycleBuffer OBSOLETE" "3pf"
.SH NAME
.upperok
.B pfCycleBuffer,
.B pfCycleMemory
\- 
pfCycleBuffer and pfCycleMemory obsoleted by pfFlux and pfFluxMemory
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfCycleBuffer\ *\ \ \ 'u
#include <Performer/pr/pfCycleBuffer.h>
.nf
.fi
.TP
\ 
\f3\%pfCycleBuffer::pfCycleBuffer\fP(size_t\ nbytes)
.nf
.fi
.TP
static pfType *
\f3\%pfCycleBuffer::getClassType\fP(void);
.nf
.fi
.TP
void *
\f3\%pfCycleBuffer::getCurData\fP();
.nf
.fi
.TP
pfCycleMemory *
\f3\%pfCycleBuffer::getCMem\fP(int\ index);
.nf
.fi
.TP
void
\f3\%pfCycleBuffer::changed\fP();
.nf
.fi
.TP
void
\f3\%pfCycleBuffer::init\fP(void\ *data);
.nf
.fi
.TP
static int
\f3\%pfCycleBuffer::config\fP(int\ numBuffers);
.nf
.fi
.TP
static int
\f3\%pfCycleBuffer::getConfig\fP(void);
.nf
.fi
.TP
static int
\f3\%pfCycleBuffer::frame\fP(void);
.nf
.fi
.TP
static int
\f3\%pfCycleBuffer::getFrameCount\fP(void);
.nf
.fi
.TP
static int
\f3\%pfCycleBuffer::getCurIndex\fP(void);
.nf
.fi
.TP
static void
\f3\%pfCycleBuffer::setCurIndex\fP(int\ index);
.nf
.fi
.TP
static pfCycleBuffer *
\f3\%pfCycleBuffer::getCBuffer\fP(void\ *data);
.nf
.fi
.TP
static pfType *
\f3\%pfCycleMemory::getClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfCycleMemory::getFrame\fP(void);
.nf
.fi
.TP
pfCycleBuffer *
\f3\%pfCycleMemory::getCBuffer\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfCycleBuffer\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfCycleBuffer\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfCycleBuffer\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

Together, pfCycleBuffer and pfCycleMemory provide an automated
mechanism for managing dynamic data in a pipelined, multiprocessing
environment.  In this kind of environment, data is typically modified
at the head of the pipeline and must propagate down it in a
"frame-accurate" fashion.  For example, assume the coordinates of a
pfGeoSet are modified for facial animation. If a two-stage rendering
pipeline is used, then it is likely that the coordinates will be
modified in the head of the pipeline, at the same time they are being
rendered in the tail of the pipeline. If only a single memory buffer is
used, then the pfGeoSet might be rendered when its coordinates are only
partially updated, potentially resulting in cracks in the facial mesh
or other anomalies.

A solution to this problem is to use two memory buffers for the
coordinates, one written to by the head and one read from by the tail
of the pipeline. In order for the new coordinates to propagate to the
rendering stage we could copy the newly updated buffer into the
renderer's buffer during a handshake period between the two stages.
However, if the buffer is large, the copy time could become
objectionable. Another alternative is to simply swap pointers to the
two buffers - the classic "double-buffering" approach. This is much
more efficient but requires that the contents of the buffer be
completely updated each frame. Otherwise the render stage will access a
"stale" buffer that represents the facial expression at a previous time
so that the animation will appear to go backwards.

The pfCycleBuffer/pfCycleMemory combination supports efficient dynamic
data management in an N-stage pipeline. A pfCycleBuffer logically
contains multiple pfCycleMemorys. Each process has a global index which
selects the currently active pfCycleMemory in each pfCycleBuffer. This
index can be advanced once a frame by
\f3\%pfCycleBuffer::setCurIndex\fP so that the
buffers "cycle". By advancing the index appropriately in each pipeline
stage, dynamic data can be frame-accurately propagated down the
pipeline.

While pfCycleBuffers can be used for generic dynamic data, a
prominent use is as attribute arrays for pfGeoSets. The
function \f3\%pfGeoSet::setAttr\fP accepts
pfCycleBuffer memory for attribute arrays and the pfGeoSet will index the
appropriate pfCycleMemory when rendering and intersection testing.
Currently, pfGeoSets do not support pfCycleBuffer index lists.

\f3\%new\fP(arena) allocates a pfCycleBuffer from the specified memory
arena, or from the process heap if \f2arena\fP is NULL.  \f3\%new\fP
allocates a pfCycleBuffer from the default memory arena (see
\f3\%pfGetSharedArena\fP).  Like other pfObjects, pfCycleBuffers cannot be
created statically, automatically on the stack or in arrays.  The
argument \f2nbytes\fP to the constructor specifies the length of each
associated pfCycleMemory.  pfCycleBuffers should be deleted with
\f3\%pfDelete\fP rather than the delete operator.

The number of pfCycleMemorys allocated for each pfCycleBuffer is
specified by \f3\%pfCBufferConfig\fP which is typically called only once
at initialization time. \f3\%pfGetCBufferConfig\fP returns the number set
by \f3\%pfCBufferConfig\fP.

\f3\%pfCycleBuffer::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfCycleBuffer\fP.  The \f3\%pfType\fP* returned
by \f3\%pfCycleBuffer::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfCycleBuffer\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfCycleMemory::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfCycleMemory\fP.

\f3\%pfCycleBuffer::init\fP initializes all pfCycleMemorys of
a pfCycleBuffer to the data referenced by \f2data\fP. \f2data\fP
should be at least of size \f2nbytes\fP.

pfCycleMemory is derived from pfMemory and also provides
access to its raw data in the form of a void* pointer through the
\f3\%pfMemory::getData\fP call.  Thus pfCycleBuffer memory is
arranged in a hierarchy: pfCycleBuffer -> pfCycleMemory -> void* and various
routines exist which convert one handle into another.  These routines are listed
in the following table.

.TS
tab($) ;
C | C | C | C
L | L | L | C .
$pfCycleBuffer*$pfCycleMemory*$pfMemory*
_
pfCycleBuffer*$NA$getCMem$getCurData
pfCycleMemory*$getCBuffer$NA$getData
void*$getCBuffer$getMemory$NA
.TE

The currently active pfCycleMemory portion of a pfCycleBuffer is
selected by the global index specified by
\f3\%pfCycleBuffer::setCurIndex\fP,
and is returned by \f3\%pfCycleBuffer::getCurIndex.\fP
One can think of this in pseudocode as
.Ex
.nf

current pfCycleMemory = pfCycleBuffer[pfCurCBufferIndex]
.Ee
.fi
.na

Thus one should always get a new handle to the currently active data
whenever the global index changes. Data modification that is
incremental, (such as a += .2) must retain a handle to the previous
data for proper results (current a = previous a + .2).

As mentioned above, cycling buffer pointers is efficient but requires
that the buffers be completely updated each frame. If the data at some
time becomes static, it must then be copied into those buffers that are
out of date. pfCycleBuffer supports this copying automatically with
\f3\%pfCycleBuffer::changed\fP in conjunction with \f3\%pfCycleBuffer::frame\fP.
The member function \f3\%frame\fP advances a global frame counter that is used to
frame-stamp pfCycleMemorys.  After the pfCycleBuffer has been updated,
\f3\%changed\fP frame-stamps the pfCycleBuffer with the current frame
count.  Then if that pfCycleBuffer is not changed in a later frame,
the member function \f3\%frame\fP will automatically copy the latest pfCycleMemory
into its currently active, sibling pfCycleMemory. This copying will
continue until all selected pfCycleMemorys contain the latest data.
To determine the frame stamp of a pfCycleMemory, use the member function
\f3\%getFrame\fP. \f3\%pfCycleBuffer::getFrameCount\fP returns the current, global,
pfCycleBuffer frame count.


The following are examples of pfCycleBuffer usage for \f3\%libpr\fP-only
and \f3\%libpf\fP applications. When using \f3\%libpf\fP, \f3\%pfConfig\fP
and \f3\%pfFrame\fP call \f3\%pfCycleBuffer::config\fP and \f3\%pfCycleBuffer::frame\fP
respectively so the application should not call the latter routines.
In addition, \f3\%libpf\fP calls \f3\%pfCurCBufferIndex\fP in each process
so that pfCycleBuffer changes are properly propagated down
the processing pipelines.

Example 1: \f3\%libpr\fP-only pfCycleBuffer example

.Ex
.nf

pfVec3		*prevVerts, *curVerts;

/*
 * Configure number of pfCycleMemorys per pfCycleBuffer
*/
numBuffers->config();

verts = new pfCycleBuffer(sizeof(pfVec3) * numVerts);
gset->setAttr(PFGS_COORD3, PFGS_PER_VERTEX, verts, NULL);

while(!done)
{
    static int	index = 0;

    index->setCurIndex();

    curVerts = verts->getCurData();

    /* Compute new positions of mass-spring system */
    for (i=0; i<numVerts; i++)
	curVerts[i] = prevVerts[i] + netForceVector * deltaTime;

    /* Indicate that 'verts' has changed */
    verts->changed();

    prevVerts = curVerts;

    /* Advance cyclebuffer frame count */
    pfCycleBuffer::frame();

    /* Advance buffer index. */
    index = (index + 1) % numBuffers;
}

.Ee
.fi
.na


Example 2: \f3\%libpf\fP pfCycleBuffer example

.Ex
.nf

pfVec3		*prevVerts, *curVerts;

pfInit();

pfMultiprocess(mpMode);

/*
 * This calls pfCycleBuffer::config() with the number of buffers
 * appropriate to the multiprocessing mode.
*/
pfConfig();

verts = new(pfGetSharedArena()) pfCycleBuffer(sizeof(pfVec3) * numVerts);
gset->setAttr(PFGS_COORD3, PFGS_PER_VERTEX, verts, NULL);

while(!done)
{
    curVerts = verts->getCurData();

    /* Compute new positions of mass-spring system */
    for (i=0; i<numVerts; i++)
	curVerts[i] = prevVerts[i] + netForceVector * deltaTime;

    /* Indicate that 'verts' has changed */
    verts->changed();

    prevVerts = curVerts;

    /* This calls pfCycleBuffer::frame() */
    pfFrame();
}

.Ee
.fi
.na



.SH NOTES

The global index which selects the currently active pfCycleMemory is
unique for a given address space. Specifically, share group processes
like those spawned by \f3\%sproc\fP will share the same global index.

.SH OBSOLETE

\f3\%pfCycleBuffer\fP and \f3\%pfCycleMemory\fP have been obsoleted by \f3\%pfFlux\fP
and \f3\%pfFluxMemory\fP.  See the \f3\%pfFlux\fP man page for examples
on converting code using pfCycleBuffer to pfFluxBuffer.

.SH SEE ALSO
pfFlux,
pfDelete,
pfGetData,
pfGetMemory,
pfMemory
