'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfGetId" "3pf"
.SH NAME
.upperok
.B pfGetId,
.B pfUpdatable
\- 
Get unique id of libpf object.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'virtual\ int\ \ \ 'u
#include <Performer/pf/pfUpdatable.h>
.nf
.fi
.TP
virtual int
\f3\%pfUpdatable::pf_getpfId\fP(void);
.fi
.SH DESCRIPTION

All OpenGL Performer objects defined in the \f3\%libpf\fP library have a
unique integer identifier.
The virtual member function \f3\%pfUpdatable::pf_getpfId\fP
returns the identifier of a \f3\%libpf\fP object
derived from class \f3\%pfUpdatable\fP.
.SH SEE ALSO
pfNode,
pfUpdatable
