'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfMPClipTexture" "3pf"
.SH NAME
.upperok
.B pfMPClipTexture,
.B pfGetMPClipTexture,
.B pfClipTexture
\- 
Create, modify, and query a libpf multiprocessing shadow for pfClipTextures
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfMPClipText\ \ \ 'u
#include <Performer/pf/pfMPClipTexture.h>
.nf
.fi
.TP
\ 
\f3\%pfMPClipTexture::pfMPClipTexture\fP()
.nf
.fi
.TP
pfType *
\f3\%pfMPClipTexture::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setClipTexture\fP(pfClipTexture\ *clip);
.nf
.fi
.TP
pfClipTexture *
\f3\%pfMPClipTexture::getClipTexture\fP(void);
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setCenter\fP(int\ s,
'in +2
'll -2
int\ t,
int\ r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::getCenter\fP(int\ *s,
'in +2
'll -2
int\ *t,
int\ *r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setInvalidBorder\fP(int\ border);
.nf
.fi
.TP
int
\f3\%pfMPClipTexture::getInvalidBorder\fP(void);
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setVirtualLODOffset\fP(int\ offset);
.nf
.fi
.TP
int
\f3\%pfMPClipTexture::getVirtualLODOffset\fP(void);
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setNumEffectiveLevels\fP(int\ levels);
.nf
.fi
.TP
int
\f3\%pfMPClipTexture::getNumEffectiveLevels\fP(void);
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setMaster\fP(pfMPClipTexture\ *master);
.nf
.fi
.TP
pfMPClipTexture *
\f3\%pfMPClipTexture::getMaster\fP(void);
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setShareMask\fP(uint\ mask);
.nf
.fi
.TP
uint
\f3\%pfMPClipTexture::getShareMask\fP(void);
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setLODRange\fP(float\ min,
'in +2
'll -2
float\ max);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::getLODRange\fP(float\ *min,
'in +2
'll -2
float\ *max);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setMagFilter\fP(uint\ filter);
.nf
.fi
.TP
uint
\f3\%pfGetMPClipTexture::getMagFilter\fP(void);
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setLODBias\fP(float\ biasS,
'in +2
'll -2
float\ biasT,
float\ biasR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetMPClipTexture::getLODBias\fP(float\ *biasS,
'in +2
'll -2
float\ *biasT,
float\ *biasR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::apply\fP(void);
.nf
.fi
.TP
pfPipe *
\f3\%pfMPClipTexture::getPipe\fP(void);
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setDTRFadeCount\fP(int\ count);
.nf
.fi
.TP
int
\f3\%pfMPClipTexture::getDTRFadeCount\fP(void);
.nf
.fi
.TP
void
\f3\%pfClipTexture::setDTRMode\fP(pfClipTexture\ *tex,
'in +2
'll -2
uint\ DTRMode);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfClipTexture::getDTRMode\fP(pfClipTexture\ *tex);
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setTexLoadTime\fP(float\ time);
.nf
.fi
.TP
float
\f3\%pfMPClipTexture::getTexLoadTime\fP(void);
.nf
.fi
.TP
float
\f3\%pfMPClipTexture::getCurTexLoadTime\fP(void);
.nf
.fi
.TP
pfList *
\f3\%pfMPClipTexture::getSlaves\fP(void);
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setTexLoadTimeFrac\fP(float\ fraction);
.nf
.fi
.TP
float
\f3\%pfMPClipTexture::getTexLoadTimeFrac\fP(void);
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setDTRBlurMargin\fP(float\ margin);
.nf
.fi
.TP
float
\f3\%pfMPClipTexture::getDTRBlurMargin\fP(void);
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setLODOffsetLimit\fP(int\ lo,
'in +2
'll -2
int\ hi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::getLODOffsetLimit\fP(int\ *lo,
'in +2
'll -2
int\ *hi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setNumEffectiveLevelsLimit\fP(int\ lo,
'in +2
'll -2
int\ hi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::getNumEffectiveLevelsLimit\fP(int\ *lo,
'in +2
'll -2
int\ *hi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setMinLODLimit\fP(float\ lo,
'in +2
'll -2
float\ hi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::getMinLODLimit\fP(float\ *lo,
'in +2
'll -2
float\ *hi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setMaxLODLimit\fP(float\ lo,
'in +2
'll -2
float\ hi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::getMaxLODLimit\fP(float\ *lo,
'in +2
'll -2
float\ *hi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::setLODBiasLimit\fP(float\ Slo,
'in +2
'll -2
float\ Shi,
float\ Tlo,
float\ Thi,
float\ Rlo,
float\ Rhi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMPClipTexture::getLODBiasLimit\fP(float\ *Slo,
'in +2
'll -2
float\ *Shi,
float\ *Tlo,
float\ *Thi,
float\ *Rlo,
float\ *Rhi);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfMPClipTexture\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfMPClipTexture\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfMPClipTexture\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A pfMPClipTexture is a libpf wrapper used to allow for the multi-process
operation of a pfClipTexture.  A pfMPClipTexture allows user to center
the pfClipTexture (or change its invalid border) in the app,
have all of the work to determine the
necessary disk and texture loading done in the cull, and have all of texture
loads applied frame accurately in the draw.  After setting up a
pfMPClipTexture, it should be attached to a pfPipe via the pfPipe routine
\f3\%pfAddMPClipTexture\fP. This will force the pfPipe to automatically
perform all necessary applying of the pfClipTexture at the
correct times and in the correct processes.  Therefore, normal users
of pfMPClipTextures should NOT call nor have any reason to call
\f3\%pfMPClipTexture::apply\fP
Note that all of the settable fields on a pfMPClipTexture mirror a subset
of those found on a pfClipTexture.  Thus, see the \f3\%pfClipTexture\fP man
page for more detailed description of these fields.

\f3\%new pfMPClipTexture\fP creates and returns a handle to a pfMPClipTexture.
pfMPClipTextures are always allocated from shared memory and
cannot be created statically, on the stack, or in arrays.
pfMPClipTextures should be deleted using \f3\%pfDelete\fP rather than the
delete operator.

\f3\%pfMPClipTexture::getClassType\fP returns
the \f3\%pfType\fP* for the class \f3\%pfMPClipTexture\fP.  The \f3\%pfType\fP* returned
by \f3\%pfMPClipTexture::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking  the virtual
function \f3\%getType\fP on any instance of class \f3\%pfMPClipTexture\fP.
Because OpenGL Performer allows subclassing of built-in types, when
decisions are maded based on the type of an object, it is usually better
to use  the member function \f3\%isOfType\fP to test
if an object is of a type derived from a Performer type rather than to
test for strict equality of the \f3\%pfType\fP*'s.

\f3\%pfMPClipTexture::setClipTexture\fP
sets the libpr pfClipTexture that this pfMPClipTexture should multiprocess.
Thus for all pfMPClipTextures, a libpr pfClipTexture should be created
and configured and the attached to a pfMPClipTexture.
\f3\%pfMPClipTexture::getClipTexture\fP
returns the libpr pfClipTexture that this pfMPClipTexture is driving
safely through Performer's multiprocessed environment.

\f3\%pfMPClipTexture::setCenter\fP sets the
center to be applied to the shadowed libpr pfClipTexture in a frame accurate
manner based on Performer's current multiprocessing configuration
\f3\%pfMPClipTexture::getCenter\fP returns
the current center set for the pfMPClipTexture.
Any of the arguments s,t,r may be NULL in which case it will be ignored.

\f3\%pfMPClipTexture::setInvalidBorder\fP
sets the invalid border to be used by libpr pfClipTexture for the current
frame. This invalid border is used for load management.  See
\f3\%pfClipTextureInvalidBorder\fP and the \f3\%notes\fP section of the libpr
\f3\%pfClipTexture\fP man page for more details.
\f3\%pfMPClipTexture::getInvalidBorder\fP
returns the invalid border which will currently be used for this frame.

\f3\%pfMPClipTexture::setVirtualLODOffset\fP
\f3\%pfMPClipTexture::getVirtualLODOffset\fP returns the virtual LOD Offset
currently being used by the pfMPClipTexture.

\f3\%pfMPClipTexture::setNumEffectiveLevels\fP
\f3\%pfMPClipTexture::getNumEffectiveLevels\fP returns
the number of effective levels
currently being used by the pfMPClipTexture.

\f3\%pfMPClipTexture::setMaster\fP establishes a
master/slave relationship between two mpcliptextures. It also establishes
the same relationship between both mpcliptextures' corresponding cliptextures
and image caches. The pfMPClipTexture that is called becomes a slave to the
mpcliptexture given as an argument.
See the description of \f3\%pfClipTextureMaster\fP and the \f3\%notes\fP section of
the libpr \f3\%pfClipTexture\fP man page for more details.
\f3\%pfMPClipTexture::getMaster\fP returns the master pfMPClipTexture of this
pfMPClipTexture, if this pfMPClipTexture is a slave. If the pfMPClipTexture is
not a slave, it returns NULL.

\f3\%pfMPClipTexture::getSlaves\fP
returns a pointer to a pfList. If the mpcliptexture is a master,
the list contains pointers to pfMPClipTextures that are slaves of this master.
If the mpcliptexture isn't a master, the pointer value returned is NULL.

\f3\%pfMPClipTexture::setShareMask\fP is used
to set a bitwise "and" of the control flags used to determine the amount of
optional data sharing between masters and slave mpcliptextures. Currently
only one bit is defined; PFMPCLIPTEXTURE_SHARE_CENTER, which is set "on" by
default. Giving zero indicates no sharing beyond the mandatory sharing of
disk and system memory image caches.

If PFMPCLIPTEXTURE_SHARE_CENTER is set, then the slaves will get updated
whenever the master gets its center changed. Changing slave centers will
be ignored by the slave, and will have no effect on the master. Center sharing
can be individually toggled on each slave. Changing the status of center
sharing on the master has no effect.

Sharing mask values have no effect pfMPClipTextures that aren't masters or
slaves.

\f3\%pfMPClipTexture::getShareMask\fP returns the share mask
currently being used by a slave pfMPClipTexture. The value returned by the
master is meaningless.

\f3\%pfMPClipTexture::setLODRange\fP sets the
minimum and maximum LOD range to be used in the virtual mpcliptextures. These
values are clamped by the current effective levels setting. The minimum and
maximum LOD range values are defined in terms of the virtual texture; so they
are not affected by the value of virtual LOD offset.

See the description of \f3\%pfLODRange\fP in the libpr \f3\%pfTexture\fP man page
for more details.

\f3\%pfMPClipTexture::getLODRange\fP returns the LOD Range currently being used
by the pfMPClipTexture.
Either of the arguments min,max may be NULL in which case it will be ignored.

\f3\%pfMPClipTexture::getPipe\fP returns the a
pointer to the pfPipe that the pfMPClipTexture has been added to. If
the pfMPClipTexture  currently connected to any pipe, it returns NULL.

\f3\%pfMPClipTexture::setMagFilter\fP
sets the pfMPClipTexture magnification filter type. See the
\f3\%pfTexture::setFilter\fP man page for details on the
\f2filter\fP argument.
\f3\%pfMPClipTexture::getMagFilter\fP returns
the current magnifying filter type for the pfMPClipTexture.

\f3\%pfMPClipTexture::setLODBias\fP sets the
pfMPClipTexture texture bias parameters. These parameters are used to alter
the level of detail computations. See the
\f3\%pfTexture::setLODBias\fP man page for
more details on the \f2biasS\fP, \f2biasT\fP, and \f2biasR\fP arguments.
\f3\%pfTexture::getLODBias\fP gets the current
LOD Bias values in the pfMPClipTexture.
Any of the arguments biasS,biasT,biasR may be NULL in which case it
will be ignored.

\f3\%pfMPClipTexture::setDTRFadeCount\fP
is used to adjust the number of frames it takes to fade in a new level of
the cliptexture. DTR (clip texture load control) adjusts the sharpest visible
level based on which levels have tile files available and have the draw
process time to download them into texture memory. When a new, finer level
becomes available, DTRFadeCount is used to keep the new level from appearing
too abruptly. It fades in the new level or levels over the number of
frames specified by DTRFadeCount. The default fade count is 5. This call
can be used to change the fade count to any non-negative value. If the
fade count is set to zero, new levels appear immediately, with no fading.
\f3\%pfMPClipTexture::getDTRFadeCount\fP
is used to query the currently set DTR fade count. Since the count is set
in the APP process, used in the CULL, and the results appear in the DRAW,
changes to the DTR fade count may have up to 2 frames of latency before
taking effect.

\f3\%pfMPClipTexture::setDTRMode\fP
Is used to control DTR (dynamic texture resolution) or clip texture
load control. Clip texture DTR consists of a number of independent load
control modes, control by the DTRMode bitmask, and a number of user-settable
parameters, all of which have reasonable default values. Currently, the
DTR bitmask can be any combination of the following bits: PF_DTR_MEMLOAD,
PF_DTR_TEXLOAD, PF_DTR_READSORT, and PF_DTR_TEXSIZE. PF_DTR_MEMLOAD uses
image tile availability to adjust load control, PF_DTR_TEXLOAD uses estimated
texture subload time to adjust load control, PF_DTR_READSORT turns on sorting
in the image tile read queue, and PF_DTR_TEXSIZE allows adjustment of the
effective clipsize (changed by adjusting the invalid border) to allow finer
levels, albeit at a smaller than normal size, when choosing which cliptexture
levels to make visible. These modes can be set singly or in any combination.
The default value is PF_DTR_MEMLOAD|PF_DTR_TEXLOAD|PF_DTR_READSORT.
\f3\%pfMPClipTexture::getDTRMode\fP
can be used to get the currently set DTR mode.

\f3\%pfMPClipTexture::setTexLoadTime\fP
sets the time allowed to download all of the cliptexture updates for a
particular cliptexture. DTR (Dynamic Texture Resolution) has a mode,
PF_DTR_TEXLOAD, where it estimates the amount of time necessary to
perform the texture subloads to update the cliptexture for the current
frame. This time is summed up over all the subloads in all the clipped
levels of the cliptexture. The estimate uses the size of the texture
downloads and a cost table, which contains download times for different
size subregions. There are multiple cost tables available. The one
appropriate to the machine in use is chosen. As the cost of the downloads
necessary to update the cliptexture are computed, level by level, from
coarsest to finest, the running total is compared against the maximum
allowed cost. When a level is reached that would cause the total to
exceed the maximum allowed cost, DTR shrinks all the levels or gives
up and blurs down to the next lower level, depending on whether PF_DTR_TEXSIZE
is set in the mode bit (see minClipSizeRatio for details). This way
the time in the DRAW process is rationed. This call can adjust the maximum
allowed time for cliptexture downloads. The default value is 6. The value
is a non-negative floating point amount of milliseconds. This value has no
effect unless PF_DTR_TEXLOAD is set. If it is not set, there is no time
rationing.
\f3\%pfMPClipTexture::getTexLoadTime\fP
is used to get the currently set maximum download time. Since the value
is set in the CULL process, and the effects will be seen in the DRAW
process, there may be a delay of up to 1 frame before changes take effect.


\f3\%pfMPClipTexture::getCurTexLoadTime\fP
return the tex load time actually being used by the pfMPClipTexture DTR
load control system. This value is either the tex load time set on the
pfMPClipTexture, or if no value was set their, the total tex load time set
on the pfMPClipTexture's pipe scaled by the normalized down load time frac
value, set by calling
\f3\%pfMPClipTexture::setTexLoadTimeFrac\fP.

\f3\%pfMPClipTexture::setTexLoadTimeFrac\fP.
sets the fractional values used to scale the total tex load time on the
pfPipe that this pfMPClipTexture is attached to. The product of the pfPipe's
total tex load time and the pfMPClipTexture's tex load time frac provides the
pfMPClipTexture with a download time to use with its DTR load control system.

The tex load time frac values for all the pfMPClipTextures attached to a
given pfPipe are summed together and normalized. The normalization factor
is applied when the frac value is used to compute a pfMPClipTexture's
texture download time.

\f3\%pfMPClipTexture::getTexLoadTimeFrac\fP.
returns the current value of the pfMPClipTexture's tex download time fraction.
The default value is 1.

\f3\%pfMPClipTexture::setDTRBlurMargin\fP.
sets the blur margin value used to control DTR load control hysteresis.
This hysterisis controls LOD flickering when the remaining download time is
nearly equal to the time it will take to download the next finer level.

The blur margin value is used by DTR to compute a cushion of extra time that
must be available before sharpening to the next level. This cushion of time
helps average out the small differences in download time caused by different
tile boundary alignments from frame to frame. The pfMPClipTexture will show
the image at a constant, blurrier level, rather then oscillate between that
level and the next finest one. The larger the blur margin value, the more
cushion. An excessive blur margin value will cause DTR to show a blurrier
level than necessary for a given center speed.

\f3\%pfMPClipTexture::getDTRBlurMargin\fP.
return the current blur margin value being used by DTR.
The default value is .5.

The functions
\f3\%
setLODOffsetLimit,
setNumEffectiveLevelsLimit,
setMinLODLimit,
setMaxLODLimit,
setLODBiasLimit
\fPand corresponding query functions\f3\%
getLODOffsetLimit,
getNumEffectiveLevelsLimit,
getMinLODLimit,
getMaxLODLimit,
getLODBiasLimit
\fPare analogous to the corresponding functions of pfClipTexture
(see the pfClipTexture man page for more details).
The limits are passed down from the APP process to the CULL process and stored
in the pfClipTexture at the beginning of the CULL's frame,
so callback functions in the CULL can frame-accurately query the values
from either the pfMPClipTexture or the pfClipTexture.
This technique is used by clip texture scene loaders
such as .spherepatch and .ct to communicate with applications
such as the clipfly program
(see the sample source code for clipfly and these loaders for details.)

.SH NOTES

ClipTexture functionality is not supported under Linux.

.SH BUGS


\f3\%pfMPClipTextures\fP do not work (they should be no-ops) in
Performer's CULLoDRAW multiprocessing mode.

.SH SEE ALSO
pfPipe,
pfClipTexture,
pfImageCache
