'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfString" "3pf"
.SH NAME
.upperok
.B pfString
\- 
String facility using pfFont
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'const\ pfGeoSet*\ \ \ 'u
#include <Performer/pr/pfString.h>
.nf
.fi
.TP
\ 
\f3\%pfString::pfString\fP();
.nf
.fi
.TP
pfType*
\f3\%pfString::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfString::setMat\fP(const\ pfMatrix\ *mat);
.nf
.fi
.TP
void
\f3\%pfString::getMat\fP(pfMatrix\ &at);
.nf
.fi
.TP
void
\f3\%pfString::setMode\fP(int\ mode,
'in +2
'll -2
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfString::getMode\fP(int\ mode);
.nf
.fi
.TP
void
\f3\%pfString::setFont\fP(pfFont*\ font);
.nf
.fi
.TP
pfFont*
\f3\%pfString::getFont\fP(void);
.nf
.fi
.TP
void
\f3\%pfString::setString\fP(const\ char*\ cstr);
.nf
.fi
.TP
const char*
\f3\%pfString::getString\fP(void);
.nf
.fi
.TP
void
\f3\%pfString::setBBox\fP(pfBox\ *newBBox);
.nf
.fi
.TP
const pfBox*
\f3\%pfString::getBBox\fP(void);
.nf
.fi
.TP
void
\f3\%pfString::setSpacingScale\fP(float\ horiz,
'in +2
'll -2
float\ vert,
float\ depth);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfString::getSpacingScale\fP(float\ *horiz,
'in +2
'll -2
float\ *vert,
float\ *depth);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfString::setColor\fP(float\ r,
'in +2
'll -2
float\ g,
float\ b,
float\ a);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfString::getColor\fP(float\ *r,
'in +2
'll -2
float\ *g,
float\ *b,
float\ *a);
.in
.ll
.nf
.fi
.TP
const pfGeoSet*
\f3\%pfString::getCharGSet\fP(void);
.nf
.fi
.TP
const pfVec3*
\f3\%pfString::getCharPos\fP(void);
.nf
.fi
.TP
size_t
\f3\%pfString::getStringLength\fP(void);
.nf
.fi
.TP
void
\f3\%pfString::setGState\fP(pfGeoState*\ gstate);
.nf
.fi
.TP
pfGeoState*
\f3\%pfString::getGState\fP(void);
.nf
.fi
.TP
void
\f3\%pfString::draw\fP(void);
.nf
.fi
.TP
void
\f3\%pfString::flatten\fP(void);
.nf
.fi
.TP
void
\f3\%pfString::setIsectMask\fP(uint\ mask,
'in +2
'll -2
int\ setMode,
int\ bitOp);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfString::getIsectMask\fP(void);
.nf
.fi
.TP
int
\f3\%pfString::isect\fP(pfSegSet\ *segSet,
'in +2
'll -2
pfHit\ **hits[]);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfString\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfString\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfString\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH PARAMETERS
.TP \w'string\ \ 'u
\f2string\fP
identifies a pointer to a pfString
.TP
\f2font\fP
identifies a pointer to a pfFont
.SH DESCRIPTION

\f3\%new\fP(arena) allocates a pfString from the specified memory arena,
or from the process heap if \f2arena\fP is NULL.  \f3\%new\fP allocates a
pfString from the default memory arena (see \f3\%pfGetSharedArena\fP).
Like other pfObjects, pfStrings cannot be created statically,
automatically on the stack or in arrays.  pfStrings should be deleted
with \f3\%pfDelete\fP rather than the delete operator.

\f3\%pfString::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfString\fP.  The \f3\%pfType\fP* returned
by \f3\%pfString::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfString\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfString::setMat\fP sets the transformation matrix for the pfString to \f2mat\fP
or to the identity matrix if \f2mat\fP is NULL.  Call \f3\%pfString::getMat\fP
to retrieve the matrix.

Use \f3\%pfString::setMode\fP and \f3\%pfString::getMode\fP to set and get modes of
the pfString.
Use the \f3\%PFSTR_JUSTIFY\fP mode to set the justification of the
string to one of the following:

.RS
.TP 5
\f3\%PFSTR_FIRST\fP or \f3\%PFSTR_LEFT\fP
Set the string to be left-justified; the first character will be immediately
to the right of the origin.
.TP
\f3\%PFSTR_MIDDLE\fP or \f3\%PFSTR_CENTER\fP
Set the string to be center-justified; the string will be centered at the
origin.
.TP
\f3\%PFSTR_LAST\fP or \f3\%PFSTR_RIGHT\fP
Set the string to be right-justified; the last character will be immediately
to the left of the origin.
.RE

Use the \f3\%PFSTR_CHAR_SIZE\fP to specify the size, in bytes, of each
character in the string. \f2val\fP is one of
\f3\%PFSTR_CHAR\fP, \f3\%PFSTR_SHORT\fP, \f3\%PFSTR_INT\fP indicating that
character sizes are sizeof(char), sizeof(short),
and sizeof(int) respectively.

Call \f3\%pfString::getBBox\fP to retrieve the
bounding box around the pfString as if it were
drawn using the assigned justification,
drawing style, font, and character string.
Call \f3\%pfString::setBBox\fP to set this
bounding box explicitly.

\f3\%pfString::setSpacingScale\fP
and \f3\%pfString::getSpacingScale\fP
set and get the spacing scales of the pfString.
Normally after rendering a character, the rendering position is translated
in x, y, and z by the character's spacing which is supplied by the
pfFont associated with the pfString. This spacing is scaled by
the supplied scale factors enabling greater/lesser distances
between characters. Also, when the \f3\%PFSTR_AUTO_SPACING\fP mode
is enabled, the spacing scales can be used to change the direction
of the rendered string, for example, spacing scales of (0, -1, 0)
will render the string vertically, suitable for labeling
the vertical axis of a 2D graph.

of the steps used when drawing each succeeding character from the pfString. The default spacing scales are all 1.0  An interesting
example is horizontal scale 0 and vertical scale -1, in which case the
string is drawn downward like a neon sign outside a downtown bar and grill.

\f3\%pfString::setGState\fP and \f3\%pfString::getGState\fP set and get the \f3\%pfGeoState\fP
attached to the pfString.  If no \f3\%pfGeoState\fP is attached, then the pfString
will be drawn with whatever graphics state is active at draw time.

Call \f3\%pfString::setFont\fP and \f3\%pfString::getFont\fP to set or get the pfFont
used by the pfString.  Call \f3\%pfString::setString\fP and
\f3\%pfString::getString\fP to set or get the character string for
the pfString.  \f3\%pfString::getStringLength\fP
will return the length of a \f3\%pfString\fP's current character string.
\f3\%pfString::setColor\fP and \f3\%pfString::getColor\fP get and
set \f2string's\fP color.

\f3\%pfString::getCharGSet\fP returns a pointer to the
GeoSet currently being used to draw the character at place \f2index\fP in the
pfString's string.
\f3\%pfString::getCharPos\fP likewise returns a pointer
to a pfVec3 that specifies the exact location relative to the current
transform where the character in position \f2index\fP in the string array
will be drawn.
Both of the above functions will return NULL if \f2index\fP is greater than
or equal to the pfString's length - which may be obtained through
\f3\%pfString::getStringLength\fP.

Call \f3\%pfString::draw\fP to draw the string, including applying the
\f3\%pfGeoState\fP if available, the color, and the texture if this
is a \f3\%PFSTR_TEXTURED\fP string.

A \f3\%pfString\fP is normally composed of a \f3\%pfGeoSet\fP per character in
the string.  Call \f3\%pfString::flatten\fP to flatten
the character spacings into the individual GeoSets.  A flattened primitive is
faster, but flattening has overhead which should be avoided if the
string will be changing quickly, e.g. in every frame.  \f3\%pfString::flatten\fP
Must be called every time you change the contents of the string geometry;
e.g. after calling \f3\%pfString::setString\fP.

\f3\%pfString::setIsectMask\fP enables
intersections and sets the intersection mask for the
pfString.  \f2mask\fP is a 32-bit mask used to determine whether a
particular pfString should be examined during a particular
intersection request.  A non-zero bit-wise AND of the pfString's mask
with the mask of the intersection request
(\f3\%pfString::isect\fP) indicates that the
pfString should be tested.  The default mask is all 1's, i.e.
0xffffffff.

\f3\%pfString::getIsectMask\fP returns the
intersection mask of the specified pfString.

\f3\%pfString::isect\fP tests for intersection
between the pfString the pfString and the group
of line segments specified in \f2string\fP.  This is done by testing
against each of the pfGeoSets in the pfString.  The resulting
intersections (if any) are returned in \f2hits\fP.  The return value
of \f3\%pfString::isect\fP is the number of
segments that intersected the pfString.  See \f3\%pfGSetIsectSegs\fP for
intersection information returned from tests against the geometric
primitives inside pfGeoSets.

.Ex
.nf


.SH NOTES

See \f3\%pfText\fP for sample code demonstrating \f3\%pfString\fP.
.SH SEE ALSO
pfFont,
pfDelete,
pfGeoSet,
pfText
