'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfdASDClipring" "3pf"
.SH NAME
.upperok
.B pfdASDClipring
\- 
Construct pfASD clipring size and value for virtual cliptexture
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'void\ \ \ 'u
#include <Performer/pfdu.h>
.nf
.fi
.TP
void
\f3\%pfdASDClipring\fP(pfASD\ *asd,
'in +2
'll -2
int\ numrings);
.in
.ll
.fi
.SH DESCRIPTION

\f3\%pfdASDClipring\fP
computes numrings level of pfLODRange based on the original asd LODRange
and enables clipring in pfASD node.

See libpfdb/pfevt.c  for example.
Set _PFASD_CLIPRINGS without any particular value
will turn on the automatic generation of number of cliprings.
Set _PFASD_CLIPRINGS to an int, then pfdASDClipring will build
that many additional LODRanges inside the smallest switchin range
and use them as clipring boundries.

The libpfdu source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
.SH SEE ALSO
pfASD,
pfTerrain
