'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfdOpenFile" "3pf"
.SH NAME
.upperok
.B pfdOpenFile
\- 
Search for and open a file.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'FILE\ *\ \ \ 'u
#include <Performer/pfdu.h>
.nf
.fi
.TP
FILE *
\f3\%pfdOpenFile\fP(char\ *fileName);
.fi
.SH DESCRIPTION

\f3\%pfdOpenFile\fP opens the specified file (much like \f3\%fopen\fP).  However,
rather than simply looking in the current directory, \f3\%pfdOpenFile\fP
will search the Performer file path (see \f3\%pfFilePath\fP) for the given
filename.
.SH NOTES

The libpfdu source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
.SH SEE ALSO
fopen,
pfFilePath
