'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfCycleBuffer OBSOLETE" "3pf"
.SH NAME
.upperok
.B pfNewCBuffer,
.B pfGetCBufferClassType,
.B pfGetCurCBufferData,
.B pfGetCBufferCMem,
.B pfCBufferChanged,
.B pfInitCBuffer,
.B pfCBufferConfig,
.B pfGetCBufferConfig,
.B pfCBufferFrame,
.B pfGetCBufferFrameCount,
.B pfGetCurCBufferIndex,
.B pfCurCBufferIndex,
.B pfGetCBuffer,
.B pfGetCMemFrame,
.B pfGetCMemCBuffer,
.B pfGetCMemClassType
\- 
pfCycleBuffer and pfCycleMemory obsoleted by pfFlux and pfFluxMemory
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfCycleBuffer\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfCycleBuffer *
\f3\%pfNewCBuffer\fP(size_t\ nbytes,
'in +2
'll -2
void\ *arena);
.in
.ll
.nf
.fi
.TP
pfType *
\f3\%pfGetCBufferClassType\fP(void);
.nf
.fi
.TP
void *
\f3\%pfGetCurCBufferData\fP(const\ pfCycleBuffer\ *cbuf);
.nf
.fi
.TP
pfCycleMemory *
\f3\%pfGetCBufferCMem\fP(const\ pfCycleBuffer\ *cbuf,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfCBufferChanged\fP(pfCycleBuffer\ *cbuf);
.nf
.fi
.TP
void
\f3\%pfInitCBuffer\fP(pfCycleBuffer\ *cbuf,
'in +2
'll -2
void\ *data);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfCBufferConfig\fP(int\ numBuffers);
.nf
.fi
.TP
int
\f3\%pfGetCBufferConfig\fP(void);
.nf
.fi
.TP
int
\f3\%pfCBufferFrame\fP(void);
.nf
.fi
.TP
int
\f3\%pfGetCBufferFrameCount\fP(void);
.nf
.fi
.TP
int
\f3\%pfGetCurCBufferIndex\fP(void);
.nf
.fi
.TP
void
\f3\%pfCurCBufferIndex\fP(int\ index);
.nf
.fi
.TP
pfCycleBuffer *
\f3\%pfGetCBuffer\fP(void\ *data);
.nf
.fi
.TP
int
\f3\%pfGetCMemFrame\fP(const\ pfCycleMemory\ *cmem);
.nf
.fi
.TP
pfCycleBuffer *
\f3\%pfGetCMemCBuffer\fP(pfCycleMemory\ *cmem);
.nf
.fi
.TP
pfType *
\f3\%pfGetCMemClassType\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfCycleBuffer\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfCycleBuffer\fP.
Casting an object of class \f3\%pfCycleBuffer\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfCycleBuffer\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH DESCRIPTION

Together, pfCycleBuffer and pfCycleMemory provide an automated
mechanism for managing dynamic data in a pipelined, multiprocessing
environment.  In this kind of environment, data is typically modified
at the head of the pipeline and must propagate down it in a
"frame-accurate" fashion.  For example, assume the coordinates of a
pfGeoSet are modified for facial animation. If a two-stage rendering
pipeline is used, then it is likely that the coordinates will be
modified in the head of the pipeline, at the same time they are being
rendered in the tail of the pipeline. If only a single memory buffer is
used, then the pfGeoSet might be rendered when its coordinates are only
partially updated, potentially resulting in cracks in the facial mesh
or other anomalies.

A solution to this problem is to use two memory buffers for the
coordinates, one written to by the head and one read from by the tail
of the pipeline. In order for the new coordinates to propagate to the
rendering stage we could copy the newly updated buffer into the
renderer's buffer during a handshake period between the two stages.
However, if the buffer is large, the copy time could become
objectionable. Another alternative is to simply swap pointers to the
two buffers - the classic "double-buffering" approach. This is much
more efficient but requires that the contents of the buffer be
completely updated each frame. Otherwise the render stage will access a
"stale" buffer that represents the facial expression at a previous time
so that the animation will appear to go backwards.

The pfCycleBuffer/pfCycleMemory combination supports efficient dynamic
data management in an N-stage pipeline. A pfCycleBuffer logically
contains multiple pfCycleMemorys. Each process has a global index which
selects the currently active pfCycleMemory in each pfCycleBuffer. This
index can be advanced once a frame by
\f3\%pfCurCBufferIndex\fP so that the
buffers "cycle". By advancing the index appropriately in each pipeline
stage, dynamic data can be frame-accurately propagated down the
pipeline.

While pfCycleBuffers can be used for generic dynamic data, a
prominent use is as attribute arrays for pfGeoSets. \f3\%pfGSetAttr\fP accepts
pfCycleBuffer memory for attribute arrays and the pfGeoSet will index the
appropriate pfCycleMemory when rendering and intersection testing.
Currently, pfGeoSets do not support pfCycleBuffer index lists.

\f3\%pfNewCBuffer\fP returns a pfCycleBuffer allocated out of \f2arena\fP or
off the heap if \f2arena\fP is \f3\%NULL\fP.  The argument \f2nbytes\fP
specifies the length of each associated pfCycleMemory.  pfCycleBuffers
can be deleted with \f3\%pfDelete\fP.

The number of pfCycleMemorys allocated for each pfCycleBuffer is
specified by \f3\%pfCBufferConfig\fP which is typically called only once
at initialization time. \f3\%pfGetCBufferConfig\fP returns the number set
by \f3\%pfCBufferConfig\fP.

\f3\%pfGetCBufferClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfCycleBuffer\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetCBufferClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfCycleBuffer\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfGetCMemClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfCycleMemory\fP.

\f3\%pfInitCBuffer\fP initializes all pfCycleMemorys of
\f2cbuf\fP to the data referenced by \f2data\fP. \f2data\fP
should be at least of size \f2nbytes\fP.

pfCycleMemory is derived from pfMemory and also provides
access to its raw data in the form of a void* pointer through the
\f3\%pfGetData\fP call.  Thus pfCycleBuffer memory is
arranged in a hierarchy: pfCycleBuffer -> pfCycleMemory -> void* and various
routines exist which convert one handle into another.  These routines are listed
in the following table.

.TS
tab($) ;
C | C | C | C
L | L | L | C .
$pfCycleBuffer*$pfCycleMemory*$void*
_
pfCycleBuffer*$NA$pfGetCBufferCMem$pfGetCurCBufferData
pfCycleMemory*$pfGetCMemCBuffer$NA$pfGetData
void*$pfGetCBuffer$pfGetMemory$NA
.TE

The currently active pfCycleMemory portion of a pfCycleBuffer is
selected by the global index specified by
\f3\%pfCurCBufferIndex\fP,
and is returned by \f3\%pfGetCurCBufferIndex.\fP
One can think of this in pseudocode as
.Ex
.nf

current pfCycleMemory = pfCycleBuffer[pfCurCBufferIndex]
.Ee
.fi
.na

Thus one should always get a new handle to the currently active data
whenever the global index changes. Data modification that is
incremental, (such as a += .2) must retain a handle to the previous
data for proper results (current a = previous a + .2).

As mentioned above, cycling buffer pointers is efficient but requires
that the buffers be completely updated each frame. If the data at some
time becomes static, it must then be copied into those buffers that are
out of date. pfCycleBuffer supports this copying automatically with
\f3\%pfCBufferChanged\fP in conjunction with \f3\%pfCBufferFrame\fP.
\f3\%pfCBufferFrame\fP advances a global frame counter that is used to
frame-stamp pfCycleMemorys.  After \f2cbuf\fP has been updated,
\f3\%pfCBufferChanged\fP frame-stamps \f2cbuf\fP with the current frame
count.  Then if \f2cbuf\fP is not changed in a later frame,
\f3\%pfCBufferFrame\fP will automatically copy the latest pfCycleMemory
into its currently active, sibling pfCycleMemory. This copying will
continue until all selected pfCycleMemorys contain the latest data.
\f3\%pfGetCMemFrame\fP returns the frame stamp of \f2cmem\fP.
\f3\%pfGetCBufferFrameCount\fP returns the current, global,
pfCycleBuffer frame count.

The following are examples of pfCycleBuffer usage for \f3\%libpr\fP-only
and \f3\%libpf\fP applications. When using \f3\%libpf\fP, \f3\%pfConfig\fP
and \f3\%pfFrame\fP call \f3\%pfCBufferConfig\fP and \f3\%pfCBufferFrame\fP
respectively so the application should not call the latter routines.
In addition, \f3\%libpf\fP calls \f3\%pfCurCBufferIndex\fP in each process
so that pfCycleBuffer changes are properly propagated down
the processing pipelines.

Example 1: \f3\%libpr\fP-only pfCycleBuffer example

.Ex
.nf

pfVec3		*prevVerts, *curVerts;

/*
 * Configure number of pfCycleMemorys per pfCycleBuffer
*/
pfCBufferConfig(numBuffers);

verts = pfNewCBuffer(sizeof(pfVec3) * numVerts, arena);
pfGSetAttr(gset, PFGS_COORD3, PFGS_PER_VERTEX, verts, NULL);

while(!done)
{
    static int	index = 0;

    pfCurCBufferIndex(index);

    curVerts = pfGetCurCBufferData(verts);

    /* Compute new positions of mass-spring system */
    for (i=0; i<numVerts; i++)
	curVerts[i] = prevVerts[i] + netForceVector * deltaTime;

    /* Indicate that 'verts' has changed */
    pfCBufferChanged(verts);

    prevVerts = curVerts;

    /* Advance cyclebuffer frame count */
    pfCBufferFrame();

    /* Advance buffer index. */
    index = (index + 1) % numBuffers;
}

.Ee
.fi
.na


Example 2: \f3\%libpf\fP pfCycleBuffer example

.Ex
.nf

pfVec3		*prevVerts, *curVerts;

pfInit();

pfMultiprocess(mpMode);

/*
 * This calls pfCBufferConfig() with the number of buffers
 * appropriate to the multiprocessing mode.
*/
pfConfig();

verts = pfNewCBuffer(sizeof(pfVec3) * numVerts, pfGetSharedArena());
pfGSetAttr(gset, PFGS_COORD3, PFGS_PER_VERTEX, verts, NULL);

while(!done)
{
    curVerts = pfGetCurCBufferData(verts);

    /* Compute new positions of mass-spring system */
    for (i=0; i<numVerts; i++)
	curVerts[i] = prevVerts[i] + netForceVector * deltaTime;

    /* Indicate that 'verts' has changed */
    pfCBufferChanged(verts);

    prevVerts = curVerts;

    /* This calls pfCBufferFrame() */
    pfFrame();
}

.Ee
.fi
.na



.SH NOTES

The global index which selects the currently active pfCycleMemory is
unique for a given address space. Specifically, share group processes
like those spawned by \f3\%sproc\fP will share the same global index.

.SH OBSOLETE

\f3\%pfCycleBuffer\fP and \f3\%pfCycleMemory\fP have been obsoleted by \f3\%pfFlux\fP
and \f3\%pfFluxMemory\fP.  See the \f3\%pfFlux\fP man page for examples
on converting code using pfCycleBuffer to pfFluxBuffer.

.SH SEE ALSO
pfFlux,
pfDelete,
pfGetData,
pfGetMemory,
pfMemory
