'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfFrameStats" "3pf"
.SH NAME
.upperok
.B pfNewFStats,
.B pfGetFStatsClassType,
.B pfDrawFStats,
.B pfCopyFStats,
.B pfGetOpenFStats,
.B pfOpenFStats,
.B pfCloseFStats,
.B pfFStatsCountNode,
.B pfFStatsClass,
.B pfGetFStatsClass,
.B pfFStatsClassMode,
.B pfGetFStatsClassMode,
.B pfFStatsAttr,
.B pfGetFStatsAttr,
.B pfResetFStats,
.B pfClearFStats,
.B pfFStatsCountGSet,
.B pfAccumulateFStats,
.B pfAverageFStats,
.B pfQueryFStats,
.B pfMQueryFStats
\- 
Specify pfFrameStats modes and get collected values.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfFrameStats\ *\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
#include <Performer/pfstats.h>
.nf
.fi
.TP
pfFrameStats *
\f3\%pfNewFStats\fP(void);
.nf
.fi
.TP
pfType*
\f3\%pfGetFStatsClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfDrawFStats\fP(pfFrameStats\ *fstats,
'in +2
'll -2
pfChannel\ *chan);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfCopyFStats\fP(pfFrameStats\ *dst,
'in +2
'll -2
pfFrameStats\ *src,
uint\ dSel,
uint\ sSel,
uint\ classes);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfGetOpenFStats\fP(pfFrameStats\ *fstats,
'in +2
'll -2
uint\ emask);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfOpenFStats\fP(pfFrameStats\ *fstats,
'in +2
'll -2
uint\ enmask);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfCloseFStats\fP(uint\ enmask);
.nf
.fi
.TP
void
\f3\%pfFStatsCountNode\fP(pfFrameStats\ *fstats,
'in +2
'll -2
int\ class,
uint\ mode,
pfNode\ *\ node);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfFStatsClass\fP(pfFrameStats\ *fstats,
'in +2
'll -2
uint\ enmask,
int\ val);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfGetFStatsClass\fP(pfFrameStats\ *fstats,
'in +2
'll -2
uint\ enmask);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfFStatsClassMode\fP(pfFrameStats\ *fstats,
'in +2
'll -2
int\ class,
uint\ mask,
int\ val);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfGetFStatsClassMode\fP(pfFrameStats\ *fstats,
'in +2
'll -2
int\ class);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFStatsAttr\fP(pfFrameStats\ *fstats,
'in +2
'll -2
int\ attr,
float\ val);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetFStatsAttr\fP(pfFrameStats\ *fstats,
'in +2
'll -2
int\ attr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfResetFStats\fP(pfFrameStats\ *fstats);
.nf
.fi
.TP
void
\f3\%pfClearFStats\fP(pfFrameStats\ *fstats,
'in +2
'll -2
uint\ which);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFStatsCountGSet\fP(pfFrameStats\ *\ fstats,
'in +2
'll -2
pfGeoSet\ *\ gset);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfAccumulateFStats\fP(pfFrameStats*\ dst,
'in +2
'll -2
pfFrameStats*\ src,
uint\ which);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfAverageFStats\fP(pfFrameStats*\ dst,
'in +2
'll -2
pfFrameStats*\ src,
uint\ which,
int\ num);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfQueryFStats\fP(pfFrameStats\ *fstats,
'in +2
'll -2
uint\ which,
float\ *dst,
int\ size);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfMQueryFStats\fP(pfFrameStats\ *fstats,
'in +2
'll -2
uint\ *which,
float\ *dst,
int\ size);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfFrameStats\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfFrameStats\fP.
Casting an object of class \f3\%pfFrameStats\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfFrameStats\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'fstats\ \ 'u
\f2fstats\fP
identifies a pfFrameStats.
.SH DESCRIPTION

The pfFrameStats utilities provide for the collection of statistics
about all parts of OpenGL Performer processing of a scene for a given
frame.  These statistics can be kept automatically on every pfChannel,
or users may accumulate and store their own statistics.  Routines for
operating on, displaying, and  printing statistics are also provided.

The frame statistics for a channel are fetched by first getting the
pointer to the channel's statistics structure with
\f3\%pfGetChanFStats\fP, and then enabling the
desired statistics classes.  When a channel is automatically
accumulating frame statistics, it enables the necessary statistics
hardware and statistics accumulation in the correct processes.
The resulting collected statistics can then be displayed in a channel,
queried, or printed.  These statistics may be accumulated and averaged
over a specified number of frames or seconds.  The pfFrameStats
declarations are contained in pfstats.h.  The class of process frame
timing statistics for each of the OpenGL Performer processes of
application, cull and draw, is enabled by default.

Many pfFrameStats routines are borrowed from pfStats.  These routines
have the identical function as the pfStats routines but operate on a
pfFrameStats rather than a pfStats. The routine correspondence is
listed in the following table.

.TS
center tab($);
C | C
L | L .
pfFrameStats routine$pfStats routine
_
pfAccumulateFStats$pfAccumulateStats
pfAverageFStats$pfAverageStats
pfClearFStats$pfClearStats
pfCloseFStats$pfCloseStats
pfFStatsAttr$pfStatsAttr
pfFStatsClass$pfStatsClass
pfFStatsClassMode$pfStatsClassMode
pfGetFStatsClassMode$pfGetStatsClassMode
pfFStatsCountGSet$pfStatsCountGSet
pfGetFStatsAttr$pfGetStatsAttr
pfGetFStatsClass$pfGetStatsClass
pfOpenFStats$pfOpenStats
pfCloseFStats$pfCloseStats
pfGetOpenFStats$pfGetOpenStats
pfMQueryFStats$pfMQueryStats
pfOpenFStats$pfOpenStats
pfGetOpenFStats$pfGetOpenStats
pfQueryFStats$pfQueryStats
pfResetFStats$pfResetStats
_
.TE
Refer to the pfStats man page for detailed descriptions of these routines.

\f3\%pfGetFStatsClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfFrameStats\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetFStatsClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfFrameStats\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an object,
it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from a
Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

The pfFrameStats structure stores accumulated statistics in several
buffers.  The following is a list of the frame statistics buffers:
.RS
.TP 30
\f3\%PFFSTATS_BUF_PREV\fP
Statistics for previous completed frame
.TP
\f3\%PFFSTATS_BUF_CUR\fP
Buffer for current statistics collection
.TP
\f3\%PFFSTATS_BUF_CUM\fP
Statistics accumulated since last update
.TP
\f3\%PFFSTATS_BUF_AVG\fP
Statistics averaged over previous update period
.RE

These different buffers can be queried with
\f3\%pfQueryFStats\fP and printed with
\f3\%pfPrint\fP.  The desired \f3\%PFFSTATS_BUF_*\fP
token is simply bitwise OR-ed with the desired statistics value token.

The following table of additional frame statistics classes, their
naming token, and their enable token for forming bitmasks.  Notice that
pfFrameStats tokens start with \f3\%PFFSTATS*\fP.

.TS
center tab($) ;
c s s
c | c | c
l | l | l .
Frame Statistics Class Table
_
Class$PFSTATS_* Token$PFSTATS_EN* token
_
Process frame times$\f3\%PFFSTATS_PFTIMES\fP$\f3\%PFFSTATS_ENPFTIMES\fP

Database$\f3\%PFFSTATS_DB\fP$\f3\%PFFSTATS_ENDB\fP

Cull$\f3\%PFFSTATS_CULL\fP$\f3\%PFFSTATS_ENCULL\fP
.TE

This table lists the frame statistics modes and tokens.

.TS
center tab($) ;
c s s
c | c | c
l | l | l .
Frame Statistics Class Mode Table
_
Class$PFSTATS_ Token$Modes
_
Process frame times$\f3\%PFFSTATS_PFTIMES\fP$\f3\%PFFSTATS_PFTIMES_BASIC\fP
$$\f3\%PFFSTATS_PFTIMES_HIST\fP

Database$\f3\%PFFSTATS_DB\fP$\f3\%PFFSTATS_DB_VIS\fP
$$\f3\%PFFSTATS_DB_EVAL\fP

Cull$\f3\%PFFSTATS_CULL\fP$\f3\%PFFSTATS_CULL_TRAV\fP
.TE

\f3\%pfNewFStats\fP creates and returns a handle to a pfFrameStats.
pfFrameStats are always allocated from shared memory and
can be deleted using \f3\%pfDelete\fP.
A pfFrameStats structure contains pfStats statistics as well as
additional statistics classes and support for tracking frame related
tasks.

Only the additional support for pfFrameStats above and beyond that of
\f3\%pfNewStats\fP is discussed here.
There are also examples showing different basic
operations with pfFrameStats at the end of this man page.

\f3\%pfDrawFStats\fP displays the pfFrameStats structure \f2fstats\fP in the
channel specified by \f2chan\fP.  This is useful for displaying the
statistics in a special channel separate from the main scene channel.
\f3\%pfDrawChanStats\fP may be called from OpenGL Performer's application,
cull, or draw processes and must be called each frame a statistics
display is desired.  See \f3\%pfDrawChanStats\fP for a detailed explanation
of the channel statistics display.

.ne 10
\f3\%pfFStatsClass\fP takes a pointer to a statistics structure, \f2fstats\fP,
and will set the classes specified in the bitmask, \f2enmask\fP, according
to the \f2val\fP, which is one of the following:
.RS
.TP 30
\f3\%PFSTATS_ON\fP
Enables the specified classes.
.TP
\f3\%PFSTATS_OFF\fP
Disables the specified classes.
.TP
\f3\%PFSTATS_DEFAULT\fP
Sets the specified classes to their default values.
.TP
\f3\%PFSTATS_SET\fP
Sets the class enable mask to \f2enmask\fP.
.RE

All stats collection can be set at once to on, off, or the default by
using \f3\%PFSTATS_ALL\fP for the bitmask and the appropriate value for
the enable flag.  For example, the following function call will enable
all frame statistics, as well as basic statistics classes, with their
current class mode settings.
.Ex
.nf

pfFStatsClass(fstats, PFSTATS_ALL, PFSTATS_ON);
.Ee
.fi
.na


Only statistics classes that are enabled with pfFStatsClass are able to
be printed with \f3\%pfPrint\fP, collected, copied, accumulated, averaged,
and queried.

\f3\%pfGetFStatsClass\fP takes a pointer to a statistics structure, \f2fstats\fP,
and the statistics classes of interest specified in the bitmask,
\f2enmask\fP.  The frame statistics classes are enabled through
\f3\%pfFStatsClass\fP and the frame statistics class bitmasks may be
combined with the basic statistics classes.  If any of the statistics
classes specified in \f2enmask\fP are enabled, then \f3\%pfGetFStatsClass\fP
will return the bitmask of those classes, and will otherwise return
zero.

\f3\%pfFStatsClassMode\fP takes a pointer to a pfFrameStats structure, \f2fstats\fP,
the name of the class to set, \f2class\fP, a mask of class modes,
\f2mask\fP, and the value for those modes, \f2val\fP.
The pfFrameStats classes include all of the pfStats classes.
If \f2class\fP is \f3\%PFSTATS_CLASSES\fP, then all pfFrameStats classes
will have their modes set according to \f2mask\fP and \f2val\fP.
Each statistics class has its own mode tokens
that may be used for \f2mask\fP.  \f2mask\fP may also be one of
\f3\%PFSTATS_ALL\fP or 0x0.  \f2val\fP is one of the statistics value
tokens:  \f3\%PFSTATS_ON\fP, \f3\%PFSTATS_OFF\fP, \f3\%PFSTATS_SET\fP, or
\f3\%PFSTATS_DEFAULT\fP.  See the pfStats man page for more general
information on pfStats statistics classes and value tokens
under \f3\%pfStatsClassMode\fP.  The
following describes the additional classes for frame statistics and
their corresponding modes.

Process Frame Times Modes:
.RS
.TP 5
\f3\%PFFSTATS_PFTIMES_BASIC\fP
This mode enables a running average of the time for each OpenGL Performer
process of application, cull, and draw to complete the tasks for a
single frame.  This mode is enabled by default.
.TP
\f3\%PFFSTATS_PFTIMES_HIST\fP
In this mode, a history of time stamps is maintained for different tasks within each
of the OpenGL Performer processes: application processes, cull
processes, draw processes, and intersection processes. Examples of
time stamps include when
each process starts and ends processing a frame, and that processes application
frame number for that frame.  There are special
additional time stamps for each kind of process.  For application
processes there are time stamps to mark
when the application process starts and finishes cleaning the scene in pfSync,
a time stamp when the application process wakes up to sync to the next frame
boundary (done when the application process is running with phase set to
\f3\%PFPHASE_LOCK\fP or \f3\%PFPHASE_FLOAT\fP), and a time stamp to mark when
the application process returns after setting off a forked CULL or ISECT
process. The time stamps for each process are defined in the
pfFStatsValPFTimes* data type and queried by providing the corresponding
\f3\%PFFSTATSVAL_PFTIMES_HIST_*\fP tokens to \f3\%pfQueryFStats\fP.
.RE

Database Statistics Modes:
.RS
.TP 5
\f3\%PFFSTATS_DB_VIS\fP
This mode enables tracking of how many pfNodes of each different type
are visible and drawn in a given frame.  This mode is enabled by
default.  These statistics are queried by providing the desired
\f3\%PFFSTATSVAL_VISIBLE*\fP token to \f3\%pfQueryFStats\fP.
.TP
\f3\%PFFSTATS_DB_EVAL\fP
This mode enables tracking of how many pfNodes of each different type
have special evaluations in a given frame.  Node types that require
special evaluation steps include pfBillboard, pfSCS, pfDCS, pfLayer,
pfLightPoint, pfLightSource, pfPartition, and pfSequence.  There are
also query tokens to query what processes the evaluation step for a
given node type is done in.  This mode is enabled by default.
These statistics are queried by providing the desired
\f3\%PFFSTATSVAL_EVALUATED*\fP token to \f3\%pfQueryFStats\fP.
.RE

Cull Statistics Modes:
.RS
.TP 5
\f3\%PFFSTATS_CULL_TRAV\fP
There is only one cull frame statistics mode and it tracks culling
traversal statistics: how many pfGeoSets and pfNodes of each type are
traversed in the cull operation, how many pfNodes are trivially in or
out of the viewing frustum, and how many must pass through a bounding
sphere or bounding box test. These statistics are queried by providing
one of the \f3\%PFFSTATSVAL_CULLTRAV\fP tokens to \f3\%pfQueryFStats\fP.
There are also statistics on the test results of the cull traversal,
queried with the \f3\%PFFSTATSVAL_CULLTEST*\fP tokens.
.RE

\f3\%pfGetFStatsClassMode\fP takes a pointer to a statistics structure, \f2fstats\fP,
and the name of the class to query, \f2class\fP.  The return value is the
mode of \f2class\fP.

\f3\%pfFStatsAttr\fP takes a pointer to a statistics structure, \f2fstats\fP, the
name of the attribute to set, \f2attr\fP, and the attribute value,
\f2val\fP.  Frame statistics provide additional attributes beyond the basic
pfStats attributes.  These attributes are only relevant when automatic
statistics collection is being done by a parent channel.  These
attributes are:
.RS
.TP 5
\f3\%PFFSTATS_UPDATE_FRAMES\fP
The number of frames over which statistics should be averaged.  The default
value is 2.  If \f2val\fP is 0, statistics accumulation and averaging is
disabled and only the \f3\%CUR\fP and \f3\%PREV\fP statistics for enabled classes
will be maintained.  This is recommended for applications that are not
using the averaged statistics and require a high, fixed frame rate.
.TP
\f3\%PFFSTATS_UPDATE_SECS\fP
The number of seconds, over which statistics should be averaged.  The
default uses the number of frames.  As with \f3\%PFFSTATS_UPDATE_FRAMES\fP,
if \f2val\fP is 0, statistics accumulation and averaging is disabled and
only the \f3\%CUR\fP and \f3\%PREV\fP statistics for enabled classes will be
maintained.
.TP
\f3\%PFFSTATS_PFTIMES_HIST_FRAMES\fP
For the Process Frame Times Statistics, \f3\%PFFSTATS_PFTIMES\fP, the number
of frames of time-stamp history to keep.  The default value is 4.
.RE

\f3\%pfGetFStatsAttr\fP takes a pointer to a statistics structure, \f2fstats\fP,
and the name of the attribute to query, \f2attr\fP.  The return value is
that of attribute \f2attr\fP.

\f3\%pfQueryFStats\fP takes a pointer to a statistics structure,
\f2fstats\fP.  \f2which\fP is a \f3\%PFSTATSVAL_*\fP or \f3\%PFFSTATSVAL_*\fP token
that specifies the value or values to query in \f2which\fP, and \f2dst\fP
destination buffer that is a pointer to a float, a pfStatsVal* or
pfFStatsVal* structure.  The size of the expected return data is
specified by \f2size\fP and if non-zero, will prevent \f3\%pfQueryFStats\fP from
writing beyond a buffer that is too small.
The return value is the number of bytes
written to the destination buffer.  A single \f3\%PFFSTATS_BUF_*\fP token
should be bitwise OR-ed into the \f2which\fP flag to select a frame stats
buffer: \f3\%PREV\fP, \f3\%CUR\fP, \f3\%AVG\fP, or \f3\%CUM\fP.  If no frame statistics
buffer is selected, then the query accesses the \f3\%PREV\fP buffer by default.
If multiple stats buffers are selected, no results will be written and
a warning message will be printed.  In a running application, one
should query frame statistics in the application process and query the
\f3\%PREV\fP and \f3\%AVG\fP statistics buffers.  The pfFrameStats query
structures and tokens are all defined in pfstats.h.  Frame statistics
queries may be mixed with standard statistics queries.  There are
tokens for getting back all of the statistics, entire sub-structures,
and individual values.

\f3\%pfMQueryFStats\fP takes a pointer to a statistics structure,
\f2fstats\fP, a pointer to the start of a PFSTATSVAL_NULL-terminated
array of query tokens in
\f2which\fP, and a destination buffer \f2dst\fP.  The size of the expected return
data is specified by \f2size\fP and if non-zero, will prevent \f3\%pfMQueryFStats\fP
from writing beyond a buffer that is too small.
The return value is the number of bytes written to the
destination buffer.  If at any point in
the query, an error is encountered, the query will return and not
finish the rest of the requests.


\f3\%pfCopyFStats\fP:
The \f2dSel\fP and \f2sSel\fP arguments explicitly specify the statistics
buffers for both source and destination pfFrameStats structures.  A
value of 0 is defaulted to the value \f3\%PFFSTATS_BUF_CUR\fP.
The \f2classes\fP argument is a \f3\%_EN*\fP statistics class enable bitmask.  Any buffer
select token included with the class bitmask is ignored.

\f3\%pfFStatsCountNode\fP will count \f2node\fP in the specified stats
\f2class\fP for the specified \f2mode\fP of the pfFrameStats structure
\f2fstats\fP.  Only one class and mode may be specified, and children of
\f2node\fP are not traversed.

\f3\%pfFStatsCountGSet\fP works as documented for the pfStats statistics
structure. It accumulates the statistics into the \f3\%CUR\fP statistics buffer.

The \f3\%pfClearFStats\fP, \f3\%pfAccumulateFStats\fP, \f3\%pfAverageFStats\fP routines
all take pointers to a pfFrameStats structure, \f2fstats\fP, and work
as documented for the basic pfStats statistics
structure. However, for operating on a pfFrameStats structure, these routines
need to know which pfFrameStats buffer to access.
A pfFrameStats buffer is selected by OR-ing in a \f3\%_BUF_\fP token with
the statistics class enable.  The same pfFrameStats buffer is used for
both source and destination pfFrameStats structures.  If no pfFrameStats
buffer is selected with a \f3\%_BUF_\fP token, a default value of
\f3\%PFFSTATS_BUF_CUR\fP is used for calls to
\f3\%pfClearFStats\fP and
\f3\%pfAccumulateFStats\fP, and a default
value of \f3\%PFFSTATS_BUF_CUM\fP is used for calls to
\f3\%pfAverageFStats\fP.

.SH EXAMPLES
For a class of statistics to be collected, the following must be true:
.RS
.TP 5
1.
A pfFrameStats structure must be fetched from the channel of interest, or created.
.TP
2.
The corresponding statistics class must be enabled with \f3\%pfFStatsClass\fP.
No statistics classes are enabled by default.
.TP
3.
The corresponding statistics class mode must be enabled with \f3\%pfFStatsClassMode\fP
However, each statistics class does have a reasonable set of statistics
modes enabled by default.
.RE

Here a pfFrameStats structure is obtained for the channel of interest and
then database, cull, and graphics statistics are enabled.
.Ex
.nf

pfFrameStats *fstats = NULL;
fstats = pfGetChanFStats(chan);
pfFStatsClass(stats, PFSTATS_ENGFX | PFFSTATS_ENDB | PFFSTATS_ENCULL, PFSTATS_ON);
.Ee
.fi
.na

This example shows how to enable and display just the frame times and the
number of triangles per frame.  This is a very efficient configuration.
.Ex
.nf

pfFrameStats *fstats = NULL;
fstats = pfGetChanFStats(chan);

/* first, turn off the frame history stats */
pfFStatsClassMode(fstats, PFFSTATS_PFTIMES, PFFSTATS_PFTIMES_HIST, PFSTATS_OFF);

/* Only enable the geometry counts in the graphics stats */
pfFStatsClassMode(fstats, PFSTATS_GFX, PFSTATS_GFX_GEOM, PFSTATS_SET);

/* disable the display of the verbose graphics stats
 * and just have the total tris number at the top of your display.
 */
pfChanFStatsMode(chan, PFCSTATS_DRAW, PFFSTATS_ENPFTIMES);
.Ee
.fi
.na


The following is an example of querying a few specific statistics.
Note that if the corresponding stats class and mode is not enabled
then the query will simply return 0 for that value.
.Ex
.nf

uint qtmp[5];
float ftmp[5];
pfFrameStats *fstats = NULL;

fstats = pfGetChanFStats(chan);

qtmp[0] = PFFSTATS_BUF_AVG | PFSTATSVAL_GFX_GEOM_TRIS;
qtmp[1] = PFFSTATS_BUF_AVG | PFFSTATSVAL_PFTIMES_PROC_TOTAL;
qtmp[2] = PFFSTATS_BUF_AVG | PFSTATSVAL_CPU_SYS_BUSY;
qtmp[3] = NULL;

pfMQueryFStats(fstats, qtmp, ftmp, sizeof(ftmp));

fprintf(stderr, "Query num tris: %.0f\\n", ftmp[0]);
fprintf(stderr, "Query frame time: %.0f msecs\\n", ftmp[1]*1000.0f);
fprintf(stderr, "Query sys busy: %.0f%%\\n", ftmp[2]);
.Ee
.fi
.na

This example shows using a very inexpensive pfFrameStats
mode to track frame rates and frames that missed the goal frame rate.
.Ex
.nf

/* enable only the most minimal stats - tracking of process frame times */
pfFrameStats *fstats = pfGetChanFStats(chan);
pfFStatsClass(fstats, PFFSTATS_ENPFTIMES, PFSTATS_SET);
pfFStatsClassMode(fstats, PFFSTATS_PFTIMES, PFFSTATS_PFTIMES_BASIC, PFSTATS_SET);

/* turn off accumulation and averaging of stats */
pfFStatsAttr(fstats, PFFSTATS_UPDATE_FRAMES, 0.0f);

\#define STAMPS 0
\#define TIMES  1
\#define MISSES 2
static uint query[] = {
    PFFSTATS_BUF_PREV | PFFSTATSVAL_PFTIMES_APPSTAMP,
    PFFSTATS_BUF_PREV | PFFSTATSVAL_PFTIMES_PROC,
    PFFSTATS_BUF_PREV | PFFSTATSVAL_PFTIMES_MISSES,
    NULL
};

static pfFStatsValProc dst[3];
int i;

if (!FrameStats)
    initFrameStats();

/* get the prev frame times and corresponding app frame stamps */
pfMQueryFStats(fstats, query, dst, sizeof(dst));

/* record the collected data here */
.Ee
.fi
.na

.SH NOTES

\f3\%pfDrawFStats\fP does not actually draw the diagram but sets a flag so
that the diagram is drawn just before OpenGL Performer swaps buffers.

The CPU statistics from the pfStats class \f3\%PFSTATSHW_CPU\fP are
obtained from IRIX process accounting data at the start and end of the
update period.  They are then copied into the \f3\%CUR\fP and \f3\%AVG\fP
buffers.

\f3\%pfOpenFStats\fP and \f3\%pfCloseFStats\fP cannot be executed on a pfFrameStats
structure.  All actual frame statistics collection is done only by individual
pfChannels.  Frame statistics can be copied and accumulated into additional
pfFrameStats structures.

The \f3\%pfDrawChanStats\fP manual page gives some pointers on how to
interpret the statistics to help in tuning your database.  Refer to the
OpenGL Performer Programming Guide for more detailed information.
.SH BUGS


Calls to \f3\%pfQueryFStats\fP with the query
tokens \f3\%PFFSTATSVAL_NUMFRAMES\fP or \f3\%PFFSTATSVAL_NUMISECTFRAMES\fP
return values formatted as floats, even though the corresponding
fields in the pfFrameStatsValues structure are of type type \f3\%int\fP.

The checking of \f2size\fP in
and \f3\%pfMQueryFStats\fP is not yet
implemented.
.SH SEE ALSO
pfChanStatsMode,
pfDrawChanStats,
pfGetChanFStats,
pfStats,
pfDelete
