'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfGetId" "3pf"
.SH NAME
.upperok
.B pfGetId
\- 
Get unique id of libpf object.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'int\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
int
\f3\%pfGetId\fP(void\ *unknown);
.fi
.SH PARAMETERS
.TP \w'unknown\ \ 'u
\f2unknown\fP
is a pointer to a libpf object
.SH DESCRIPTION

All OpenGL Performer objects defined in the \f3\%libpf\fP library have a
unique integer identifier.
\f3\%pfGetId\fP returns the identifier of
\f2unknown\fP or -1 if \f2unknown\fP is not a \f3\%libpf\fP data type.
.SH SEE ALSO
pfNode,
pfUpdatable
