'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfPipeWindow" "3pf"
.SH NAME
.upperok
.B pfNewPWin,
.B pfGetPWinClassType,
.B pfPWinAspect,
.B pfPWinConfigFunc,
.B pfPWinFBConfig,
.B pfPWinFBConfigAttrs,
.B pfPWinFBConfigData,
.B pfPWinFBConfigId,
.B pfPWinFullScreen,
.B pfPWinGLCxt,
.B pfPWinIndex,
.B pfPWinList,
.B pfPWinMode,
.B pfPWinName,
.B pfPWinOrigin,
.B pfPWinOriginSize,
.B pfPWinOverlayWin,
.B pfPWinScreen,
.B pfPWinShare,
.B pfPWinSize,
.B pfPWinStatsWin,
.B pfPWinType,
.B pfPWinWSConnectionName,
.B pfPWinWSDrawable,
.B pfPWinWSWindow,
.B pfGetPWinAspect,
.B pfGetPWinChanIndex,
.B pfGetPWinConfigFunc,
.B pfGetPWinCurOriginSize,
.B pfGetPWinCurScreenOriginSize,
.B pfGetPWinCurState,
.B pfGetPWinCurWSDrawable,
.B pfGetPWinFBConfig,
.B pfGetPWinFBConfigAttrs,
.B pfGetPWinFBConfigData,
.B pfGetPWinFBConfigId,
.B pfGetPWinGLCxt,
.B pfGetPWinIndex,
.B pfGetPWinList,
.B pfGetPWinMode,
.B pfGetPWinName,
.B pfGetPWinOrigin,
.B pfGetPWinOverlayWin,
.B pfGetPWinPipe,
.B pfGetPWinPipeIndex,
.B pfGetPWinPosPVChan,
.B pfGetPWinScreen,
.B pfGetPWinScreenOrigin,
.B pfGetPWinSelect,
.B pfGetPWinShare,
.B pfGetPWinSize,
.B pfGetPWinStatsWin,
.B pfGetPWinType,
.B pfGetPWinWSConnectionName,
.B pfGetPWinWSDrawable,
.B pfGetPWinWSWindow,
.B pfPWinPVChan,
.B pfPWinAddPVChan,
.B pfPWinRemovePVChan,
.B pfPWinRemovePVChanIndex,
.B pfGetPWinNumPVChans,
.B pfGetPWinPVChan,
.B pfGetPWinPVChanId,
.B pfGetPWinPVChanIndex,
.B pfBindPWinPVChans,
.B pfUnbindPWinPVChans,
.B pfAttachPWin,
.B pfAttachPWinWin,
.B pfClosePWin,
.B pfClosePWinGL,
.B pfConfigPWin,
.B pfOpenPWin,
.B pfIsPWinOpen,
.B pfIsManagedPWin,
.B pfMQueryPWin,
.B pfQueryPWin,
.B pfChoosePWinFBConfig,
.B pfSelectPWin,
.B pfAttachPWinSwapGroup,
.B pfAttachPWinWinSwapGroup,
.B pfPWinInSwapGroup,
.B pfPWinSwapBarrier,
.B pfGetPWinSwapBarrier,
.B pfSwapPWinBuffers,
.B pfGetNumChans,
.B pfAddChan,
.B pfGetChan,
.B pfInsertChan,
.B pfMoveChan,
.B pfRemoveChan,
.B pfInitGfx
\- 
Initialize and manipulate pfPipeWindows within a pfPipe
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfPipeVideoChannel*\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfPipeWindow*
\f3\%pfNewPWin\fP(pfPipe\ *p);
.nf
.fi
.TP
pfType*
\f3\%pfGetPWinClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfPWinAspect\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ x,
int\ y);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinConfigFunc\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
pfPWinFuncType\ func);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinFBConfig\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
XVisualInfo\ *vi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinFBConfigAttrs\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ *attr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinFBConfigData\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
void\ *data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinFBConfigId\fP(pfWindow\ *win,
'in +2
'll -2
int\ id);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinFullScreen\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
void
\f3\%pfPWinGLCxt\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
pfGLContext\ gc);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinIndex\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinList\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
pfList\ *wlist);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinMode\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinName\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinOrigin\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ xo,
int\ yo);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinOriginSize\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ xo,
int\ yo,
int\ xs,
int\ ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinOverlayWin\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
pfWindow\ *ow);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinScreen\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ screen);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinShare\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinSize\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ xs,
int\ ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinStatsWin\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
pfWindow\ *sw);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinType\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
uint\ type);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinWSConnectionName\fP(const\ pfWindow\ *win,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinWSDrawable\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
pfWSConnection\ dsp,
pfWSDrawable\ gxw);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinWSWindow\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
pfWSConnection\ dsp,
pfWSWindow\ wsw);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetPWinAspect\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ *x,
int\ *y);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetPWinChanIndex\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
pfChannel\ *chan);
.in
.ll
.nf
.fi
.TP
pfPWinFuncType
\f3\%pfGetPWinConfigFunc\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
void
\f3\%pfGetPWinCurOriginSize\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ *xo,
int\ *yo,
int\ *xs,
int\ *ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetPWinCurScreenOriginSize\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ *xo,
int\ *yo,
int\ *xs,
int\ *ys);
.in
.ll
.nf
.fi
.TP
pfState*
\f3\%pfGetPWinCurState\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
pfWSDrawable
\f3\%pfGetPWinCurWSDrawable\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
XVisualInfo*
\f3\%pfGetPWinFBConfig\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
int*
\f3\%pfGetPWinFBConfigAttrs\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
void*
\f3\%pfGetPWinFBConfigData\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
int
\f3\%pfGetPWinFBConfigId\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
pfGLContext
\f3\%pfGetPWinGLCxt\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
int
\f3\%pfGetPWinIndex\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
pfList*
\f3\%pfGetPWinList\fP(const\ pfPipeWindow\ *pwin);
.nf
.fi
.TP
int
\f3\%pfGetPWinMode\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
const char*
\f3\%pfGetPWinName\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
void
\f3\%pfGetPWinOrigin\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ *xo,
int\ *yo);
.in
.ll
.nf
.fi
.TP
pfWindow*
\f3\%pfGetPWinOverlayWin\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
pfPipe*
\f3\%pfGetPWinPipe\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
int
\f3\%pfGetPWinPipeIndex\fP(const\ pfPipeWindow\ *pwin);
.nf
.fi
.TP
pfPipeVideoChannel*
\f3\%pfGetPWinPosPVChan\fP(const\ pfPipeWindow\ *pwin,
'in +2
'll -2
int\ x,
int\ y);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetPWinScreen\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
void
\f3\%pfGetPWinScreenOrigin\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ *xo,
int\ *yo);
.in
.ll
.nf
.fi
.TP
pfWindow*
\f3\%pfGetPWinSelect\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
uint
\f3\%pfGetPWinShare\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
void
\f3\%pfGetPWinSize\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ *xs,
int\ *ys);
.in
.ll
.nf
.fi
.TP
pfWindow*
\f3\%pfGetPWinStatsWin\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
uint
\f3\%pfGetPWinType\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
const char*
\f3\%pfGetPWinWSConnectionName\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
pfWSDrawable
\f3\%pfGetPWinWSDrawable\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
Window
\f3\%pfGetPWinWSWindow\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
void
\f3\%pfPWinPVChan\fP(pfPipeWindow*\ pwin,
'in +2
'll -2
int\ num,
pfPipeVideoChannel\ *pvchan);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfPWinAddPVChan\fP(pfPipeWindow*\ pwin,
'in +2
'll -2
pfPipeVideoChannel\ *pvchan);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinRemovePVChan\fP(pfPipeWindow*\ pwin,
'in +2
'll -2
pfPipeVideoChannel\ *pvchan);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPWinRemovePVChanIndex\fP(pfPipeWindow*\ pwin,
'in +2
'll -2
int\ num);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetPWinNumPVChans\fP(const\ pfPipeWindow*\ pwin);
.nf
.fi
.TP
pfPipeVideoChannel*
\f3\%pfGetPWinPVChan\fP(pfPipeWindow*\ pwin,
'in +2
'll -2
int\ num);
.in
.ll
.nf
.fi
.TP
pfPipeVideoChannel*
\f3\%pfGetPWinPVChanId\fP(pfPipeWindow*\ pwin,
'in +2
'll -2
int\ num);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetPWinPVChanIndex\fP(pfPipeWindow*\ pwin,
'in +2
'll -2
pfPipeVideoChannel\ *pvchan);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfBindPWinPVChans\fP(pfPipeWindow*\ pwin);
.nf
.fi
.TP
void
\f3\%pfUnbindPWinPVChans\fP(pfPipeWindow*\ pwin);
.nf
.fi
.TP
int
\f3\%pfAttachPWin\fP(pfPipeWindow\ *pwin0,
'in +2
'll -2
pfPipeWindow\ *pwin1);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfAttachPWinWin\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
pfWindow\ *w);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfClosePWin\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
void
\f3\%pfClosePWinGL\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
void
\f3\%pfConfigPWin\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
void
\f3\%pfOpenPWin\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
int
\f3\%pfIsPWinOpen\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
int
\f3\%pfIsManagedPWin\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
int
\f3\%pfMQueryPWin\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ *which,
int\ *dst);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfQueryPWin\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ which,
int\ *dst);
.in
.ll
.nf
.fi
.TP
pfFBConfig
\f3\%pfChoosePWinFBConfig\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
pfWSConnection\ dsp,
int\ screen,
int\ *attr);
.in
.ll
.nf
.fi
.TP
pfWindow*
\f3\%pfSelectPWin\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
void
\f3\%pfAttachPWinSwapGroup\fP(pfPipeWindow*\ pwin0,
'in +2
'll -2
pfPipeWindow*\ pwin1);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfAttachPWinWinSwapGroup\fP(pfPipeWindow*\ pwin,
'in +2
'll -2
pfWindow*\ win);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfPWinInSwapGroup\fP(pfPipeWindow*\ pwin);
.nf
.fi
.TP
void
\f3\%pfPWinSwapBarrier\fP(pfPipeWindow*\ pwin,
'in +2
'll -2
int\ barrier);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetPWinSwapBarrier\fP(pfPipeWindow*\ pwin);
.nf
.fi
.TP
void
\f3\%pfSwapPWinBuffers\fP(pfPipeWindow\ *pwin);
.nf
.fi
.TP
int
\f3\%pfGetNumChans\fP(const\ pfPipeWindow\ *pwin);
.nf
.fi
.TP
int
\f3\%pfAddChan\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
pfChannel\ *chan);
.in
.ll
.nf
.fi
.TP
pfChannel*
\f3\%pfGetChan\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ which);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfInsertChan\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ where,
pfChannel\ *chan);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMoveChan\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ where,
pfChannel\ *chan);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfRemoveChan\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
pfChannel\ *chan);
.in
.ll
.nf
.fi
.TP
extern void
\f3\%pfInitGfx\fP(void);
.fi

.Ex
.nf

/* pfPipeWindow-specific types */
typedef void (*pfPWinFuncType)(pfPipeWindow *pw);

/* X-Window system based Performer types */
typedef Display         *pfWSConnection;
typedef XVisualInfo     pfFBConfig;
typedef Window          pfWSWindow;
typedef Drawable        pfWSDrawable;

typedef GLXFBConfigSGIX pfGLXFBConfig;
typedef GLXContext      pfGLContext;
.Ee
.fi
.na

.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfPipeWindow\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfPipeWindow\fP.
Casting an object of class \f3\%pfPipeWindow\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfPipeWindow\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'pwin\ \ 'u
\f2pwin\fP
identifies a pfPipeWindow.
.TP
\f2dsp\fP
identifies a pfWSConnection.
.TP
\f2wsw\fP
identifies a pfWSWindow.
.TP
\f2gxw\fP
identifies a pfWSDrawable.
.TP
\f2gc\fP
identifies a pfGLContext.
.SH DESCRIPTION

OpenGL Performer programs render a pfChannel to a pfPipeWindow of the same
parent pfPipe. Multiple pfPipeWindows can be open on a single pfPipe. A
pfPipe and all of its windows have the same screen, or hardware graphics pipeline.
By default, pfChannels are assigned to the first
pfPipeWindow of a pfPipe.  pfChannels can be removed from the pfPipeWindow and
assigned to other pfPipeWindows.
pfPipeWindows can be opened/closed and created at any time.
Refer to the \f3\%pfPipe\fP man page for more information on how pfPipeWindows
fit into the hierarchy of pfPipes, pfPipeWindows, and pfChannels.

pfPipeWindows are similar to pfWindows but are tracked/maintained by
libpf and are needed by libpf to draw pfChannels.  Because of their
similarity, many of the pfPipeWindow routines are identical to
pfWindow routines except for the fact that the pfPWin<*> routines
operate on a pfPipeWindow and the pfWin<*> routines operate on a
pfWindow.  These corresponding routines are listed in the table below
and their functionality is documented in the pfWindow man page.
Routines documented here have special extended functionality for
pfPipeWindows.

.ne 34
.TS
center tab($);
C | C
L | L .
pfPipeWindow routine$pfWindow routine
_
pfPWinAspect$pfWinAspect
pfPWinFBConfig$pfWinFBConfig
pfPWinFBConfigAttrs$pfWinFBConfigAttrs
pfPWinFBConfigData$pfWinFBConfigData
pfPWinFBConfigId$pfWinFBConfigId
pfPWinFullScreen$pfWinFullScreen
pfPWinGLCxt$pfWinGLCxt
pfPWinIndex$pfWinIndex
pfPWinMode$pfWinMode
pfPWinName$pfWinName
pfPWinOrigin$pfWinOrigin
pfPWinOriginSize$pfWinOriginSize
pfPWinOverlayWin$pfWinOverlayWin
pfPWinScreen$pfWinScreen
pfPWinShare$pfWinShare
pfPWinSize$pfWinSize
pfPWinStatsWin$pfWinStatsWin
pfPWinWSConnectionName$pfWinWSConnectionName
pfPWinWSDrawable$pfWinWSDrawable
pfPWinWSWindow$pfWinWSWindow
pfGetPWinAspect$pfGetWinAspect
pfGetPWinCurOriginSize$pfGetWinCurOriginSize
pfGetPWinCurScreenOriginSize$pfGetWinCurScreenOriginSize
pfGetPWinCurState$pfGetWinCurState
pfGetPWinCurWSDrawable$pfGetWinCurWSDrawable
pfGetPWinFBConfig$pfGetWinFBConfig
pfGetPWinFBConfigAttrs$pfGetWinFBConfigAttrs
pfGetPWinFBConfigData$pfGetWinFBConfigData
pfGetPWinFBConfigId$pfGetWinFBConfigId
pfGetPWinGLCxt$pfGetWinGLCxt
pfGetPWinIndex$pfGetWinIndex
pfGetPWinList$pfGetWinList
pfGetPWinMode$pfGetWinMode
pfGetPWinName$pfGetWinName
pfGetPWinOrigin$pfGetWinOrigin
pfGetPWinOverlayWin$pfGetWinOverlayWin
pfGetPWinScreen$pfGetWinScreen
pfGetPWinSelect$pfGetWinSelect
pfGetPWinShare$pfGetWinShare
pfGetPWinSize$pfGetWinSize

.TE

.ne 16
.TS
center tab($);
C | C
L | L .
pfPipeWindow routine$pfWindow routine
_
pfGetPWinStatsWin$pfGetWinStatsWin
pfGetPWinType$pfGetWinType
pfGetPWinWSConnectionName$pfGetWinWSConnectionName
pfGetPWinWSDrawable$pfGetWinWSDrawable
pfGetPWinWSWindow$pfGetWinWSWindow
pfChoosePWinFBConfig$pfChooseWinFBConfig
pfAttachPWin$pfAttachWin
pfSelectPWin$pfSelectWin
pfAttachPWinSwapGroup$pfAttachWinSwapGroup
pfAttachPWinWinSwapGroup$pfAttachWinSwapGroup
pfPWinInSwapGroup$pfWinInSwapGroup
pfPWinSwapBarrier$pfWinSwapBarrier
pfGetPWinSwapBarrier$pfGetWinSwapBarrier
pfSwapPWinBuffers$pfSwapWinBuffers
pfIsPWinOpen$pfIsWinOpen
pfIsManagedPWin$pfIsManagedWin
pfQueryPWin$pfQueryWin
pfMQueryPWin$pfMQueryWin
.TE

\f3\%pfNewPWin\fP
creates and returns a handle to a pfPipeWindow on the screen managed by
\f2pipe\fP.
Like other pfUpdatables, pfPipeWindows are always allocated from shared
memory.
The pipe of a pfPipeWindow cannot be changed.
\f3\%pfGetPWinPipe\fP returns a pointer to the pfPipe of \f2pwin\fP.
Like other pfObjects, pfPipeWindows must be created in the application
process.

\f3\%pfGetPWinClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfPipeWindow\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetPWinClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfPipeWindow\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.


\f3\%pfWinFBConfigId\fP allows you to directly set the
OpenGL X visual id to be used in configuring the resulting OpenGL/X window.
\f3\%pfGetWinFBConfigId\fP will return the current
OpenGL visual id of the window (or -1 if the id is not known).
This routine is useful in multiprocess operation if you want
to be able to directly specify the framebuffer configuration of an X window
in the application process.
See the \f3\%XVisualIDFromVisual(3X11)\fP and \f3\%XGetVisualInfo(3X11)\fP
man pages for more information about X visuals.


\f3\%pfPWinScreen\fP will set the screen of
\f2pwin\fP and on the parent pfPipe.
Once set, the screen cannot be changed.  If the screen of the parent
pfPipe had already been set when the pfPipeWindow was created, the
pfPipeWindow will inherit that screen setting and will not accept another.
The pfPipeWindow will direct all rendering comments to the hardware
graphics pipeline specified by \f2screen\fP.  As with pfWindows, if a
screen is never set, the default screen of the current window system
connection will be set as the screen when the window is opened with
\f3\%pfOpenPWin::\fP.
\f3\%pfGetPWinScreen\fP will return the
screen of the pfPipeWindow.  If the screen has not yet been set, (-1)
will be returned.
See the \f3\%pfGetCurWSConnection\fP man page for more information on the
specification of a default screen.
See the \f3\%pfPipeScreen\fP man page for
special restrictions and proper specification of pfPipe and pfPipeWindow screens
in multipipe configurations.

\f3\%pfPWinWSConnectionName\fP allows you to
specify the exact window server and default screen for the successive opening
of the window. This can be used for specifying remote displays or on
machines running more than one window server.
\f3\%pfGetPWinWSConnectionName\fP will return
the name specifying the current window server target.
As with the setting of screens, a window server target specified on a pfPipe
will take precedence over a target set on a pfPipeWindow. If a window server
target is not specified for the parent pfPipe of a pfPipeWindow, the parent
pfPipe will inherit the window setting.   Because of these restrictions,
this routine must be called in the application process, before the first
call to \f3\%pfFrame\fP.
See the \f3\%pfPipeScreen\fP man page for
special restrictions and proper specification of pfPipe and pfPipeWindow screens
in multipipe configurations.

\f3\%pfGetPWinIndex\fP returns the
index of \f2pwin\fP in the pfPipeWindow list of
the parent pfPipe.

pfChannels are assigned to a pfPipeWindow upon their creation.
pfPipeWindows also have list-style API for adding, removing, inserting,
and reordering pfChannels on a pfPipeWindow:
\f3\%pfAddChan\fP will append \f2chan\fP as the last pfChannel of
\f2pwin\fP and
and returns the resulting index or (-1) if an error was encountered.
\f3\%pfInsertChan\fP will insert \f2chan\fP as the \f2where\fPth pfChannel
of \f2pwin\fP.
\f3\%pfMoveChan\fP will move \f2chan\fP from its current position in
the pfChannel list of \f2pwin\fP to position \f2where\fP.  If \f2chan\fP
does not belong to \f2pwin\fP, no action is taken and an error flag
of (-1) is returned; otherwise, \f2where\fP is returned.
\f3\%pfRemoveChan\fP will remove \f2chan\fP from \f2pwin\fP.
If \f2chan\fP does not belong to \f2pwin\fP, no action is done and
an error flag of (-1) is returned.  Otherwise, the previous index of
\f2chan\fP is returned.
\f3\%pfGetChan\fP returns a pointer to the \f2index\fPth pfChannel of
\f2pwin\fP. \f3\%pfGetNumChans\fP returns the number of pfChannels attached
to \f2pwin\fP.
\f3\%pfGetPWinChanIndex\fP returns the index of the \f2chan\fP
in the channel list, or (-1) if the pfChannel is not attached to \f2pwin\fP.

\f3\%pfClosePWin\fP can be called from the application process
to close a window.  However, if additional draw process work
is needed to be done, a \f3\%pfConfigPWin\fP draw process callback should
be used.

\f3\%pfConfigPWin\fP, called from the application process,
will trigger the configuration callback
function to be called in the draw process for the current frame.
If no user configuration callback function has been specified,
a default configuration function will be called that will
open and initialize \f2pwin\fP.
\f3\%pfPWinConfigFunc\fP, called from the application process,
specifies a draw process callback function, \f2func\fP, to
configure \f2pwin\fP.  The configure function can be used to make draw process
calls to open, initialize, and close pfPipeWindows.
In this window configuration callback function \f3\%pfOpenPWin\fP can
be called on the pfPipeWindow, or an OpenGL window
can be created and assigned to the pfPipeWindow.
\f3\%pfGetPWinConfigFunc\fP returns the pointer to the user-specified
window configuration callback function, or NULL of no such function has
been set.  If the application is multiprocessed, the window is opened
asynchronously in the DRAW process.  The draw process is activated by a call
to \f3\%pfFrame\fP. This means that an immediate query of state from the APP process
after an APP process call to \f3\%pfOpenPWin\fP or
\f3\%pfConfigPWin\fP may not return valid results.

\f3\%pfOpenPWin\fP will cause
\f2pwin\fP to be opened and initialized via
\f3\%pfInitGfx\fP. If called from the application process,
the pfPipeWindow will be automatically opened in the draw process
for the corresponding frame.  If called in the draw process,
the pfPipeWindow will be opened automatically.
Similarly, \f3\%pfClosePWin\fP and \f3\%pfClosePWinGL\fP
can be called from either the application process or the draw process and
will cause the \f2pwin\fP or the graphics context, respectively,
to be closed in the draw process for the given frame. If application specific work
needs to be done in the draw process for manipulating pfPipeWindows,
\f3\%pfConfigPWin\fP should be used.

OpenGL Performer automatically calls \f3\%pfInitGfx\fP for windows that it creates
and opens. For pfPipeWindows, \f3\%pfInitGfx\fP does the same operations as for
pfWindows, and in addition, will
apply a default material and a default MODULATE texture environment
(\f3\%pfApplyTEnv\fP), and enable backface culling
(\f3\%pfCullFace\fP(\f3\%PFCF_BACK\fP)).

\f3\%pfPWinList\fP can be used to specify a pfList of pfWindows, \f2wlist\fP,
that can draw into a single pfPipeWindow. This enables a pfPipeWindow to
maintain a list of alternate framebuffer configurations for the base pfPipeWindow.
A pfPipeWindow always maintains a default main graphics pfWindow and
a pfWindow list.  Two of the windows in this list are
so commonly needed that they have special names and can be
created automatically for the user: OVERLAY and STATS.
The user can also add his own pfWindows to the pfWindow list for additional
configurations.  This list may only hold pfWindows, NOT pfPipeWindows.
With window lists, we have an effective pfWindow
hierarchy of: screen->pfPipe->pfPipeWindow[graphics, stats, overlay, ...]->pfChannel(s).
See the \f3\%pfWinList\fP
man page for more information on these alternate framebuffer
configuration windows.

\f3\%pfPWinIndex\fP selects pfWindow \f2index\fP
from the alternate configuration window list to be the current pfWindow the
pfPipeWindow shall render to.
All the pfChannels attached to the pfPipeWindow will automatically
be drawn into this current pfWindow.  See \f3\%pfWinIndex\fP
for more details of this operation.
\f3\%pfGetPWinIndex\fP will return the current
index of the pfPipeWindow.

\f3\%pfPWinType\fP
sets the type of a pfPipeWindow where \f2type\fP is an or-ed
bitmask that may contain the type constants listed below.
\f3\%pfGetPWinType\fP returns the type of a pfPipeWindow.
A change in the type of a pfPipeWindow takes effect upon the call
to \f3\%pfOpenPWin\fP.
The type of an open pfPipeWindow cannot be changed.
The pfWindow type attributes all start with \f3\%PFPWIN_TYPE_\fP and are:
.RS
.TP
\f3\%PFPWIN_TYPE_X\fP
has identical characteristics to the \f3\%PFWIN_TYPE_X\fP specification for
pfWindows.  See the \f3\%pfWinType\fP man
page for more information.
.TP
\f3\%PFPWIN_TYPE_SHARE\fP
Specifies that this window should be automatically attached to the
first pfPipeWindow on the parent pfPipe.  See the
\f3\%pfAttachWin\fP man page for more details.
.TP
\f3\%PFPWIN_TYPE_STATS\fP
has identical characteristics to the \f3\%PFWIN_TYPE_STATS\fP specification for
pfWindows.  See the \f3\%pfWinType\fP man
page for more information.
.TP
\f3\%PFPWIN_TYPE_PBUFFER\fP
The window drawable will be created in a pbuffer.  For this, you must
also specify an GLXFBConfigSGIX with
\f3\%pfPWinFBConfig\fP before
the window is opened.
.TP
\f3\%PFPWIN_TYPE_NOXEVENTS\fP
OpenGL Performer will not track X configuration events (resizing,
repositioning, etc.) on this window.  This can save a little bit
of system overhead so for a deployed, static, real-time flight
simulator in "training" mode where every little bit counts, use
this.  In development mode, or for interactive applications, you
probably want to leave this off.
.TP
\f3\%PFPWIN_TYPE_UNMANAGED\fP
OpenGL Performer will not do automatic X window management on this window.
This includes size and position tracking, resizing of alternate configuration
windows, and swapbuffers. OpenGL Performer will still make the graphics
context of this window current if it is open for a pfPipe to render to and
has attached pfChannels. pfPipeWindows with drawables that are of type
GLXPbufferSGIX or Pixmap are automatically made unmanaged.
.RE

\f3\%pfGetPWinOrigin\fP returns
the cached parent relative origin of \f2win\fP, if open,
from the last time the window size was set or an X configuration event
was detected.
Otherwise it returns the origin and size set
by \f3\%pfPWinOrigin\fP.

\f3\%pfGetPWinSize\fP returns
the cached size of \f2win\fP, if open,
from the last time the window size was set or an X configuration event
was detected. Otherwise it returns the size set
by \f3\%pfPWinSize\fP.

\f3\%pfGetPWinScreenOrigin\fP returns
the cached screen relative origin of \f2win\fP, if open,
from the last time the \f2pwin\fP size was set or an X
configuration event was detected.
Otherwise it returns the origin and size set
by \f3\%pfPWinOrigin\fP.


\f3\%pfPWinPVChan\fP sets pfPipeVideoChannel
\f2pvchan\fP for the pfPipeWindow \f2pwin\fP
based on the index \f2num\fP.
\f3\%pfGetPWinPVChan\fP performs the opposite
task, returning a pointer to the \f2num\fP'th pfPipeVideoChannel of the
pfPipeWindow.
The total number of pfPipeVideoChannels associated with the pfPipeWindow
is returned by \f3\%pfGetPWinNumPVChans\fP.

\f3\%pfPWinAddPVChan\fP adds the
pfPipeVideoChannel \f2pvchan\fP to a pfPipeWindow and returns the
resulting index or (-1) if an error was encountered. If \f2pvchan\fP
has not already been assigned a hardware video channel, then the
next active hardware video channel after the previous pfPipeVideoChannel
on the pfPipeWindow will be assigned to the new pfPipeVideoChannel.
This assignment can be changed with
\f3\%pfPVChanId\fP.
pfPipeWindows start out with an initial pfPipeVideoChannel that will
reference the first active hardware video channel.

\f3\%pfPWinRemovePVChan\fP removes
the pfPipeVideoChannel  \f2pvchan\fP from a pfPipeWindow using the
pfPipeVideoChannel's pointer as search through the list, while
\f3\%pfPWinRemovePVChanIndex\fP
is used to remove the pfPipeVideoChannel indexed by \f2num\fP from
the pfPipeWindow's pfPipeVideoChannel list.

The index value can be obtained from
\f3\%pfGetPWinPVChanIndex\fP which
returns the index of pfPipeVideoChannel \f2pvchan\fP.
The opposite action is provided by
\f3\%pfGetPWinPVChanId\fP which accepts
the argument \f2num\fP and returns the pointer to the \f2num\fP'th
pfPipeVideoChannel of the indicated pfPipeWindow.

All of the pfPipeVideoChannels associated with a pfPipeWindow can
be bound with
\f3\%pfBindPWinPVChans\fP
and unbound with
\f3\%pfUnbindPWinPVChans\fP.

\f3\%pfGetPWinPosPVChan\fP
returns the pointer to the pfPipeVideoChannel on
\f2pwin\fP
that contains the screen relative position \f2x\fP, \f2y\fPx.
This can be useful for getting the pfPipeVideoChannel that
contains the mouse.

\f3\%pfAttachPWin\fP will add the windows
of the share group of \f2pwin1\fP to that of \f2pwin0\fP.
\f3\%pfAttachPWinWin\fP will place the
pfWindow \f2win\fP in the share group of \f2pwin\fP.
pfPipeWindow share groups can contain pfWindow so long as the primary group window is
a pfPipeWindow.  This is useful if you want to have a process sproced
off the DRAW process with a pfWindow and graphics context for creating
OpenGL display lists and textures shared with the pfPipeWindow of the
main drawing process.

\f3\%pfAttachPWinSwapGroup\fP will add the windows
of the swap group of \f2pwin1\fP to that of \f2pwin0\fP.
\f3\%pfAttachPWinWinSwapGroup\fP will place the
pfWindow \f2win\fP in the swap group of \f2pwin\fP.
pfPipeWindow swap groups can contain pfWindow so long as the primary group window is
a pfPipeWindow.  The swap group API is only supported under OpenGL operation.
OpenGL programs can use the \f3\%PFCHAN_SWAPBUFFERS_HW\fP share token
with pfChannel share groups to easily and automatically create window swap groups.

.SH EXAMPLES

The following is an example of basic pfPipeWindow creation:
.Ex
.nf

{ /* in the application process after pfConfig() */
	pfPipeWindow *pw;
	pw = pfNewPWin(pfGetPipe(0));
	pfPWinName(pw,"PipeWin");
	pfPWinOriginSize(pw, 0, 0, 500, 500);
	pfPWinType(pw, PFPWIN_TYPE_X);
	pfOpenPWin(pw);
	/* set off the draw process to open window */
	pfFrame();
}
.Ee
.fi
.na


If special draw process operations are to be done with the
opening of the window, a pfConfigPWin callback function
should be used.
.Ex
.nf

{
	/* in the application process pfPipeWindow init callback */
	pfPWinConfigFunc(pw,OpenPipeWin);
	/* trigger the draw process to call the config callback
	 * for this frame
	 */
	pfConfigPWin(pw);
}
/* in the draw process pfPipeWindow init callback */
void OpenPipeWin(pfPipeWindow *pw)
{
	pfOpenPWin(pw);
	/* do other application specific draw process work,
	 * such as downloading scene textures, displaying
	 * welcome messages, etc.
	 */
}
.Ee
.fi
.na


If you have triggered the opening of a pfPipeWindow from the
application process, you may have to wait for it to be opened
in the DRAW process to do queries that depend on state of an
opened window. While you wait, you must call pfFrame to trigger
DRAW frames.
.Ex
.nf

while (!pfIsPWinOpen(pwin)) pfFrame();
.Ee
.fi
.na


The following is an example that shows the creation of multiple
pfPipeWindows for a single pfPipe and the assignment of pfChannels
to the different windows:
.Ex
.nf

{
    pfChannel *chan[MAX_CHANS];
    pfPipeWindow *pwin[MAX_PWINS];
    pfPipe *p = pfGetPipe(0);

    for (int loop=0; loop < NumWins; loop++)
    {
        pfPipeWindow *pw;
        char str[PF_MAXSTRING];
        pwin[loop] = pfNewPWin(p);
        sprintf(str, "OpenGL Performer - Win %d", loop);
        pfPWinName(pwin[loop], str);
        pfPWinOriginSize(pwin[loop], (loop&0x1)*315, ((loop&0x2)>>1)*340, 300, 300);
	pfPWinConfigFunc(pwin[loop], OpenPipeWin);
        pfConfigPWin(pwin[loop]);
    }

    /* Create and configure a pfChannel for each pfPipeWindow. */
    for (int loop=0; loop < NumWins; loop++)
    {
        chan[loop] = pfNewChan(p);
        pfAddChan(pwin[loop], chan[loop]);
    }

    /* set off the draw process to config window */
    pfFrame();
}
.Ee
.fi
.na


\f3\%pfOpenPWin\fP and \f3\%pfClosePWin\fP can both be called from the
application process, or from the draw process.
The following example demonstrates using \f3\%pfConfigPWin\fP to
close a pfPipeWindow:
.Ex
.nf

{
    /* in the application process specify a close config func */
    pfPWinConfigFunc(pw,ClosePipeWin);
    pfConfigPWin(pw);

}

/* in the draw process pfPipeWindow init callback */
void ClosePipeWin(pfPipeWindow *pw)
{
    pfClosePWin(pw);
    /* do other application specific draw process calls */
}
.Ee
.fi
.na

.SH NOTES

pfPipeWindows handle the multiprocessing details of OpenGL Performer applications
for pfWindows. pfPipeWindows must be created in the application process.
However, with some minor exceptions, pfPipeWindows may be configured, opened,
closed, and edited in either the  application process or draw process.
Typically, a pfPipeWindow is created and configured in the application process.
Custom graphics state is initialized in a
\f3\%pfPWinConfigFunc\fP
callback function.
The pfPipeWindow of a channel or a channel's position in a pfPipeWindow list
may only be modified in the application process.
The specification of the current drawing window with
\f3\%pfSelectPWin\fP
must be done in the drawing process.
Explicit specification of the pfGLContext or pfFBConfig
must be done in the drawing process.
pfPipeWindow queries are also best done in the draw process as the query
may have to access the graphics context to provide the requested information.

The following table shows from which process pfPipeWindow routines may
be called.
.ne 34
.TS
center tab($);
C | C | C
L | L | L.
pfPipeWindow routine$Application Process$Draw Process
_
pfNewPWin$Yes$No
pfPWinAspect$Yes$Yes
pfPWinConfigFunc$Yes$No
pfPWinFBConfig$Yes$No
pfPWinFBConfigAttrs$Yes$Yes
pfPWinFBConfigData$No$Yes
pfPWinFBConfigId$Yes$Yes
pfPWinFullScreen$Yes$Yes
pfPWinGLCxt$No$Yes
pfPWinIndex$Yes$Yes
pfPWinList$Yes$Yes
pfPWinMode$Yes$Yes
pfPWinName$Yes$Yes
pfPWinOrigin$Yes$Yes
pfPWinOriginSize$Yes$Yes
pfPWinOverlayWin$Yes$Yes
pfPWinScreen$Yes$Yes
pfPWinShare$Yes$Yes
pfPWinSize$Yes$Yes
pfPWinStatsWin$Yes$Yes
pfPWinType$Yes$Yes
pfPWinWSConnectionName$Yes$No
pfPWinWSDrawable$Yes$Yes
pfPWinWSWindow$Yes$Yes
.TE

.ne 16
.TS
center tab($);
C | C | C
L | L | L.
pfPipeWindow routine$Application Process$Draw Process
_
pfAttachPWin$Yes$Yes
pfPWinAddPVChan$Yes$Yes
pfClosePWin$Yes$Yes
pfClosePWinGL$Yes$Yes
pfConfigPWin$Yes$Yes
pfOpenPWin$Yes$Yes
pfIsPWinOpen$Yes$Yes
pfMQueryPWin$No$Yes
pfQueryPWin$No$Yes
pfChoosePWinFBConfig$No$Yes
pfSelectPWin$No$Yes
pfAttachPWinSwapGroup$Yes$Yes
pfPWinSwapBarrier$Yes$Yes
pfSwapPWinBuffers$No$Yes
pfGetNumChans$Yes$Yes
pfAddChan$Yes$No
pfGetChan$Yes$Yes
pfInsertChan$Yes$No
pfMoveChan$Yes$No
pfRemoveChan$Yes$No
.TE

Note that whenever any pfObjects are given to a pfPipeWindow,
such as \f3\%pfPWinList\fP,
the data must be valid for access by the graphics process.
This data, such as pfLists and pfWindows, should always be allocated
from shared memory.
Structures provided by X, such as that returned by
\f3\%pfChoosePWinFBConfig\fP, or
\f3\%pfChooseFBConfig\fP, will not have been allocated in shared memory.
Therefore, those routines must be called from the draw process.
Under OpenGL operation, \f3\%pfWinFBConfigId\fP
can be used to set the framebuffer configuration of an X window in the
application process.

pfPipeWindows support windows in the multiprocessed libpf
environment and are the glue between pfChannels and pfPipes.
There are times when you might want to use pfWindows, instead of pfPipeWindows,
even in a libpf application.  For example, popping up a simple dialog
window in the draw process should use pfWindows and not pfPipeWindows.
Additionally, if you want to maintain alternate windows with different
visual (framebuffer) configurations for your pfPipeWindow, you use
pfWindows that are alternate framebuffer configurations for the
base pfPipeWindow.
The PFWIN_STATS_WIN, PFWIN_OVERLAY_WIN, and other pfPWinList windows
must themselves be pfWindows and not pfPipeWindows.
See the pfPWinList routine below and the pfWindow man page
for more information.

\f3\%X Window origin and size\fP:
There are some subtle issues in the management of origin and size of X
windows.It can be very expensive to immediately obtain the
current screen relative origin of a window, particularly if the
window is in a hierarchy.  pfPipeWindows have the size and position
of the window tracked by the application process. However, it is still
recommended that user code should not rely on knowning the up to date screen
relative origin but should be window-coordinate relative to be
efficient and reliable.


\f3\%Gang Swap\fP
Swap groups can contain windows from separate pfPipes rendering to different
graphics pipelines and force that their double-buffering is synchronized so that
they are guaranteed to always be displaying the same frame and have their
hardware swapbuffers happen simultaneously. This is often referred to as Gang Swap.
For this to work, you must first have the graphics pipelines genlocked.
See the \f3\%genlock(7)\fP man page for more informations.
Next, you must connect the proper cable between the SwapReady connectors
on the graphics pipelines.  On the InfiniteReality this is a simple
BNC cable of any Ohms.

.SH BUGS


pfPipeWindows cannot be deleted.

Detach from share groups and swap groups is not supported.

.SH SEE ALSO
pfNewChan,
pfGetPipe,
pfNewWin,
pfGetCurWSConnection,
genlock,
XGetVisualInfo,
XVisualIDFromVisual
