'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfWindow" "3pf"
.SH NAME
.upperok
.B pfNewWin,
.B pfGetWinClassType,
.B pfWinAspect,
.B pfWinFBConfig,
.B pfWinFBConfigAttrs,
.B pfWinFBConfigData,
.B pfWinFBConfigId,
.B pfWinFullScreen,
.B pfWinGLCxt,
.B pfWinIndex,
.B pfWinList,
.B pfWinMode,
.B pfWinName,
.B pfWinOrigin,
.B pfWinOriginSize,
.B pfWinOverlayWin,
.B pfWinScreen,
.B pfWinShare,
.B pfWinSize,
.B pfWinStatsWin,
.B pfWinType,
.B pfWinWSConnectionName,
.B pfWinWSDrawable,
.B pfWinWSWindow,
.B pfGetWinAspect,
.B pfGetWinCurOriginSize,
.B pfGetWinCurScreenOriginSize,
.B pfGetWinCurState,
.B pfGetWinCurWSDrawable,
.B pfGetWinFBConfig,
.B pfGetWinFBConfigAttrs,
.B pfGetWinFBConfigData,
.B pfGetWinFBConfigId,
.B pfGetWinGLCxt,
.B pfGetWinIndex,
.B pfGetWinList,
.B pfGetWinMode,
.B pfGetWinName,
.B pfGetWinOrigin,
.B pfGetWinOverlayWin,
.B pfGetWinScreen,
.B pfGetWinScreenOrigin,
.B pfGetWinSelect,
.B pfGetWinShare,
.B pfGetWinSize,
.B pfGetWinStatsWin,
.B pfGetWinType,
.B pfGetWinWSConnectionName,
.B pfGetWinWSDrawable,
.B pfGetWinWSWindow,
.B pfAttachWin,
.B pfChooseWinFBConfig,
.B pfCloseWin,
.B pfCloseWinGL,
.B pfIsWinOpen,
.B pfIsManagedWin,
.B pfMQueryWin,
.B pfOpenNewNoPortWin,
.B pfOpenWin,
.B pfQueryWin,
.B pfSelectWin,
.B pfAttachWinSwapGroup,
.B pfWinInSwapGroup,
.B pfWinSwapBarrier,
.B pfGetWinSwapBarrier,
.B pfSwapWinBuffers,
.B pfGetCurWin,
.B pfInitGfx
\- 
GL-independent window creation/management routines
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfWSDrawable\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfWindow*
\f3\%pfNewWin\fP(void\ *arena);
.nf
.fi
.TP
pfType*
\f3\%pfGetWinClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfWinAspect\fP(pfWindow\ *win,
'in +2
'll -2
int\ x,
int\ y);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinFBConfig\fP(pfWindow\ *win,
'in +2
'll -2
pfFBConfig\ config);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinFBConfigAttrs\fP(pfWindow\ *win,
'in +2
'll -2
int\ *attr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinFBConfigData\fP(pfWindow\ *win,
'in +2
'll -2
void\ *data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinFBConfigId\fP(pfWindow\ *win,
'in +2
'll -2
int\ id);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinFullScreen\fP(pfWindow\ *win);
.nf
.fi
.TP
void
\f3\%pfWinGLCxt\fP(pfWindow\ *win,
'in +2
'll -2
pfGLContext\ gCxt);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinIndex\fP(pfWindow\ *win,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinList\fP(pfWindow\ *win,
'in +2
'll -2
pfList\ *wlist);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinMode\fP(pfWindow\ *win,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinName\fP(pfWindow\ *win,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinOrigin\fP(pfWindow\ *win,
'in +2
'll -2
int\ xo,
int\ yo);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinOriginSize\fP(pfWindow\ *win,
'in +2
'll -2
int\ xo,
int\ yo,
int\ xs,
int\ ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinOverlayWin\fP(pfWindow\ *win,
'in +2
'll -2
pfWindow\ *ow);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinScreen\fP(pfWindow\ *win,
'in +2
'll -2
int\ s);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinShare\fP(pfWindow\ *win,
'in +2
'll -2
uint\ mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinSize\fP(pfWindow\ *win,
'in +2
'll -2
int\ xs,
int\ ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinStatsWin\fP(pfWindow\ *win,
'in +2
'll -2
pfWindow\ *ow);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinType\fP(pfWindow\ *win,
'in +2
'll -2
uint\ type);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinWSConnectionName\fP(const\ pfWindow\ *win,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinWSDrawable\fP(pfWindow\ *win,
'in +2
'll -2
pfWSConnection\ dsp,
pfWSDrawable\ xWin);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfWinWSWindow\fP(pfWindow\ *win,
'in +2
'll -2
pfWSConnection\ dsp,
pfWSWindow\ xWin);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetWinAspect\fP(const\ pfWindow\ *win,
'in +2
'll -2
int\ *x,
int\ *y);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetWinCurOriginSize\fP(pfWindow\ *win,
'in +2
'll -2
int\ *xo,
int\ *yo,
int\ *xs,
int\ *ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetWinCurScreenOriginSize\fP(pfWindow\ *win,
'in +2
'll -2
int\ *xo,
int\ *yo,
int\ *xs,
int\ *ys);
.in
.ll
.nf
.fi
.TP
pfState*
\f3\%pfGetWinCurState\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
pfWSDrawable
\f3\%pfGetWinCurWSDrawable\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
pfFBConfig
\f3\%pfGetWinFBConfig\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
int*
\f3\%pfGetWinFBConfigAttrs\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
void*
\f3\%pfGetWinFBConfigData\fP(pfWindow\ *win);
.nf
.fi
.TP
int
\f3\%pfGetWinFBConfigId\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
pfGLContext
\f3\%pfGetWinGLCxt\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
int
\f3\%pfGetWinIndex\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
pfList*
\f3\%pfGetWinList\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
int
\f3\%pfGetWinMode\fP(const\ pfWindow\ *win,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
const char*
\f3\%pfGetWinName\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
void
\f3\%pfGetWinOrigin\fP(const\ pfWindow\ *win,
'in +2
'll -2
int\ *xo,
int\ *yo);
.in
.ll
.nf
.fi
.TP
pfWindow*
\f3\%pfGetWinOverlayWin\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
int
\f3\%pfGetWinScreen\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
void
\f3\%pfGetWinScreenOrigin\fP(const\ pfWindow\ *win,
'in +2
'll -2
*xo,
*yo);
.in
.ll
.nf
.fi
.TP
pfWindow*
\f3\%pfGetWinSelect\fP(pfWindow\ *win);
.nf
.fi
.TP
uint
\f3\%pfGetWinShare\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
void
\f3\%pfGetWinSize\fP(const\ pfWindow\ *win,
'in +2
'll -2
int\ *xs,
int\ *ys);
.in
.ll
.nf
.fi
.TP
pfWindow*
\f3\%pfGetWinStatsWin\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
uint
\f3\%pfGetWinType\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
const char*
\f3\%pfGetWinWSConnectionName\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
pfWSDrawable
\f3\%pfGetWinWSDrawable\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
pfWSWindow
\f3\%pfGetWinWSWindow\fP(const\ pfWindow\ *win);
.nf
.fi
.TP
int
\f3\%pfAttachWin\fP(pfWindow\ *win0,
'in +2
'll -2
pfWindow\ *win1);
.in
.ll
.nf
.fi
.TP
pfFBConfig
\f3\%pfChooseWinFBConfig\fP(pfWindow\ *win,
'in +2
'll -2
int\ *attr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfCloseWin\fP(pfWindow\ *win);
.nf
.fi
.TP
void
\f3\%pfCloseWinGL\fP(pfWindow\ *win);
.nf
.fi
.TP
int
\f3\%pfIsWinOpen\fP(pfWindow\ *win);
.nf
.fi
.TP
int
\f3\%pfIsManagedWin\fP(pfWindow\ *win);
.nf
.fi
.TP
int
\f3\%pfMQueryWin\fP(const\ pfWindow\ *win,
'in +2
'll -2
int\ *which,
int\ *dst);
.in
.ll
.nf
.fi
.TP
pfWindow*
\f3\%pfOpenNewNoPortWin\fP(const\ char\ *name,
'in +2
'll -2
int\ screen);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfOpenWin\fP(pfWindow\ *win);
.nf
.fi
.TP
int
\f3\%pfQueryWin\fP(const\ pfWindow\ *win,
'in +2
'll -2
int\ which,
int\ *dst);
.in
.ll
.nf
.fi
.TP
pfWindow*
\f3\%pfSelectWin\fP(pfWindow\ *win);
.nf
.fi
.TP
void
\f3\%pfAttachWinSwapGroup\fP(pfWindow*\ win0,
'in +2
'll -2
pfWindow\ *win1);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfWinInSwapGroup\fP(pfWindow*\ win);
.nf
.fi
.TP
void
\f3\%pfWinSwapBarrier\fP(pfWindow*\ win,
'in +2
'll -2
int\ barrier);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetWinSwapBarrier\fP(pfWindow*\ win);
.nf
.fi
.TP
void
\f3\%pfSwapWinBuffers\fP(pfWindow\ *win);
.nf
.fi
.TP
pfWindow *
\f3\%pfGetCurWin\fP(void);
.nf
.fi
.TP
void
\f3\%pfInitGfx\fP(void);
.fi

.Ex
.nf

/* typedef of X-based Performer Types */
typedef Display         *pfWSConnection;
typedef XVisualInfo     pfFBConfig;
typedef Window          pfWSWindow;
typedef Drawable        pfWSDrawable;

typedef GLXFBConfigSGIX pfGLXFBConfig;
typedef GLXContext      pfGLContext;
.Ee
.fi
.na

.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfWindow\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfWindow\fP.
Casting an object of class \f3\%pfWindow\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfWindow\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'win\ \ 'u
\f2win\fP
identifies a pfWindow.
.SH DESCRIPTION

These functions provide a single API for creating and managing windows.

\f3\%pfNewWin\fP creates and returns a handle to a pfWindow.
\f2arena\fP specifies a malloc arena out of which the pfWindow is
allocated or \f3\%NULL\fP for allocation off the process heap.

\f3\%pfGetWinClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfWindow\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetWinClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfWindow\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.


\f3\%pfWinAspect\fP sets the aspect ratio
of \f2win\fP to be \f2x\fP:\f2y\fP.
\f3\%pfGetWinAspect\fP returns the aspect X and Y components
of \f2win\fP in \f2x\fP and \f2y\fP.

\f3\%pfWinFullScreen\fP will cause the
window to be a full screen window and change its size appropriately.
Future queries of size and origin will reflect this new full screen size.

\f3\%pfWinFBConfig\fP sets the framebuffer configuration for
\f2win\fP to be that specified by \f2config\fP which must be
an XVisualInfo* or an GLXFBConfigSGIX.  OpenGL Performer will derive an X visual
from \f2config\fP if necessary.
This will determine the framebuffer configuration used to create the
graphics context.
\f3\%pfGetWinFBConfig\fP will return the XVisualInfo*
for the visual of \f2win\fP.

\f3\%pfWinFBConfigAttrs\fP provides a window system independent list
of attribute tokens, \f2attr\fP, to describe the desired
framebuffer configuration of \f2win\fP.
The attribute list format is the same as the SGI GLX attribute
format for OpenGL, but with matching \f3\%PFFB_*\fP tokens that can
be used with OpenGL in place of the \f3\%GLX_*\fP tokens.
See the \f3\%glXChooseVisual\fP man pages for more information.
\f3\%pfGetWinFBConfigAttrs\fP will return the attribute array corresponding
to the visual of \f2win\fP.

\f3\%pfWinFBConfigData\fP can be used to provide
GL dependent data directly to the OpenGL framebuffer configuration
routine. \f3\%pfGetWinFBConfigData\fP can
be used to get back GL dependent data resulting from these calls.
See the \f3\%GLXgetconfig(3g)\fP and \f3\%GLXlink(3g)\fP man pages for more information.

\f3\%pfWinFBConfigId\fP allows you to directly set the
OpenGL X visual id to be used in configuring the resulting OpenGL/X window.
\f3\%pfGetWinFBConfigId\fP will return the current
OpenGL visual id of the window (or -1 if the id is not known)
See the \f3\%XVisualIDFromVisual(3X11)\fP and \f3\%XGetVisualInfo(3X11)\fP
man pages for more information about X visuals.

\f3\%pfWinGLCxt\fP sets the graphics context of
\f2win\fP to be \f2gCxt\fP.
If the graphics context window of \f2win\fP has been set,
\f3\%pfOpenWin\fP
on \f2win\fP will use that context and not create another.
\f3\%pfGetWinGLCxt\fP will return the graphics context of
\f2win\fP.

\f3\%pfWinIndex\fP sets the alternate configuration window list
index of \f2win\fP to be \f2index\fP.  If \f2index\fP
is greater than or equal to zero, it will select an alternate configuration window
from the pfWindow \f3\%pfWinList\fP.  \f2index\fP may also select one of the standard
windows: \f3\%PFWIN_STATS_WIN\fP,
\f3\%PFWIN_OVERLAY_WIN\fP, and the default, \f3\%PFWIN_GFX_WIN\fP.
The window indexing is only one level deep - if the selected pfWindow
has a window list and index, it is ignored and the graphics window
and context of that pfWindow is used to determine the drawing area.
\f3\%pfGetWinIndex\fP will return the current index
for \f2win\fP.
\f3\%pfGetWinSelect\fP will return the pointer
to the currently selected pfWindow for \f2win\fP.

\f3\%pfWinList\fP sets a pfWindow list of alternate
configuration windows for \f2win\fP to be the pfList of pfWindow*s,
\f2wlist\fP. \f3\%pfGetWinList\fP will return
the current window list. These alternate configuration windows are assumed to have
the same pfWSWindow parent window as the base pfWindow.

\f3\%pfWinMode\fP sets the pfWindow mode specified by \f2mode\fP of
\f2win\fP
to \f2val\fP. \f2mode\fP may be one of:
.RS
.TP 25
\f3\%PFWIN_ORIGIN_LL\fP
will cause placement of \f2win\fP to be relative to the lower left corner of
it and its parent window.
.TP
\f3\%PFWIN_NOBORDER\fP
will cause the window to not have the window system border around the
outside of its drawing area. To have a drawing area that is truly
full screen, this mode should be set.
.TP
\f3\%PFWIN_AUTO_RESIZE\fP
will cause sub-pfWindows of \f2win\fP who also have this mode set to be
automatically reconfigured to match the size and position of \f2win\fP.
This includes the \f3\%PFWIN_OVERLAY_WIN\fP, the \f3\%PFWIN_STATS_WIN\fP,
and the current selected window from the pfWindow list. The selection
of a new window from the pfWindow list will also be automatically
sized and positioned if it is using the \f3\%PFWIN_AUTO_RESIZE\fP mode.
This mode is on by default.
.TP
\f3\%PFWIN_HAS_OVERLAY\fP
will cause \f3\%pfOpenWin\fP to automatically create and open (if necessary)
an overlay window for the main pfWindow.  If the window is of type
\f3\%PFWIN_AUTO_RESIZE\fP, the overlay window will be automatically
configured to keep the same size/position as the main window.
.TP
\f3\%PFWIN_EXIT\fP
Causes the window to receive special ClientMessage X events when the
user selects "Quit" or "Exit" from the window manager border menu on
the window.  The XEvent.xclient.message_type field will be set to point
to the X atom for "WM_PROTOCOLS" and XEvent.xclient.data.l[0] will be
set to point to the X atom, "WM_DELETE_WINDOW".  See the examples below
and the \f3\%XClientMessageEvent\fP man page for more information.
.RE
\f3\%pfGetWinMode\fP will return the value
of the requested mode in \f2mode\fP.

\f3\%pfWinName\fP sets the name of a pfWindow. By default, pfWindows have
no name.  \f3\%pfGetWinName\fP returns the name of a pfWindow.

\f3\%pfWinOrigin\fP sets the origin of the pfWindow
\f2win\fP to be (\f2xo\fP,\f2yo\fP), relative to its parent window.
\f3\%pfGetWinOrigin\fP
returns the origin set by \f3\%pfWinOrigin\fP.  If the pfWindow mode is
\f3\%PFWIN_ORIGIN_LL\fP, the origin of the window is considered to be the
lower-left corner. Otherwise, the origin of the window is considered to
be the X-style upper-left corner.  \f3\%pfWinSize\fP sets the size of the
pfWindow \f2win\fP to be \f2x\fP by \f2y\fP.
\f3\%pfGetWinSize\fP returns the
size of the pfWindow set by \f3\%pfWinSize\fP, by
\f3\%pfOpenWin\fP, or by
\f3\%pfGetWinCurOriginSize\fP.
\f3\%pfWinOriginSize\fP sets both the origin
and size of \f2win\fP.

\f3\%pfGetWinCurOriginSize\fP returns the current origin and
size of the pfWindow \f2win\fP, if open, otherwise it returns
the origin and size set by \f3\%pfWinOrigin\fP,
\f3\%pfWinSize\fP, or
\f3\%pfWinOriginSize\fP. The internal origin and size of \f2win\fP will
be updated. This routine accesses the graphics context
and/or the X server and is slow on a window of type \f3\%PFWIN_TYPE_X\fP.

\f3\%pfGetWinCurScreenOrigin\fP returns the
cached screen relative origin of \f2win\fP, if open, from the
last time the window size was set and then selected.
Otherwise it returns the origin and size set by \f3\%pfWinOrigin\fP.

\f3\%pfGetWinCurScreenOriginSize\fP returns the
current screen-relative origin and size of \f2win\fP, if open.
Otherwise it returns the origin and size set by \f3\%pfWinOrigin\fP,
\f3\%pfWinSize\fP, or
\f3\%pfWinOriginSize\fP.
For windows of type \f3\%PFWIN_TYPE_X\fP, it must make expensive
queries to the X server and can be very slow.


\f3\%pfWinOverlayWin\fP sets the pfWindow \f2overlay\fP to be the
associated \f3\%PFWIN_OVERLAY_WIN\fP window
for the main drawing pfWindow, \f2win\fP.
This pfWindow is selected on \f2win\fP with
\f3\%pfWinIndex\fP(\f2win\fP, \f3\%PFWIN_OVERLAY_WIN\fP).
\f2overlay\fP should have the same parent X window as \f2win\fP.
\f3\%pfGetWinOverlayWin\fP will return the
\f3\%PFWIN_OVERLAY_WIN\fP pfWindow.

\f3\%pfWinScreen\fP sets the screen of \f2win\fP to be \f2screen\fP.
The screen selection takes effect upon \f3\%pfOpenWin\fP.
A screen will be set by \f3\%pfOpenWin\fP if on was not previously set.
The screen of a pfWindow cannot be changed once set.
\f3\%pfGetWinScreen\fP will return the screen of a pfWindow.

\f3\%pfWinShare\fP sets the attributes that are to be shared by pfWindows
of the share group of \f2win\fP to be the bitmask specified by \f2share\fP.
Some share attributes, such as \f3\%PFWIN_SHARE_TYPE\fP and
\f3\%PFWIN_SHARE_GFX_OBJS\fP, must be specified before windows in the
share group are opened.
The following tokens specify the attributes that may be shared among
pfWindows and may be or-ed together to from \f2share\fP:
.RS
.TP 25
\f3\%PFWIN_SHARE_MODE\fP
.TP
\f3\%PFWIN_SHARE_FBCONFIG\fP
.TP
\f3\%PFWIN_SHARE_GL_CXT\fP
.TP
\f3\%PFWIN_SHARE_GL_OBJS\fP
.TP
\f3\%PFWIN_SHARE_STATE\fP
.TP
\f3\%PFWIN_SHARE_OVERLAY_WIN\fP
.TP
\f3\%PFWIN_SHARE_STATS_WIN\fP
.TP
\f3\%PFWIN_SHARE_TYPE\fP
.TP
\f3\%PFWIN_SHARE_WSDRAWABLE\fP
.TP
\f3\%PFWIN_SHARE_WSWINDOW\fP
.RE
\f3\%pfGetWinShare\fP will return the share bitmask
of \f2win\fP.

\f3\%pfWinStatsWin\fP sets the pfWindow
\f2statsWin\fP to be the associated \f3\%PFWIN_OVERLAY_WIN\fP window for the main
drawing pfWindow, \f2win\fP.  This pfWindow is
selected on \f2win\fP with
\f3\%pfWinIndex\fP(\f2win\fP,
\f3\%PFWIN_STATS_WIN\fP).  \f2statsWin\fP should have the same parent X
window as \f2win\fP.
\f3\%pfGetWinStatsWin\fP will return the
\f3\%PFWIN_STATS_WIN\fP pfWindow.

\f3\%pfWinType\fP sets the type of a pfWindow where \f2type\fP is an or-ed
bitmask that may contain the type constants listed below.
\f3\%pfGetWinType\fP returns the type of a pfWindow.
The type of a pfWindow only takes effect by the call of \f3\%pfOpenWin\fP.
The type of an open pfWindow cannot be changed.
The pfWindow type attributes all start with \f3\%PFWIN_TYPE_\fP and are:
.RS
.TP
\f3\%PFWIN_TYPE_NOPORT\fP
The resulting window will have a graphics context but will not be mapped onto
the screen. Windows of type \f3\%PFWIN_TYPE_NOPORT\fP are useful for
queries about the graphics resources of the system and are needed for
accessing the Video Sync Clock.  To facilitate this, there is the
special utility routine, \f3\%pfOpenNewNoPortWin\fP.
Also, see the man pages for \f3\%pfInitVClock\fP, and \f3\%pfQuerySys\fP.
If this token is specified, all other type tokens are ignored.
.TP
\f3\%PFWIN_TYPE_X\fP
The window opened will be an X window. OpenGL windows are always of type
\f3\%PFWIN_TYPE_X\fP.  Windows of this type
have as their pfWSWindow an X window (\f3\%pfWinWSWindow\fP).
The pfWSDrawable that is attached to the
graphics context is by default an X window (but can be set as an X Pixmap --
\f3\%pfWinWSWindow\fP)
and has a framebuffer configuration matching that specified by the pfWindow.
If the pfWSDrawable of the pfWindow is a separate X window from
the parent pfWSWindow X window (as is created by default),
the pfWSDrawable window can actually be changed for one with a different
framebuffer configuration without ugly flashing. To facilitate this,
pfWindows may also have a list of windows
(\f3\%pfWinList\fP) that
may have different framebuffer configuration types and pfWSDrawable X windows
but all share the same parent X pfWSWindow.
.TP
\f3\%PFWIN_TYPE_OVERLAY\fP
The pfWindow \f2win\fP will be given an appropriate framebuffer
configuration, if not already set,
that will support the standard overlay draw configuration at the
time of the call to \f3\%pfOpenWin\fP.
For X windows, an X colormap will also
be created and attached to the corresponding X window.
See the man pages for \f3\%XCreateWindow\fP, and \f3\%XCreateColormap\fP
for more information.
.TP
\f3\%PFPWIN_TYPE_PBUFFER\fP
The window drawable will be created in a pbuffer.  For this, you must
also specify an GLXFBConfigSGIX with
\f3\%pfWinFBConfig\fP before
the window is opened.
.TP
\f3\%PFWIN_TYPE_STATS\fP
The pfWindow \f2win\fP will be given a framebuffer configuration,
if one has not already
been specified through \f3\%pfWinFBConfig\fP or \f3\%pfChooseWinFBConfig\fP,
that will support the current \f3\%pfStatsHwAttr\fP configuration at the
time of the call to \f3\%pfOpenWin\fP.
See the \f3\%pfStatsHwAttr\fP man page for information on different
statistics attributes and their framebuffer requirements.
.TP
\f3\%PFPWIN_TYPE_UNMANAGED\fP
OpenGL Performer will not do automatic X window management on this window.
This includes size and position tracking, resizing of alternate configuration
windows, and swapbuffers. OpenGL Performer will still make the graphics
context of this window current if it is selected. pfWindows with drawables
that are of type GLXPbufferSGIX or Pixmap are automatically made unmanaged.
.RE

\f3\%pfWinWSWindow\fP sets the main window system window of
\f2win\fP to be \f2xWin\fP
This routine is only relevant for pfWindows of type \f3\%PFWIN_TYPE_X\fP.
The WSWindow of a pfWindow, if not NULL, is used to manage the size
and position of the pfWindow. The WSWindow should also be the parent window of
the WSDrawable window of \f2Win\fP. The WSWindow should be shared amongst all
sub-pfWindows, such as the overlay window, the stats window, and any windows
n the pfWindow list.  If the WSWindow of \f2win\fP has been set, \f3\%pfOpenWin\fP
on \f2win\fP will use that X window and not create another.
\f3\%pfGetWinWSWindow\fP will return the X Window of \f2win\fP.

\f3\%pfWinWSDrawable\fP sets the graphics X drawable of \f2win\fP to be \f2drawable\fP.
The drawable of a pfWindow is attached to the graphics context
and may be an X Pixmap, a GLXPbufferSGIX, or an X Window. If
provided as an X Window, it should be a child of the WSWindow of
the pfWindow.
If a drawable has not been provided by the time of \f3\%pfOpenWin\fP,
an X Window will be created by default.
If the graphics drawable of \f2win\fP has been set, \f3\%pfOpenWin\fP
on \f2win\fP will use that X window and not create another.
\f3\%pfGetWinWSDrawable\fP will return the drawable of \f2win\fP.
\f3\%pfGetWinCurWSDrawable\fP
will return the drawable of the currently selected window of the window list.

\f3\%pfWinWSConnectionName\fP allows you to
specify the exact window server and default screen for the successive opening
of the window. This can be used for specifying remote displays or on
machines running more than one window server.
\f3\%pfGetWinWSConnectionName\fP will return
the name specifying the current window server target.

\f3\%pfAttachWin\fP puts \f2win1\fP, and its
current share group, in the pfWindow share group of \f2win0\fP.  The attributes of \f2win0\fP will be
copied to \f2win1\fP and all of the windows in \f2win1\fP's previous share
group. pfWindows cannot be removed from a share group.

\f3\%pfChooseWinFBConfig\fP will select a framebuffer configuration
for \f2win\fP, constrained by current settings, such as type and
the framebuffer configuration attributes, on \f2win\fP.
Additionally, the selection of the framebuffer configuration will be relative to
the screen of \f2win\fP.  If the screen has not been set, it
will be determined from the default screen of the current pfWSConnection or DISPLAY
environment variable.
The return value is the resulting pfFBConfig, or NULL, indicating failure.
For X windows, \f3\%pfChooseWinFBConfig\fP and
\f3\%pfGetWinFBConfig\fP
returns the resulting XVisualInfo*.

\f3\%pfOpenWin\fP creates a graphics context and window, constrained by the
settings of \f2win\fP on the current selected display via
\f3\%pfGetCurWSConnection\fP.  Attributes of \f2win\fP that are not set are
created and set as necessary.  If the graphics window and context are
not set, they will be created.

If the pfWindow framebuffer
configuration is not set (\f3\%pfWinFBConfig\fP or
\f3\%pfChooseWinFBConfig\fP), the graphics window
will get the default rendering framebuffer configuration for its current type
(\f3\%pfWinType\fP).
For a rendering graphics window of type
\f3\%PFWIN_TYPE_X\fP, if the graphics drawable has been set via
\f3\%pfWinWSDrawable\fP, the framebuffer
configuration of that window is
used for the graphics context.  Otherwise, a default rendering
framebuffer configuration for the current machine will be chosen via
(\f3\%pfChooseFBConfig\fP).
not have multisample buffers by default.
All pfWindows are automatically initialized with \f3\%pfInitGfx\fP
upon opening with \f3\%pfOpenWin\fP.

If the x or y size of the pfWindow is <= 0,
then a rubber-band window will be created for the user to determine the
origin and size of the window, constrained by the pfWindow aspect if
set (\f3\%pfWinAspect\fP).
If the size of the pfWindow is <= 0 but the
origin is < 0, then the graphics window will be opened with fixed size
but allow the user to place the window. The pfWindow origin and size
may both be internally set by \f3\%pfOpenWin\fP. If the
\f3\%PFWIN_HAS_OVERLAY\fP mode has been set, a \f3\%PFWIN_OVERLAY_WIN\fP will
be automatically created (if not already set, \f3\%pfWinOverlayWin\fP) and
opened.  If \f2win\fP has a pfWindow list (\f3\%pfWinList\fP) and the current
pfWindow index is not \f3\%PFWIN_GFX_WIN\fP, then the selected pfWindow
from the list will be opened. A pfState is automatically created for
the pfWindow and the pfWindow is made the current libpr pfWindow.
\f3\%pfGetWinCurState\fP will
return the current pfState of \f2win\fP.
\f3\%pfGetCurWin\fP will return the pointer to the current libpr pfWindow.

\f3\%pfCloseWin\fP will destroy the graphics context of the open \f2win\fP.
If \f2win\fP is of type \f3\%PFWIN_TYPE_X\fP, its X windows will
be unmapped. \f3\%pfCloseWinGL\fP will destroy the
current graphics context and graphics X window but leaves the top level X window
in tact.

\f3\%pfIsWinOpen\fP returns the open status of \f2win\fP.

\f3\%pfIsManagedWin\fP returns whether or not
of \f2win\fP is of type \f3\%PFPWIN_TYPE_UNMANAGED\fP.

\f3\%pfQueryWin\fP takes a window configuration query token \f2which\fP
and writes into \f2dst\fP the value for the corresponding
configuration of the the opened pfWindow \f2win\fP.
The pfWindow query token may be one of:
.RS
.TP 25
\f3\%PFQWIN_RGB_BITS\fP
returns the number of bits per R_G_B color component allocated in the
main color buffer.
.TP
\f3\%PFQWIN_ALPHA_BITS\fP
returns the number of bits allocated for alpha in the
main color buffer.
.TP
\f3\%PFQWIN_CI_BITS\fP
returns the number of bits for colorindex indices.
.TP
\f3\%PFQWIN_DEPTH_BITS\fP
returns the number of framebuffer bits allocated for Z.
.TP
\f3\%PFQWIN_MIN_DEPTH_VAL\fP
returns the minimum representable Z depth value.
.TP
\f3\%PFQWIN_MAX_DEPTH_VAL\fP
returns the maximum representable Z depth value.
.TP
\f3\%PFQWIN_MS_SAMPLES\fP
returns the number of multisample samples.
.TP
\f3\%PFQWIN_STENCIL_BITS\fP
returns the number of bits in the stencil buffer.
.TP
\f3\%PFQWIN_STEREO\fP
returns whether the window has stereo buffers allocated.
.TP
\f3\%PFQWIN_DOUBLEBUFFER\fP
returns whether the window has double-buffered color buffers allocated.
.TP
\f3\%PFQWIN_NUM_AUX_BUFFERS\fP
returns the number of auxiliary color buffers allocated for the window.
.TP
\f3\%PFQWIN_LEVEL\fP
returns the level of window planes (0 is  normal drawing level, negative for
underlay and positive for overlay).
.TP
\f3\%PFQWIN_ACCUM_RGB_BITS\fP
returns the number of bits per R_G_B color component allocated in the
accumulation buffer.
.TP
\f3\%PFQWIN_ACCUM_ALPHA_BITS\fP
returns the number of bits of alpha allocated in the
accumulation buffer.
.RE

\f3\%pfMQueryWin\fP takes an NULL-terminated array of query tokens
and a destination buffer and will do multiple queries.
The return value will be the number of bytes successfully written.
This routine is more efficient than \f3\%pfQueryWin\fP
if multiple queries are desired.

\f3\%pfAttachWinSwapGroup\fP will place the
windows in the swap group of \f2win1\fP in the swap  group of \f2win0\fP.
Windows in a swap group will always swap buffers at the same time.
If two windows are in the same SwapGroup, but
not on the same screen, then OpenGL Performer will automatically hook up a named
SwapBarrier that is used to synchronize across graphics pipelines. This
also requires system configuration (see the notes below).
\f3\%pfWinInSwapGroup\fP returns a boolean indicating
if \f2win\fP has been attached to a hardware SwapGroup.
This attachment will not happen until a call to \f3\%pfSelectWin\fP.

\f3\%pfWinSwapBarrier\fP let you attach the SwapGroup
that contains \f2win\fP to a \f2barrier\fP. If \f2barrier\fP is (-1),
OpenGL Performer will pick a barrier name.  Currently on InfiniteReality there is
only one barrier available and will be name (1).
This might be necessary if you have other non-Performer windows
hooked up to an OpenGL barrier with \f3\%glXBindSwapBarrierSGIX(3G)\fP and want to
add OpenGL Performer windows, first to a swap group, then to the named barrier.
Additionally, this is useful for InfiniteReality Calligraphic setup which uses
the \f3\%SwapReady\fP interface to synchronize raster and calligraphic displays.
\f3\%pfGetWinSwapBarrier\fP return 0 if no barrier
is set, or the barrier number otherwise.

\f3\%pfSwapWinBuffers\fP
causes the currently selected front and back buffers of the normal framebuffer
of an open window to be exchanged during the next vertical retrace period.

\f3\%pfGetCurWin\fP will return the pointer current OpenGL Performer pfWindow.
This a window is made the current window when it is opened with
\f3\%pfOpenWin\fP or selected with
\f3\%pfSelectWin\fP.

\f3\%pfInitGfx\fP will  configure the current graphics
context correctly for OpenGL Performer rendering operation and is called
automatically when pfWindows are opened.
It will enable z-buffer depth testing, viewport clipping,
and  subpixel vertex accuracy mode.
The Viewing projection will be a two-dimensional one-to-one orthographic
mapping from eye coordinates to window coordinates with
distances to near and far clipping planes -1 and 1,
respectively.  The model matrix will be the current matrix
and will be initialized to the identity matrix.
It is highly recommended that a libpr application managing its own windows call
\f3\%pfInitGfx\fP for its normal drawing.

.SH NOTES


\f3\%X Window origin and size\fP:
There are some subtle issues in the management of origin and size of X
windows. With X windows, it can be very expensive to obtain the
current screen relative origin of a window, particularly if the
window is in a hierarchy.  Therefore, the origin of a window
is defined to be that relative to it's parent window (which can
be the screen).  Additionally, there are a bevy of routines for
getting the window origin.
User code should not rely on knowning the up to date screen
relative origin but should be window-coordinate relative to be
efficient and reliable.

\f3\%X Framebuffer Configuration\fP:
The selection of framebuffer configurations for X windows uses
the default GL selection function \f3\%glXChooseVisual(3X11)\fP.
This function returns
the maximum possible framebuffer configuration matching the requested
attributes.  However, this may not be the optimal configuration for
performance.  One such example occurs with OpenGL on RealityEngine:
when requesting four multisample subsamples and a depth buffer of
24 bits, a depth buffer of 32 bits will be returned which has
measurably slower fill rate than a 24 bit depth buffer.  If the
default functions are not returning the desired framebuffer configuration,
you can do your own X visual selection and set the visual id or the visual
itself on the pfWindow with
\f3\%pfWinFBConfigId\fP
and
\f3\%pfWinFBConfig\fP
respectively.
Additionally, libpfutil provides an OpenGL visual chooser,
\f3\%pfuChooseFBConfig\fP, that limits
the performance critical attributes: multisamples, depth, RGB color, and stencil.

A special case for framebuffer configuration exists for the Extreme
graphics platforms.  On these platforms, the default framebuffer configuration
has NO allocated stencil bits because stencil bits will reduce depth
buffer resolution. The user may explicitly request stencil bits if desired.



.SH EXAMPLES
This example creates a pfWindow structure and opens and initializes
the window for Performer drawing. This window will be an OpenGL/X window.
.Ex
.nf

{
	pfWindow *win;

	pfInitState();
	win = pfNewWin(NULL);
	pfWinName(win, "Performer");
	pfOpenWin(win); /* create window and rendering context */
	......
}
.Ee
.fi
.na


This example is a more detailed example for creating a window of
pre-defined size and position.
It will have an overlay window created automatically
when the window is opened.
.Ex
.nf

{
	pfWindow *win;
	pfWindow *overlay;
	pfWSConnection dsp;

	pfInitState();
	win = pfNewWin(NULL);
	pfWinName(win, "Performer");
	pfWinOriginSize(win, 0, 0, 500, 500);
	pfWinType(win, PFWIN_TYPE_X);
	pfWinMode(win, PFWIN_HAS_OVERLAY, PF_TRUE);
	pfOpenWin(win); /* create window, overlay, and rendering context */

	/* get back some useful things created by Performer */
	overlay = pfGetWinOverlayWin(win);
	/* get back Performer's internal shared display
	   connection to use for event handling */
	dsp = pfGetCurWSConnection();
}
.Ee
.fi
.na


This example demonstrates how to catch the X ClientMessage event
when a window of a pfWindow of mode PFWIN_EXIT is killed via the
Quit or Exit option in the window manager menu on the window border.
.Ex
.nf

{
    WSConnection theDisplay = pfGetCurWSConnection();
    Atom WMProtocols = XInternAtom(theDisplay, "WM_PROTOCOLS", 1);
    ATOM WMDeleteWindow = XInternAtom(theDisplay, "WM_DELETE_WINDOW", 1);
    ....
    /* in X event handling loop */
    {
	XEvent event;
	XNextEvent(theDisplay, &event);
	/* in X event handling switch */
	case ClientMessage:
	    if ((event.xclient.message_type == wm_protocols) &&
		(event.xclient.data.l[0] == wm_delete_window)) {
                    /* handle window exit */
                }
                break;
	.....
    }
}
.Ee
.fi
.na



Swap groups can contain windows rendering to different
graphics pipelines to force that their double-buffering is synchronized so that
they are guaranteed to always be displaying the same frame and have their
hardware swapbuffers happen simultaneously.  For this to work, you must
first have the graphics pipelines genlocked.
See the \f3\%genlock(7)\fP man page for more informations.
Next, you must connect the proper cable between the SwapReady connectors
on the graphics pipelines.  On the InfiniteReality this is a simple
BNC cable of any Ohms.
The SwapGroup functionality on pfWindows is only supported under OpenGL operation.

.SH BUGS


Detach from share groups and swap groups is not supported.


.SH SEE ALSO
pfStatsHwAttr,
pfNewState,
pfSelectWSConnection,
pfGetCurWSConnection,
pfuChooseFBConfig,
GLXgetconfig,
GLXlink,
XCreateWindow,
XGetWindowAttributes,
XGetVisualInfo,
XVisualIDFromVisual
