'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfiInputXform" "3pf"
.SH NAME
.upperok
.B pfiNewIXform,
.B pfiNewInputCoord,
.B pfiNewMotionCoord,
.B pfiNewInput,
.B pfiGetIXformClassType,
.B pfiGetInputClassType,
.B pfiGetInputCoordClassType,
.B pfiGetMotionCoordClassType,
.B pfiIsIXformInMotion,
.B pfiInputName,
.B pfiIsIXGetName,
.B pfiInputFocus,
.B pfiGetInputFocus,
.B pfiInputEventMask,
.B pfiGetInputEventMask,
.B pfiInputEventStreamCollector,
.B pfiGetInputEventStreamCollector,
.B pfiInputEventStreamProcessor,
.B pfiGetInputEventStreamProcessor,
.B pfiInputEventHandler,
.B pfiGetInputEventHandler,
.B pfiIXformMat,
.B pfiGetIXformMat,
.B pfiIXformInput,
.B pfiGetIXformInput,
.B pfiIXformInputCoordPtr,
.B pfiGetIXformInputCoordPtr,
.B pfiIXformMotionCoord,
.B pfiGetIXformMotionCoord,
.B pfiIXformResetCoord,
.B pfiGetIXformResetCoord,
.B pfiIXformCoord,
.B pfiGetIXformCoord,
.B pfiIXformStartMotion,
.B pfiGetIXformStartMotion,
.B pfiIXformMotionLimits,
.B pfiGetIXformMotionLimits,
.B pfiIXformDBLimits,
.B pfiGetIXformDBLimits,
.B pfiIXformBSphere,
.B pfiGetIXformBSphere,
.B pfiIXformUpdateFunc,
.B pfiGetIXformUpdateFunc,
.B pfiIXformMotionFuncs,
.B pfiGetIXformMotionFuncs,
.B pfiResetInput,
.B pfiCollectInputEvents,
.B pfiProcessInputEvents,
.B pfiStopIXform,
.B pfiResetIXform,
.B pfiUpdateIXform,
.B pfiResetIXformPosition,
.B pfiHaveFastMouseClick
\- 
pfiInputXform functions.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfiMotionCoord\ *\ \ \ 'u
#include <Performer/pfui.h>
.nf
.fi
.TP
pfiInputXform *
\f3\%pfiNewIXform\fP(void\ *arena);
.nf
.fi
.TP
pfiInputCoord *
\f3\%pfiNewInputCoord\fP(void\ *arena);
.nf
.fi
.TP
pfiMotionCoord *
\f3\%pfiNewMotionCoord\fP(void\ *arena);
.nf
.fi
.TP
pfiInput *
\f3\%pfiNewInput\fP(void\ *arena);
.nf
.fi
.TP
pfType *
\f3\%pfiGetIXformClassType\fP(void);
.nf
.fi
.TP
pfType *
\f3\%pfiGetInputClassType\fP(void);
.nf
.fi
.TP
pfType *
\f3\%pfiGetInputCoordClassType\fP(void);
.nf
.fi
.TP
pfType *
\f3\%pfiGetMotionCoordClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfiIsIXformInMotion\fP(pfiInputXform\ *ix);
.nf
.fi
.TP
void
\f3\%pfiInputName\fP(pfiInput\ *in,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.nf
.fi
.TP
const char *
\f3\%pfiIsIXGetName\fP(pfiInput\ *in);
.nf
.fi
.TP
void
\f3\%pfiInputFocus\fP(pfiInput\ *in,
'in +2
'll -2
int\ focus);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfiGetInputFocus\fP(pfiInput\ *in);
.nf
.fi
.TP
void
\f3\%pfiInputEventMask\fP(pfiInput\ *in,
'in +2
'll -2
int\ emask);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfiGetInputEventMask\fP(pfiInput\ *in);
.nf
.fi
.TP
void
\f3\%pfiInputEventStreamCollector\fP(pfiInput\ *in,
'in +2
'll -2
pfiEventStreamHandlerType\ func,
void\ *data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetInputEventStreamCollector\fP(pfiInput\ *in,
'in +2
'll -2
pfuEventHandlerFuncType\ *func,
void\ **data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiInputEventStreamProcessor\fP(pfiInput\ *in,
'in +2
'll -2
pfiEventStreamHandlerType\ func,
void\ *data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetInputEventStreamProcessor\fP(pfiInput\ *in,
'in +2
'll -2
pfuEventHandlerFuncType\ *func,
void\ **data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiInputEventHandler\fP(pfiInput\ *in,
'in +2
'll -2
pfuEventHandlerFuncType\ func,
void\ *data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetInputEventHandler\fP(pfiInput\ *in,
'in +2
'll -2
pfuEventHandlerFuncType\ *func\ void\ **data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiIXformMat\fP(pfiInputXform\ *ix,
'in +2
'll -2
PFMATRIX\ mat);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetIXformMat\fP(pfiInputXform\ *ix,
'in +2
'll -2
PFMATRIX\ mat);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiIXformInput\fP(pfiInputXform\ *ix,
'in +2
'll -2
pfiInput\ *in);
.in
.ll
.nf
.fi
.TP
pfiInput *
\f3\%pfiGetIXformInput\fP(pfiInputXform\ *ix);
.nf
.fi
.TP
void
\f3\%pfiIXformInputCoordPtr\fP(pfiInputXform\ *ix,
'in +2
'll -2
pfiInputCoord\ *icoord);
.in
.ll
.nf
.fi
.TP
pfiInputCoord *
\f3\%pfiGetIXformInputCoordPtr\fP(pfiInputXform\ *ix);
.nf
.fi
.TP
void
\f3\%pfiIXformMotionCoord\fP(pfiInputXform\ *ix,
'in +2
'll -2
pfiMotionCoord\ *xcoord);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetIXformMotionCoord\fP(pfiInputXform\ *ix,
'in +2
'll -2
pfiMotionCoord\ *xcoord);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiIXformResetCoord\fP(pfiInputXform\ *ix,
'in +2
'll -2
pfCoord\ *resetPos);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetIXformResetCoord\fP(pfiInputXform\ *ix,
'in +2
'll -2
pfCoord\ *resetPos);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiIXformCoord\fP(pfiInputXform\ *ix,
'in +2
'll -2
pfCoord\ *coord);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetIXformCoord\fP(pfiInputXform\ *ix,
'in +2
'll -2
pfCoord\ *coord);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiIXformStartMotion\fP(pfiInputXform\ *ix,
'in +2
'll -2
float\ startSpeed,
float\ startAccel);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetIXformStartMotion\fP(pfiInputXform\ *ix,
'in +2
'll -2
float\ *startSpeed,
float\ *startAccel);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiIXformMotionLimits\fP(pfiInputXform\ *ix,
'in +2
'll -2
float\ maxSpeed,
float\ angularVel,
float\ maxAccel);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetIXformMotionLimits\fP(pfiInputXform\ *ix,
'in +2
'll -2
float\ *maxSpeed,
float\ *angularVel,
float\ *maxAccel);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiIXformDBLimits\fP(pfiInputXform\ *ix,
'in +2
'll -2
pfBox\ *dbLimits);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetIXformDBLimits\fP(pfiInputXform\ *ix,
'in +2
'll -2
pfBox\ *dbLimits);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiIXformBSphere\fP(pfiInputXform\ *ix,
'in +2
'll -2
pfSphere\ *sphere);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetIXformBSphere\fP(pfiInputXform\ *ix,
'in +2
'll -2
pfSphere\ *sphere);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiIXformUpdateFunc\fP(pfiInputXform\ *ix,
'in +2
'll -2
pfiInputXformUpdateFuncType\ func,
void\ *data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetIXformUpdateFunc\fP(pfiInputXform\ *ix,
'in +2
'll -2
pfiInputXformUpdateFuncType\ *func,
void\ **data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiIXformMotionFuncs\fP(pfiInputXform\ *ix,
'in +2
'll -2
pfiInputXformFuncType\ start,
pfiInputXformFuncType\ stop,
void\ *data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetIXformMotionFuncs\fP(pfiInputXform\ *ix,
'in +2
'll -2
pfiInputXformFuncType\ *start,
pfiInputXformFuncType\ *stop,
void\ **data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiResetInput\fP(pfiInput\ *in);
.nf
.fi
.TP
void
\f3\%pfiCollectInputEvents\fP(pfiInput\ *in);
.nf
.fi
.TP
void
\f3\%pfiProcessInputEvents\fP(pfiInput\ *in);
.nf
.fi
.TP
void
\f3\%pfiStopIXform\fP(pfiInputXform\ *ix);
.nf
.fi
.TP
void
\f3\%pfiResetIXform\fP(pfiInputXform\ *ix);
.nf
.fi
.TP
void
\f3\%pfiUpdateIXform\fP(pfiInputXform\ *ix);
.nf
.fi
.TP
void
\f3\%pfiResetIXformPosition\fP(pfiInputXform\ *ix);
.nf
.fi
.TP
int
\f3\%pfiHaveFastMouseClick\fP(pfuMouse\ *mouse,
'in +2
'll -2
int\ button,
float\ msecs);
.in
.ll
.fi

.Ex
.nf

typedef int (*pfiEventStreamHandlerType)(pfiInput *, pfuEventStream *);
typedef int (*pfiInputXformFuncType)(pfiInputXform *, void *);
typedef int (*pfiInputXformUpdateFuncType)(pfiInputXform *, pfiInputCoord *, void *);
.Ee
.fi
.na

.SH DESCRIPTION

\f3\%pfiInputXform\fP is a basic facility for tying together routines to get and
process user input, invoke a model for computing transformations based on
that input, and applying those transformations to the viewing position
or transformation matrix to be applied to a database.

The pfiInputXform has a complete C++ API
following the conventions of general OpenGL Performer C++ API; C++ methods
are declared in /usr/include/Performer/pfui/pfiInputXform.h.

\f3\%pfiInit\fP should be called once before any pfiInputXform routines and before
the forked creation of any additional processes that will be calling
pfiInputXform routines.

\f3\%pfiGetIXformClassType\fP  returns the
\f3\%pfType\fP* for the class \f3\%pfiXformer\fP.
Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP
to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfiNewIXform\fP creates a new \f3\%pfiInputXform\fP data structure as described
above and returns a pointer to that structure.  \f2arena\fP should
specify the shared arena handle returned by \f3\%pfGetSharedArena\fP or
'NULL' indicating that the pfiXformer structure should be allocated
from the process dynamic memory area.

\f3\%pfiIXformInput\fP makes \f2in\fP the pfiInput of the pfiInputXform \f2ix\fP.
A pfiInput structure make be created with \f3\%pfiNewInput\fP.
By default, a pfiInputXform has a NULL pfiInput*.
\f3\%pfiGetIXformInput\fP will return the pfiInput* of the pfiInputXform \f2ix\fP.

\f3\%pfiIXformInputCoordPtr\fP makes \f2icoord\fP the pfiInputCoord of the
pfiInputXform \f2ix\fP.
A pfiInput structure make be created with \f3\%pfiNewInputCoord\fP.
By default, a pfiInputXform has a NULL pfiInputCoord*.
\f3\%pfiGetIXformInputCoordPtr\fP will return the pfiInputCoord* of the pfiInputXform \f2ix\fP.

\f3\%pfiIXformMotionCoord\fP will copy the contents of
\f2mcoord\fP to the pfiMotionCoord of \f2ix\fP.
A pfiMotionCoord structure make be created with \f3\%pfiNewMotionCoord\fP.
A pfiInputXform has a fixed pfiMotionCoord structure.

\f3\%pfiIXformMat\fP sets the current transformation matrix of \f2ix\fP to be \f2mat\fP.
This will also cause the current position of \f2ix\fP to be recomputed.
\f3\%pfiGetIXformMat\fP will return the current transformation matrix of \f2ix\fP.

\f3\%pfiIXformCoord\fP sets the current position (XYZ and HPR) of \f2ix\fP to be
\f2coord\fP.
This will also cause the current transformation matrix of \f2ix\fP to be recomputed.
\f3\%pfiGetIXformCoord\fP will return the current position pfCoord of \f2ix\fP.

\f3\%pfiIXformResetCoord\fP specifies the position that \f2ix\fP should reset to
upon a call to \f3\%pfiResetIXformPosition\fP.
\f3\%pfiGetIXformResetCoord\fP will return the current reset position.
This position is by default xyz=(0.0, 0.0, 0.0) and hpr=(0.0, 0.0, 0.0).

\f3\%pfiIXformDBLimits\fP will set the database bounding box of \f2ix\fP
to be \f2dbLimits\fP. A bounding sphere and database center (if not previously
set with \f3\%pfiIXformBSphere\fP) will be automatically recalculated.
The default bounding box is of size PFI_BIGDB and
is centered at (0.0, 0.0, 0.0).
\f3\%pfiGetIXformDBLimits\fP will return the current bounding box of \f2ix\fP
in \f2dblimits\fP.  The database size, center, and limits are often used
in setting and constraining the speed and position of motion models.

\f3\%pfiIXformBSphere\fP will fix a bounding sphere \f2sphere\fP for \f2ix\fP.
\f3\%pfiGetIXformBSphere\fP will return the current bounding sphere.

\f3\%pfiIXformStartMotion\fP specifies the starting speed and acceleration to
be used by \f2ix\fP when starting motion.  These parameters may be queried with
\f3\%pfiGetIXformStartMotion\fP.

\f3\%pfiIXformMotionLimits\fP specifies the maximum
speed, angular velocity, and acceleration for \f2ix\fP.
These parameters may be queried with \f3\%pfiGetIXformMotionLimits\fP.

\f3\%pfiHaveFastMouseClick\fP will determine if a mouse button \f2button\fP of \f2mouse\fP
was clicked for less than \f2msecs\fP.

\f3\%pfiIXformUpdateFunc\fP specifies the callback function and associated data
that will be called upon a call to \f3\%pfiUpdateIXform\fP on \f2ix\fP.
\f3\%pfiGetIXformUpdateFunc\fP will return the update callback function pointer
and associated data.  By default, the update callback function is NULL.

\f3\%pfiInputEventStreamCollector\fP sets the callback function and
associated data for the collection of
events for the event stream of the pfiInput \f2in\fP.
This routine will be called upon a call to \f3\%pfiCollectInputEvents\fP on \f2in\f3\%.
\fPpfiGetInputEventStreamCollector\f3\% will return the current callback function and data.

\fPpfiInputEventStreamProcessor\f3\% sets the callback function and
associated data for processing of the events stored
in the event stream of the pfiInput \fPin\f2.
This routine will be called upon a call to \fPpfiProcessInputEvents\f3\% on \fPin\fP.
\f3\%pfiGetInputEventStreamProcessor\fP will return the current callback function and data.

\f3\%pfiIXformMode\fP sets the specified \f2mode\fP of \f2ix\fP to have value \f2val\fP.
\f3\%pfiGetIXformMode\fP returns the value of specified \f2mode\fP of \f2ix\fP.
pfiInputXform modes and corresponding values are:
.RS
.TP 10
\f3\%PFIX_MODE_MOTION\fP
sets the basic motion mode for the motion model.
\f3\%PFIX_MOTION_STOP\fP is the basic motion mode that all pfiInputXforms
must understand.
.TP
\f3\%PFIX_MODE_MOTION_MOD\fP
sets a bitmask of special motion modifiers. A bitmask of 0x0
implies that motion does not undergo any special modifications beyond
that expected by the current motion mode.
.TP
\f3\%PFIX_MODE_ACCEL\fP
sets the current acceleration mode for \f2ix\fP.
\f3\%PFIX_ACCEL_NONE\fP is the basic acceleration mode that all pfiInputXforms
must understand.
.TP
\f3\%PFIX_MODE_AUTO\fP
sets the automatic motion condition \f2val\fP.
.TP
\f3\%PFIX_MODE_LIMIT_POS\fP
sets a bitmask indicating the types of position limits that should
be enforced by \f2ix\fP.  The bitmask \f2val\fP may contain one or more of
\f3\%PFIX_LIMIT_POS_HORIZ\fP, \f3\%PFIX_LIMIT_POS_BOTTOM\fP,
and \f3\%PFIX_LIMIT_POS_TOP\fP.
A value of \f3\%PFIX_LIMIT_POS_NONE\fP will prohibit limits on position.
.TP
\f3\%PFIX_MODE_LIMIT_SPEED\fP
sets a bitmask indicating what types of speed limits that \f2ix\fP
should enforce.
The bitmask \f2val\fP may contain one or more of \f3\%PFIX_LIMIT_SPEED_MAX\fP
and \f3\%PFIX_LIMIT_SPEED_DB\fP.
A value of \f3\%PFIX_LIMIT_SPEED_NONE\fP will prohibit limits on speed.
.TP
\f3\%PFIX_MODE_LIMIT_ACCEL\fP
sets a bitmask indicating what types of speed limits that \f2ix\fP
should enforce.
The bitmask \f2val\fP may contain one or more of \f3\%PFIX_LIMIT_ACCEL_MAX\fP
and \f3\%PFIX_LIMIT_ACCEL_DB\fP.
A value of \f3\%PFIX_LIMIT_ACCEL_NONE\fP will prohibit limits on acceleration.
.RE

\f3\%pfiStopIXform\fP halts motion of \f2ix\fP by setting the current speed and
acceleration to zero.

\f3\%pfiResetIXform\fP resets the motion and positional parameters to their
initial values.

\f3\%pfiResetIXformPosition\fP sets current position of \f2ix\fP to be the current
reset position, which can be set with \f3\%pfiIXformResetCoord\fP.

\f3\%pfiUpdateIXform\fP copies the current position of the pfiMotionCoord of
\f2ix\fP to the stored previous position of the pfiMotionCoord and calls the current
update callback function with its associated data.

.SH NOTES

The libpfui source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
