'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfiInputXformFly" "3pf"
.SH NAME
.upperok
.B pfiGetIXformFlyClassType,
.B pfiNewIXFly,
.B pfiIXformFlyMode,
.B pfiGetIXformFlyMode,
.B pfiCreate2DIXformFly,
.B pfiUpdate2DIXformFly
\- 
pfiInputXformFly functions.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfiInputXformFly\ *\ \ \ 'u
#include <Performer/pfui.h>
.nf
.fi
.TP
pfType *
\f3\%pfiGetIXformFlyClassType\fP(void);
.nf
.fi
.TP
pfiInputXformFly *
\f3\%pfiNewIXFly\fP(void\ *arena);
.nf
.fi
.TP
void
\f3\%pfiIXformFlyMode\fP(pfiInputXformFly\ *fly,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfiGetIXformFlyMode\fP(pfiInputXformFly\ *fly,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
pfiInputXformFly *
\f3\%pfiCreate2DIXformFly\fP(void\ *arena);
.nf
.fi
.TP
int
\f3\%pfiUpdate2DIXformFly\fP(pfiInputXform\ *fly,
'in +2
'll -2
pfiInputCoord\ *icoord,
void\ *data);
.in
.ll
.fi
.SH DESCRIPTION

\f3\%pfiInputXformFly\fP functions.

A pfiInputXformFly is a child of the pfiInputXform class and
so pfiInputXform routines may be called with a pfiInputXformFly.
See the pfiInputXform reference page for information on pfiInputXform
functionality.
The pfiInputXformFly has a complete C++ API
following the conventions of general OpenGL Performer C++ API; C++ methods
are declared in /usr/include/Performer/pfui/pfiInputXformFly.h.

\f3\%pfiInit\fP should be called once before any pfiInputXformFly routines and before
the forked creation of any additional processes that will be calling
pfiInputXformFly routines.
.SH NOTES

The libpfui source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
