'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfiInputXformTrackball" "3pf"
.SH NAME
.upperok
.B pfiGetIXformTrackballClassType,
.B pfiNewIXformTrackball,
.B pfiIXformTrackballMode,
.B pfiGetIXformTrackballMode,
.B pfiCreate2DIXformTrackball,
.B pfiUpdate2DIXformTrackball
\- 
pfiInputXformTrackball functions.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfiInputXformTrackball\ *\ \ \ 'u
#include <Performer/pfui.h>
.nf
.fi
.TP
pfType *
\f3\%pfiGetIXformTrackballClassType\fP(void);
.nf
.fi
.TP
pfiInputXformTrackball *
\f3\%pfiNewIXformTrackball\fP(void\ *arena);
.nf
.fi
.TP
void
\f3\%pfiIXformTrackballMode\fP(pfiInputXformTrackball\ *tb,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfiGetIXformTrackballMode\fP(pfiInputXformTrackball\ *tb,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
pfiInputXformTrackball *
\f3\%pfiCreate2DIXformTrackball\fP(void\ *arena);
.nf
.fi
.TP
int
\f3\%pfiUpdate2DIXformTrackball\fP(pfiInputXform\ *tb,
'in +2
'll -2
pfiInputCoord\ *icoord,
void\ *data);
.in
.ll
.fi
.SH DESCRIPTION

\f3\%pfiInputXformTrackball\fP functions.

A pfiInputXformTrackball is a child of the pfiInputXform class and
so pfiInputXform routines may be called with a pfiInputXformTrackball.
See the pfiInputXform reference page for information on pfiInputXform
functionality.
The pfiInputXformTrackball has a complete C++ API
following the conventions of general OpenGL Performer C++ API; C++ methods
are declared in /usr/include/Performer/pfui/pfiTrackball.h.

\f3\%pfiInit\fP should be called once before any pfiInputXformTrackball routines and before
the forked creation of any additional processes that will be calling
pfiInputXformTrackball routines.
.SH NOTES

The libpfui source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
