'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuGUI" "3pf"
.SH NAME
.upperok
.B pfuInitGUI,
.B pfuExitGUI,
.B pfuEnableGUI,
.B pfuUpdateGUI,
.B pfuRedrawGUI,
.B pfuGUIViewport,
.B pfuGetGUIViewport,
.B pfuInGUI,
.B pfuInitGUICursors,
.B pfuGetGUIChan,
.B pfuGUICursor,
.B pfuGetGUICursor,
.B pfuGUIHlight,
.B pfuGetGUIHlight,
.B pfuGUICursorSel,
.B pfuGetGUICursorSel,
.B pfuUpdateGUICursor,
.B pfuFitWidgets,
.B pfuGetGUIScale,
.B pfuGetGUITranslation,
.B pfuNewPanel,
.B pfuEnablePanel,
.B pfuDisablePanel,
.B pfuGetPanelOriginSize,
.B pfuNewWidget,
.B pfuDisableWidget,
.B pfuEnableWidget,
.B pfuIsWidgetOn,
.B pfuHideWidget,
.B pfuGetWidgetType,
.B pfuGetWidgetId,
.B pfuWidgetDim,
.B pfuGetWidgetDim,
.B pfuWidgetLabel,
.B pfuGetWidgetLabelWidth,
.B pfuGetWidgetLabel,
.B pfuWidgetRange,
.B pfuWidgetValue,
.B pfuGetWidgetValue,
.B pfuWidgetDefaultValue,
.B pfuWidgetActionFunc,
.B pfuGetWidgetActionFunc,
.B pfuWidgetSelectFunc,
.B pfuGetWidgetSelectFunc,
.B pfuWidgetDrawFunc,
.B pfuGetWidgetDrawFunc,
.B pfuWidgetSelections,
.B pfuWidgetSelection,
.B pfuGetWidgetSelection,
.B pfuWidgetDefaultSelection,
.B pfuWidgetDefaultOnOff,
.B pfuWidgetOnOff,
.B pfuWidgetMode,
.B pfuGetWidgetMode,
.B pfuUnhideWidget,
.B pfuResetGUI,
.B pfuResetPanel,
.B pfuResetWidget,
.B pfuDrawMessage,
.B pfuDrawMessageCI,
.B pfuDrawMessageRGB,
.B pfuDrawTree
\- 
High-performance graphical user interface routines.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfuWidgetAct\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
void
\f3\%pfuInitGUI\fP(pfPipeWindow\ *pipe);
.nf
.fi
.TP
void
\f3\%pfuExitGUI\fP(void);
.nf
.fi
.TP
void
\f3\%pfuEnableGUI\fP(int\ en);
.nf
.fi
.TP
void
\f3\%pfuUpdateGUI\fP(pfuMouse\ *mouse);
.nf
.fi
.TP
void
\f3\%pfuRedrawGUI\fP(void);
.nf
.fi
.TP
void
\f3\%pfuGUIViewport\fP(float\ l,
'in +2
'll -2
float\ r,
float\ b,
float\ t);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuGetGUIViewport\fP(float\ *l,
'in +2
'll -2
float\ *r,
float\ *b,
float\ *t);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuInGUI\fP(int\ x,
'in +2
'll -2
int\ y);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuInitGUICursors\fP(void);
.nf
.fi
.TP
pfChannel *
\f3\%pfuGetGUIChan\fP(void);
.nf
.fi
.TP
void
\f3\%pfuGUICursor\fP(int\ target,
'in +2
'll -2
int\ c);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuGetGUICursor\fP(int\ target);
.nf
.fi
.TP
void
\f3\%pfuGUIHlight\fP(pfHighlight\ *hlight);
.nf
.fi
.TP
pfHighlight *
\f3\%pfuGetGUIHlight\fP(void);
.nf
.fi
.TP
void
\f3\%pfuGUICursorSel\fP(int\ c);
.nf
.fi
.TP
int
\f3\%pfuGetGUICursorSel\fP(void);
.nf
.fi
.TP
void
\f3\%pfuUpdateGUICursor\fP(void);
.nf
.fi
.TP
void
\f3\%pfuFitWidgets\fP(int\ val);
.nf
.fi
.TP
void
\f3\%pfuGetGUIScale\fP(float\ *x,
'in +2
'll -2
float\ *y);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuGetGUITranslation\fP(float\ *x,
'in +2
'll -2
float\ *y);
.in
.ll
.nf
.fi
.TP
pfuPanel *
\f3\%pfuNewPanel\fP(void);
.nf
.fi
.TP
void
\f3\%pfuEnablePanel\fP(pfuPanel\ *p);
.nf
.fi
.TP
void
\f3\%pfuDisablePanel\fP(pfuPanel\ *p);
.nf
.fi
.TP
void
\f3\%pfuGetPanelOriginSize\fP(pfuPanel\ *p,
'in +2
'll -2
float\ *xo,
float\ *yo,
float\ *xs,
float\ *ys);
.in
.ll
.nf
.fi
.TP
pfuWidget *
\f3\%pfuNewWidget\fP(pfuPanel\ *p,
'in +2
'll -2
int\ type,
int\ id);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuDisableWidget\fP(pfuWidget\ *w);
.nf
.fi
.TP
void
\f3\%pfuEnableWidget\fP(pfuWidget\ *w);
.nf
.fi
.TP
int
\f3\%pfuIsWidgetOn\fP(pfuWidget\ *w);
.nf
.fi
.TP
void
\f3\%pfuHideWidget\fP(pfuWidget\ *w);
.nf
.fi
.TP
int
\f3\%pfuGetWidgetType\fP(pfuWidget\ *w);
.nf
.fi
.TP
int
\f3\%pfuGetWidgetId\fP(pfuWidget\ *w);
.nf
.fi
.TP
void
\f3\%pfuWidgetDim\fP(pfuWidget\ *w,
'in +2
'll -2
int\ xo,
int\ yo,
int\ xs,
int\ ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuGetWidgetDim\fP(pfuWidget\ *w,
'in +2
'll -2
int\ *xo,
int\ *yo,
int\ *xs,
int\ *ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuWidgetLabel\fP(pfuWidget\ *w,
'in +2
'll -2
const\ char\ *label);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuGetWidgetLabelWidth\fP(pfuWidget\ *w);
.nf
.fi
.TP
const char *
\f3\%pfuGetWidgetLabel\fP(pfuWidget\ *w);
.nf
.fi
.TP
void
\f3\%pfuWidgetRange\fP(pfuWidget\ *w,
'in +2
'll -2
int\ printMode,
float\ min,
float\ max,
float\ val);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuWidgetValue\fP(pfuWidget\ *w,
'in +2
'll -2
float\ newval);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfuGetWidgetValue\fP(pfuWidget\ *w);
.nf
.fi
.TP
void
\f3\%pfuWidgetDefaultValue\fP(pfuWidget\ *w,
'in +2
'll -2
float\ val);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuWidgetActionFunc\fP(pfuWidget\ *w,
'in +2
'll -2
pfuWidgetActionFuncType\ func);
.in
.ll
.nf
.fi
.TP
pfuWidgetActionFuncType
\f3\%pfuGetWidgetActionFunc\fP(pfuWidget\ *w);
.nf
.fi
.TP
void
\f3\%pfuWidgetSelectFunc\fP(pfuWidget\ *w,
'in +2
'll -2
pfuWidgetSelectFuncType\ func);
.in
.ll
.nf
.fi
.TP
pfuWidgetSelectFuncType
\f3\%pfuGetWidgetSelectFunc\fP(pfuWidget\ *w);
.nf
.fi
.TP
void
\f3\%pfuWidgetDrawFunc\fP(pfuWidget\ *w,
'in +2
'll -2
pfuWidgetDrawFuncType\ func);
.in
.ll
.nf
.fi
.TP
pfuWidgetDrawFuncType
\f3\%pfuGetWidgetDrawFunc\fP(pfuWidget\ *w);
.nf
.fi
.TP
void
\f3\%pfuWidgetSelections\fP(pfuWidget\ *w,
'in +2
'll -2
pfuGUIString\ *selectionList,
int\ *valList,
void\ (**funcList)(pfuWidget\ *w),
int\ numSelections);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuWidgetSelection\fP(pfuWidget\ *w,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuGetWidgetSelection\fP(pfuWidget\ *w);
.nf
.fi
.TP
void
\f3\%pfuWidgetDefaultSelection\fP(pfuWidget\ *w,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuWidgetDefaultOnOff\fP(pfuWidget\ *\ w,
'in +2
'll -2
int\ on);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuWidgetOnOff\fP(pfuWidget\ *w,
'in +2
'll -2
int\ on);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuWidgetMode\fP(pfuWidget\ *w,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuGetWidgetMode\fP(pfuWidget\ *w,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuUnhideWidget\fP(pfuWidget\ *w);
.nf
.fi
.TP
void
\f3\%pfuResetGUI\fP(void);
.nf
.fi
.TP
void
\f3\%pfuResetPanel\fP(pfuPanel\ *p);
.nf
.fi
.TP
void
\f3\%pfuResetWidget\fP(pfuWidget\ *w);
.nf
.fi
.TP
void
\f3\%pfuDrawMessage\fP(pfChannel\ *chan,
'in +2
'll -2
const\ char\ *msg,
int\ rel,
int\ just,
float\ x,
float\ y,
int\ size,
int\ cimode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuDrawMessageCI\fP(pfChannel\ *chan,
'in +2
'll -2
const\ char\ *msg,
int\ rel,
int\ just,
float\ x,
float\ y,
int\ size,
int\ textClr,
int\ shadowClr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuDrawMessageRGB\fP(pfChannel\ *chan,
'in +2
'll -2
const\ char\ *msg,
int\ rel,
int\ just,
float\ x,
float\ y,
int\ size,
pfVec4\ textClr,
pfVec4\ shadowClr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuDrawTree\fP(pfChannel\ *chan,
'in +2
'll -2
pfNode\ *tree,
pfVec3\ panScale);
.in
.ll
.fi

.Ex
.nf

typedef void (*pfuWidgetDrawFuncType)(pfuWidget *widget, pfuPanel *panel);
typedef pfuWidget* (*pfuWidgetSelectFuncType)(pfuWidget *widget, pfuPanel *panel);
typedef void (*pfuWidgetActionFuncType)(pfuWidget *widget);
.Ee
.fi
.na

.SH DESCRIPTION

These functions define a simple graphical user interface library for
the OpenGL Performer sample application \f3\%perfly\fP.

Call \f3\%pfuInitGUI\fP to initialize the GUI module.  Call \f3\%pfuExitGUI\fP
on exit to deallocate GUI data structures and print brief frame
statistics through \f3\%pfNotify\fP at notification level \f3\%PFNFY_INFO\fP.

\f3\%pfuGetGUIChan\fP returns the pfChannel used by the GUI.

\f3\%pfuEnableGUI\fP disables or enables GUI processing and GUI panel
updates depending on the value of \f2en\fP.  \f3\%pfuUpdateGUI\fP uses the
current mouse data in \f2mouse\fP to draw the GUI according to its
current configuration. The mouse data can be collected by your own input
handling routines and stored in a pfuMouse structure to give to the GUI
or retrieved from the libpfutil
input collector using \f3\%pfuGetMouse\fP.
\f3\%pfuRedrawGUI\fP redraws the GUI.

\f3\%pfuGUIViewport\fP sets the GUI coordinates relative to the GUI
window.  \f3\%pfuGetGUIViewport\fP retrieves the current coordinates.

\f3\%pfuInGUI\fP returns true if the point \f2(x, y)\fP lies within the GUI.
\f2x\fP and \f2y\fP should be given relative to the window, not the
screen.

Your application should call \f3\%pfuFitWidgets\fP if you change your panel layout
after initialization so that the widgets in the window are accurately scaled and
translated to fit inside the window.  This function is called automatically
from \f3\%pfuUpdateGUI\fP
if a change in window size is detected. \f2val\fP is currently ignored.

\f3\%pfuGetGUIScale\fP can be called to retrieve the relative scale of the
GUI to the display window.  Similarly, \f3\%pfuGetGUITranslation\fP will
retrieve the current translation.

\f3\%pfuNewPanel\fP allocates and initializes a new GUI panel,
\f3\%pfuEnablePanel\fP is used to enable a panel, and \f3\%pfuDisablePanel\fP
disables a panel.  GUI panels are essentially a region containing
widgets, rectangular regions which can be customized as buttons, menus,
and other interface items.  \f3\%pfuResetPanel\fP restores the widgets in
\f2panel\fP to their default values.  \f3\%pfuGetPanelOriginSize\fP retrieves
the origin and size for \f2panel\fP.

\f3\%pfuNewWidget\fP allocates and initializes a new widget of type
\f2type\fP. \f2id\fP is the handle by which the new widget is identified.
\f3\%pfuGetWidgetType\fP returns \f2w\fP's type while \f3\%pfuGetWidgetId\fP
returns \f2w\fP's id.  Use \f3\%pfuEnableWidget\fP and \f3\%pfuDisableWidget\fP to
enable or disable the action of a widget \f2w\fP.

\f3\%pfuWidgetDim\fP sets \f2w\fP's lower left corner at \f2(xo, yo)\fP and
its top right corner at \f2(xo+xs, yo+ys)\fP. \f3\%pfuGetWidgetDim\fP
returns \f2w\fP in \f2xo\fP and \f2yo\fP and its size in \f2xs\fP and \f2ys\fP.

\f3\%pfuWidgetLabel\fP sets \f2label\fP to be the label by which \f2w\fP will
be identified. \f3\%pfuGetWidgetLabelWidth\fP returns the length of
\f2w\fP's label while \f3\%pfuGetWidgetLabel\fP returns the label itself.

\f3\%pfuWidgetRange\fP sets the range of legal values for the widget (\f2min\fP
and \f2max\fP), and initial value of \f2w\fP in \f2val\fP. The
\f2printMode\fP arg takes the values 1 or 0 and is used to indicate if the
value should be printed as an int \f3\%PFUGUI_INT\fP or float \f3\%PFUGUI_FLOAT\fP.

\f3\%pfuWidgetValue\fP essentially sets \f2w\fP's value to \f2newval\fP. The
actions are different depending on \f2w\fP's type.
.RS
.TP 5
\f3\%PFUGUI_SLIDER\fP
\f2w\fP's value is set to \f2newval\fP.
.TP
\f3\%PFUGUI_SLIDER_LOG\fP
\f2w\fP's value is set to the base-10 logarithm of \f2newval\fP.
.TP
\f3\% PFUGUI_SWITCH\fP,
\f2w\fP's value is set to its minimum possible provided \f2newval\fP is
close to the minimum. Otherwise, \f2w\fP's value is set to its maximum
possible.
.TP
\f3\%PFGUI_BUTTON\fP
\f2w\fP is highlighted if \f2newval\fP is non-zero, otherwise it is
unhighlighted.
.TP
\f3\%PFUGUI_MENU_BUTTON\fP
\f2w\fP's value is set to the index of the selection whose value is
close to \f2newval\fP.
.TP
\f3\%PFUGUI_RADIO_BUTTON\fP or \f3\%PFUGUI_RADIO_BUTTON_TOGGLE\fP
\f2w\fP's value is set to the index of the selection whose value is
close to \f2newval\fP.
.RE

\f3\%pfuGetWidgetValue\fP returns \f2w\fP's
value. \f3\%pfuWidgetDefaultValue\fP works just like \f3\%pfuWidgetValue\fP
but sets \f2w\fP's default value to \f2newval\fP instead.

\f3\%pfuWidgetActionFunc\fP is used to set the callback function when the
mouse button is clicked on the widget.
\f3\%pfuGetWidgetActionFunc\fP will return the widget's action callback function.
\f3\%pfuWidgetSelectFunc\fP and
\f3\%pfuWidgetDrawFunc\fP are used to set up custom widgets.
\f3\%pfuWidgetSelectFunc\fP is called with a custom selection function
in \f2func\fP. \f2func\fP is called when the mouse button is clicked on the
widget; \f2func\fP returns a pointer to another widget, whose action
function is called instead of the custom widget's action function.
If \f3\%pfuWidgetDrawFunc\fP is called to set a custom draw function,
that function will be called instead of the built-in draw function
when that widget needs to be redrawn.
\f3\%pfuGetWidgetDrawFunc\fP and \f3\%pfuGetWidgetSelectFunc\fP will return the custom
draw and selection callback functions, respectively.

\f3\%pfuWidgetSelections\fP sets the selection choices for the widget
\f2w\fP, which must be of type \f3\%PFUGUI_RADIO_BUTTON\fP or
\f3\%PFUGUI_MENU_BUTTON\fP.  \f2val\fP contains a list of the values assigned
to each of the selections; if \f2val\fP is NULL, then the selection value
will be set to the ordinal index of the selection.  \f2funcList\fP
contains a list of action functions corresponding to each selection; if
\f2funcList\fP is NULL, then the widget's default action function will
be used for all of the selections.  Use \f3\%pfuWidgetSelection\fP to set
the current selection.  Use \f3\%pfuGetWidgetSelection\fP to retrieve the
selection last chosen or set.  Use \f3\%pfuWidgetDefaultSelection\fP to set
the selection which will be set when the widget (or the panel that
contains it) is reset.

\f3\%pfuWidgetOnOff\fP changes various fields of \f2w\fP depending on
whether \f2on\fP is 0 or 1. These changes essentially correspond to
setting the widget off or on. Exactly how \f2w\fP is changed depends on
its type as follows.
.RS
.TP 5
\f3\%PFUGUI_SWITCH\fP
If \f2on\fP is 0, \f2w\fP's value is set to its minimum. Otherwise, it is
set to the maximum possible value.
.TP
\f3\%PFUGUI_BUTTON\fP
If \f2on\fP is 1, \f2w\fP's value is set to 1 and \f2w\fP is highlighted. If
\f2on\fP is 0, \f2w\fP's value is set to 0 and \f2w\fP is restored to its
normal, unhighlighted state.
.TP
\f3\%PFUGUI_RADIO_BUTTON\fP
If \f2on\fP is 1, \f2w\fP is set on; otherwise it is set off.
.RE

\f3\%pfuWidgetDefaultOnOff\fP works essentially like
\f3\%pfuWidgetOnOff\fP. If \f2w\fP is of type \f3\%PFUGUI_SWITCH\fP, \f2w\fP's
default value is modified. If \f2w\fP is of type
\f3\%PFUGUI_RADIO_BUTTON\fP, \f2w\fP's default on value is modified.

\f3\%pfuIsWidgetOn\fP returns the status of \f2w\fP - whether it is on or
off.

\f3\%pfuHideWidget\fP marks widget \f2w\fP to not be displayed in the GUI.
\f3\%pfuUnhideWidget\fP restores widget \f2w\fP for display.

\f3\%pfuWidgetMode\fP sets the specified \f2mode\fP to the given \f2val\fP.
Currently only the boolean mode \f3\%PFUGUI_STICKY_DEFAULT\fP
is supported for sliders.
\f3\%pfuGetWidgetMode\fP returns the value for the specified \f2mode\fP.

\f3\%pfuResetWidget\fP resets \f2w\fP to its default values and calls
\f2w\fP's action function if that function has been set.

\f3\%pfuDrawMessage\fP draws the message \f2msg\fP justified with respect to
(\f2x\fP, \f2y\fP) in a font of size \f2size\fP. \f2x\fP and \f2y\fP must range
between 0 and 1 and \f2size\fP should take the value \f3\%PFU_FONT_SMALL\fP,
\f3\%PFU_FONT_MED\fP, or \f3\%PFU_FONT_BIG\fP. \f2just\fP specifies the
justification and can take the value \f3\%PFU_CENTER_JUSTIFIED\fP,
\f3\%PFU_LEFT_JUSTIFIED\fP or \f3\%PFU_RIGHT_JUSTIFIED\fP. Set \f2cimode\fP to
\f3\%PFU_CI\fP to use color-indexing mode or \f3\%PFU_RGB\fP to use direct
color mode. \f2rel\fP controls whether \f2x\fP and \f2y\fP are specified as
absolute values or relative to \f2chan\fP's origin.

\f3\%pfuDrawMessageCI\fP works just like \f3\%pfuDrawMessage\fP except that
\f2cimode\fP is set to \f3\%PFU_CI\fP. The color indices are specified in
\f2textClr\fP and \f2shadowClr\fP.

\f3\%pfuDrawMessageRGB\fP also works just like \f3\%pfuDrawMessage\fP except
that \f2cimode\fP is set to \f3\%PFU_RGB\fP. The RGB color values are
specified in \f2textClr\fP and \f2shadowClr\fP.

\f3\%pfuDrawTree\fP draws each node of the subtree of the scene graph
rooted at \f2tree\fP inside the view frustum defined by \f2chan\fP.

The following functions are not normally called by user applications
but are used by the GUI module to manipulate its internal state and
are provided here for completeness.

\f3\%pfuInitGUICursors\fP initializes the cursors used by the GUI module.

\f3\%pfuGetGUICursor\fP and \f3\%pfuGUICursor\fP are used to get and set cursor
definitions, respectively.  \f3\%pfuGetGUICursorSel\fP and
\f3\%pfuGUICursorSel\fP are used to get and set the current cursor,
respectively. \f3\%pfuUpdateGUICursor\fP is called to load the current
cursor bitmap into the display window.

\f3\%pfuGUIHlight\fP and \f3\%pfuGetGUIHlight\fP are used to get and set the
\f2pfHighlight\fP definition used to highlight selected geometry.

.SH NOTES


\f3\%pfuInit\fP should be called before \f3\%pfConfig\fP to initialize the libpfutil
library and C++ classes for multiprocessed access.

Additionally, the GUI relies on receiving mouse information via \f3\%pfuGetMouse\fP.
This input can be collected automatically via input handling utilities in libpfutil.
See the \f3\%pfuInitInput\fP man pages.

These functions use \f3\%pfDataPools\fP to store multiply accessed data so
as to work well in multiprocessing applications. See
"/usr/share/Performer/src/lib/libpfutil/gui.c" for further details.

Sample source code programs using the GUI utilities include
"/usr/share/Performer/src/pguide/libpf/C/detail.c" and the perfly sample application.

The libpfutil source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
.SH SEE ALSO
pfDataPool,
pfuXFont,
pfuCursor,
pfuInitInput,
pfuInit,
pfuGetMouse
