'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuXformer" "3pf"
.SH NAME
.upperok
.B pfuNewXformer,
.B pfuXformerMode,
.B pfuGetXformerMode,
.B pfuStopXformer,
.B pfuXformerAutoInput,
.B pfuXformerMat,
.B pfuGetXformerMat,
.B pfuXformerCoord,
.B pfuGetXformerCoord,
.B pfuXformerLimits,
.B pfuGetXformerLimits,
.B pfuXformerCollision,
.B pfuGetXformerCollisionStatus,
.B pfuUpdateXformer,
.B pfuCollideXformer
\- 
Backward compatibility module for basic flight models and transformers.
.SH DESCRIPTION

In releases of OpenGL Performer since 2.0, the pfuXformer has been moved to libpfui --
the OpenGL Performer User Interface library, and is now the pfiXformer.
The original pfuXformer API has been preserved, but now has a pfi- prefix.
For compatibility with previous releases of OpenGL Performer,
there are compatibility defines from the old \f2pfu\fP routine names
to the new \f2pfi\fP routine names in <Performer/pfui.h> that are enabled
if the PF_COMPAT_1_2 variable is defined.

See the \f3\%pfiNewXformer\fP man page for information on the pfiXformer.
.SH NOTES

These functions are provided to ease the transition of programs from
the older IRIS Performer 1.2 release to the current release. These
functions should not be used in new application development since
they will be removed in a future release of OpenGL Performer.
